/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Z){for(var e=[],D=0,O=Z.length;D<O;D++)e[D]=ne[Z[D]];return e};define(ne[63],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(L){return(R,I,S)=>{let P=null,v=null;if(typeof S.value=="function"?(P="value",v=S.value):typeof S.get=="function"&&(P="get",v=S.get),!v)throw new Error("not supported");S[P]=L(v,I)}}function O(L,R,I){let S=null,P=null;if(typeof I.value=="function"?(S="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",P=I.get),!P)throw new Error("not supported");const v=`$memoize$${R}`;I[S]=function(...m){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[v]}}e.memoize=O;function l(L,R,I){return D((S,P)=>{const v=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...g){this[m]||(this[m]=I?I():void 0),clearTimeout(this[v]),R&&(this[m]=R(this[m],...g),g=[this[m]]),this[v]=setTimeout(()=>{S.apply(this,g),this[m]=I?I():void 0},L)}})}e.debounce=l;function A(L,R,I){return D((S,P)=>{const v=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,g=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...p){if(this[m]||(this[m]=I?I():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...p)),this[f])return;const h=this[g]+L;h<=Date.now()?(this[g]=Date.now(),S.apply(this,[this[m]]),this[m]=I?I():void 0):(this[f]=!0,this[v]=setTimeout(()=>{this[f]=!1,this[g]=Date.now(),S.apply(this,[this[m]]),this[m]=I?I():void 0},h-Date.now()))}})}e.throttle=A}),define(ne[8],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=D,e.errorHandler=new D;function O(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function l(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function A(t){S(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function L(t){S(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=L;function R(t){if(t instanceof Error){const{name:a,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:n,noTelemetry:b.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=R;const I="Canceled";function S(t){return t instanceof P?!0:t instanceof Error&&t.name===I&&t.message===I}e.isCancellationError=S;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function v(){const t=new Error(I);return t.name=t.message,t}e.canceled=v;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=m;function g(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=g;function f(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function p(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=p;function h(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=h;class u extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=u;class d extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=d;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const i=new b;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class C extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(ne[20],se([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(H,X=0){return H[H.length-(1+X)]}e.tail=O;function l(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=l;function A(H,X,te=(le,he)=>le===he){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let le=0,he=H.length;le<he;le++)if(!te(H[le],X[le]))return!1;return!0}e.equals=A;function L(H,X){const te=H.length-1;X<te&&(H[X]=H[te]),H.pop()}e.removeFastWithoutKeepingOrder=L;function R(H,X,te){return I(H.length,le=>te(H[le],X))}e.binarySearch=R;function I(H,X){let te=0,le=H-1;for(;te<=le;){const he=(te+le)/2|0,me=X(he);if(me<0)te=he+1;else if(me>0)le=he-1;else return he}return-(te+1)}e.binarySearch2=I;function S(H,X){let te=0,le=H.length;if(le===0)return 0;for(;te<le;){const he=Math.floor((te+le)/2);X(H[he])?le=he:te=he+1}return te}e.findFirstInSorted=S;function P(H,X,te){if(H=H|0,H>=X.length)throw new TypeError("invalid index");const le=X[Math.floor(X.length*Math.random())],he=[],me=[],pe=[];for(const Se of X){const Ee=te(Se,le);Ee<0?he.push(Se):Ee>0?me.push(Se):pe.push(Se)}return H<he.length?P(H,he,te):H<he.length+pe.length?pe[0]:P(H-(he.length+pe.length),me,te)}e.quickSelect=P;function v(H,X){const te=[];let le;for(const he of H.slice(0).sort(X))!le||X(le[0],he)!==0?(le=[he],te.push(le)):le.push(he);return te}e.groupBy=v;function m(H,X,te){const le=[];function he(Se,Ee,De){if(Ee===0&&De.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===Se?(ke.deleteCount+=Ee,ke.toInsert.push(...De)):le.push({start:Se,deleteCount:Ee,toInsert:De})}let me=0,pe=0;for(;;){if(me===H.length){he(me,0,X.slice(pe));break}if(pe===X.length){he(me,H.length-me,[]);break}const Se=H[me],Ee=X[pe],De=te(Se,Ee);De===0?(me+=1,pe+=1):De<0?(he(me,1,[]),me+=1):De>0&&(he(me,0,[Ee]),pe+=1)}return le}e.sortedDiff=m;function g(H,X,te){const le=m(H,X,te),he=[],me=[];for(const pe of le)he.push(...H.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:he,added:me}}e.delta=g;function f(H,X,te){if(te===0)return[];const le=H.slice(0,te).sort(X);return h(H,X,le,te,H.length),le}e.top=f;function p(H,X,te,le,he){return te===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const Se=H.length,Ee=H.slice(0,te).sort(X);for(let De=te,ke=Math.min(te+le,Se);De<Se;De=ke,ke=Math.min(ke+le,Se)){if(De>te&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new D.CancellationError;h(H,X,Ee,De,ke)}return Ee})().then(me,pe)})}e.topAsync=p;function h(H,X,te,le,he){for(const me=te.length;le<he;le++){const pe=H[le];if(X(pe,te[me-1])<0){te.pop();const Se=S(te,Ee=>X(pe,Ee)<0);te.splice(Se,0,pe)}}}function u(H){return H.filter(X=>!!X)}e.coalesce=u;function d(H){let X=0;for(let te=0;te<H.length;te++)H[te]&&(H[X]=H[te],X+=1);H.length=X}e.coalesceInPlace=d;function y(H,X,te){H.splice(te,0,H.splice(X,1)[0])}e.move=y;function b(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=b;function C(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=C;function t(H,X=te=>te){const te=new Set;return H.filter(le=>{const he=X(le);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=t;function a(H){const X=new Set;return te=>{const le=H(te);return X.has(le)?!1:(X.add(le),!0)}}e.uniqueFilter=a;function i(H,X){const te=n(H,X);if(te!==-1)return H[te]}e.findLast=i;function n(H,X){for(let te=H.length-1;te>=0;te--){const le=H[te];if(X(le))return te}return-1}e.lastIndex=n;function r(H,X){return H.length>0?H[0]:X}e.firstOrDefault=r;function o(H,X){return H.length>0?H[H.length-1]:X}e.lastOrDefault=o;function s(H,X,te=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(H.length,X.length);he<me&&te(H[he],X[he]);he++)le++;return le}e.commonPrefixLength=s;function c(H){return[].concat(...H)}e.flatten=c;function w(H,X){let te=typeof X=="number"?H:0;typeof X=="number"?te=H:(te=0,X=H);const le=[];if(te<=X)for(let he=te;he<X;he++)le.push(he);else for(let he=te;he>X;he--)le.push(he);return le}e.range=w;function E(H,X,te){return H.reduce((le,he)=>(le[X(he)]=te?te(he):he,le),Object.create(null))}e.index=E;function k(H,X){return H.push(X),()=>N(H,X)}e.insert=k;function N(H,X){const te=H.indexOf(X);if(te>-1)return H.splice(te,1),X}e.remove=N;function M(H,X,te){const le=H.slice(0,X),he=H.slice(X);return le.concat(te,he)}e.arrayInsert=M;function $(H,X){let te;if(typeof X=="number"){let le=X;te=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let le=H.length-1;le>0;le-=1){const he=Math.floor(te()*(le+1)),me=H[le];H[le]=H[he],H[he]=me}}e.shuffle=$;function T(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.unshift(X))}e.pushToStart=T;function B(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.push(X))}e.pushToEnd=B;function q(H,X){for(const te of X)H.push(te)}e.pushMany=q;function G(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=G;function Q(H){return Array.isArray(H)?H:[H]}e.asArray=Q;function re(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=re;function K(H,X){for(const te of H){const le=X(te);if(le!==void 0)return le}}e.mapFind=K;function W(H,X,te){const le=J(H,X),he=H.length,me=te.length;H.length=he+me;for(let pe=he-1;pe>=le;pe--)H[pe+me]=H[pe];for(let pe=0;pe<me;pe++)H[pe+le]=te[pe]}e.insertInto=W;function F(H,X,te,le){const he=J(H,X),me=H.splice(he,te);return W(H,he,le),me}e.splice=F;function J(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}var ee;(function(H){function X(he){return he<0}H.isLessThan=X;function te(he){return he>0}H.isGreaterThan=te;function le(he){return he===0}H.isNeitherLessOrGreaterThan=le,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function oe(H,X){return(te,le)=>X(H(te),H(le))}e.compareBy=oe;function ce(...H){return(X,te)=>{for(const le of H){const he=le(X,te);if(!ee.isNeitherLessOrGreaterThan(he))return he}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=ce;const V=(H,X)=>H-X;e.numberComparator=V;function j(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>0&&(te=he)}return te}e.findMaxBy=j;function U(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=U;function z(H,X){return j(H,(te,le)=>-X(te,le))}e.findMinBy=z;class x{constructor(X){this.f=X,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(X){let te=this.c;for(;te<this.f.length&&X(this.f[te]);)te++;const le=te===this.c?null:this.f.slice(this.c,te);return this.c=te,le}takeFromEndWhile(X){let te=this.d;for(;te>=0&&X(this.f[te]);)te--;const le=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const X=this.f[this.c];return this.c++,X}removeLast(){const X=this.f[this.d];return this.d--,X}takeCount(X){const te=this.f.slice(this.c,this.c+X);return this.c+=X,te}}e.ArrayQueue=x;class _{constructor(X){this.iterate=X}forEach(X){this.iterate(te=>(X(te),!0))}toArray(){const X=[];return this.iterate(te=>(X.push(te),!0)),X}filter(X){return new _(te=>this.iterate(le=>X(le)?te(le):!0))}map(X){return new _(te=>this.iterate(le=>te(X(le))))}some(X){let te=!1;return this.iterate(le=>(te=X(le),!te)),te}findFirst(X){let te;return this.iterate(le=>X(le)?(te=le,!1):!0),te}findLast(X){let te;return this.iterate(le=>(X(le)&&(te=le),!0)),te}findLastMaxBy(X){let te,le=!0;return this.iterate(he=>((le||ee.isGreaterThan(X(he,te)))&&(le=!1,te=he),!0)),te}}_.empty=new _(H=>{}),e.CallbackIterable=_}),define(ne[128],se([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=O;function l(I,S="Unreachable"){throw new Error(S)}e.assertNever=l;function A(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=A;function L(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function R(I,S){let P=0;for(;P<I.length-1;){const v=I[P],m=I[P+1];if(!S(v,m))return!1;P++}return!0}e.checkAdjacentItems=R}),define(ne[82],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(O){const l=this;let A=!1,L;return function(){return A||(A=!0,L=O.apply(l,arguments)),L}}e.once=D}),define(ne[64],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function l(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}O.is=l;const A=Object.freeze([]);function L(){return A}O.empty=L;function*R(b){yield b}O.single=R;function I(b){return l(b)?b:R(b)}O.wrap=I;function S(b){return b||A}O.from=S;function P(b){return!b||b[Symbol.iterator]().next().done===!0}O.isEmpty=P;function v(b){return b[Symbol.iterator]().next().value}O.first=v;function m(b,C){for(const t of b)if(C(t))return!0;return!1}O.some=m;function g(b,C){for(const t of b)if(C(t))return t}O.find=g;function*f(b,C){for(const t of b)C(t)&&(yield t)}O.filter=f;function*p(b,C){let t=0;for(const a of b)yield C(a,t++)}O.map=p;function*h(...b){for(const C of b)for(const t of C)yield t}O.concat=h;function u(b,C,t){let a=t;for(const i of b)a=C(a,i);return a}O.reduce=u;function*d(b,C,t=b.length){for(C<0&&(C+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);C<t;C++)yield b[C]}O.slice=d;function y(b,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,b];const a=b[Symbol.iterator]();for(let i=0;i<C;i++){const n=a.next();if(n.done)return[t,O.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}O.consume=y})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function L(t,a=!1){let i=0;const n=t.length;let r="",o=0,s=16,c=0;function w(B){let q=0,G=0;for(;q<B;){const Q=t.charCodeAt(i);if(Q>=48&&Q<=57)G=G*16+Q-48;else if(Q>=65&&Q<=70)G=G*16+Q-65+10;else if(Q>=97&&Q<=102)G=G*16+Q-97+10;else break;i++,q++}return q<B&&(G=-1),G}function E(B){i=B,r="",o=0,s=16,c=0}function k(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&S(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&S(t.charCodeAt(i)))for(i++;i<t.length&&S(t.charCodeAt(i));)i++;else return c=3,t.substring(B,i);let q=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&S(t.charCodeAt(i))){for(i++;i<t.length&&S(t.charCodeAt(i));)i++;q=i}else c=3;return t.substring(B,q)}function N(){let B="",q=i;for(;;){if(i>=n){B+=t.substring(q,i),c=2;break}const G=t.charCodeAt(i);if(G===34){B+=t.substring(q,i),i++;break}if(G===92){if(B+=t.substring(q,i),i++,i>=n){c=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const re=w(4);re>=0?B+=String.fromCharCode(re):c=4;break}default:c=5}q=i;continue}if(G>=0&&G<=31)if(I(G)){B+=t.substring(q,i),c=2;break}else c=6;i++}return B}function M(){if(r="",c=0,o=i,i>=n)return o=n,s=17;let B=t.charCodeAt(i);if(R(B)){do i++,r+=String.fromCharCode(B),B=t.charCodeAt(i);while(R(B));return s=15}if(I(B))return i++,r+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(B){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=N(),s=10;case 47:{const q=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!I(t.charCodeAt(i));)i++;return r=t.substring(q,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const G=n-1;let Q=!1;for(;i<G;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,Q=!0;break}i++}return Q||(i++,c=1),r=t.substring(q,i),s=13}return r+=String.fromCharCode(B),i++,s=16}case 45:if(r+=String.fromCharCode(B),i++,i===n||!S(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=k(),s=11;default:for(;i<n&&$(B);)i++,B=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(B),i++,s=16}}function $(B){if(R(B)||I(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let B;do B=M();while(B>=12&&B<=15);return B}return{setPosition:E,getPosition:()=>i,scan:a?T:M,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>c}}e.createScanner=L;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function I(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function v(t,a){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function c(w,E,k,N){o.value=w,o.offset=E,o.length=k,o.type=N,o.colonOffset=void 0,r=o}try{y(t,{onObjectBegin:(w,E)=>{if(a<=w)throw n;r=void 0,s=a>w,i.push("")},onObjectProperty:(w,E,k)=>{if(a<E||(c(w,E,k,"property"),i[i.length-1]=w,a<=E+k))throw n},onObjectEnd:(w,E)=>{if(a<=w)throw n;r=void 0,i.pop()},onArrayBegin:(w,E)=>{if(a<=w)throw n;r=void 0,i.push(0)},onArrayEnd:(w,E)=>{if(a<=w)throw n;r=void 0,i.pop()},onLiteralValue:(w,E,k)=>{if(a<E||(c(w,E,k,C(w)),a<=E+k))throw n},onSeparator:(w,E,k)=>{if(a<=E)throw n;if(w===":"&&r&&r.type==="property")r.colonOffset=E,s=!1,r=void 0;else if(w===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(w){if(w!==n)throw w}return{path:i,previousNode:r,isAtPropertyKey:s,matches:w=>{let E=0;for(let k=0;E<w.length&&k<i.length;k++)if(w[E]===i[k]||w[E]==="*")E++;else if(w[E]!=="**")return!1;return E===w.length}}}e.getLocation=v;function m(t,a=[],i=A.DEFAULT){let n=null,r=[];const o=[];function s(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}return y(t,{onObjectBegin:()=>{const w={};s(w),o.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const w=[];s(w),o.push(r),r=w,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:s,onError:(w,E,k)=>{a.push({error:w,offset:E,length:k})}},i),r[0]}e.parse=m;function g(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function o(w){return n.children.push(w),w}y(t,{onObjectBegin:w=>{n=o({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,E,k)=>{n=o({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:E,length:k,parent:n})},onObjectEnd:(w,E)=>{n.length=w+E-n.offset,n=n.parent,r(w+E)},onArrayBegin:(w,E)=>{n=o({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,E)=>{n.length=w+E-n.offset,n=n.parent,r(w+E)},onLiteralValue:(w,E,k)=>{o({type:C(w),offset:E,length:k,parent:n,value:w}),r(E+k)},onSeparator:(w,E,k)=>{n.type==="property"&&(w===":"?n.colonOffset=E:w===","&&r(E))},onError:(w,E,k)=>{a.push({error:w,offset:E,length:k})}},i);const c=n.children[0];return c&&delete c.parent,c}e.parseTree=g;function f(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=f;function p(t){if(!t.parent||!t.parent.children)return[];const a=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=p;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=h(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function d(t,a,i=!1){if(u(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const o=d(n[r],a,i);if(o)return o}return t}}e.findNodeAtOffset=d;function y(t,a,i=A.DEFAULT){const n=L(t,!1);function r(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(oe){return oe?ce=>oe(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=r(a.onObjectBegin),c=o(a.onObjectProperty),w=r(a.onObjectEnd),E=r(a.onArrayBegin),k=r(a.onArrayEnd),N=o(a.onLiteralValue),M=o(a.onSeparator),$=r(a.onComment),T=o(a.onError),B=i&&i.disallowComments,q=i&&i.allowTrailingComma;function G(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:B||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(oe){case 12:case 13:B?Q(10):$();break;case 16:Q(1);break;case 15:case 14:break;default:return oe}}}function Q(oe,ce=[],V=[]){if(T(oe),ce.length+V.length>0){let j=n.getToken();for(;j!==17;){if(ce.indexOf(j)!==-1){G();break}else if(V.indexOf(j)!==-1)break;j=G()}}}function re(oe){const ce=n.getTokenValue();return oe?N(ce):c(ce),G(),!0}function K(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(Q(2),oe=0)}catch{Q(2)}N(oe);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function W(){return n.getToken()!==10?(Q(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(M(":"),G(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function F(){s(),G();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),M(","),G(),n.getToken()===2&&q)break}else oe&&Q(6,[],[]);W()||Q(4,[],[2,5]),oe=!0}return w(),n.getToken()!==2?Q(7,[2],[]):G(),!0}function J(){E(),G();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),M(","),G(),n.getToken()===4&&q)break}else oe&&Q(6,[],[]);ee()||Q(4,[],[4,5]),oe=!0}return k(),n.getToken()!==4?Q(8,[4],[]):G(),!0}function ee(){switch(n.getToken()){case 3:return J();case 1:return F();case 10:return re(!0);default:return K()}}return G(),n.getToken()===17?i.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(n.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=y;function b(t,a){const i=L(t),n=[];let r,o=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==s&&n.push(t.substring(o,s)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=b;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(ne[42],se([0,1,35]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(S,P,v){let m,g,f,p,h;if(P){for(p=P.offset,h=p+P.length,f=p;f>0&&!I(S,f-1);)f--;let s=h;for(;s<S.length&&!I(S,s);)s++;g=S.substring(f,s),m=L(g,v)}else g=S,m=0,f=0,p=0,h=S.length;const u=R(v,S);let d=!1,y=0,b;v.insertSpaces?b=A(" ",v.tabSize||4):b="	";const C=(0,D.createScanner)(g,!1);let t=!1;function a(){return u+A(b,m+y)}function i(){let s=C.scan();for(d=!1;s===15||s===14;)d=d||s===14,s=C.scan();return t=s===16||C.getTokenError()!==0,s}const n=[];function r(s,c,w){!t&&c<h&&w>p&&S.substring(c,w)!==s&&n.push({offset:c,length:w-c,content:s})}let o=i();if(o!==17){const s=C.getTokenOffset()+f,c=A(b,m);r(c,f,s)}for(;o!==17;){let s=C.getTokenOffset()+C.getTokenLength()+f,c=i(),w="";for(;!d&&(c===12||c===13);){const k=C.getTokenOffset()+f;r(" ",s,k),s=C.getTokenOffset()+C.getTokenLength()+f,w=c===12?a():"",c=i()}if(c===2)o!==1&&(y--,w=a());else if(c===4)o!==3&&(y--,w=a());else{switch(o){case 3:case 1:y++,w=a();break;case 5:case 12:w=a();break;case 13:d?w=a():w=" ";break;case 6:w=" ";break;case 10:if(c===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?w=" ":c!==5&&c!==17&&(t=!0);break;case 16:t=!0;break}d&&(c===12||c===13)&&(w=a())}const E=C.getTokenOffset()+f;r(w,s,E),o=c}return n}e.format=O;function l(S,P){const v=JSON.stringify(S,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?v.replace(/\r\n|\r|\n/g,P.eol):v}e.toFormattedString=l;function A(S,P){let v="";for(let m=0;m<P;m++)v+=S;return v}function L(S,P){let v=0,m=0;const g=P.tabSize||4;for(;v<S.length;){const f=S.charAt(v);if(f===" ")m++;else if(f==="	")m+=g;else break;v++}return Math.floor(m/g)}function R(S,P){for(let v=0;v<P.length;v++){const m=P.charAt(v);if(m==="\r")return v+1<P.length&&P.charAt(v+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function I(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=I}),define(ne[83],se([0,1,35,42]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(S,P,v){return A(S,P,void 0,v)}e.removeProperty=l;function A(S,P,v,m,g){const f=P.slice(),p=[],h=(0,D.parseTree)(S,p);let u,d;for(;f.length>0&&(d=f.pop(),u=(0,D.findNodeAtLocation)(h,f),u===void 0&&v!==void 0);)typeof d=="string"?v={[d]:v}:v=[v];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const y=(0,D.findNodeAtLocation)(u,[d]);if(y!==void 0)if(v===void 0){if(!y.parent)throw new Error("Malformed AST");const b=u.children.indexOf(y.parent);let C,t=y.parent.offset+y.parent.length;if(b>0){const a=u.children[b-1];C=a.offset+a.length}else C=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return L(S,{offset:C,length:t-C,content:""},m)}else return L(S,{offset:y.offset,length:y.length,content:JSON.stringify(v)},m);else{if(v===void 0)return[];const b=`${JSON.stringify(d)}: ${JSON.stringify(v)}`,C=g?g(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(C>0){const a=u.children[C-1];t={offset:a.offset+a.length,length:0,content:","+b}}else u.children.length===0?t={offset:u.offset+1,length:0,content:b}:t={offset:u.offset+1,length:0,content:b+","};return L(S,t,m)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(v!==void 0){const y=`${JSON.stringify(v)}`;let b;if(u.children.length===0||d===0)b={offset:u.offset+1,length:0,content:u.children.length===0?y:y+","};else{const C=d===-1||d>u.children.length?u.children.length:d,t=u.children[C-1];b={offset:t.offset+t.length,length:0,content:","+y}}return L(S,b,m)}else{const y=d,b=u.children[y];let C;if(u.children.length===1)C={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===y){const t=u.children[y-1],a=t.offset+t.length,i=u.offset+u.length;C={offset:a,length:i-2-a,content:""}}else C={offset:b.offset,length:u.children[y+1].offset-b.offset,content:""};return L(S,C,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return L(S,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(v)},m)}}e.setProperty=A;function L(S,P,v){let m=R(S,P),g=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;g>0&&!(0,O.isEOL)(m,g-1);)g--;for(;f<m.length&&!(0,O.isEOL)(m,f);)f++}const p=(0,O.format)(m,{offset:g,length:f-g},v);for(let u=p.length-1;u>=0;u--){const d=p[u];m=R(m,d),g=Math.min(g,d.offset),f=Math.max(f,d.offset+d.length),f+=d.content.length-d.length}const h=S.length-(m.length-f)-g;return[{offset:g,length:h,content:m.substring(g,f)}]}e.withFormatting=L;function R(S,P){return S.substring(0,P.offset)+P.content+S.substring(P.offset+P.length)}e.applyEdit=R;function I(S,P){const v=P.slice(0).sort((g,f)=>{const p=g.offset-f.offset;return p===0?g.length-f.length:p});let m=S.length;for(let g=v.length-1;g>=0;g--){const f=v[g];if(f.offset+f.length<=m)S=R(S,f);else throw new Error("Overlapping edit");m=f.offset}return S}e.applyEdits=I}),define(ne[129],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=D}),define(ne[2],se([0,1,82,64]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let A=null;function L(o){A=o}if(e.setDisposableTracker=L,l){const o="__is_disposable_tracked__";L(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return A?.trackDisposable(o),o}function I(o){A?.markAsDisposed(o)}function S(o,s){A?.setParent(o,s)}function P(o,s){if(!!A)for(const c of o)A.setParent(c,s)}function v(o){return A?.markAsSingleton(o),o}e.markAsSingleton=v;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function g(o){if(O.Iterable.is(o)){const s=[];for(const c of o)if(c)try{c.dispose()}catch(w){s.push(w)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=g;function f(o){for(const s of o)m(s)&&s.dispose();return[]}e.disposeIfDisposable=f;function p(...o){const s=h(()=>g(o));return P(o,s),s}e.combinedDisposable=p;function h(o){const s=R({dispose:(0,D.once)(()=>{I(s),o()})});return s}e.toDisposable=h;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return S(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class d{constructor(){this.q=new u,R(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}d.None=Object.freeze({dispose(){}}),e.Disposable=d;class y{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&S(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&S(s,null),s}}e.MutableDisposable=y;class b{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=b;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let c=s;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,I(this))},this}}e.SafeDisposable=C;class t{constructor(){this.a=new Map}acquire(s,...c){let w=this.a.get(s);w||(w={counter:0,object:this.b(s,...c)},this.a.set(s,w));const{object:E}=w,k=(0,D.once)(()=>{--w.counter===0&&(this.c(s,w.object),this.a.delete(s))});return w.counter++,{object:E,dispose:k}}}e.ReferenceCollection=t;class a{constructor(s){this.a=s}async acquire(s,...c){const w=this.a.acquire(s,...c);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(E){throw w.dispose(),E}}}e.AsyncReferenceCollection=a;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(o){const s=new u;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n;class r{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,c,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(s)?.dispose(),this.a.set(s,c)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ne[84],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const L=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,L){const R=new D(A);if(this.a===D.Undefined)this.a=R,this.b=R;else if(L){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(R))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const L=A.prev;L.next=A.next,A.next.prev=L}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=O}),define(ne[37],se([0,1]),function(Z,e){"use strict";var D,O,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(f,p,h){let u=f.get(p);return u===void 0&&(u=h,f.set(p,u)),u}e.getOrSet=A;function L(f){const p=[];return f.forEach((h,u)=>{p.push(`${u} => ${h}`)}),`Map(${f.size}) {${p.join(", ")}}`}e.mapToString=L;function R(f){const p=[];return f.forEach(h=>{p.push(h)}),`Set(${f.size}) {${p.join(", ")}}`}e.setToString=R;class I{constructor(p,h){this.uri=p,this.value=h}}class S{constructor(p,h){this[D]="ResourceMap",p instanceof S?(this.b=new Map(p.b),this.c=h??S.a):(this.b=new Map,this.c=p??S.a)}set(p,h){return this.b.set(this.c(p),new I(p,h)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,h){typeof h<"u"&&(p=p.bind(h));for(const[u,d]of this.b)p(d.value,d.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}S.a=f=>f.toString(),e.ResourceMap=S;class P{constructor(p,h){this[O]="ResourceSet",!p||typeof p=="function"?this.a=new S(p):(this.a=new S(h),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,h){this.a.forEach((u,d)=>p.call(h,d,d,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var v;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class m{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,h=0){const u=this.a.get(p);if(!!u)return h!==0&&this.j(u,h),u.value}set(p,h,u=0){let d=this.a.get(p);if(d)d.value=h,u!==0&&this.j(d,u);else{switch(d={key:p,value:h,next:void 0,previous:void 0},u){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(p,d),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const h=this.a.get(p);if(!!h)return this.a.delete(p),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,h){const u=this.e;let d=this.b;for(;d;){if(h?p.bind(h)(d.value,d.key,this):p(d.value,d.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.key,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}values(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.value,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}entries(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:[u.key,u.value],done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>p;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const h=p.next,u=p.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}p.next=void 0,p.previous=void 0,this.e++}j(p,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(p===this.b)return;const u=p.next,d=p.previous;p===this.c?(d.next=void 0,this.c=d):(u.previous=d,d.next=u),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(h===2){if(p===this.c)return;const u=p.next,d=p.previous;p===this.b?(u.previous=void 0,this.b=u):(u.previous=d,d.next=u),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((h,u)=>{p.push([u,h])}),p}fromJSON(p){this.clear();for(const[h,u]of p)this.set(h,u)}}e.LinkedMap=m;class g extends m{constructor(p,h=1){super(),this.k=p,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,h=2){return super.get(p,h)}peek(p){return super.get(p,0)}set(p,h){return super.set(p,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),define(ne[85],se([0,1,37]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new D.LRUCache(1e4);function l(S){return I(S,"NFC",O)}e.normalizeNFC=l;const A=new D.LRUCache(1e4);function L(S){return I(S,"NFD",A)}e.normalizeNFD=L;const R=/[^\u0000-\u0080]/;function I(S,P,v){if(!S)return S;const m=v.get(S);if(m)return m;let g;return R.test(S)?g=S.normalize(P):g=S,v.set(S,g),g}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(P){return L(P).replace(S,"")}}()}),define(ne[130],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function D(R,I,S){return Math.min(Math.max(R,I),S)}e.clamp=D;function O(R,I){return(I+R%I)%I}e.rot=O;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class A{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class L{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const S=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=L}),function(){function Z(l){const A=[];typeof l=="number"&&A.push("code/timeOrigin",l);function L(I){A.push(I,Date.now())}function R(){const I=[];for(let S=0;S<A.length;S+=2)I.push({name:A[S],startTime:A[S+1]});return I}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(l+L.startTime)});return A}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function D(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:Z)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function D(O){if(e[O])return e[O].exports;var l=e[O]={i:O,l:!1,exports:{}};return Z[O].call(l.exports,l,l.exports,D),l.l=!0,l.exports}return D.m=Z,D.c=e,D.d=function(O,l,A){D.o(O,l)||Object.defineProperty(O,l,{enumerable:!0,get:A})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,l){if(1&l&&(O=D(O)),8&l||4&l&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&l&&typeof O!="string")for(var L in O)D.d(A,L,function(R){return O[R]}.bind(null,L));return A},D.n=function(O){var l=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(l,"a",l),l},D.o=function(O,l){return Object.prototype.hasOwnProperty.call(O,l)},D.p="",D(D.s=0)}([function(Z,e,D){(function(O){var l;e=Z.exports=V,l=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],S=0,P=S++;I[P]="0|[1-9]\\d*";var v=S++;I[v]="[0-9]+";var m=S++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=S++;I[g]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var f=S++;I[f]="("+I[v]+")\\.("+I[v]+")\\.("+I[v]+")";var p=S++;I[p]="(?:"+I[P]+"|"+I[m]+")";var h=S++;I[h]="(?:"+I[v]+"|"+I[m]+")";var u=S++;I[u]="(?:-("+I[p]+"(?:\\."+I[p]+")*))";var d=S++;I[d]="(?:-?("+I[h]+"(?:\\."+I[h]+")*))";var y=S++;I[y]="[0-9A-Za-z-]+";var b=S++;I[b]="(?:\\+("+I[y]+"(?:\\."+I[y]+")*))";var C=S++,t="v?"+I[g]+I[u]+"?"+I[b]+"?";I[C]="^"+t+"$";var a="[v=\\s]*"+I[f]+I[d]+"?"+I[b]+"?",i=S++;I[i]="^"+a+"$";var n=S++;I[n]="((?:<|>)?=?)";var r=S++;I[r]=I[v]+"|x|X|\\*";var o=S++;I[o]=I[P]+"|x|X|\\*";var s=S++;I[s]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[u]+")?"+I[b]+"?)?)?";var c=S++;I[c]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[d]+")?"+I[b]+"?)?)?";var w=S++;I[w]="^"+I[n]+"\\s*"+I[s]+"$";var E=S++;I[E]="^"+I[n]+"\\s*"+I[c]+"$";var k=S++;I[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;I[N]="(?:~>?)";var M=S++;I[M]="(\\s*)"+I[N]+"\\s+",R[M]=new RegExp(I[M],"g");var $=S++;I[$]="^"+I[N]+I[s]+"$";var T=S++;I[T]="^"+I[N]+I[c]+"$";var B=S++;I[B]="(?:\\^)";var q=S++;I[q]="(\\s*)"+I[B]+"\\s+",R[q]=new RegExp(I[q],"g");var G=S++;I[G]="^"+I[B]+I[s]+"$";var Q=S++;I[Q]="^"+I[B]+I[c]+"$";var re=S++;I[re]="^"+I[n]+"\\s*("+a+")$|^$";var K=S++;I[K]="^"+I[n]+"\\s*("+t+")$|^$";var W=S++;I[W]="(\\s*)"+I[n]+"\\s*("+a+"|"+I[s]+")",R[W]=new RegExp(I[W],"g");var F=S++;I[F]="^\\s*("+I[s]+")\\s+-\\s+("+I[s]+")\\s*$";var J=S++;I[J]="^\\s*("+I[c]+")\\s+-\\s+("+I[c]+")\\s*$";var ee=S++;I[ee]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)l(oe,I[oe]),R[oe]||(R[oe]=new RegExp(I[oe]));function ce(ae,fe){if(ae instanceof V)return ae;if(typeof ae!="string"||ae.length>A||!(fe?R[i]:R[C]).test(ae))return null;try{return new V(ae,fe)}catch{return null}}function V(ae,fe){if(ae instanceof V){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof V))return new V(ae,fe);l("SemVer",ae,fe),this.loose=fe;var de=ae.trim().match(fe?R[i]:R[C]);if(!de)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<L)return Pe}return Ie}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ce,e.valid=function(ae,fe){var de=ce(ae,fe);return de?de.version:null},e.clean=function(ae,fe){var de=ce(ae.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(ae){return l("SemVer.compare",this.version,this.loose,ae),ae instanceof V||(ae=new V(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},V.prototype.compareMain=function(ae){return ae instanceof V||(ae=new V(ae,this.loose)),U(this.major,ae.major)||U(this.minor,ae.minor)||U(this.patch,ae.patch)},V.prototype.comparePre=function(ae){if(ae instanceof V||(ae=new V(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],Ie=ae.prerelease[fe];if(l("prerelease compare",fe,de,Ie),de===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(de===void 0)return-1;if(de!==Ie)return U(de,Ie)}while(++fe)},V.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,de,Ie){typeof de=="string"&&(Ie=de,de=void 0);try{return new V(ae,de).inc(fe,Ie).version}catch{return null}},e.diff=function(ae,fe){if(H(ae,fe))return null;var de=ce(ae),Ie=ce(fe);if(de.prerelease.length||Ie.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=U;var j=/^[0-9]+$/;function U(ae,fe){var de=j.test(ae),Ie=j.test(fe);return de&&Ie&&(ae=+ae,fe=+fe),de&&!Ie?-1:Ie&&!de?1:ae<fe?-1:ae>fe?1:0}function z(ae,fe,de){return new V(ae,de).compare(new V(fe,de))}function x(ae,fe,de){return z(ae,fe,de)>0}function _(ae,fe,de){return z(ae,fe,de)<0}function H(ae,fe,de){return z(ae,fe,de)===0}function X(ae,fe,de){return z(ae,fe,de)!==0}function te(ae,fe,de){return z(ae,fe,de)>=0}function le(ae,fe,de){return z(ae,fe,de)<=0}function he(ae,fe,de,Ie){var Pe;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Pe=ae===de;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Pe=ae!==de;break;case"":case"=":case"==":Pe=H(ae,de,Ie);break;case"!=":Pe=X(ae,de,Ie);break;case">":Pe=x(ae,de,Ie);break;case">=":Pe=te(ae,de,Ie);break;case"<":Pe=_(ae,de,Ie);break;case"<=":Pe=le(ae,de,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function me(ae,fe){if(ae instanceof me){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof me))return new me(ae,fe);l("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ae,fe){return U(fe,ae)},e.major=function(ae,fe){return new V(ae,fe).major},e.minor=function(ae,fe){return new V(ae,fe).minor},e.patch=function(ae,fe){return new V(ae,fe).patch},e.compare=z,e.compareLoose=function(ae,fe){return z(ae,fe,!0)},e.rcompare=function(ae,fe,de){return z(fe,ae,de)},e.sort=function(ae,fe){return ae.sort(function(de,Ie){return e.compare(de,Ie,fe)})},e.rsort=function(ae,fe){return ae.sort(function(de,Ie){return e.rcompare(de,Ie,fe)})},e.gt=x,e.lt=_,e.eq=H,e.neq=X,e.gte=te,e.lte=le,e.cmp=he,e.Comparator=me;var pe={};function Se(ae,fe){if(ae instanceof Se)return ae.loose===fe?ae:new Se(ae.raw,fe);if(ae instanceof me)return new Se(ae.value,fe);if(!(this instanceof Se))return new Se(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ee(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function De(ae,fe,de,Ie,Pe,Fe,Ae,ze,Ne,Te,Be,ie,ue){return((fe=Ee(de)?"":Ee(Ie)?">="+de+".0.0":Ee(Pe)?">="+de+"."+Ie+".0":">="+fe)+" "+(ze=Ee(Ne)?"":Ee(Te)?"<"+(+Ne+1)+".0.0":Ee(Be)?"<"+Ne+"."+(+Te+1)+".0":ie?"<="+Ne+"."+Te+"."+Be+"-"+ie:"<="+ze)).trim()}function ke(ae,fe){for(var de=0;de<ae.length;de++)if(!ae[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ae.length;de++)if(l(ae[de].semver),ae[de].semver!==pe&&ae[de].semver.prerelease.length>0){var Ie=ae[de].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(ae,fe,de){try{fe=new Se(fe,de)}catch{return!1}return fe.test(ae)}function $e(ae,fe,de,Ie){var Pe,Fe,Ae,ze,Ne;switch(ae=new V(ae,Ie),fe=new Se(fe,Ie),de){case">":Pe=x,Fe=le,Ae=_,ze=">",Ne=">=";break;case"<":Pe=_,Fe=te,Ae=x,ze="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ae,fe,Ie))return!1;for(var Te=0;Te<fe.set.length;++Te){var Be=fe.set[Te],ie=null,ue=null;if(Be.forEach(function(ge){ge.semver===pe&&(ge=new me(">=0.0.0")),ie=ie||ge,ue=ue||ge,Pe(ge.semver,ie.semver,Ie)?ie=ge:Ae(ge.semver,ue.semver,Ie)&&(ue=ge)}),ie.operator===ze||ie.operator===Ne||(!ue.operator||ue.operator===ze)&&Fe(ae,ue.semver)||ue.operator===Ne&&Ae(ae,ue.semver))return!1}return!0}me.prototype.parse=function(ae){var fe=this.loose?R[re]:R[K],de=ae.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ae);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new V(de[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(ae){return l("Comparator.test",ae,this.loose),this.semver===pe||(typeof ae=="string"&&(ae=new V(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ae,fe){if(!(ae instanceof me))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Se(ae.value,fe),We(this.value,de,fe);if(ae.operator==="")return de=new Se(this.value,fe),We(ae.semver,de,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),ze=he(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ne=he(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ie||Pe||Fe&&Ae||ze||Ne},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),l("range",ae,fe);var de=fe?R[J]:R[F];ae=ae.replace(de,De),l("hyphen replace",ae),ae=ae.replace(R[W],"$1$2$3"),l("comparator trim",ae,R[W]),ae=(ae=(ae=ae.replace(R[M],"$1~")).replace(R[q],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[re]:R[K],Pe=ae.split(" ").map(function(Fe){return function(Ae,ze){return l("comp",Ae),Ae=function(Ne,Te){return Ne.trim().split(/\s+/).map(function(Be){return function(ie,ue){l("caret",ie,ue);var ge=ue?R[Q]:R[G];return ie.replace(ge,function(we,ve,Ce,Re,Le){var Oe;return l("caret",ie,we,ve,Ce,Re,Le),Ee(ve)?Oe="":Ee(Ce)?Oe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Re)?Oe=ve==="0"?">="+ve+"."+Ce+".0 <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+".0 <"+(+ve+1)+".0.0":Le?(l("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=ve==="0"?Ce==="0"?">="+ve+"."+Ce+"."+Re+Le+" <"+ve+"."+Ce+"."+(+Re+1):">="+ve+"."+Ce+"."+Re+Le+" <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+"."+Re+Le+" <"+(+ve+1)+".0.0"):(l("no pr"),Oe=ve==="0"?Ce==="0"?">="+ve+"."+Ce+"."+Re+" <"+ve+"."+Ce+"."+(+Re+1):">="+ve+"."+Ce+"."+Re+" <"+ve+"."+(+Ce+1)+".0":">="+ve+"."+Ce+"."+Re+" <"+(+ve+1)+".0.0"),l("caret return",Oe),Oe})}(Be,Te)}).join(" ")}(Ae,ze),l("caret",Ae),Ae=function(Ne,Te){return Ne.trim().split(/\s+/).map(function(Be){return function(ie,ue){var ge=ue?R[T]:R[$];return ie.replace(ge,function(we,ve,Ce,Re,Le){var Oe;return l("tilde",ie,we,ve,Ce,Re,Le),Ee(ve)?Oe="":Ee(Ce)?Oe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Re)?Oe=">="+ve+"."+Ce+".0 <"+ve+"."+(+Ce+1)+".0":Le?(l("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=">="+ve+"."+Ce+"."+Re+Le+" <"+ve+"."+(+Ce+1)+".0"):Oe=">="+ve+"."+Ce+"."+Re+" <"+ve+"."+(+Ce+1)+".0",l("tilde return",Oe),Oe})}(Be,Te)}).join(" ")}(Ae,ze),l("tildes",Ae),Ae=function(Ne,Te){return l("replaceXRanges",Ne,Te),Ne.split(/\s+/).map(function(Be){return function(ie,ue){ie=ie.trim();var ge=ue?R[E]:R[w];return ie.replace(ge,function(we,ve,Ce,Re,Le,Oe){l("xRange",ie,we,ve,Ce,Re,Le,Oe);var Ue=Ee(Ce),je=Ue||Ee(Re),qe=je||Ee(Le);return ve==="="&&qe&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&qe?(je&&(Re=0),qe&&(Le=0),ve===">"?(ve=">=",je?(Ce=+Ce+1,Re=0,Le=0):qe&&(Re=+Re+1,Le=0)):ve==="<="&&(ve="<",je?Ce=+Ce+1:Re=+Re+1),we=ve+Ce+"."+Re+"."+Le):je?we=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":qe&&(we=">="+Ce+"."+Re+".0 <"+Ce+"."+(+Re+1)+".0"),l("xRange return",we),we})}(Be,Te)}).join(" ")}(Ae,ze),l("xrange",Ae),Ae=function(Ne,Te){return l("replaceStars",Ne,Te),Ne.trim().replace(R[ee],"")}(Ae,ze),l("stars",Ae),Ae}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new me(Fe,fe)})},Se.prototype.intersects=function(ae,fe){if(!(ae instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ie){return ae.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ae,fe){return new Se(ae,fe).set.map(function(de){return de.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new V(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ae))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ae,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ae.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==-1||(Pe=new V(Ie=Ae,de)))}),Ie},e.minSatisfying=function(ae,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ae.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==1||(Pe=new V(Ie=Ae,de)))}),Ie},e.validRange=function(ae,fe){try{return new Se(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,de){return $e(ae,fe,"<",de)},e.gtr=function(ae,fe,de){return $e(ae,fe,">",de)},e.outside=$e,e.prerelease=function(ae,fe){var de=ce(ae,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ae,fe,de){return ae=new Se(ae,de),fe=new Se(fe,de),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof V)return ae;if(typeof ae!="string")return null;var fe=ae.match(R[k]);return fe==null?null:ce((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Z,e){var D,O,l=Z.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(h){if(D===setTimeout)return setTimeout(h,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(h,0);try{return D(h,0)}catch{try{return D.call(null,h,0)}catch{return D.call(this,h,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var I,S=[],P=!1,v=-1;function m(){P&&I&&(P=!1,I.length?S=I.concat(S):v=-1,S.length&&g())}function g(){if(!P){var h=R(m);P=!0;for(var u=S.length;u;){for(I=S,S=[];++v<u;)I&&I[v].run();v=-1,u=S.length}I=null,P=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(h)}}function f(h,u){this.fun=h,this.array=u}function p(){}l.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];S.push(new f(h,u)),S.length!==1||P||R(g)},f.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=p,l.addListener=p,l.once=p,l.off=p,l.removeListener=p,l.removeAllListeners=p,l.emit=p,l.prependListener=p,l.prependOnceListener=p,l.listeners=function(h){return[]},l.binding=function(h){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(h){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ne[131],se([0,1]),function(Z,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,I,S){this.level=R,this.key=I,this.value=S,this.forward=[]}}const l=void 0;class A{constructor(R,I=2**16){this.comparator=R,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new O(this.c,l,l)}get size(){return this.f}clear(){this.e=new O(this.c,l,l)}has(R){return Boolean(A.g(this,R,this.comparator))}get(R){return A.g(this,R,this.comparator)?.value}set(R,I){return A.h(this,R,I,this.comparator)&&(this.f+=1),this}delete(R){const I=A.k(this,R,this.comparator);return I&&(this.f-=1),I}forEach(R,I){let S=this.e.forward[0];for(;S;)R.call(I,S.value,S.key,this),S=S.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this.e.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static g(R,I,S){let P=R.e;for(let v=R.d-1;v>=0;v--)for(;P.forward[v]&&S(P.forward[v].key,I)<0;)P=P.forward[v];if(P=P.forward[0],P&&S(P.key,I)===0)return P}static h(R,I,S,P){const v=[];let m=R.e;for(let g=R.d-1;g>=0;g--){for(;m.forward[g]&&P(m.forward[g].key,I)<0;)m=m.forward[g];v[g]=m}if(m=m.forward[0],m&&P(m.key,I)===0)return m.value=S,!1;{const g=A.j(R);if(g>R.d){for(let f=R.d;f<g;f++)v[f]=R.e;R.d=g}m=new O(g,I,S);for(let f=0;f<g;f++)m.forward[f]=v[f].forward[f],v[f].forward[f]=m;return!0}}static j(R,I=.5){let S=1;for(;Math.random()<I&&S<R.c;)S+=1;return S}static k(R,I,S){const P=[];let v=R.e;for(let m=R.d-1;m>=0;m--){for(;v.forward[m]&&S(v.forward[m].key,I)<0;)v=v.forward[m];P[m]=v}if(v=v.forward[0],!v||S(v.key,I)!==0)return!1;for(let m=0;m<R.d&&P[m].forward[m]===v;m++)P[m].forward[m]=v.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===l;)R.d-=1;return!0}}e.SkipList=A}),define(ne[43],se([0,1,8,2]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(b){const C=b;return C?typeof C.read=="function":!1}e.isReadable=l;function A(b){const C=b;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function L(b){const C=b;return C?A(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=L;function R(b,C){return new I(b,C)}e.newWriteableStream=R;class I{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,D.onUnexpectedError)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let a;switch(C){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(b,C){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return C(t)}e.consumeReadable=S;function P(b,C,t){const a=[];let i;for(;(i=b.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?C(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return b.read()}}}e.peekReadable=P;function v(b,C){return new Promise((t,a)=>{const i=[];m(b,{onData:n=>{C&&i.push(n)},onError:n=>{C?a(n):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=v;function m(b,C){let t=!1;return b.on("error",a=>{t||C.onError(a)}),b.on("end",()=>{t||C.onEnd()}),b.on("data",a=>{t||C.onData(a)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=m;function g(b,C){return new Promise((t,a)=>{const i=new O.DisposableStore,n=[],r=c=>{if(n.push(c),n.length>C)return i.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},o=c=>a(c),s=()=>t({stream:b,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>b.removeListener("error",o))),b.on("error",o),i.add((0,O.toDisposable)(()=>b.removeListener("end",s))),b.on("end",s),i.add((0,O.toDisposable)(()=>b.removeListener("data",r))),b.on("data",r)})}e.peekStream=g;function f(b,C){const t=R(C);return t.end(b),t}e.toStream=f;function p(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=p;function h(b){let C=!1;return{read:()=>C?null:(C=!0,b)}}e.toReadable=h;function u(b,C,t){const a=R(t);return m(b,{onData:i=>a.write(C.data(i)),onError:i=>a.error(C.error?C.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function d(b,C,t){let a=!1;return{read:()=>{const i=C.read();return a?i:(a=!0,i!==null?t([b,i]):b)}}}e.prefixedReadable=d;function y(b,C,t){let a=!1;const i=R(t);return m(C,{onData:n=>a?i.write(n):(a=!0,i.write(t([b,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(b)),i.end()}}),i}e.prefixedStream=y}),define(ne[17],se([0,1,43]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let l,A;class L{static alloc(c){return O?new L(Buffer.allocUnsafe(c)):new L(new Uint8Array(c))}static wrap(c){return O&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new L(c)}static fromString(c,w){return!(w?.dontUseNodeBuffer||!1)&&O?new L(Buffer.from(c)):(l||(l=new TextEncoder),new L(l.encode(c)))}static fromByteArray(c){const w=L.alloc(c.length);for(let E=0,k=c.length;E<k;E++)w.buffer[E]=c[E];return w}static concat(c,w){if(typeof w>"u"){w=0;for(let N=0,M=c.length;N<M;N++)w+=c[N].byteLength}const E=L.alloc(w);let k=0;for(let N=0,M=c.length;N<M;N++){const $=c[N];E.set($,k),k+=$.byteLength}return E}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=L.alloc(this.byteLength);return c.set(this),c}toString(){return O?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(c,w){return new L(this.buffer.subarray(c,w))}set(c,w){if(c instanceof L)this.buffer.set(c.buffer,w);else if(c instanceof Uint8Array)this.buffer.set(c,w);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),w);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return S(this.buffer,c)}writeUInt32BE(c,w){P(this.buffer,c,w)}readUInt32LE(c){return v(this.buffer,c)}writeUInt32LE(c,w){m(this.buffer,c,w)}readUInt8(c){return g(this.buffer,c)}writeUInt8(c,w){f(this.buffer,c,w)}}e.VSBuffer=L;function R(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0}e.readUInt16LE=R;function I(s,c,w){s[w+0]=c&255,c=c>>>8,s[w+1]=c&255}e.writeUInt16LE=I;function S(s,c){return s[c]*2**24+s[c+1]*2**16+s[c+2]*2**8+s[c+3]}e.readUInt32BE=S;function P(s,c,w){s[w+3]=c,c=c>>>8,s[w+2]=c,c=c>>>8,s[w+1]=c,c=c>>>8,s[w]=c}e.writeUInt32BE=P;function v(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0|s[c+2]<<16>>>0|s[c+3]<<24>>>0}e.readUInt32LE=v;function m(s,c,w){s[w+0]=c&255,c=c>>>8,s[w+1]=c&255,c=c>>>8,s[w+2]=c&255,c=c>>>8,s[w+3]=c&255}e.writeUInt32LE=m;function g(s,c){return s[c]}e.readUInt8=g;function f(s,c,w){s[w]=c}e.writeUInt8=f;function p(s){return D.consumeReadable(s,c=>L.concat(c))}e.readableToBuffer=p;function h(s){return D.toReadable(s)}e.bufferToReadable=h;function u(s){return D.consumeStream(s,c=>L.concat(c))}e.streamToBuffer=u;async function d(s){return s.ended?L.concat(s.buffer):L.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=d;function y(s){return D.toStream(s,c=>L.concat(c))}e.bufferToStream=y;function b(s){return D.transform(s,{data:c=>typeof c=="string"?L.fromString(c):L.wrap(c)},c=>L.concat(c))}e.streamToBufferReadableStream=b;function C(s){return D.newWriteableStream(c=>L.concat(c),s)}e.newWriteableBufferStream=C;function t(s,c){return D.prefixedReadable(s,c,w=>L.concat(w))}e.prefixedBufferReadable=t;function a(s,c){return D.prefixedStream(s,c,w=>L.concat(w))}e.prefixedBufferStream=a;function i(s){let c=0,w=0,E=0;const k=new Uint8Array(Math.floor(s.length/4*3)),N=$=>{switch(w){case 3:k[E++]=c|$,w=0;break;case 2:k[E++]=c|$>>>2,c=$<<6,w=3;break;case 1:k[E++]=c|$>>>4,c=$<<4,w=2;break;default:c=$<<2,w=1}};for(let $=0;$<s.length;$++){const T=s.charCodeAt($);if(T>=65&&T<=90)N(T-65);else if(T>=97&&T<=122)N(T-97+26);else if(T>=48&&T<=57)N(T-48+52);else if(T===43||T===45)N(62);else if(T===47||T===95)N(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${s[$]}`)}}const M=E;for(;w>0;)N(0);return L.wrap(k).slice(0,M)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},c=!0,w=!1){const E=w?r:n;let k="";const N=s.byteLength%3;let M=0;for(;M<s.byteLength-N;M+=3){const $=s[M+0],T=s[M+1],B=s[M+2];k+=E[$>>>2],k+=E[($<<4|T>>>4)&63],k+=E[(T<<2|B>>>6)&63],k+=E[B&63]}if(N===1){const $=s[M+0];k+=E[$>>>2],k+=E[$<<4&63],c&&(k+="==")}else if(N===2){const $=s[M+0],T=s[M+1];k+=E[$>>>2],k+=E[($<<4|T>>>4)&63],k+=E[T<<2&63],c&&(k+="=")}return k}e.encodeBase64=o}),define(ne[132],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ne[12],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(a){return typeof a=="string"}e.isString=D;function O(a){return Array.isArray(a)&&a.every(i=>D(i))}e.isStringArray=O;function l(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=l;function A(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=A;function L(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=L;function R(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=R;function I(a){return a===!0||a===!1}e.isBoolean=I;function S(a){return typeof a>"u"}e.isUndefined=S;function P(a){return!v(a)}e.isDefined=P;function v(a){return S(a)||a===null}e.isUndefinedOrNull=v;function m(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=m;function g(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=g;function f(...a){const i=[];for(let n=0;n<a.length;n++){const r=a[n];if(v(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(r)}return i}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function h(a){if(!l(a))return!1;for(const i in a)if(p.call(a,i))return!1;return!0}e.isEmptyObject=h;function u(a){return typeof a=="function"}e.isFunction=u;function d(...a){return a.length>0&&a.every(u)}e.areFunctions=d;function y(a,i){const n=Math.min(a.length,i.length);for(let r=0;r<n;r++)b(a[r],i[r])}e.validateConstraints=y;function b(a,i){if(D(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!v(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function C(a){return a===null?void 0:a}e.withNullAsUndefined=C;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ne[52],se([0,1,12]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function l(R,I){if((0,D.isString)(I)){const S=O[I];if(S===void 0)throw new Error(`${R} references an unknown codicon: ${I}`);I=S}return O[R]=I,{id:R}}function A(){return O}e.getCodiconFontCharacters=A;function L(){return Object.values(e.Codicon)}e.getAllCodicons=L,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ne[32],se([0,1,12]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([y,b])=>{d[y]=b&&typeof b=="object"?O(b):b}),d}e.deepClone=O;function l(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const y=d.shift();Object.freeze(y);for(const b in y)if(A.call(y,b)){const C=y[b];typeof C=="object"&&!Object.isFrozen(C)&&!(0,D.isTypedArray)(C)&&d.push(C)}}return u}e.deepFreeze=l;const A=Object.prototype.hasOwnProperty;function L(u,d){return R(u,d,new Set)}e.cloneAndChange=L;function R(u,d,y){if((0,D.isUndefinedOrNull)(u))return u;const b=d(u);if(typeof b<"u")return b;if(Array.isArray(u)){const C=[];for(const t of u)C.push(R(t,d,y));return C}if((0,D.isObject)(u)){if(y.has(u))throw new Error("Cannot clone recursive data-structure");y.add(u);const C={};for(const t in u)A.call(u,t)&&(C[t]=R(u[t],d,y));return y.delete(u),C}return u}function I(u,d,y=!0){return(0,D.isObject)(u)?((0,D.isObject)(d)&&Object.keys(d).forEach(b=>{b in u?y&&((0,D.isObject)(u[b])&&(0,D.isObject)(d[b])?I(u[b],d[b],y):u[b]=d[b]):u[b]=d[b]}),u):d}e.mixin=I;function S(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let y,b;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(y=0;y<u.length;y++)if(!S(u[y],d[y]))return!1}else{const C=[];for(b in u)C.push(b);C.sort();const t=[];for(b in d)t.push(b);if(t.sort(),!S(C,t))return!1;for(y=0;y<C.length;y++)if(!S(u[C[y]],d[C[y]]))return!1}return!0}e.equals=S;function P(u){const d=new Set;return JSON.stringify(u,(y,b)=>{if((0,D.isObject)(b)||Array.isArray(b)){if(d.has(b))return"[Circular]";d.add(b)}return b})}e.safeStringify=P;function v(u,d){const y=Object.create(null);return!u||!d||Object.keys(d).forEach(C=>{const t=u[C],a=d[C];S(t,a)||(y[C]=a)}),y}e.distinct=v;function m(u,d){const y=d.toLowerCase(),b=Object.keys(u).find(C=>C.toLowerCase()===y);return b?u[b]:u[d]}e.getCaseInsensitive=m;function g(u,d){const y=Object.create(null);for(const[b,C]of Object.entries(u))d(b,C)&&(y[b]=C);return y}e.filter=g;function f(u){let d=[],y=Object.getPrototypeOf(u);for(;Object.prototype!==y;)d=d.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return d}e.getAllPropertyNames=f;function p(u){const d=[];for(const y of f(u))typeof u[y]=="function"&&d.push(y);return d}e.getAllMethodNames=p;function h(u,d){const y=C=>function(){const t=Array.prototype.slice.call(arguments,0);return d(C,t)},b={};for(const C of u)b[C]=y(C);return b}e.createProxyObject=h}),define(ne[133],se([0,1,52]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(L){function R(I){return I&&typeof I=="object"&&typeof I.id=="string"}L.isThemeColor=R})(O=e.ThemeColor||(e.ThemeColor={}));function l(L){return{id:L}}e.themeColorFromId=l;var A;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function I(d){const y=R.exec(d.id);if(!y)return I(D.Codicon.error);const[,b,C]=y,t=["codicon","codicon-"+b];return C&&t.push("codicon-modifier-"+C.substring(1)),t}L.asClassNameArray=I;function S(d){return I(d).join(" ")}L.asClassName=S;function P(d){return"."+I(d).join(".")}L.asCSSSelector=P;function v(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||O.isThemeColor(d.color))}L.isThemeIcon=v;const m=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function g(d){const y=m.exec(d);if(!y)return;const[,b]=y;return{id:b}}L.fromString=g;function f(d){return{id:d}}L.fromId=f;function p(d,y){let b=d.id;const C=b.lastIndexOf("~");return C!==-1&&(b=b.substring(0,C)),y&&(b=`${b}~${y}`),{id:b}}L.modify=p;function h(d){const y=d.id.lastIndexOf("~");if(y!==-1)return d.id.substring(y+1)}L.getModifier=h;function u(d,y){return d.id===y.id&&d.color?.id===y.color?.id}L.isEqual=u})(A=e.ThemeIcon||(e.ThemeIcon={}))}),define(ne[31],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(l){return D.test(l)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){l(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,S="";return S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S}}()}),define(ne[134],se([0,1,34]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(L){const R=L.replace(/\-/g,":").toLowerCase();return!O.has(R)}function A(){const L=(0,D.networkInterfaces)();for(const R in L){const I=L[R];if(I){for(const{mac:S}of I)if(l(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[135],se([0,1,86]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,I,S,P=1){let v=!1;return new Promise(m=>{const g=setTimeout(()=>{if(!v)return v=!0,m(0)},S);l(R,I,P,f=>{if(!v)return v=!0,clearTimeout(g),m(f)})})}e.findFreePort=O;function l(R,I,S,P){if(I===0)return P(0);const v=new D.Socket;v.once("connect",()=>(L(v),l(R+S,I-1,S,P))),v.once("data",()=>{}),v.once("error",m=>(L(v),m.code!=="ECONNREFUSED"?l(R+S,I-1,S,P):P(R))),v.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,I,S,P="127.0.0.1"){let v=!1,m,g=1;const f=D.createServer({pauseOnConnect:!0});function p(h,u){v||(v=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),u(h))}return new Promise(h=>{m=setTimeout(()=>{p(0,h)},S),f.on("listening",()=>{p(R,h)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&g<I?(R++,g++,f.listen(R,P)):p(0,h)}),f.on("close",()=>{p(0,h)}),f.listen(R,P)})}e.findFreePortFaster=A;function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(ne[136],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function O(A){return A instanceof l?!0:A instanceof Error&&A.name===D&&A.message===D}e.isOfflineError=O;class l extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=l}),define(ne[137],se([0,1,17,8,136]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(I,S){I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((v,m)=>{P.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(P,I),P.responseType="arraybuffer",P.onerror=g=>m(navigator.onLine?new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed"):new l.OfflineError),P.onload=g=>{v({res:{statusCode:P.status,headers:R(P)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=g=>m(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(P.timeout=I.timeout),P.send(I.data),S.onCancellationRequested(()=>{P.abort(),m((0,O.canceled)())})})}e.request=A;function L(I,S){if(S.headers){e:for(const P in S.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(P,S.headers[P])}}}function R(I){const S=Object.create(null);for(const P of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const v=P.indexOf(":");S[P.substr(0,v).trim().toLowerCase()]=P.substr(v+1).trim()}return S}}),define(ne[138],se([9,7]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ne[65],se([0,1,138]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,l=O*60,A=l*24,L=A*7,R=A*30,I=A*365;function S(v,m,g,f){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,D.localize)(0,null,S(new Date().getTime()+p*1e3,!1));if(!f&&p<30)return(0,D.localize)(1,null);let h;return p<O?(h=p,m?h===1?g?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):g?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h):h===1?g?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):g?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):p<l?(h=Math.floor(p/O),m?h===1?g?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):g?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h):h===1?g?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):g?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):p<A?(h=Math.floor(p/l),m?h===1?g?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):g?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h):h===1?g?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):g?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):p<L?(h=Math.floor(p/A),m?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h)):p<R?(h=Math.floor(p/L),m?h===1?g?(0,D.localize)(30,null,h):(0,D.localize)(31,null,h):g?(0,D.localize)(32,null,h):(0,D.localize)(33,null,h):h===1?g?(0,D.localize)(34,null,h):(0,D.localize)(35,null,h):g?(0,D.localize)(36,null,h):(0,D.localize)(37,null,h)):p<I?(h=Math.floor(p/R),m?h===1?g?(0,D.localize)(38,null,h):(0,D.localize)(39,null,h):g?(0,D.localize)(40,null,h):(0,D.localize)(41,null,h):h===1?g?(0,D.localize)(42,null,h):(0,D.localize)(43,null,h):g?(0,D.localize)(44,null,h):(0,D.localize)(45,null,h)):(h=Math.floor(p/I),m?h===1?g?(0,D.localize)(46,null,h):(0,D.localize)(47,null,h):g?(0,D.localize)(48,null,h):(0,D.localize)(49,null,h):h===1?g?(0,D.localize)(50,null,h):(0,D.localize)(51,null,h):g?(0,D.localize)(52,null,h):(0,D.localize)(53,null,h))}e.fromNow=S;function P(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[139],se([9,7]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ne[38],se([0,1,20,12,139]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(v,m){return m&&(v.stack||v.stacktrace)?l.localize(0,null,R(v),L(v.stack)||L(v.stacktrace)):R(v)}function L(v){return Array.isArray(v)?v.join(`
`):v}function R(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?l.localize(1,null,v.message):v.message||l.localize(2,null)}function I(v=null,m=!1){if(!v)return l.localize(3,null);if(Array.isArray(v)){const g=D.coalesce(v),f=I(g[0],m);return g.length>1?l.localize(4,null,f,g.length):f}if(O.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return A(g.error,m);if(g.exception)return A(g.exception,m)}return v.stack?A(v,m):v.message?v.message:l.localize(5,null)}e.toErrorMessage=I;function S(v){const m=v;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=S;function P(v,m){let g;return typeof v=="string"?g=new Error(v):g=v,g.actions=m,g}e.createErrorWithActions=P}),define(ne[140],se([9,7]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(ne[141],se([0,1,140]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(l){switch(l){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ne[142],se([9,7]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(ne[4],se([0,1,142]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,l=!1,A=!1,L=!1,R=!1,I=!1,S=!1,P=!1,v=!1,m=!1,g,f=e.LANGUAGE_DEFAULT,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const d=typeof u?.versions?.electron=="string",y=d&&u?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,O=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,I=!0,g=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=g;else if(typeof u=="object"){O=u.platform==="win32",l=u.platform==="darwin",A=u.platform==="linux",L=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=d,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),w=c.availableLanguages["*"];g=c.locale,f=w||e.LANGUAGE_DEFAULT,p=c._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function C(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let t=0;l?t=1:O?t=3:A&&(t=2),e.isWindows=O,e.isMacintosh=l,e.isLinux=A,e.isLinuxSnap=L,e.isNative=R,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=m,e.isCI=v,e.platform=t,e.userAgent=h,e.language=f;var a;(function(s){function c(){return e.language}s.value=c;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=w;function E(){return e.language==="en"}s.isDefault=E})(a=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let E=0,k=s.length;E<k;E++){const N=s[E];if(N.id===w.data.vscodeScheduleAsyncWork){s.splice(E,1),N.callback();return}}});let c=0;return w=>{const E=++c;s.push({id:E,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||P?2:O?1:3;let n=!0,r=!1;function o(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],se([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const l=D.globals.vscode.process;O={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(ne[13],se([0,1,36]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,l=97,A=90,L=122,R=46,I=47,S=92,P=58,v=63;class m extends Error{constructor(a,i,n){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const o=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${o} ${r} of type ${i}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,a){if(t===null||typeof t!="object")throw new m(a,"Object",t)}function f(t,a){if(typeof t!="string")throw new m(a,"string",t)}const p=D.platform==="win32";function h(t){return t===I||t===S}function u(t){return t===I}function d(t){return t>=O&&t<=A||t>=l&&t<=L}function y(t,a,i,n){let r="",o=0,s=-1,c=0,w=0;for(let E=0;E<=t.length;++E){if(E<t.length)w=t.charCodeAt(E);else{if(n(w))break;w=I}if(n(w)){if(!(s===E-1||c===1))if(c===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const k=r.lastIndexOf(i);k===-1?(r="",o=0):(r=r.slice(0,k),o=r.length-1-r.lastIndexOf(i)),s=E,c=0;continue}else if(r.length!==0){r="",o=0,s=E,c=0;continue}}a&&(r+=r.length>0?`${i}..`:"..",o=2)}else r.length>0?r+=`${i}${t.slice(s+1,E)}`:r=t.slice(s+1,E),o=E-s-1;s=E,c=0}else w===R&&c!==-1?++c:c=-1}return r}function b(t,a){g(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let r=t.length-1;r>=-1;r--){let o;if(r>=0){if(o=t[r],f(o,"path"),o.length===0)continue}else a.length===0?o=D.cwd():(o=D.env[`=${a}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===S)&&(o=`${a}\\`));const s=o.length;let c=0,w="",E=!1;const k=o.charCodeAt(0);if(s===1)h(k)&&(c=1,E=!0);else if(h(k))if(E=!0,h(o.charCodeAt(1))){let N=2,M=N;for(;N<s&&!h(o.charCodeAt(N));)N++;if(N<s&&N!==M){const $=o.slice(M,N);for(M=N;N<s&&h(o.charCodeAt(N));)N++;if(N<s&&N!==M){for(M=N;N<s&&!h(o.charCodeAt(N));)N++;(N===s||N!==M)&&(w=`\\\\${$}\\${o.slice(M,N)}`,c=N)}}}else c=1;else d(k)&&o.charCodeAt(1)===P&&(w=o.slice(0,2),c=2,s>2&&h(o.charCodeAt(2))&&(E=!0,c=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(n){if(a.length>0)break}else if(i=`${o.slice(c)}\\${i}`,n=E,E&&a.length>0)break}return i=y(i,!n,"\\",h),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){f(t,"path");const a=t.length;if(a===0)return".";let i=0,n,r=!1;const o=t.charCodeAt(0);if(a===1)return u(o)?"\\":t;if(h(o))if(r=!0,h(t.charCodeAt(1))){let c=2,w=c;for(;c<a&&!h(t.charCodeAt(c));)c++;if(c<a&&c!==w){const E=t.slice(w,c);for(w=c;c<a&&h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&!h(t.charCodeAt(c));)c++;if(c===a)return`\\\\${E}\\${t.slice(w)}\\`;c!==w&&(n=`\\\\${E}\\${t.slice(w,c)}`,i=c)}}}else i=1;else d(o)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),i=2,a>2&&h(t.charCodeAt(2))&&(r=!0,i=3));let s=i<a?y(t.slice(i),!r,"\\",h):"";return s.length===0&&!r&&(s="."),s.length>0&&h(t.charCodeAt(a-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(t){f(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return h(i)||a>2&&d(i)&&t.charCodeAt(1)===P&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let o=0;o<t.length;++o){const s=t[o];f(s,"path"),s.length>0&&(a===void 0?a=i=s:a+=`\\${s}`)}if(a===void 0)return".";let n=!0,r=0;if(typeof i=="string"&&h(i.charCodeAt(0))){++r;const o=i.length;o>1&&h(i.charCodeAt(1))&&(++r,o>2&&(h(i.charCodeAt(2))?++r:n=!1))}if(n){for(;r<a.length&&h(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(t,a){if(f(t,"from"),f(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===S;)r++;let o=t.length;for(;o-1>r&&t.charCodeAt(o-1)===S;)o--;const s=o-r;let c=0;for(;c<a.length&&a.charCodeAt(c)===S;)c++;let w=a.length;for(;w-1>c&&a.charCodeAt(w-1)===S;)w--;const E=w-c,k=s<E?s:E;let N=-1,M=0;for(;M<k;M++){const T=t.charCodeAt(r+M);if(T!==a.charCodeAt(c+M))break;T===S&&(N=M)}if(M!==k){if(N===-1)return n}else{if(E>k){if(a.charCodeAt(c+M)===S)return n.slice(c+M+1);if(M===2)return n.slice(c+M)}s>k&&(t.charCodeAt(r+M)===S?N=M:M===2&&(N=3)),N===-1&&(N=0)}let $="";for(M=r+N+1;M<=o;++M)(M===o||t.charCodeAt(M)===S)&&($+=$.length===0?"..":"\\..");return c+=N,$.length>0?`${$}${n.slice(c,w)}`:(n.charCodeAt(c)===S&&++c,n.slice(c,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===S){if(a.charCodeAt(1)===S){const i=a.charCodeAt(2);if(i!==v&&i!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===S)return`\\\\?\\${a}`;return t},dirname(t){f(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const r=t.charCodeAt(0);if(a===1)return h(r)?t:".";if(h(r)){if(i=n=1,h(t.charCodeAt(1))){let c=2,w=c;for(;c<a&&!h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&!h(t.charCodeAt(c));)c++;if(c===a)return t;c!==w&&(i=n=c+1)}}}}else d(r)&&t.charCodeAt(1)===P&&(i=a>2&&h(t.charCodeAt(2))?3:2,n=i);let o=-1,s=!0;for(let c=a-1;c>=n;--c)if(h(t.charCodeAt(c))){if(!s){o=c;break}}else s=!1;if(o===-1){if(i===-1)return".";o=i}return t.slice(0,o)},basename(t,a){a!==void 0&&f(a,"ext"),f(t,"path");let i=0,n=-1,r=!0,o;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=i;--o){const w=t.charCodeAt(o);if(h(w)){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(w===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=i;--o)if(h(t.charCodeAt(o))){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){f(t,"path");let a=0,i=-1,n=0,r=-1,o=!0,s=0;t.length>=2&&t.charCodeAt(1)===P&&d(t.charCodeAt(0))&&(a=n=2);for(let c=t.length-1;c>=a;--c){const w=t.charCodeAt(c);if(h(w)){if(!o){n=c+1;break}continue}r===-1&&(o=!1,r=c+1),w===R?i===-1?i=c:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||r===-1||s===0||s===1&&i===r-1&&i===n+1?"":t.slice(i,r)},format:b.bind(null,"\\"),parse(t){f(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,r=t.charCodeAt(0);if(i===1)return h(r)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(h(r)){if(n=1,h(t.charCodeAt(1))){let N=2,M=N;for(;N<i&&!h(t.charCodeAt(N));)N++;if(N<i&&N!==M){for(M=N;N<i&&h(t.charCodeAt(N));)N++;if(N<i&&N!==M){for(M=N;N<i&&!h(t.charCodeAt(N));)N++;N===i?n=N:N!==M&&(n=N+1)}}}}else if(d(r)&&t.charCodeAt(1)===P){if(i<=2)return a.root=a.dir=t,a;if(n=2,h(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let o=-1,s=n,c=-1,w=!0,E=t.length-1,k=0;for(;E>=n;--E){if(r=t.charCodeAt(E),h(r)){if(!w){s=E+1;break}continue}c===-1&&(w=!1,c=E+1),r===R?o===-1?o=E:k!==1&&(k=1):o!==-1&&(k=-1)}return c!==-1&&(o===-1||k===0||k===1&&o===c-1&&o===s+1?a.base=a.name=t.slice(s,c):(a.name=t.slice(s,o),a.base=t.slice(s,c),a.ext=t.slice(o,c))),s>0&&s!==n?a.dir=t.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(p){const t=/\\/g;return()=>{const a=D.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const r=n>=0?t[n]:C();f(r,"path"),r.length!==0&&(a=`${r}/${a}`,i=r.charCodeAt(0)===I)}return a=y(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I,i=t.charCodeAt(t.length-1)===I;return t=y(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===I},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];f(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(f(t,"from"),f(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,r=n-i,o=1,s=a.length-o,c=r<s?r:s;let w=-1,E=0;for(;E<c;E++){const N=t.charCodeAt(i+E);if(N!==a.charCodeAt(o+E))break;N===I&&(w=E)}if(E===c)if(s>c){if(a.charCodeAt(o+E)===I)return a.slice(o+E+1);if(E===0)return a.slice(o+E)}else r>c&&(t.charCodeAt(i+E)===I?w=E:E===0&&(w=0));let k="";for(E=i+w+1;E<=n;++E)(E===n||t.charCodeAt(E)===I)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(o+w)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I;let i=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===I){if(!n){i=r;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&f(a,"ext"),f(t,"path");let i=0,n=-1,r=!0,o;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=0;--o){const w=t.charCodeAt(o);if(w===I){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(w===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===I){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){f(t,"path");let a=-1,i=0,n=-1,r=!0,o=0;for(let s=t.length-1;s>=0;--s){const c=t.charCodeAt(s);if(c===I){if(!r){i=s+1;break}continue}n===-1&&(r=!1,n=s+1),c===R?a===-1?a=s:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||n===-1||o===0||o===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){f(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===I;let n;i?(a.root="/",n=1):n=0;let r=-1,o=0,s=-1,c=!0,w=t.length-1,E=0;for(;w>=n;--w){const k=t.charCodeAt(w);if(k===I){if(!c){o=w+1;break}continue}s===-1&&(c=!1,s=w+1),k===R?r===-1?r=w:E!==1&&(E=1):r!==-1&&(E=-1)}if(s!==-1){const k=o===0&&i?1:o;r===-1||E===0||E===1&&r===s-1&&r===o+1?a.base=a.name=t.slice(k,s):(a.name=t.slice(k,r),a.base=t.slice(k,s),a.ext=t.slice(r,s))}return o>0?a.dir=t.slice(0,o-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ne[143],se([0,1,13]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const v=(0,D.extname)(P),m=O[v.toLowerCase()];return m!==void 0?m:L(P)}e.getMediaOrTextMime=A;function L(P){const v=(0,D.extname)(P);return l[v.toLowerCase()]}e.getMediaMime=L;function R(P){for(const v in l)if(l[v]===P)return v}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function S(P,v){const m=I.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:v?void 0:P}e.normalizeMimeType=S}),define(ne[87],se([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...I){const S=I.reduce((m,g)=>(m[g]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!S[m]).forEach(m=>{for(let g=0;g<P.length;g++)if(m.search(P[g])!==-1){delete R[m];break}})}e.sanitizeProcessEnvironment=A;function L(R){!R||(delete R.DEBUG,D.isMacintosh&&delete R.DYLD_LIBRARY_PATH,D.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(ne[88],se([0,1,4]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=D.globals.performance&&typeof D.globals.performance.now=="function";class l{static create(L=!0){return new l(L)}constructor(L){this.a=O&&L,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ne[3],se([0,1,8,82,2,84,88]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var S;(function(o){o.None=()=>l.Disposable.None;function s(z){if(I){const{onDidAddListener:x}=z,_=f.create();let H=0;z.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),x?.()}}}function c(z,x){return q(z,()=>{},0,void 0,!0,void 0,x)}o.defer=c;function w(z){return(x,_=null,H)=>{let X=!1,te;return te=z(le=>{if(!X)return te?te.dispose():X=!0,x.call(_,le)},null,H),X&&te.dispose(),te}}o.once=w;function E(z,x,_){return B((H,X=null,te)=>z(le=>H.call(X,x(le)),null,te),_)}o.map=E;function k(z,x,_){return B((H,X=null,te)=>z(le=>{x(le),H.call(X,le)},null,te),_)}o.forEach=k;function N(z,x,_){return B((H,X=null,te)=>z(le=>x(le)&&H.call(X,le),null,te),_)}o.filter=N;function M(z){return z}o.signal=M;function $(...z){return(x,_=null,H)=>(0,l.combinedDisposable)(...z.map(X=>X(te=>x.call(_,te),null,H)))}o.any=$;function T(z,x,_,H){let X=_;return E(z,te=>(X=x(X,te),X),H)}o.reduce=T;function B(z,x){let _;const H={onWillAddFirstListener(){_=z(X.fire,X)},onDidRemoveLastListener(){_?.dispose()}};x||s(H);const X=new h(H);return x?.add(X),X.event}function q(z,x,_=100,H=!1,X=!1,te,le){let he,me,pe,Se=0,Ee;const De={leakWarningThreshold:te,onWillAddFirstListener(){he=z(We=>{Se++,me=x(me,We),H&&!pe&&(ke.fire(me),me=void 0),Ee=()=>{const $e=me;me=void 0,pe=void 0,(!H||Se>1)&&ke.fire($e),Se=0},typeof _=="number"?(clearTimeout(pe),pe=setTimeout(Ee,_)):pe===void 0&&(pe=0,queueMicrotask(Ee))})},onWillRemoveListener(){X&&Se>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,he.dispose()}};le||s(De);const ke=new h(De);return le?.add(ke),ke.event}o.debounce=q;function G(z,x=0,_){return o.debounce(z,(H,X)=>H?(H.push(X),H):[X],x,void 0,!0,void 0,_)}o.accumulate=G;function Q(z,x=(H,X)=>H===X,_){let H=!0,X;return N(z,te=>{const le=H||!x(te,X);return H=!1,X=te,le},_)}o.latch=Q;function re(z,x,_){return[o.filter(z,x,_),o.filter(z,H=>!x(H),_)]}o.split=re;function K(z,x=!1,_=[]){let H=_.slice(),X=z(he=>{H?H.push(he):le.fire(he)});const te=()=>{H?.forEach(he=>le.fire(he)),H=null},le=new h({onWillAddFirstListener(){X||(X=z(he=>le.fire(he)))},onDidAddFirstListener(){H&&(x?setTimeout(te):te())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return le.event}o.buffer=K;class W{constructor(x){this.event=x,this.c=new l.DisposableStore}map(x){return new W(E(this.event,x,this.c))}forEach(x){return new W(k(this.event,x,this.c))}filter(x){return new W(N(this.event,x,this.c))}reduce(x,_){return new W(T(this.event,x,_,this.c))}latch(){return new W(Q(this.event,void 0,this.c))}debounce(x,_=100,H=!1,X=!1,te){return new W(q(this.event,x,_,H,X,te,this.c))}on(x,_,H){return this.event(x,_,H)}once(x,_,H){return w(this.event)(x,_,H)}dispose(){this.c.dispose()}}function F(z){return new W(z)}o.chain=F;function J(z,x,_=H=>H){const H=(...he)=>le.fire(_(...he)),X=()=>z.on(x,H),te=()=>z.removeListener(x,H),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}o.fromNodeEventEmitter=J;function ee(z,x,_=H=>H){const H=(...he)=>le.fire(_(...he)),X=()=>z.addEventListener(x,H),te=()=>z.removeEventListener(x,H),le=new h({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}o.fromDOMEventEmitter=ee;function oe(z){return new Promise(x=>w(z)(x))}o.toPromise=oe;function ce(z,x){return x(void 0),z(_=>x(_))}o.runAndSubscribe=ce;function V(z,x){let _=null;function H(te){_?.dispose(),_=new l.DisposableStore,x(te,_)}H(void 0);const X=z(te=>H(te));return(0,l.toDisposable)(()=>{X.dispose(),_?.dispose()})}o.runAndSubscribeWithStore=V;class j{constructor(x,_){this.obs=x,this.c=0,this.d=!1;const H={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};_||s(H),this.emitter=new h(H),_&&_.add(this.emitter)}beginUpdate(x){this.c++}handleChange(x,_){this.d=!0}endUpdate(x){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(z,x){return new j(z,x).emitter.event}o.fromObservable=U})(S=e.Event||(e.Event={}));class P{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${P.c++}`,P.all.add(this)}start(s){this.d=new L.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let v=-1;function m(o){const s=v;return v=o,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=m;class g{constructor(s,c=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=c,this.d=0}dispose(){this.c?.clear()}check(s,c){const w=this.threshold;if(w<=0||c<w)return;this.c||(this.c=new Map);const E=this.c.get(s.value)||0;if(this.c.set(s.value,E+1),this.d-=1,this.d<=0){this.d=w*.5;let k,N=0;for(const[M,$]of this.c)(!k||N<$)&&(k=M,N=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${N}):`),console.warn(k)}return()=>{const k=this.c.get(s.value)||0;this.c.set(s.value,k-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,c,w){this.callback=s,this.callbackThis=c,this.stack=w,this.subscription=new l.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class h{constructor(s){this.j=!1,this.d=s,this.f=v>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const s=Array.from(this.q);queueMicrotask(()=>{for(const c of s)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,c,w)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let k,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=f.create(),k=this.f.check(N,this.q.size+1)),R&&(N=N??f.create());const M=new p(s,c,N),$=this.q.push(M);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,c);const T=M.subscription.set(()=>{k?.(),this.j||(this.d?.onWillRemoveListener?.(this),$(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof l.DisposableStore?w.add(T):Array.isArray(w)&&w.push(T),T}),this.l}fire(s){if(this.q){this.m||(this.m=new d);for(const c of this.q)this.m.push(this,c,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class u{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(s,c,w){this.c.push(new y(s,c,w))}clear(s){const c=new A.LinkedList;for(const w of this.c)w.emitter!==s&&c.push(w);this.c=c}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(c){(0,D.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=u;class d extends u{clear(s){this.c.clear()}}class y{constructor(s,c,w){this.emitter=s,this.listener=c,this.event=w}}class b extends h{async fireAsync(s,c,w){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const E of this.q)this.c.push([E,s]);for(;this.c.size>0&&!c.isCancellationRequested;){const[E,k]=this.c.shift(),N=[],M={...k,token:c,waitUntil:$=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");w&&($=w($,E.callback)),N.push($)}};try{E.invoke(M)}catch($){(0,D.onUnexpectedError)($);continue}Object.freeze(N),await Promise.allSettled(N).then($=>{for(const T of $)T.status==="rejected"&&(0,D.onUnexpectedError)(T.reason)})}}}}e.AsyncEmitter=b;class C extends h{constructor(s){super(s),this.h=0,this.s=new A.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=C;class t extends C{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class a extends h{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(c=>super.fire(c)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const c={event:s,listener:null};this.f.push(c),this.d&&this.j(c);const w=()=>{this.d&&this.k(c);const E=this.f.indexOf(c);this.f.splice(E,1)};return(0,l.toDisposable)((0,O.once)(w))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(c=>this.c.fire(c))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(s){return(c,w,E)=>s(k=>{const N=this.c[this.c.length-1];N?N.push(()=>c.call(w,k)):c.call(w,k)},void 0,E)}bufferEvents(s){const c=[];this.c.push(c);const w=s();return this.c.pop(),c.forEach(E=>E()),w}}e.EventBufferer=n;class r{constructor(){this.c=!1,this.d=S.None,this.f=l.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ne[24],se([0,1,3]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,I){const S=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(S)}}});var l;(function(R){function I(S){return S===R.None||S===R.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(l=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=L}),define(ne[144],se([0,1,24]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new D.CancellationTokenSource,I=this.b(R.token);return this.a={promise:I,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=O;class l{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const I=JSON.stringify(R);return this.b!==I&&(this.b=I,this.a=this.c(R)),this.a}}e.LRUCachedFunction=l;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const I=this.b(R);return this.a.set(R,I),I}}e.CachedFunction=A}),define(ne[26],se([0,1,144,129]),function(Z,e,D,O){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=A;const L=/{(\d+)}/g;function R(ie,...ue){return ue.length===0?ie:ie.replace(L,function(ge,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?ge:ue[ve]})}e.format=R;const I=/{([^}]+)}/g;function S(ie,ue){return ie.replace(I,(ge,we)=>ue[we]??ge)}e.format2=S;function P(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function v(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function m(ie,ue){let ge=0;const we=ue.charCodeAt(0);for(let ve=ie.length-1;ve>=0;ve--)ie.charCodeAt(ve)===we&&ge++;return ge}e.count=m;function g(ie,ue,ge="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${ge}`}e.truncate=g;function f(ie,ue=" "){const ge=p(ie,ue);return h(ge,ue)}e.trim=f;function p(ie,ue){if(!ie||!ue)return ie;const ge=ue.length;if(ge===0||ie.length===0)return ie;let we=0;for(;ie.indexOf(ue,we)===we;)we=we+ge;return ie.substring(we)}e.ltrim=p;function h(ie,ue){if(!ie||!ue)return ie;const ge=ue.length,we=ie.length;if(ge===0||we===0)return ie;let ve=we,Ce=-1;for(;Ce=ie.lastIndexOf(ue,ve-1),!(Ce===-1||Ce+ge!==ve);){if(Ce===0)return"";ve=Ce}return ie.substring(0,ve)}e.rtrim=h;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function y(ie,ue,ge={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=v(ie)),ge.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let we="";return ge.global&&(we+="g"),ge.matchCase||(we+="i"),ge.multiline&&(we+="m"),ge.unicode&&(we+="u"),new RegExp(ie,we)}e.createRegExp=y;function b(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=t;function a(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=a;function i(ie){for(let ue=0,ge=ie.length;ue<ge;ue++){const we=ie.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function n(ie,ue=0,ge=ie.length){for(let we=ue;we<ge;we++){const ve=ie.charCodeAt(we);if(ve!==32&&ve!==9)return ie.substring(ue,we)}return ie.substring(ue,ge)}e.getLeadingWhitespace=n;function r(ie,ue=ie.length-1){for(let ge=ue;ge>=0;ge--){const we=ie.charCodeAt(ge);if(we!==32&&we!==9)return ge}return-1}e.lastNonWhitespaceIndex=r;function o(ie,ue,ge){const we=[];let ve=0;for(const Ce of ie.matchAll(ue)){if(we.push(ie.slice(ve,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ve=Ce.index+Ce[0].length,we.push(ge(Ce[0],...Ce.slice(1),Ce.index,ie,Ce.groups))}return we.push(ie.slice(ve)),Promise.all(we).then(Ce=>Ce.join(""))}e.replaceAsync=o;function s(ie,ue){return ie<ue?-1:ie>ue?1:0}e.compare=s;function c(ie,ue,ge=0,we=ie.length,ve=0,Ce=ue.length){for(;ge<we&&ve<Ce;ge++,ve++){const Oe=ie.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Oe<Ue)return-1;if(Oe>Ue)return 1}const Re=we-ge,Le=Ce-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstring=c;function w(ie,ue){return E(ie,ue,0,ie.length,0,ue.length)}e.compareIgnoreCase=w;function E(ie,ue,ge=0,we=ie.length,ve=0,Ce=ue.length){for(;ge<we&&ve<Ce;ge++,ve++){let Oe=ie.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Oe===Ue)continue;if(Oe>=128||Ue>=128)return c(ie.toLowerCase(),ue.toLowerCase(),ge,we,ve,Ce);N(Oe)&&(Oe-=32),N(Ue)&&(Ue-=32);const je=Oe-Ue;if(je!==0)return je}const Re=we-ge,Le=Ce-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstringIgnoreCase=E;function k(ie){return ie>=48&&ie<=57}e.isAsciiDigit=k;function N(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=N;function M(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=M;function $(ie,ue){return ie.length===ue.length&&E(ie,ue)===0}e.equalsIgnoreCase=$;function T(ie,ue){const ge=ue.length;return ue.length>ie.length?!1:E(ie,ue,0,ge)===0}e.startsWithIgnoreCase=T;function B(ie,ue){const ge=Math.min(ie.length,ue.length);let we;for(we=0;we<ge;we++)if(ie.charCodeAt(we)!==ue.charCodeAt(we))return we;return ge}e.commonPrefixLength=B;function q(ie,ue){const ge=Math.min(ie.length,ue.length);let we;const ve=ie.length-1,Ce=ue.length-1;for(we=0;we<ge;we++)if(ie.charCodeAt(ve-we)!==ue.charCodeAt(Ce-we))return we;return ge}e.commonSuffixLength=q;function G(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=G;function Q(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=Q;function re(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.computeCodePoint=re;function K(ie,ue,ge){const we=ie.charCodeAt(ge);if(G(we)&&ge+1<ue){const ve=ie.charCodeAt(ge+1);if(Q(ve))return re(we,ve)}return we}e.getNextCodePoint=K;function W(ie,ue){const ge=ie.charCodeAt(ue-1);if(Q(ge)&&ue>1){const we=ie.charCodeAt(ue-2);if(G(we))return re(we,ge)}return ge}class F{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=W(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=K(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=F;class J{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new F(ue,ge)}nextGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ce=ge.offset,Re=ue.getGraphemeBreakType(ge.nextCodePoint());if(fe(ve,Re)){ge.setOffset(Ce);break}ve=Re}return ge.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ce=ge.offset,Re=ue.getGraphemeBreakType(ge.prevCodePoint());if(fe(Re,ve)){ge.setOffset(Ce);break}ve=Re}return we-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ee(ie,ue){return new J(ie,ue).nextGraphemeLength()}e.nextCharLength=ee;function oe(ie,ue){return new J(ie,ue).prevGraphemeLength()}e.prevCharLength=oe;function ce(ie,ue){ue>0&&Q(ie.charCodeAt(ue))&&ue--;const ge=ue+ee(ie,ue);return[ge-oe(ie,ge),ge]}e.getCharContainingOffset=ce;function V(ie){const ue=new J(ie);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=V;let j;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(ie){return j||(j=U()),j.test(ie)}e.containsRTL=z;const x=/^[\t\n\r\x20-\x7E]*$/;function _(ie){return x.test(ie)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=H;function X(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=X;function te(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=te;function le(ie,ue){if(ie.length<ue)return ie;const ge=/\b/g;let we=0;for(;ge.test(ie)&&!(ie.length-ge.lastIndex<ue);)we=ge.lastIndex,ge.lastIndex+=1;return ie.substring(we).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ie){return ie&&(ie=ie.replace(he,"")),ie}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Se(ie){return pe(ie)?ie.substr(1):ie}e.stripUTF8BOM=Se;function Ee(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const ge=ue.length,we=ie.toLowerCase();let ve=0,Ce=-1;for(;ve<ge;){const Re=we.indexOf(ue[ve],Ce+1);if(Re<0)return!1;Ce=Re,ve++}return!0}e.fuzzyContains=Ee;function De(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=De;function ke(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=ke;function We(ie,ue=1){if(ue===0)return"";let ge=-1;do ge=ie.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?ie:(ie[ge-1]==="\r"&&ge--,ie.substr(0,ge))}e.getNLines=We;function $e(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=$e;function ae(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ae;function fe(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var de;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,we=ge.length/3;let ve=1;for(;ve<=we;)if(ue<ge[3*ve])ve=2*ve;else if(ue>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ie,ue){if(ie===0)return 0;const ge=Ae(ie,ue);if(ge!==void 0)return ge;const we=new F(ue,ie);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Ae(ie,ue){const ge=new F(ue,ie);let we=ge.prevCodePoint();for(;ze(we)||we===65039||we===8419;){if(ge.offset===0)return;we=ge.prevCodePoint()}if(!te(we))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function ze(ie){return 127995<=ie&&ie<=127999}var Ne;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Te{static getInstance(ue){return Te.d.get(Array.from(ue))}static getLocales(){return Te.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Te,Te.c=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.d=new D.LRUCachedFunction(ie=>{function ue(Ue){const je=new Map;for(let qe=0;qe<Ue.length;qe+=2)je.set(Ue[qe],Ue[qe+1]);return je}function ge(Ue,je){const qe=new Map(Ue);for(const[_e,nt]of je)qe.set(_e,nt);return qe}function we(Ue,je){if(!Ue)return je;const qe=new Map;for(const[_e,nt]of Ue)je.has(_e)&&qe.set(_e,nt);return qe}const ve=l.c.value;let Ce=ie.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ce.length===0&&(Ce=["_default"]);let Re;for(const Ue of Ce){const je=ue(ve[Ue]);Re=we(Re,je)}const Le=ue(ve._common),Oe=ge(Le,Re);return new Te(Oe)}),Te.e=new O.Lazy(()=>Object.keys(Te.c.value).filter(ie=>!ie.startsWith("_"))),e.AmbiguousCharacters=Te;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(ue){return Be.e().has(ue)}static get codePoints(){return Be.e()}}Be.d=void 0,e.InvisibleCharacters=Be}),define(ne[48],se([0,1,13,4,26,12]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function R(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function I(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function S(r,o=D.posix.sep){if(!r)return"";const s=r.length,c=r.charCodeAt(0);if(L(c)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let E=3;const k=E;for(;E<s&&!L(r.charCodeAt(E));E++);if(k!==E&&!L(r.charCodeAt(E+1))){for(E+=1;E<s;E++)if(L(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(u(c)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<s;w++)if(L(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=S;function P(r){if(!O.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let s=2;const c=s;for(;s<r.length&&(o=r.charCodeAt(s),o!==92);s++);return!(c===s||(o=r.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=P;const v=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,o=O.isWindows){const s=o?v:m;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||o&&g.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function p(r,o,s){const c=r===o;return!s||c?c:!r||!o?!1:(0,l.equalsIgnoreCase)(r,o)}e.isEqual=p;function h(r,o,s,c=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(s){if(!(0,l.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let E=o.length;return o.charAt(o.length-1)===c&&E--,r.charAt(E)===c}return o.charAt(o.length-1)!==c&&(o+=c),r.indexOf(o)===0}e.isEqualOrParent=h;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,o){return O.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(o,r)),r=(0,D.normalize)(r),O.isWindows?(r=(0,l.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,l.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=d;function y(r){const o=(0,D.normalize)(r);return O.isWindows?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=y;function b(r,o=O.isWindows){return o?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function C(r){return b(r)?r[0]:void 0}e.getDriveLetter=C;function t(r,o,s){return o.length>r.length?-1:r===o?0:(s&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function a(r){const o=r.split(":");let s,c,w;for(const E of o){const k=Number(E);(0,A.isNumber)(k)?c===void 0?c=k:w===void 0&&(w=k):s=s?[s,E].join(":"):E}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:w!==void 0?w:c!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,s=8){let c="";for(let E=0;E<s;E++)c+=i.charAt(Math.floor(Math.random()*i.length));let w;return o?w=`${o}-${c}`:w=c,r?(0,D.join)(r,w):w}e.randomPath=n}),define(ne[66],se([0,1,26]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(u){return l(u,0)}e.hash=O;function l(u,d){switch(typeof u){case"object":return u===null?A(349,d):Array.isArray(u)?I(u,d):S(u,d);case"string":return R(u,d);case"boolean":return L(u,d);case"number":return A(u,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=l;function A(u,d){return(d<<5)-d+u|0}e.numberHash=A;function L(u,d){return A(u?433:863,d)}function R(u,d){d=A(149417,d);for(let y=0,b=u.length;y<b;y++)d=A(u.charCodeAt(y),d);return d}e.stringHash=R;function I(u,d){return d=A(104579,d),u.reduce((y,b)=>l(b,y),d)}function S(u,d){return d=A(181387,d),Object.keys(u).sort().reduce((y,b)=>(y=R(b,y),l(u[b],y)),d)}class P{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=l(d,this.g),this.g}}e.Hasher=P;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function m(u,d,y=32){const b=y-d,C=~((1<<b)-1);return(u<<d|(C&u)>>>b)>>>0}function g(u,d=0,y=u.byteLength,b=0){for(let C=0;C<y;C++)u[d+C]=b}function f(u,d,y="0"){for(;u.length<d;)u=y+u;return u}function p(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(y=>y.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),d/4)}e.toHexString=p;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const y=d.length;if(y===0)return;const b=this.p;let C=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=d.charCodeAt(0),i=0);;){let n=a;if(D.isHighSurrogate(a))if(i+1<y){const r=d.charCodeAt(i+1);D.isLowSurrogate(r)?(i++,n=D.computeCodePoint(a,r)):n=65533}else{t=a;break}else D.isLowSurrogate(a)&&(n=65533);if(C=this.w(b,C,n),i++,i<y)a=d.charCodeAt(i);else break}this.r=C,this.u=t}w(d,y,b){return b<128?d[y++]=b:b<2048?(d[y++]=192|(b&1984)>>>6,d[y++]=128|(b&63)>>>0):b<65536?(d[y++]=224|(b&61440)>>>12,d[y++]=128|(b&4032)>>>6,d[y++]=128|(b&63)>>>0):(d[y++]=240|(b&1835008)>>>18,d[y++]=128|(b&258048)>>>12,d[y++]=128|(b&4032)>>>6,d[y++]=128|(b&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=h.g,y=this.q;for(let s=0;s<64;s+=4)d.setUint32(s,y.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)d.setUint32(s,m(d.getUint32(s-12,!1)^d.getUint32(s-32,!1)^d.getUint32(s-56,!1)^d.getUint32(s-64,!1),1),!1);let b=this.h,C=this.l,t=this.m,a=this.n,i=this.o,n,r,o;for(let s=0;s<80;s++)s<20?(n=C&t|~C&a,r=1518500249):s<40?(n=C^t^a,r=1859775393):s<60?(n=C&t|C&a|t&a,r=2400959708):(n=C^t^a,r=3395469782),o=m(b,5)+n+i+r+d.getUint32(s*4,!1)&4294967295,i=a,a=t,t=m(C,30),C=b,b=o;this.h=this.h+b&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}h.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(ne[89],se([0,1,26]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(O||(O={})),function(l){const A="error",L="warning",R="warn",I="info",S="ignore";function P(m){return m?D.equalsIgnoreCase(A,m)?l.Error:D.equalsIgnoreCase(L,m)||D.equalsIgnoreCase(R,m)?l.Warning:D.equalsIgnoreCase(I,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function v(m){switch(m){case l.Error:return A;case l.Warning:return L;case l.Info:return I;default:return S}}l.toString=v}(O||(O={})),e.default=O}),define(ne[49],se([0,1,20,26]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const f=g.charCodeAt(0),p=this.b.charCodeAt(this.c);return f-p}value(){return this.b[this.c]}}e.StringIterator=l;class A{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,O.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,O.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class L{constructor(g=!0,f=!0){this.f=g,this.g=f}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let f=g.length-1;f>=0;f--,this.c--){const p=this.b.charCodeAt(f);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,O.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,O.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=L;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(g,f){this.f=g,this.g=f,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,O.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,O.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,O.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,O.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(P||(P={}));class v{static forUris(g=()=>!1,f=()=>!1){return new v(new I(g,f))}static forPaths(g=!1){return new v(new L(void 0,!g))}static forStrings(){return new v(new l)}static forConfigKeys(){return new v(new A)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,f){if(f){const p=f.slice(0);(0,D.shuffle)(p);for(const h of p)this.set(h,g)}else{const p=g.slice(0);(0,D.shuffle)(p);for(const h of p)this.set(h[0],h[1])}}set(g,f){const p=this.b.reset(g);let h;this.c||(this.c=new S,this.c.segment=p.value());const u=[];for(h=this.c;;){const y=p.cmp(h.segment);if(y>0)h.left||(h.left=new S,h.left.segment=p.value()),u.push([-1,h]),h=h.left;else if(y<0)h.right||(h.right=new S,h.right.segment=p.value()),u.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new S,h.mid.segment=p.value()),u.push([0,h]),h=h.mid;else break}const d=h.value;h.value=f,h.key=g;for(let y=u.length-1;y>=0;y--){const b=u[y][1];b.updateHeight();const C=b.balanceFactor();if(C<-1||C>1){const t=u[y][0],a=u[y+1][0];if(t===1&&a===1)u[y][1]=b.rotateLeft();else if(t===-1&&a===-1)u[y][1]=b.rotateRight();else if(t===1&&a===-1)b.right=u[y+1][1]=u[y+1][1].rotateRight(),u[y][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=u[y+1][1]=u[y+1][1].rotateLeft(),u[y][1]=b.rotateRight();else throw new Error;if(y>0)switch(u[y-1][0]){case-1:u[y-1][1].left=u[y][1];break;case 1:u[y-1][1].right=u[y][1];break;case 0:u[y-1][1].mid=u[y][1];break}else this.c=u[0][1]}}return d}get(g){return this.d(g)?.value}d(g){const f=this.b.reset(g);let p=this.c;for(;p;){const h=f.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else break}return p}has(g){const f=this.d(g);return!(f?.value===void 0&&f?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,f){const p=this.b.reset(g),h=[];let u=this.c;for(;u;){const d=p.cmp(u.segment);if(d>0)h.push([-1,u]),u=u.left;else if(d<0)h.push([1,u]),u=u.right;else if(p.hasNext())p.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:y,value:b,segment:C}=d;this.e(d.key,!1),u.key=y,u.value=b,u.segment=C}}else{const d=u.left??u.right;if(h.length>0){const[y,b]=h[h.length-1];switch(y){case-1:b.left=d;break;case 0:b.mid=d;break;case 1:b.right=d;break}}else this.c=d}for(let d=h.length-1;d>=0;d--){const y=h[d][1];y.updateHeight();const b=y.balanceFactor();if(b>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),h[d][1]=y.rotateLeft()):b<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),h[d][1]=y.rotateRight()),d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const f=this.b.reset(g);let p=this.c,h;for(;p;){const u=f.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(f.hasNext())f.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(g){return this.g(g,!1)}g(g,f){const p=this.b.reset(g);let h=this.c;for(;h;){const u=p.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this.h(h.mid):f?h.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[f,p]of this)g(p,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const f=[];return this.j(g,f),f[Symbol.iterator]()}j(g,f){!g||(g.left&&this.j(g.left,f),g.value&&f.push([g.key,g.value]),g.mid&&this.j(g.mid,f),g.right&&this.j(g.right,f))}_isBalanced(){const g=f=>{if(!f)return!0;const p=f.balanceFactor();return p<-1||p>1?!1:g(f.left)&&g(f.right)};return g(this.c)}}e.TernarySearchTree=v}),define(ne[10],se([0,1,13,4]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,A=/^\//,L=/^\/\//;function R(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,n){return!i&&!n?"file":i}function S(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const P="",v="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,o,s,c,w=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=I(n,w),this.authority=r||P,this.path=S(this.scheme,o||P),this.query=s||P,this.fragment=c||P,R(this,w))}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:s,query:c,fragment:w}=n;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),s===void 0?s=this.path:s===null&&(s=P),c===void 0?c=this.query:c===null&&(c=P),w===void 0?w=this.fragment:w===null&&(w=P),r===this.scheme&&o===this.authority&&s===this.path&&c===this.query&&w===this.fragment?this:new p(r,o,s,c,w)}static parse(n,r=!1){const o=m.exec(n);return o?new p(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),r):new p(P,P,P,P,P)}static file(n){let r=P;if(O.isWindows&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const o=n.indexOf(v,2);o===-1?(r=n.substring(2),n=v):(r=n.substring(2,o),n=n.substring(o)||v)}return new p("file",r,n,P,P)}static from(n){const r=new p(n.scheme,n.authority,n.path,n.query,n.fragment);return R(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return O.isWindows&&n.scheme==="file"?o=g.file(D.win32.join(y(n,!0),...r)).path:o=D.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const r=new p(n);return r._formatted=n.external,r._fsPath=n._sep===f?n.fsPath:null,r}}else return n}}e.URI=g;const f=O.isWindows?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=f),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,r){let o,s=-1;for(let c=0;c<i.length;c++){const w=i.charCodeAt(c);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47||r&&w===91||r&&w===93||r&&w===58)s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const E=h[w];E!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o+=E):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function d(i){let n;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(n===void 0&&(n=i.substr(0,r)),n+=h[o]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function y(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=y;function b(i,n){const r=n?d:u;let o="",{scheme:s,authority:c,path:w,query:E,fragment:k}=i;if(s&&(o+=s,o+=":"),(c||s==="file")&&(o+=v,o+=v),c){let N=c.indexOf("@");if(N!==-1){const M=c.substr(0,N);c=c.substr(N+1),N=M.lastIndexOf(":"),N===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,N),!1,!1),o+=":",o+=r(M.substr(N+1),!1,!0)),o+="@"}c=c.toLowerCase(),N=c.lastIndexOf(":"),N===-1?o+=r(c,!1,!0):(o+=r(c.substr(0,N),!1,!0),o+=c.substr(N))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const N=w.charCodeAt(1);N>=65&&N<=90&&(w=`/${String.fromCharCode(N+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const N=w.charCodeAt(0);N>=65&&N<=90&&(w=`${String.fromCharCode(N+32)}:${w.substr(2)}`)}o+=r(w,!0,!1)}return E&&(o+="?",o+=r(E,!1,!1)),k&&(o+="#",o+=n?k:u(k,!1,!1)),o}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>C(n)):i}}),define(ne[145],se([0,1,10]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(S){const P=S;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=O;function l(S){const P=[];let v;try{const m=JSON.parse(S.arguments),g=m[m.length-1];g&&g.__$stack&&(m.pop(),v=g.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",S.arguments)}return{args:P,stack:v}}e.parse=l;function A(S){if(typeof S!="string")return A(l(S).stack);const P=S;if(P){const v=L(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=A;function L(S){if(!S)return S;const P=S.indexOf(`
`);return P===-1?S:S.substring(0,P)}function R(S,P){const{args:v,stack:m}=l(S),g=typeof v[0]=="string"&&v.length===1;let f=L(m);f&&(f=`(${f.trim()})`);let p=[];if(typeof v[0]=="string"?f&&g?p=[`%c[${P}] %c${v[0]} %c${f}`,I("blue"),I(""),I("grey")]:p=[`%c[${P}] %c${v[0]}`,I("blue"),I(""),...v.slice(1)]:p=[`%c[${P}]%`,I("blue"),...v],f&&!g&&p.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,p)}e.log=R;function I(S){return`color: ${S}`}}),define(ne[67],se([0,1,17,26,10]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,R)}e.stringify=A;function L(S){let P=JSON.parse(S);return P=I(P),P}e.parse=L;function R(S,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,O.regExpFlags)(P)}:P}function I(S,P=0){if(!S||P>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return l.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof D.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let v=0;v<S.length;++v)S[v]=I(S[v],P+1);else for(const v in S)Object.hasOwnProperty.call(S,v)&&(S[v]=I(S[v],P+1))}return S}e.revive=I}),define(ne[21],se([0,1,8,4,10]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${A.vscodeRemoteResource}`}set(P,v,m){this.a[P]=v,this.b[P]=m}setConnectionToken(P,v){this.c[P]=v}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(h){return D.onUnexpectedError(h),P}const v=P.authority;let m=this.a[v];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const g=this.b[v],f=this.c[v];let p=`path=${encodeURIComponent(P.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),l.URI.from({scheme:O.isWeb?this.d:A.vscodeRemoteResource,authority:`${m}:${g}`,path:this.f,query:p})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const v=this.b(P,Z);return this.uriToBrowserUri(v)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===A.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${A.vscodeFileResource}://${R.a}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const v=this.b(P,Z);return this.uriToFileUri(v)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,v){return l.URI.isUri(P)?P:l.URI.parse(v.toUrl(P))}}R.a="vscode-app",e.FileAccess=new R;var I;(function(S){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(P.get("3"));const v="vscode-coi";function m(f){let p;typeof f=="string"?p=new URL(f).searchParams:f instanceof URL?p=f.searchParams:l.URI.isUri(f)&&(p=new URL(f.toString(!0)).searchParams);const h=p?.get(v);if(!!h)return P.get(h)}S.getHeadersFromQuery=m;function g(f,p,h){if(!globalThis.crossOriginIsolated)return;const u=p&&h?"3":h?"2":"1";f instanceof URLSearchParams?f.set(v,u):f[v]=u}S.addSearchParam=g})(I=e.COI||(e.COI={}))}),define(ne[22],se([0,1,48,21,13,4,26,10]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(g){return(0,R.uriToFsPath)(g,!0)}e.originalFSPath=I;class S{constructor(f){this.a=f}compare(f,p,h=!1){return f===p?0:(0,L.compare)(this.getComparisonKey(f,h),this.getComparisonKey(p,h))}isEqual(f,p,h=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,h)===this.getComparisonKey(p,h)}getComparisonKey(f,p=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,p,h=!1){if(f.scheme===p.scheme){if(f.scheme===O.Schemas.file)return D.isEqualOrParent(I(f),I(p),this.a(f))&&f.query===p.query&&(h||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return D.isEqualOrParent(f.path,p.path,this.a(f),"/")&&f.query===p.query&&(h||f.fragment===p.fragment)}return!1}joinPath(f,...p){return R.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return l.posix.basename(f.path)}extname(f){return l.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===O.Schemas.file?p=R.URI.file(l.dirname(I(f))).path:(p=l.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===O.Schemas.file?p=R.URI.file(l.normalize(I(f))).path:p=l.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===O.Schemas.file){const d=l.relative(I(f),I(p));return A.isWindows?D.toSlashes(d):d}let h=f.path||"/";const u=p.path||"/";if(this.a(f)){let d=0;for(const y=Math.min(h.length,u.length);d<y&&!(h.charCodeAt(d)!==u.charCodeAt(d)&&h.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);h=u.substr(0,d)+h.substr(d)}return l.posix.relative(h,u)}resolvePath(f,p){if(f.scheme===O.Schemas.file){const h=R.URI.file(l.resolve(I(f),p));return f.with({authority:h.authority,path:h.path})}return p=D.toPosixPath(p),f.with({path:l.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||f!==void 0&&p!==void 0&&(0,L.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=l.sep){if(f.scheme===O.Schemas.file){const h=I(f);return h.length>D.getRoot(h).length&&h[h.length-1]===p}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=l.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=l.sep){let h=!1;if(f.scheme===O.Schemas.file){const u=I(f);h=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=f.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(g=>g.scheme===O.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(g,f){const p=[];for(let h=0;h<g.length;h++){const u=f(g[h]);g.some((d,y)=>y===h?!1:(0,e.isEqualOrParent)(u,f(d)))||p.push(g[h])}return p}e.distinctParents=P;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function f(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(y=>{const[b,C]=y.split(":");b&&C&&h.set(b,C)});const d=p.path.substring(0,p.path.indexOf(";"));return d&&h.set(g.META_DATA_MIME,d),h}g.parseMetaData=f})(v=e.DataUri||(e.DataUri={}));function m(g,f,p){if(f){let h=g.path;return h&&h[0]!==l.posix.sep&&(h=l.posix.sep+h),g.with({scheme:p,authority:f,path:h})}return g.with({scheme:p})}e.toLocalResource=m}),define(ne[6],se([0,1,24,8,3,2,22,4,132]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(V){return!!V&&typeof V.then=="function"}e.isThenable=S;function P(V){const j=new D.CancellationTokenSource,U=V(j.token),z=new Promise((x,_)=>{const H=j.token.onCancellationRequested(()=>{H.dispose(),j.dispose(),_(new O.CancellationError)});Promise.resolve(U).then(X=>{H.dispose(),j.dispose(),x(X)},X=>{H.dispose(),j.dispose(),_(X)})});return new class{cancel(){j.cancel()}then(x,_){return z.then(x,_)}catch(x){return this.then(void 0,x)}finally(x){return z.finally(x)}}}e.createCancelablePromise=P;function v(V,j,U){return new Promise((z,x)=>{const _=j.onCancellationRequested(()=>{_.dispose(),z(U)});V.then(z,x).finally(()=>_.dispose())})}e.raceCancellation=v;function m(V,j){return new Promise((U,z)=>{const x=j.onCancellationRequested(()=>{x.dispose(),z(new O.CancellationError)});V.then(U,z).finally(()=>x.dispose())})}e.raceCancellationError=m;async function g(V){let j=-1;const U=V.map((x,_)=>x.then(H=>(j=_,H))),z=await Promise.race(U);return V.forEach((x,_)=>{_!==j&&x.cancel()}),z}e.raceCancellablePromises=g;function f(V,j,U){let z;const x=setTimeout(()=>{z?.(void 0),U?.()},j);return Promise.race([V.finally(()=>clearTimeout(x)),new Promise(_=>z=_)])}e.raceTimeout=f;function p(V){return new Promise((j,U)=>{const z=V();S(z)?z.then(j,U):j(z)})}e.asPromise=p;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(j){if(this.a){if(this.d=j,!this.b){const U=()=>{this.b=null;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(U,U).then(z)})}return new Promise((U,z)=>{this.b.then(U,z)})}return this.a=j(),new Promise((U,z)=>{this.a.then(x=>{this.a=null,U(x)},x=>{this.a=null,z(x)})})}}e.Throttler=h;class u{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.Sequencer=u;class d{constructor(){this.a=new Map}queue(j,U){const x=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(j)===x&&this.a.delete(j)});return this.a.set(j,x),x}}e.SequencerByKey=d;const y=(V,j)=>{let U=!0;const z=setTimeout(()=>{U=!1,j()},V);return{isTriggered:()=>U,dispose:()=>{clearTimeout(z),U=!1}}},b=V=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,V())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class C{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,U=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((x,_)=>{this.d=x,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=U===I.MicrotaskDelay?b(z):y(U,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(j){this.a=new C(j),this.b=new h}trigger(j,U){return this.a.trigger(()=>this.b.queue(j),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((j,U)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(V,j){return j?new Promise((U,z)=>{const x=setTimeout(()=>{_.dispose(),U()},V),_=j.onCancellationRequested(()=>{clearTimeout(x),_.dispose(),z(new O.CancellationError)})}):P(U=>n(V,U))}e.timeout=n;function r(V,j=0){const U=setTimeout(V,j);return(0,A.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function o(V){const j=[];let U=0;const z=V.length;function x(){return U<z?V[U++]():null}function _(H){H!=null&&j.push(H);const X=x();return X?X.then(_):Promise.resolve(j)}return Promise.resolve(null).then(_)}e.sequence=o;function s(V,j=z=>!!z,U=null){let z=0;const x=V.length,_=()=>{if(z>=x)return Promise.resolve(U);const H=V[z++];return Promise.resolve(H()).then(te=>j(te)?Promise.resolve(te):_())};return _()}e.first=s;function c(V,j=z=>!!z,U=null){if(V.length===0)return Promise.resolve(U);let z=V.length;const x=()=>{z=-1;for(const _ of V)_.cancel?.()};return new Promise((_,H)=>{for(const X of V)X.then(te=>{--z>=0&&j(te)?(x(),_(te)):z===0&&_(U)}).catch(te=>{--z>=0&&(x(),H(te))})})}e.firstParallel=c;class w{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((U,z)=>{this.f.push({factory:j,c:U,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const U=j.factory();U.then(j.c,j.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=w;class E extends w{constructor(){super(1)}}e.Queue=E;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new W;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,U=L.extUri){const z=U.getComparisonKey(j);let x=this.a.get(z);return x||(x=new E,l.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(z),this.f()}),this.a.set(z,x)),x}f(){!this.d()||this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class N{constructor(j,U){this.a=-1,typeof j=="function"&&typeof U=="number"&&this.setIfNotSet(j,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},U)}setIfNotSet(j,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},U))}}e.TimeoutTimer=N;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,U){this.cancel(),this.a=setInterval(()=>{j()},U)}}e.IntervalTimer=M;class ${constructor(j,U){this.b=-1,this.a=j,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class T{constructor(j,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=j,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=T;class B extends ${constructor(j,U){super(j,U),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class q extends A.Disposable{constructor(j,U){super(),this.g=j,this.h=U,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of j)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,R.setTimeout0)(()=>{if(j)return;const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(V,j)=>{const U=requestIdleCallback(V,typeof j=="number"?{timeout:j}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(U))}}}}();class G{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=G;async function Q(V,j,U){let z;for(let x=0;x<U;x++)try{return await V()}catch(_){z=_,await n(j)}throw z}e.retry=Q;class re{hasPending(j){return this.a?typeof j=="number"?this.a.taskId===j:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(j,U,z){return this.a={taskId:j,cancel:()=>z?.(),promise:U},U.then(()=>this.d(j),()=>this.d(j)),U}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this.b)this.b.run=j;else{let U,z;const x=new Promise((_,H)=>{U=_,z=H});this.b={run:j,promise:x,promiseResolve:U,promiseReject:z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=re;class K{constructor(j,U=()=>Date.now()){this.d=j,this.f=U,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.IntervalCounter=K;class W{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((j,U)=>{this.a=j,this.b=U})}complete(j){return new Promise(U=>{this.a(j),this.f=!0,U()})}error(j){return new Promise(U=>{this.b(j),this.d=!0,U()})}cancel(){new Promise(j=>{this.b(new O.CancellationError),this.d=!0,j()})}}e.DeferredPromise=W;var F;(function(V){async function j(z){let x;const _=await Promise.all(z.map(H=>H.then(X=>X,X=>{x||(x=X)})));if(typeof x<"u")throw x;return _}V.settled=j;function U(z){return new Promise(async(x,_)=>{try{await z(x,_)}catch(H){_(H)}})}V.withAsyncBody=U})(F=e.Promises||(e.Promises={}));var J;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(J||(J={}));class ee{static fromArray(j){return new ee(U=>{U.emitMany(j)})}static fromPromise(j){return new ee(async U=>{U.emitMany(await j)})}static fromPromises(j){return new ee(async U=>{await Promise.all(j.map(async z=>U.emitOne(await z)))})}static merge(j){return new ee(async U=>{await Promise.all(j.map(async z=>{for await(const x of z)U.emitOne(x)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const U={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve(j(U)),this.j()}catch(z){this.k(z)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(j,U){return new ee(async z=>{for await(const x of j)z.emitOne(U(x))})}map(j){return ee.map(this,j)}static filter(j,U){return new ee(async z=>{for await(const x of j)U(x)&&z.emitOne(x)})}filter(j){return ee.filter(this,j)}static coalesce(j){return ee.filter(j,U=>!!U)}coalesce(){return ee.coalesce(this)}static async toPromise(j){const U=[];for await(const z of j)U.push(z);return U}toPromise(){return ee.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}ee.EMPTY=ee.fromArray([]),e.AsyncIterableObject=ee;class oe extends ee{constructor(j,U){super(U),this.l=j}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function ce(V){const j=new D.CancellationTokenSource,U=V(j.token);return new oe(j,async z=>{const x=j.token.onCancellationRequested(()=>{x.dispose(),j.dispose(),z.reject(new O.CancellationError)});try{for await(const _ of U){if(j.token.isCancellationRequested)return;z.emitOne(_)}x.dispose(),j.dispose()}catch(_){x.dispose(),j.dispose(),z.reject(_)}})}e.createCancelableAsyncIterable=ce}),define(ne[90],se([0,1,20,6,48,37,13,4,26]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",v="[^/\\\\]",m=/\//g;function g(K,W){switch(K){case 0:return"";case 1:return`${v}*?`;default:return`(?:${P}|${v}+${P}${W?`|${P}${v}+`:""})*?`}}function f(K,W){if(!K)return[];const F=[];let J=!1,ee=!1,oe="";for(const ce of K){switch(ce){case W:if(!J&&!ee){F.push(oe),oe="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}oe+=ce}return oe&&F.push(oe),F}e.splitGlobAware=f;function p(K){if(!K)return"";let W="";const F=f(K,e.GLOB_SPLIT);if(F.every(J=>J===e.GLOBSTAR))W=".*";else{let J=!1;F.forEach((ee,oe)=>{if(ee===e.GLOBSTAR){if(J)return;W+=g(2,oe===F.length-1)}else{let ce=!1,V="",j=!1,U="";for(const z of ee){if(z!=="}"&&ce){V+=z;continue}if(j&&(z!=="]"||!U)){let x;z==="-"?x=z:(z==="^"||z==="!")&&!U?x="^":z===e.GLOB_SPLIT?x="":x=(0,I.escapeRegExpCharacters)(z),U+=x;continue}switch(z){case"{":ce=!0;continue;case"[":j=!0;continue;case"}":{W+=`(?:${f(V,",").map(H=>p(H)).join("|")})`,ce=!1,V="";break}case"]":{W+="["+U+"]",j=!1,U="";break}case"?":W+=v;continue;case"*":W+=g(1);continue;default:W+=(0,I.escapeRegExpCharacters)(z)}}oe<F.length-1&&(F[oe+1]!==e.GLOBSTAR||oe+2<F.length)&&(W+=P)}J=ee===e.GLOBSTAR})}return W}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(K,W){if(!K)return i;let F;typeof K!="string"?F=K.pattern:F=K,F=F.trim();const J=`${F}_${!!W.trimForExclusions}`;let ee=t.get(J);if(ee)return r(ee,K);let oe;return h.test(F)?ee=s(F.substr(4),F):(oe=u.exec(o(F,W)))?ee=c(oe[1],F):(W.trimForExclusions?y:d).test(F)?ee=w(F,W):(oe=b.exec(o(F,W)))?ee=E(oe[1].substr(1),F,!0):(oe=C.exec(o(F,W)))?ee=E(oe[1],F,!1):ee=k(F),t.set(J,ee),r(ee,K)}function r(K,W){if(typeof W=="string")return K;const F=function(J,ee){return(0,l.isEqualOrParent)(J,W.base,!R.isLinux)?K((0,I.ltrim)(J.substr(W.base.length),L.sep),ee):null};return F.allBasenames=K.allBasenames,F.allPaths=K.allPaths,F.basenames=K.basenames,F.patterns=K.patterns,F}function o(K,W){return W.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,W){return function(F,J){return typeof F=="string"&&F.endsWith(K)?W:null}}function c(K,W){const F=`/${K}`,J=`\\${K}`,ee=function(ce,V){return typeof ce!="string"?null:V?V===K?W:null:ce===K||ce.endsWith(F)||ce.endsWith(J)?W:null},oe=[K];return ee.basenames=oe,ee.patterns=[W],ee.allBasenames=oe,ee}function w(K,W){const F=Q(K.slice(1,-1).split(",").map(V=>n(V,W)).filter(V=>V!==i),K),J=F.length;if(!J)return i;if(J===1)return F[0];const ee=function(V,j){for(let U=0,z=F.length;U<z;U++)if(F[U](V,j))return K;return null},oe=F.find(V=>!!V.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const ce=F.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ce.length&&(ee.allPaths=ce),ee}function E(K,W,F){const J=L.sep===L.posix.sep,ee=J?K:K.replace(m,L.sep),oe=L.sep+ee,ce=L.posix.sep+K;let V;return F?V=function(j,U){return typeof j=="string"&&(j===ee||j.endsWith(oe)||!J&&(j===K||j.endsWith(ce)))?W:null}:V=function(j,U){return typeof j=="string"&&(j===ee||!J&&j===K)?W:null},V.allPaths=[(F?"*/":"./")+K],V}function k(K){try{const W=new RegExp(`^${p(K)}$`);return function(F){return W.lastIndex=0,typeof F=="string"&&W.test(F)?K:null}}catch{return i}}function N(K,W,F){return!K||typeof W!="string"?!1:M(K)(W,void 0,F)}e.match=N;function M(K,W={}){if(!K)return a;if(typeof K=="string"||$(K)){const F=n(K,W);if(F===i)return a;const J=function(ee,oe){return!!F(ee,oe)};return F.allBasenames&&(J.allBasenames=F.allBasenames),F.allPaths&&(J.allPaths=F.allPaths),J}return q(K,W)}e.parse=M;function $(K){const W=K;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=$;function T(K){return K.allBasenames||[]}e.getBasenameTerms=T;function B(K){return K.allPaths||[]}e.getPathTerms=B;function q(K,W){const F=Q(Object.getOwnPropertyNames(K).map(V=>G(V,K[V],W)).filter(V=>V!==i)),J=F.length;if(!J)return i;if(!F.some(V=>!!V.requiresSiblings)){if(J===1)return F[0];const V=function(z,x){let _;for(let H=0,X=F.length;H<X;H++){const te=F[H](z,x);if(typeof te=="string")return te;(0,O.isThenable)(te)&&(_||(_=[]),_.push(te))}return _?(async()=>{for(const H of _){const X=await H;if(typeof X=="string")return X}return null})():null},j=F.find(z=>!!z.allBasenames);j&&(V.allBasenames=j.allBasenames);const U=F.reduce((z,x)=>x.allPaths?z.concat(x.allPaths):z,[]);return U.length&&(V.allPaths=U),V}const ee=function(V,j,U){let z,x;for(let _=0,H=F.length;_<H;_++){const X=F[_];X.requiresSiblings&&U&&(j||(j=(0,L.basename)(V)),z||(z=j.substr(0,j.length-(0,L.extname)(V).length)));const te=X(V,j,z,U);if(typeof te=="string")return te;(0,O.isThenable)(te)&&(x||(x=[]),x.push(te))}return x?(async()=>{for(const _ of x){const H=await _;if(typeof H=="string")return H}return null})():null},oe=F.find(V=>!!V.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const ce=F.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ce.length&&(ee.allPaths=ce),ee}function G(K,W,F){if(W===!1)return i;const J=n(K,F);if(J===i)return i;if(typeof W=="boolean")return J;if(W){const ee=W.when;if(typeof ee=="string"){const oe=(ce,V,j,U)=>{if(!U||!J(ce,V))return null;const z=ee.replace("$(basename)",()=>j),x=U(z);return(0,O.isThenable)(x)?x.then(_=>_?K:null):x?K:null};return oe.requiresSiblings=!0,oe}}return J}function Q(K,W){const F=K.filter(V=>!!V.basenames);if(F.length<2)return K;const J=F.reduce((V,j)=>{const U=j.basenames;return U?V.concat(U):V},[]);let ee;if(W){ee=[];for(let V=0,j=J.length;V<j;V++)ee.push(W)}else ee=F.reduce((V,j)=>{const U=j.patterns;return U?V.concat(U):V},[]);const oe=function(V,j){if(typeof V!="string")return null;if(!j){let z;for(z=V.length;z>0;z--){const x=V.charCodeAt(z-1);if(x===47||x===92)break}j=V.substr(z)}const U=J.indexOf(j);return U!==-1?ee[U]:null};oe.basenames=J,oe.patterns=ee,oe.allBasenames=J;const ce=K.filter(V=>!V.basenames);return ce.push(oe),ce}function re(K,W){return(0,D.equals)(K,W,(F,J)=>typeof F=="string"&&typeof J=="string"?F===J:typeof F!="string"&&typeof J!="string"?F.base===J.base&&F.pattern===J.pattern:!1)}e.patternsEquals=re}),define(ne[146],se([0,1,17,10]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(v){return v.toJSON()}class A{constructor(m){this.a=m}transformIncoming(m){const g=this.a.transformIncoming(m);return g===m?m:l(O.URI.from(g))}transformOutgoing(m){const g=this.a.transformOutgoing(m);return g===m?m:l(O.URI.from(g))}transformOutgoingURI(m){const g=this.a.transformOutgoing(m);return g===m?m:O.URI.from(g)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function L(v,m,g){if(!v||g>200)return null;if(typeof v=="object"){if(v instanceof O.URI)return m.transformOutgoing(v);for(const f in v)if(Object.hasOwnProperty.call(v,f)){const p=L(v[f],m,g+1);p!==null&&(v[f]=p)}}return null}function R(v,m){const g=L(v,m,0);return g===null?v:g}e.transformOutgoingURIs=R;function I(v,m,g,f){if(!v||f>200)return null;if(typeof v=="object"){if(v.$mid===1)return g?O.URI.revive(m.transformIncoming(v)):m.transformIncoming(v);if(v instanceof D.VSBuffer)return null;for(const p in v)if(Object.hasOwnProperty.call(v,p)){const h=I(v[p],m,g,f+1);h!==null&&(v[p]=h)}}return null}function S(v,m){const g=I(v,m,!1,0);return g===null?v:g}e.transformIncomingURIs=S;function P(v,m){const g=I(v,m,!0,0);return g===null?v:g}e.transformAndReviveIncomingURIs=P}),define(ne[147],se([0,1,34,8,49,31,134]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,v=0;const m=(0,D.networkInterfaces)();for(const g in m){const f=m[g];if(f)for(const{mac:p,internal:h}of f)h||(v+=1,this.c(p.toUpperCase())&&(P+=1))}this.b=v>0?P/v:0}return this.b}};let R;async function I(){return R||(R=(async()=>await S()||A.generateUuid())()),R}e.getMachineId=I;async function S(){try{const P=await new Promise((m,g)=>{Z(["crypto"],m,g)}),v=(0,L.getMac)();return P.createHash("sha256").update(v,"utf8").digest("hex")}catch(P){O.onUnexpectedError(P);return}}}),define(ne[27],se([0,1,53,34,291,6,48,85,13,4,22,10]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function g(q,G=m.UNLINK){if((0,L.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return G===m.UNLINK?p(q):f(q)}async function f(q){try{const G=(0,L.randomPath)((0,O.tmpdir)());try{await D.promises.rename(q,G)}catch(Q){return Q.code==="ENOENT"?void 0:p(q)}p(G).catch(Q=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(q){return(0,l.promisify)(D.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function h(q){if((0,L.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(q,G){return b(await(G?d(q):(0,l.promisify)(D.readdir)(q)))}async function d(q){try{return await(0,l.promisify)(D.readdir)(q,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const G=[],Q=await u(q);for(const re of Q){let K=!1,W=!1,F=!1;try{const J=await e.Promises.lstat((0,I.join)(q,re));K=J.isFile(),W=J.isDirectory(),F=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}G.push({name:re,isFile:()=>K,isDirectory:()=>W,isSymbolicLink:()=>F})}return G}function y(q){return b(D.readdirSync(q))}e.readdirSync=y;function b(q){return q.map(G=>typeof G=="string"?S.isMacintosh?(0,R.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,R.normalizeNFC)(G.name):G.name,G))}async function C(q){const G=await u(q),Q=[];for(const re of G)await a.existsDirectory((0,I.join)(q,re))&&Q.push(re);return Q}function t(q,G=1e3){return new Promise(Q=>{let re=!1;const K=setInterval(()=>{re||(re=!0,D.access(q,W=>{re=!1,W&&(clearInterval(K),Q(void 0))}))},G)})}e.whenDeleted=t;var a;(function(q){async function G(K){let W;try{if(W=await e.Promises.lstat(K),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(S.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw J}throw F}}q.stat=G;async function Q(K){try{const{stat:W,symbolicLink:F}=await q.stat(K);return W.isFile()&&F?.dangling!==!0}catch{}return!1}q.existsFile=Q;async function re(K){try{const{stat:W,symbolicLink:F}=await q.stat(K);return W.isDirectory()&&F?.dangling!==!0}catch{}return!1}q.existsDirectory=re})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function n(q,G,Q){return i.queueFor(v.URI.file(q),P.extUriBiasedIgnorePathCase).queue(()=>{const re=w(Q);return new Promise((K,W)=>s(q,G,re,F=>F?W(F):K()))})}let r=!0;function o(q){r=q}e.configureFlushOnWrite=o;function s(q,G,Q,re){if(!r)return D.writeFile(q,G,{mode:Q.mode,flag:Q.flag},re);D.open(q,Q.flag,Q.mode,(K,W)=>{if(K)return re(K);D.writeFile(W,G,F=>{if(F)return D.close(W,()=>re(F));D.fdatasync(W,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),o(!1)),D.close(W,ee=>re(ee))))})})}function c(q,G,Q){const re=w(Q);if(!r)return D.writeFileSync(q,G,{mode:re.mode,flag:re.flag});const K=D.openSync(q,re.flag,re.mode);try{D.writeFileSync(K,G);try{D.fdatasyncSync(K)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o(!1)}}finally{D.closeSync(K)}}e.writeFileSync=c;function w(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function E(q,G){if(q!==G)try{await e.Promises.rename(q,G)}catch(Q){if(q.toLowerCase()!==G.toLowerCase()&&Q.code==="EXDEV"||q.endsWith("."))await k(q,G,{preserveSymlinks:!1}),await g(q,m.MOVE);else throw Q}}async function k(q,G,Q){return M(q,G,{root:{source:q,target:G},options:Q,handledSourcePaths:new Set})}const N=511;async function M(q,G,Q){if(Q.handledSourcePaths.has(q))return;Q.handledSourcePaths.add(q);const{stat:re,symbolicLink:K}=await a.stat(q);if(K){if(Q.options.preserveSymlinks)try{return await B(q,G,Q)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(K.dangling)return}return re.isDirectory()?$(q,G,re.mode&N,Q):T(q,G,re.mode&N)}async function $(q,G,Q,re){await e.Promises.mkdir(G,{recursive:!0,mode:Q});const K=await u(q);for(const W of K)await M((0,I.join)(q,W),(0,I.join)(G,W),re)}async function T(q,G,Q){await e.Promises.copyFile(q,G),await e.Promises.chmod(G,Q)}async function B(q,G,Q){let re=await e.Promises.readlink(q);(0,L.isEqualOrParent)(re,Q.root.source,!S.isLinux)&&(re=(0,I.join)(Q.root.target,re.substr(Q.root.source.length+1))),await e.Promises.symlink(re,G)}e.Promises=new class{get access(){return(0,l.promisify)(D.access)}get stat(){return(0,l.promisify)(D.stat)}get lstat(){return(0,l.promisify)(D.lstat)}get utimes(){return(0,l.promisify)(D.utimes)}get read(){return(q,G,Q,re,K)=>new Promise((W,F)=>{D.read(q,G,Q,re,K,(J,ee,oe)=>J?F(J):W({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,l.promisify)(D.readFile)}get write(){return(q,G,Q,re,K)=>new Promise((W,F)=>{D.write(q,G,Q,re,K,(J,ee,oe)=>J?F(J):W({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,l.promisify)(D.appendFile)}get fdatasync(){return(0,l.promisify)(D.fdatasync)}get truncate(){return(0,l.promisify)(D.truncate)}get rename(){return(0,l.promisify)(D.rename)}get copyFile(){return(0,l.promisify)(D.copyFile)}get open(){return(0,l.promisify)(D.open)}get close(){return(0,l.promisify)(D.close)}get symlink(){return(0,l.promisify)(D.symlink)}get readlink(){return(0,l.promisify)(D.readlink)}get chmod(){return(0,l.promisify)(D.chmod)}get mkdir(){return(0,l.promisify)(D.mkdir)}get unlink(){return(0,l.promisify)(D.unlink)}get rmdir(){return(0,l.promisify)(D.rmdir)}get realpath(){return(0,l.promisify)(D.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return C}get writeFile(){return n}get rm(){return g}get move(){return E}get copy(){return k}}}),define(ne[148],se([0,1,53,13,4,26,27]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(m){if(l.isLinux)return m;const g=(0,O.dirname)(m);if(m===g)return m;const f=((0,O.basename)(m)||m).toLowerCase();try{const h=(0,L.readdirSync)(g).filter(u=>u.toLowerCase()===f);if(h.length===1){const u=R(g);if(u)return(0,O.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(f);if(u>=0){const d=R(g);if(d)return(0,O.join)(d,h[u])}}}catch{}return null}e.realcaseSync=R;async function I(m){if(l.isLinux)return m;const g=(0,O.dirname)(m);if(m===g)return m;const f=((0,O.basename)(m)||m).toLowerCase();try{const h=(await L.Promises.readdir(g)).filter(u=>u.toLowerCase()===f);if(h.length===1){const u=await I(g);if(u)return(0,O.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(f);if(u>=0){const d=await I(g);if(d)return(0,O.join)(d,h[u])}}}catch{}return null}e.realcase=I;async function S(m){try{return await L.Promises.realpath(m)}catch{const f=v(m);return await L.Promises.access(f,D.constants.R_OK),f}}e.realpath=S;function P(m){try{return D.realpathSync(m)}catch{const f=v(m);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=P;function v(m){return(0,A.rtrim)((0,O.normalize)(m),O.sep)}}),define(ne[91],se([0,1,34,13,27]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var I;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class v{constructor(C,t,a){this.exePath=C,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:b=!1}={}){return b?S===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:b=!1,findPreview:C=!1}={}){const t=m({useAlternateBitness:b});if(!t)return null;const a=O.join(t,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const s of await l.Promises.readdir(a)){let c=-1;if(C){const E=s.indexOf("-");if(E<0)continue;const k=s.substring(0,E);if(!A.test(k)||s.substring(E+1)!=="preview")continue;c=parseInt(k,10)}else{if(!A.test(s))continue;c=parseInt(s,10)}if(c<=i)continue;const w=O.join(a,s,"pwsh.exe");!await l.SymlinkSupport.existsFile(w)||(n=w,i=c)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=C?" Preview":"";return new v(n,`PowerShell${o}${r}`,!0)}async function f({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const C=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=b?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await l.Promises.readdir(C))if(t.test(i)){const n=O.join(C,i,"pwsh.exe");return new v(n,a)}return null}function p(){const b=O.join(D.homedir(),".dotnet","tools","pwsh.exe");return new v(b,".NET Core PowerShell Global Tool")}function h(){const b=O.join(process.env.windir,S===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(b,"Windows PowerShell",!0)}async function*u(){let b=await g();b&&(yield b),b=await g({useAlternateBitness:!0}),b&&(yield b),b=await f(),b&&(yield b),b=p(),b&&(yield b),b=await g({findPreview:!0}),b&&(yield b),b=await f({findPreview:!0}),b&&(yield b),b=await g({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=h(),b&&(yield b)}async function*d(){for await(const b of u())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=d;async function y(){for await(const b of d())return b;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ne[92],se([0,1,13,4,36,87,12,27]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function I(v=l.env){return v.comspec||"cmd.exe"}e.getWindowsShell=I;function S(v){let m=[],g=!1;const f=function(p){if(g){m.push(p);return}(!v.send(p,u=>{if(u&&console.error(u),g=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(y=>f(y))}})||O.isWindows)&&(g=!0)};return{send:f}}e.createQueuedSender=S;var P;(function(v){async function m(g,f,p){if(D.isAbsolute(g))return g;if(f===void 0&&(f=l.cwd()),D.dirname(g)!=="."||(p===void 0&&L.isString(l.env.PATH)&&(p=l.env.PATH.split(D.delimiter)),p===void 0||p.length===0))return D.join(f,g);async function u(d){if(await R.Promises.exists(d)){let y;try{y=await R.Promises.stat(d)}catch(b){b.message.startsWith("EACCES")&&(y=await R.Promises.lstat(d))}return y?!y.isDirectory():!1}return!1}for(const d of p){let y;if(D.isAbsolute(d)?y=D.join(d,g):y=D.join(f,d,g),await u(y))return y;let b=y+".com";if(await u(b)||(b=y+".exe",await u(b)))return b}return D.join(f,g)}v.findExecutable=m})(P=e.win32||(e.win32={}))}),define(ne[149],se([0,1,50,21]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(L){return new Promise((R,I)=>{let S;const P=new Map;function v(g,f,p,h,u){const d=P.get(f);if(g===L||d){const y={name:m(p),cmd:p,pid:g,ppid:f,load:h,mem:u};P.set(g,y),g===L&&(S=y),d&&(d.children||(d.children=[]),d.children.push(y),d.children.length>1&&(d.children=d.children.sort((b,C)=>b.pid-C.pid)))}}function m(g){const f=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,h=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,y=/--crashes-directory/,b=/\\pipe\\winpty-control/,C=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(y.exec(g))return"electron-crash-reporter";if(b.exec(g))return"winpty-process";if(C.exec(g))return"console-window-host (Windows internal process)";let a=t.exec(g);if(a&&a.length===2){if(a[1]==="renderer")return f.exec(g)?"shared-process":p.exec(g)?"issue-reporter":h.exec(g)?"process-explorer":"window";if(a[1]==="utility"){if(u.exec(g))return"utility-network-service";if(d.exec(g))return"extension-host"}else if(a[1]==="extensionHost")return"extension-host";return a[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do a=i.exec(g),a&&(n+=a+" ");while(a);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{Z(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(L,p=>{if(!p){I(new Error(`Root process ${L} not found`));return}f.getProcessCpuUsage(p,h=>{const u=new Map;h.forEach(d=>{const y=g(d.commandLine||"");u.set(d.pid,{name:m(y),cmd:y,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),S=u.get(L),S?(u.forEach(d=>{const y=u.get(d.ppid);y&&(y.children||(y.children=[]),y.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((y,b)=>y.pid-b.pid))}),R(S)):I(new Error(`Root process ${L} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let g=function(){let f=[S];const p=[];for(;f.length;){const u=f.shift();u&&(p.push(u.pid),u.children&&(f=f.concat(u.children)))}let h=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+p.join(" "),(0,D.exec)(h,{},(u,d,y)=>{if(u||y)I(u||new Error(y.toString()));else{const b=d.toString().split(`
`);for(let C=0;C<p.length;C++){const t=P.get(p[C]);t.load=parseFloat(b[C])}if(!S){I(new Error(`Root process ${L} not found`));return}R(S)}})};(0,D.exec)("which ps",{},(f,p,h)=>{if(f||h)if(process.platform!=="linux")I(f||new Error(h.toString()));else{const u=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(u,{},(d,y,b)=>{d||b?I(d||new Error(b.toString())):(A(y,v),g())})}else{const u=p.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,b,C)=>{y||C&&!C.includes("screen size is bogus")?I(y||new Error(C.toString())):(A(b,v),process.platform==="linux"?g():S?R(S):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=l;function A(L,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=L.toString().split(`
`);for(const P of S){const v=I.exec(P.trim());v&&v.length===6&&R(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ne[150],se([0,1,34,4,91,92]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function L(v,m){return v===1?O.isWindows?P():A.getWindowsShell(m):I(v,m)}e.getSystemShell=L;let R=null;function I(v,m){if(O.isLinux&&v===2||O.isMacintosh&&v===3)return"/bin/bash";if(!R){let g;if(O.isWindows)g="/bin/bash";else{if(g=m.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}R=g}return R}let S=null;async function P(){return S||(S=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),S}});var ye=this&&this.__decorate||function(Z,e,D,O){var l=arguments.length,A=l<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Z,e,D,O);else for(var R=Z.length-1;R>=0;R--)(L=Z[R])&&(A=(l<3?L(A):l>3?L(e,D,A):L(e,D))||A);return l>3&&A&&Object.defineProperty(e,D,A),A};define(ne[39],se([0,1,20,6,17,24,63,8,3,2,67,26,12]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(g||(g={}));function f(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(p||(p={}));function h(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));function d(W){let F=0;for(let J=0;;J+=7){const ee=W.read(1);if(F|=(ee.buffer[0]&127)<<J,!(ee.buffer[0]&128))return F}}const y=i(0);function b(W,F){if(F===0){W.write(y);return}let J=0;for(let oe=F;oe!==0;oe=oe>>>7)J++;const ee=l.VSBuffer.alloc(J);for(let oe=0;F!==0;oe++)ee.buffer[oe]=F&127,F=F>>>7,F>0&&(ee.buffer[oe]|=128);W.write(ee)}class C{constructor(F){this.b=F,this.a=0}read(F){const J=this.b.slice(this.a,this.a+F);return this.a+=J.byteLength,J}}e.BufferReader=C;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var a;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(a||(a={}));function i(W){const F=l.VSBuffer.alloc(1);return F.writeUInt8(W,0),F}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function o(W,F){if(typeof F>"u")W.write(n.Undefined);else if(typeof F=="string"){const J=l.VSBuffer.fromString(F);W.write(n.String),b(W,J.byteLength),W.write(J)}else if(r&&Buffer.isBuffer(F)){const J=l.VSBuffer.wrap(F);W.write(n.Buffer),b(W,J.byteLength),W.write(J)}else if(F instanceof l.VSBuffer)W.write(n.VSBuffer),b(W,F.byteLength),W.write(F);else if(Array.isArray(F)){W.write(n.Array),b(W,F.length);for(const J of F)o(W,J)}else if(typeof F=="number"&&(F|0)===F)W.write(n.Uint),b(W,F);else{const J=l.VSBuffer.fromString(JSON.stringify(F));W.write(n.Object),b(W,J.byteLength),W.write(J)}}e.serialize=o;function s(W){switch(W.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return W.read(d(W)).toString();case a.Buffer:return W.read(d(W)).buffer;case a.VSBuffer:return W.read(d(W));case a.Array:{const J=d(W),ee=[];for(let oe=0;oe<J;oe++)ee.push(s(W));return ee}case a.Object:return JSON.parse(W.read(d(W)).toString());case a.Int:return d(W)}}e.deserialize=s;class c{constructor(F,J,ee=null,oe=1e3){this.h=F,this.j=J,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(F,J){this.b.set(F,J),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const J=this.o([F.type]);this.k?.logOutgoing(J,0,1,h(F.type));return}case 201:case 202:case 204:case 203:{const J=this.o([F.type,F.id],F.data);this.k?.logOutgoing(J,F.id,1,h(F.type),F.data);return}}}o(F,J=void 0){const ee=new t;return o(ee,F),o(ee,J),this.p(ee.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const J=new C(F),ee=s(J),oe=s(J),ce=ee[0];switch(ce){case 100:return this.k?.logIncoming(F.byteLength,ee[1],1,`${f(ce)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(F.byteLength,ee[1],1,`${f(ce)}: ${ee[2]}.${ee[3]}`,oe),this.t({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(F.byteLength,ee[1],1,`${f(ce)}`),this.u({type:ce,id:ee[1]});case 103:return this.k?.logIncoming(F.byteLength,ee[1],1,`${f(ce)}`),this.u({type:ce,id:ee[1]})}}s(F){const J=this.b.get(F.channelName);if(!J){this.v(F);return}const ee=new A.CancellationTokenSource;let oe;try{oe=J.call(this.j,F.name,F.arg,ee.token)}catch(j){oe=Promise.reject(j)}const ce=F.id;oe.then(j=>{this.m({id:ce,data:j,type:201}),this.d.delete(F.id)},j=>{j instanceof Error?this.m({id:ce,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:ce,data:j,type:203}),this.d.delete(F.id)});const V=(0,S.toDisposable)(()=>ee.cancel());this.d.set(F.id,V)}t(F){const J=this.b.get(F.channelName);if(!J){this.v(F);return}const ee=F.id,ce=J.listen(this.j,F.name,F.arg)(V=>this.m({id:ee,data:V,type:204}));this.d.set(F.id,ce)}u(F){const J=this.d.get(F.id);J&&(J.dispose(),this.d.delete(F.id))}v(F){let J=this.g.get(F.channelName);J||(J=[],this.g.set(F.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:F,timeoutTimer:ee})}w(F){const J=this.g.get(F);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=c;var w;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(F,J=null){this.l=F,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=J}getChannel(F){const J=this;return{call(ee,oe,ce){return J.a?Promise.reject(new R.CancellationError):J.m(F,ee,oe,ce)},listen(ee,oe){return J.a?I.Event.None:J.o(F,ee,oe)}}}m(F,J,ee,oe=A.CancellationToken.None){const ce=this.g++,j={id:ce,type:100,channelName:F,name:J,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let U;return new Promise((x,_)=>{if(oe.isCancellationRequested)return _(new R.CancellationError);const H=()=>{const he=me=>{switch(me.type){case 201:this.f.delete(ce),x(me.data);break;case 202:{this.f.delete(ce);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,_(pe);break}case 203:this.f.delete(ce),_(me.data);break}};this.f.set(ce,he),this.p(j)};let X=null;this.b===u.Idle?H():(X=(0,O.createCancelablePromise)(he=>this.u()),X.then(()=>{X=null,H()}));const te=()=>{X?(X.cancel(),X=null):this.p({id:ce,type:101}),_(new R.CancellationError)},le=oe.onCancellationRequested(te);U=(0,S.combinedDisposable)((0,S.toDisposable)(te),le),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(F,J,ee){const oe=this.g++,V={id:oe,type:102,channelName:F,name:J,arg:ee};let j=null;const U=new I.Emitter({onWillAddFirstListener:()=>{j=(0,O.createCancelablePromise)(x=>this.u()),j.then(()=>{j=null,this.d.add(U),this.p(V)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(U),this.p({id:oe,type:103}))}}),z=x=>U.fire(x.data);return this.f.set(oe,z),U.event}p(F){switch(F.type){case 100:case 102:{const J=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(J,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const J=this.q([F.type,F.id]);this.j?.logOutgoing(J,F.id,0,f(F.type));return}}}q(F,J=void 0){const ee=new t;return o(ee,F),o(ee,J),this.r(ee.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const J=new C(F),ee=s(J),oe=s(J),ce=ee[0];switch(ce){case 200:return this.j?.logIncoming(F.byteLength,0,0,h(ce)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,ee[1],0,h(ce),oe),this.t({type:ee[0],id:ee[1],data:oe})}}t(F){if(F.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([L.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class k{get connections(){const F=[];return this.f.forEach(J=>F.push(J)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:J,onDidClientDisconnect:ee})=>{I.Event.once(J.onMessage)(ce=>{const V=new C(ce),j=s(V),U=new c(J,j),z=new E(J);this.a.forEach((_,H)=>U.registerChannel(H,_));const x={channelServer:U,channelClient:z,ctx:j};this.f.add(x),this.g.fire(x),ee(()=>{U.dispose(),z.dispose(),this.f.delete(x),this.h.fire(x)})})})}getChannel(F,J){const ee=this;return{call(oe,ce,V){let j;if((0,m.isFunction)(J)){const z=(0,D.getRandomElement)(ee.connections.filter(J));j=z?Promise.resolve(z):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,J))}else j=J.routeCall(ee,oe,ce);const U=j.then(z=>z.channelClient.getChannel(F));return M(U).call(oe,ce,V)},listen(oe,ce){if((0,m.isFunction)(J))return ee.j(F,J,oe,ce);const V=J.routeEvent(ee,oe,ce).then(j=>j.channelClient.getChannel(F));return M(V).listen(oe,ce)}}}j(F,J,ee,oe){const ce=this;let V=new S.DisposableStore;const j=new I.Emitter({onWillAddFirstListener:()=>{V=new S.DisposableStore;const U=new I.EventMultiplexer,z=new Map,x=H=>{const te=H.channelClient.getChannel(F).listen(ee,oe),le=U.add(te);z.set(H,le)},_=H=>{const X=z.get(H);!X||(X.dispose(),z.delete(H))};ce.connections.filter(J).forEach(x),I.Event.filter(ce.onDidAddConnection,J)(x,void 0,V),ce.onDidRemoveConnection(_,void 0,V),U.event(j.fire,j,V),V.add(U)},onDidRemoveLastListener:()=>{V.dispose()}});return j.event}registerChannel(F,J){this.a.set(F,J),this.f.forEach(ee=>{ee.channelServer.registerChannel(F,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class N{constructor(F,J,ee=null){const oe=new t;o(oe,J),F.send(oe.buffer),this.a=new E(F,ee),this.d=new c(F,J,ee)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,J){this.d.registerChannel(F,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function M(W){return{call(F,J,ee){return W.then(oe=>oe.call(F,J,ee))},listen(F,J){const ee=new I.Relay;return W.then(oe=>ee.input=oe.listen(F,J)),ee.event}}}e.getDelayedChannel=M;function $(W){let F=!1;return{call(J,ee,oe){return F?W.call(J,ee,oe):(0,O.timeout)(0).then(()=>F=!0).then(()=>W.call(J,ee,oe))},listen(J,ee){if(F)return W.listen(J,ee);const oe=new I.Relay;return(0,O.timeout)(0).then(()=>F=!0).then(()=>oe.input=W.listen(J,ee)),oe.event}}}e.getNextTickChannel=$;class T{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const J of F.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await I.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=T;var B;(function(W){function F(ce,V){const j=ce,U=V&&V.disableMarshalling,z=new Map;for(const x in j)ee(x)&&z.set(x,I.Event.buffer(j[x],!0));return new class{listen(x,_,H){const X=z.get(_);if(X)return X;if(oe(_)){const te=j[_];if(typeof te=="function")return te.call(j,H)}throw new Error(`Event not found: ${_}`)}call(x,_,H){const X=j[_];if(typeof X=="function"){if(!U&&Array.isArray(H))for(let te=0;te<H.length;te++)H[te]=(0,P.revive)(H[te]);return X.apply(j,H)}throw new Error(`Method not found: ${_}`)}}}W.fromService=F;function J(ce,V){const j=V&&V.disableMarshalling;return new Proxy({},{get(U,z){if(typeof z=="string")return V?.properties?.has(z)?V.properties.get(z):oe(z)?function(x){return ce.listen(z,x)}:ee(z)?ce.listen(z):async function(...x){let _;V&&!(0,m.isUndefinedOrNull)(V.context)?_=[V.context,...x]:_=x;const H=await ce.call(z,_);return j?H:(0,P.revive)(H)};throw new Error(`Property not found: ${String(z)}`)}})}W.toService=J;function ee(ce){return ce[0]==="o"&&ce[1]==="n"&&v.isUpperAsciiLetter(ce.charCodeAt(2))}function oe(ce){return/^onDynamic/.test(ce)&&v.isUpperAsciiLetter(ce.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const F=W.toString();if(F!=="[object Object]")return F}return W}function Q(W){return Array.isArray(W)?W.map(G):G(W)}function re(W,F,J,ee,oe,ce,V){V=Q(V);const j=q[oe],U=j[ee%j.length];let z=[`%c[${W}]%c[${String(F).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ce)?(z=z.concat(V),z.push(")")):z.push(V),console.log.apply(console,z)}class K{constructor(F,J){this.d=F,this.f=J,this.a=0,this.b=0}logOutgoing(F,J,ee,oe,ce){this.b+=F,re(this.d,this.b,F,J,ee,oe,ce)}logIncoming(F,J,ee,oe,ce){this.a+=F,re(this.f,this.a,F,J,ee,oe,ce)}}e.IPCLogger=K}),define(ne[151],se([0,1,17,3,39]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(I){this.a=I,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",S=>D.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class L extends l.IPCClient{constructor(I,S){const P=new A(I);super(P,S),this.b=P}dispose(){this.b.disconnect()}}e.Client=L}),define(ne[93],se([0,1,6,17,3,2,39]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(E){E.enableDiagnostics=!1,E.records=[];const k=new WeakMap;let N=0;function M(T,B){if(!k.has(T)){const q=String(++N);k.set(T,q)}return k.get(T)}function $(T,B,q,G){if(!E.enableDiagnostics)return;const Q=M(T,B);if(G instanceof O.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const re=O.VSBuffer.alloc(G.byteLength);re.set(G),E.records.push({timestamp:Date.now(),id:Q,label:B,type:q,buff:re})}else E.records.push({timestamp:Date.now(),id:Q,label:B,type:q,data:G})}E.traceSocketEvent=$})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function v(){return P||(P=O.VSBuffer.alloc(0)),P}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(k){this.a.push(k),this.b+=k.byteLength}read(k){return this.c(k,!0)}peek(k){return this.c(k,!1)}c(k,N){if(k===0)return v();if(k>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===k){const B=this.a[0];return N&&(this.a.shift(),this.b-=k),B}if(this.a[0].byteLength>k){const B=this.a[0].slice(0,k);return N&&(this.a[0]=this.a[0].slice(k),this.b-=k),B}const M=O.VSBuffer.alloc(k);let $=0,T=0;for(;k>0;){const B=this.a[T];if(B.byteLength>k){const q=B.slice(0,k);M.set(q,$),$+=k,N&&(this.a[T]=B.slice(k),this.b-=k),k-=k}else M.set(B,$),$+=B.byteLength,N?(this.a.shift(),this.b-=B.byteLength):T++,k-=B.byteLength}return M}}e.ChunkStream=m;var g;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function f(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(k,N,M,$){this.type=k,this.id=N,this.ack=M,this.data=$,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends A.Disposable{constructor(k){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=k,this.b=!1,this.c=new m,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(k){if(!(!k||k.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(k);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,$=this.g.id,T=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new h(M,$,T,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(k){this.k=null,this.a=!1,this.b=!1,this.c=k,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(k){if(this.a)return;k.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=O.VSBuffer.alloc(13);N.writeUInt8(k.type,0),N.writeUInt32BE(k.id,1),N.writeUInt32BE(k.ack,5),N.writeUInt32BE(k.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(k.type),id:k.id,ack:k.ack,messageSize:k.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",k.data),this.j(N,k.data)}g(k,N){const M=this.f===0;return this.d.push(k,N),this.f+=k.byteLength+N.byteLength,M}h(){const k=O.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,k}j(k,N){this.g(k,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const k=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:k.byteLength}),this.c.write(k)}}class y extends A.Disposable{constructor(k){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=k,this.b=this.B(new d(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(k){this.b.write(new h(1,0,0,k))}}e.Protocol=y;class b extends L.IPCClient{static fromSocket(k,N){return new b(new y(k),N)}get onDidDispose(){return this.b.onDidDispose}constructor(k,N,M=null){super(k,N,M),this.b=k}dispose(){super.dispose();const k=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),k.end()}}e.Client=b;class C{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(k){this.b?this.d.length>0?this.d.push(k):this.a.fire(k):this.d.push(k)}flushBuffer(){this.d=[]}}e.BufferedEmitter=C;class t{constructor(k){this.data=k,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let k=0,N=this.a;for(;N;)N=N.next,k++;return k}peek(){return this.a?this.a.data:null}toArray(){const k=[];let N=0,M=this.a;for(;M;)k[N++]=M.data,M=M.next;return k}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(k){const N=new t(k);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const k=Date.now();for(let N=0;N<i.a;N++)this.c[N]=k-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const k=Date.now(),N=(1+i.a)*1e3;let M=0;for(let $=0;$<i.a;$++)k-this.c[$]<=N&&M++;return 1-M/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class o{constructor(k){this.connectionHealth=k}}e.ConnectionHealthChangedEvent=o;class s{constructor(k,N){this.roundTripTime=k,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=s;class c{get unacknowledgedCount(){return this.c-this.d}constructor(k){this.x=new C,this.onControlMessage=this.x.event,this.y=new C,this.onMessage=this.y.event,this.z=new C,this.onDidDispose=this.z.event,this.A=new C,this.onSocketClose=this.A.event,this.B=new C,this.onSocketTimeout=this.B.event,this.C=new C,this.onHighRoundTripTime=this.C.event,this.D=new C,this.onDidChangeConnectionHealth=this.D.event,this.u=k.loadEstimator??i.getInstance(),this.v=k.measureRoundTripTime??!1,this.w=k.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=k.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),k.initialChunk&&this.q.acceptChunk(k.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const k=new h(5,0,0,v());this.p.write(k),this.p.flush()}sendPause(){const k=new h(7,0,0,v());this.p.write(k)}sendResume(){const k=new h(8,0,0,v());this.p.write(k)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(k,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=k,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const k=new h(3,0,this.h,v());this.p.write(k);const N=this.b.toArray();for(let M=0,$=N.length;M<$;M++)this.p.write(N[M]);this.G()}acceptDisconnect(){this.z.fire()}E(k){if(k.ack>this.d){this.d=k.ack;do{const N=this.b.peek();if(N&&N.id<=k.ack)this.b.pop();else break}while(!0)}switch(k.type){case 0:break;case 1:{if(k.id>this.g)if(k.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new h(6,0,0,v())))}else this.g=k.id,this.j=Date.now(),this.F(),this.y.fire(k.data);break}case 2:{this.x.fire(k.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let M=0,$=N.length;M<$;M++)this.p.write(N[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(k.data);break}case 11:{this.r.handleResponse(k.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(k){const N=++this.c;this.h=this.g;const M=new h(1,N,this.h,k);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(k){const N=new h(2,0,0,k);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const k=Date.now()-this.j;if(k>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-k+5)}G(){if(this.c<=this.d||this.f||this.a)return;const k=this.b.peek(),N=Date.now()-k.writtenTime,M=Date.now()-this.q.lastReadTime,$=Date.now()-this.n;if(N>=2e4&&M>=2e4&&$>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:M});return}const T=Math.max(2e4-N,2e4-M,2e4-$,500);this.f=setTimeout(()=>{this.f=null,this.G()},T)}H(){if(this.g<=this.h)return;this.h=this.g;const k=new h(3,0,this.h,v());this.p.write(k)}I(){this.h=this.g;const k=new h(9,0,this.h,v());this.p.write(k)}J(k){this.h=this.g;const N=new h(10,0,this.h,k);this.p.write(N)}K(k){this.h=this.g;const N=new h(11,0,this.h,k);this.p.write(N)}}e.PersistentProtocol=c;class w extends A.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new D.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},k=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const k=++this.h,N=O.VSBuffer.alloc(4);N.writeUInt32BE(k,0),this.a.fire(N)},6e4)}handleResponse(k){if(k.byteLength!==4)return;const N=k.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const M=Date.now()-this.g,$=this.k++;this.j[$%this.j.length]=M;const T=this.l,B=this.j.filter(q=>q>=1e3).length;this.l=B>=3?1:0,M>1e3&&this.b.fire(new s(M,B)),T!==this.l&&this.c.fire(this.l)}}}),define(ne[152],se([0,1,94,3,39,151]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends l.IPCServer{static b(){const I=O.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(S,P)=>P);return O.Event.map(I,S=>{const{port1:P,port2:v}=new MessageChannel,g={protocol:new A.Protocol(P),onDidClientDisconnect:O.Event.fromDOMEventEmitter(P,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[v]),g})}constructor(){super(L.b())}}e.Server=L}),define(ne[68],se([0,1,50,6,17,24,145,8,3,2,32,92,87,39]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends g.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>l.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const y=d&&d.timeout?d.timeout:6e4;this.b=new O.Delayer(y),this.d=null,this.f=null}getChannel(u){const d=this;return{call(y,b,C){return d.k(u,y,b,C)},listen(y,b){return d.l(u,y,b)}}}k(u,d,y,b=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const C=this.n(u),t=(0,O.createCancelablePromise)(n=>C.call(d,y,n)),a=b.onCancellationRequested(()=>t.cancel()),i=(0,S.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,d,y){if(!this.b)return I.Event.None;this.b.cancel();let b;const C=new I.Emitter({onWillAddFirstListener:()=>{b=this.n(u).listen(d,y)(C.fire,C),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,D.fork)(this.i,u,d);const y=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,L.isRemoteConsoleLog)(r)){(0,L.log)(r,`IPC Library: ${this.j.serverName}`);return}y.fire(l.VSBuffer.wrap(Buffer.from(r,"base64")))});const C=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&C.send(r.buffer.toString("base64")),a=y.event,i={send:t,onMessage:a};this.f=new g.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(s=>(0,S.dispose)(s)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(ne[153],se([0,1,17,8,3,2,13,4,31,39,93]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(s,c){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,c)}constructor(s,c=""){this.f=!0,this.debugLabel=c,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,O.onUnexpectedError)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const c=w=>{this.traceSocketEvent("read",w),s(D.VSBuffer.wrap(w))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(s){const c=w=>{s({type:0,hadError:w,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(s){const c=()=>{s()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,O.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,O.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var g;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var f;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(f||(f={}));class p extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,c){this.socket.traceSocketEvent(s,c)}constructor(s,c,w,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:w?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new h(this,c,w,E,this.f,(k,N)=>this.k(k,N))),this.B(this.a.onError(k=>{console.error(k),(0,O.onUnexpectedError)(k),this.g.fire({type:0,hadError:!0,error:k})})),this.b=new P.ChunkStream,this.B(this.socket.onData(k=>this.l(k))),this.B(this.socket.onClose(k=>this.g.fire(k)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,c){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let w=2;s.byteLength<126?w+=0:s.byteLength<2**16?w+=2:w+=8;const E=D.VSBuffer.alloc(w);if(c?E.writeUInt8(194,0):E.writeUInt8(130,0),s.byteLength<126)E.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){E.writeUInt8(126,1);let k=1;E.writeUInt8(s.byteLength>>>8&255,++k),E.writeUInt8(s.byteLength>>>0&255,++k)}else{E.writeUInt8(127,1);let k=1;E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(0,++k),E.writeUInt8(s.byteLength>>>24&255,++k),E.writeUInt8(s.byteLength>>>16&255,++k),E.writeUInt8(s.byteLength>>>8&255,++k),E.writeUInt8(s.byteLength>>>0&255,++k)}this.socket.write(D.VSBuffer.concat([E,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const c=this.b.peek(this.j.readLen),w=c.readUInt8(0),E=(w&128)>>>7,k=(w&64)>>>6,N=c.readUInt8(1),M=(N&128)>>>7,$=N&127;this.j.state=2,this.j.readLen=2+(M?4:0)+($===126?2:0)+($===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(k)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const c=this.b.read(this.j.readLen),w=c.readUInt8(1),E=(w&128)>>>7;let k=w&127,N=1;k===126?k=c.readUInt8(++N)*2**8+c.readUInt8(++N):k===127&&(k=c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*2**24+c.readUInt8(++N)*2**16+c.readUInt8(++N)*2**8+c.readUInt8(++N));let M=0;E&&(M=c.readUInt8(++N)*2**24+c.readUInt8(++N)*2**16+c.readUInt8(++N)*2**8+c.readUInt8(++N)),this.j.state=3,this.j.readLen=k,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const c=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),y(c,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(c,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(s,c,w,E,k,N){super(),this.k=s,this.l=k,this.m=N,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,c?(this.b=this.B(new u(this.k,E,w,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const c=await this.r(this.f,s);this.m(c,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,c){return new Promise((w,E)=>{s.write(c),s.flush(k=>w(k))})}acceptFrame(s,c,w){this.h.push({data:s,isCompressed:c,isLastFrameOfMessage:w}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const c=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(c)}else this.l.fire(s.data)}this.s=!1}}u(s,c,w){return new Promise((E,k)=>{s.write(c),w&&s.write(D.VSBuffer.fromByteArray([0,0,255,255])),s.flush(N=>E(N))})}}class u extends A.Disposable{get recordedInflateBytes(){return this.j?D.VSBuffer.concat(this.f):D.VSBuffer.alloc(0)}constructor(s,c,w,E){super(),this.h=s,this.j=c,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(E),this.b.on("error",k=>{this.h.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.h.traceSocketEvent("zlibInflateData",k),this.g.push(D.VSBuffer.wrap(k))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const c=D.VSBuffer.concat(this.g);this.g.length=0,s(c)})}}class d extends A.Disposable{constructor(s,c){super(),this.g=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(D.VSBuffer.wrap(w))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let c=D.VSBuffer.concat(this.f);this.f.length=0,c=c.slice(0,c.byteLength-4),s(c)})}}function y(o,s){if(s===0)return;const c=o.byteLength>>>2;for(let $=0;$<c;$++){const T=o.readUInt32BE($*4);o.writeUInt32BE(T^s,$*4)}const w=c*4,E=o.byteLength-w,k=s>>>24&255,N=s>>>16&255,M=s>>>8&255;E>=1&&o.writeUInt8(o.readUInt8(w)^k,w),E>=2&&o.writeUInt8(o.readUInt8(w+1)^N,w+1),E>=3&&o.writeUInt8(o.readUInt8(w+2)^M,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function C(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):s=(0,L.join)(v().os.tmpdir(),`vscode-ipc-${o}.sock`),a(s),s}e.createRandomIPCHandle=C;function t(o,s,c){const w=v().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${c}-${s}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${c}-${s}.sock`):E=(0,L.join)(o,`${c}-${s}.sock`),a(E),E}e.createStaticIPCHandle=t;function a(o){const s=b[R.platform];typeof s=="number"&&o.length>=s&&console.warn(`WARNING: IPC handle "${o}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends S.IPCServer{static b(s){const c=l.Event.fromNodeEventEmitter(s,"connection");return l.Event.map(c,w=>({protocol:new P.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(w,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(o){return new Promise((s,c)=>{const w=v().net.createServer();w.on("error",c),w.listen(o,()=>{w.removeListener("error",c),s(new i(w))})})}e.serve=n;function r(o,s){return new Promise((c,w)=>{const E=v().net.createConnection(o,()=>{E.removeListener("error",w),c(P.Client.fromSocket(new m(E,`ipc-client${s}`),s))});E.once("error",w)})}e.connect=r}),define(ne[69],se([0,1,6,3,2,12]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L=e.StorageHint||(e.StorageHint={}));function R(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var I;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends l.Disposable{constructor(m,g=Object.create(null)){super(),this.m=m,this.n=g,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new D.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((g,f)=>this.s(f,g)),m.deleted?.forEach(g=>this.s(g,void 0))}s(m,g){if(this.c===I.Closed)return;let f=!1;(0,A.isUndefinedOrNull)(g)?f=this.f.delete(m):this.f.get(m)!==g&&(this.f.set(m,g),f=!0),f&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,g){const f=this.f.get(m);return(0,A.isUndefinedOrNull)(f)?g:f}getBoolean(m,g){const f=this.get(m);return(0,A.isUndefinedOrNull)(f)?g:f==="true"}getNumber(m,g){const f=this.get(m);return(0,A.isUndefinedOrNull)(f)?g:parseInt(f,10)}async set(m,g){if(this.c===I.Closed)return;if((0,A.isUndefinedOrNull)(g))return this.delete(m);const f=String(g);if(this.f.get(m)!==f)return this.f.set(m,f),this.j.set(m,f),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===I.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===L.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}S.a=100,e.Storage=S;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((g,f)=>this.a.set(f,g)),m.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[154],se([9,7]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(ne[155],se([9,7]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[156],se([9,7]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(ne[157],se([9,7]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(ne[158],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[159],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[160],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[161],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[162],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[163],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[164],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[165],se([9,7]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[166],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(ne[167],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ne[168],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(ne[169],se([9,7]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[170],se([9,7]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[171],se([9,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ne[172],se([9,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(ne[173],se([9,7]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(ne[174],se([9,7]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(ne[175],se([9,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ne[176],se([9,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[177],se([9,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[178],se([9,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[179],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[180],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[181],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[182],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[183],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[184],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[185],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ne[186],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[187],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ne[188],se([9,7]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(ne[95],se([0,1,65,63,21,13,36,22,10]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=L.env.VSCODE_PORTABLE;return f?I.URI.file((0,A.join)(f,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?I.URI.file((0,A.resolve)(f)):I.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const p=L.env.VSCODE_EXTENSIONS;if(p)return p;const h=L.env.VSCODE_PORTABLE;return h?(0,A.join)(h,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?I.URI.parse(p):I.URI.file((0,A.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);h&&h[1]&&h[2]&&f.push([h[1],h[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=L.env.VSCODE_PORTABLE;return f?I.URI.file((0,A.join)(f,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,h){this.a=f,this.b=p,this.c=h,this.editSessionId=this.args.editSessionId}}ye([O.memoize],S.prototype,"appRoot",null),ye([O.memoize],S.prototype,"userHome",null),ye([O.memoize],S.prototype,"userDataPath",null),ye([O.memoize],S.prototype,"appSettingsHome",null),ye([O.memoize],S.prototype,"tmpDir",null),ye([O.memoize],S.prototype,"cacheHome",null),ye([O.memoize],S.prototype,"stateResource",null),ye([O.memoize],S.prototype,"userRoamingDataHome",null),ye([O.memoize],S.prototype,"userDataSyncHome",null),ye([O.memoize],S.prototype,"userDataSyncLogResource",null),ye([O.memoize],S.prototype,"editSessionsLogResource",null),ye([O.memoize],S.prototype,"sync",null),ye([O.memoize],S.prototype,"machineSettingsResource",null),ye([O.memoize],S.prototype,"workspaceStorageHome",null),ye([O.memoize],S.prototype,"localHistoryHome",null),ye([O.memoize],S.prototype,"keyboardLayoutResource",null),ye([O.memoize],S.prototype,"argvResource",null),ye([O.memoize],S.prototype,"isExtensionDevelopment",null),ye([O.memoize],S.prototype,"untitledWorkspacesHome",null),ye([O.memoize],S.prototype,"installSourcePath",null),ye([O.memoize],S.prototype,"builtinExtensionsPath",null),ye([O.memoize],S.prototype,"extensionsPath",null),ye([O.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],S.prototype,"extensionDevelopmentKind",null),ye([O.memoize],S.prototype,"extensionTestsLocationURI",null),ye([O.memoize],S.prototype,"debugExtensionHost",null),ye([O.memoize],S.prototype,"logLevel",null),ye([O.memoize],S.prototype,"extensionLogLevel",null),ye([O.memoize],S.prototype,"serviceMachineIdResource",null),ye([O.memoize],S.prototype,"telemetryLogResource",null),ye([O.memoize],S.prototype,"disableWorkspaceTrust",null),ye([O.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function P(g,f){return m(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=P;function v(g,f){return m(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,f,g.extensionEnvironment)}e.parsePtyHostPort=v;function m(g,f,p,h,u,d){const b=Number(f||g)||(h?null:p),C=b?Boolean(!!f):!1;let t;if(d)try{t=JSON.parse(d)}catch{}return{port:b,break:C,debugId:u,env:t}}}),define(ne[189],se([0,1,292,4,156]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(p,h,u=L){const d=p.find(o=>o.length>0&&o[0]!=="-"),y={},b=["_"],C=[],t={};let a;for(const o in h){const s=h[o];s.type==="subcommand"?o===d&&(a=s):(s.alias&&(y[o]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(o),s.deprecates&&b.push(...s.deprecates)):s.type==="boolean"&&(C.push(o),s.deprecates&&C.push(...s.deprecates)),s.global&&(t[o]=s))}if(a&&d){const o=t;for(const E in a.options)o[E]=a.options[E];const s=p.filter(E=>E!==d),c=u.getSubcommandReporter?u.getSubcommandReporter(d):void 0,w=R(s,o,c);return{[d]:w,_:[]}}const i=D(p,{string:b,boolean:C,alias:y}),n={},r=i;n._=i._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in h){const s=h[o];if(s.type==="subcommand")continue;s.alias&&delete r[s.alias];let c=r[o];if(s.deprecates)for(const w of s.deprecates)r.hasOwnProperty(w)&&(c||(c=r[w],c&&u.onDeprecatedOption(w,s.deprecationMessage||(0,l.localize)(36,null,o))),delete r[w]);if(typeof c<"u"){if(s.type==="string[]"){if(Array.isArray(c)||(c=[c]),!s.allowEmptyValue){const w=c.filter(E=>E.length>0);w.length!==c.length&&(u.onEmptyValue(o),c=w.length>0?w:void 0)}}else s.type==="string"&&(Array.isArray(c)?(c=c.pop(),u.onMultipleValues(o,c)):!c&&!s.allowEmptyValue&&(u.onEmptyValue(o),c=void 0));n[o]=c,s.deprecationMessage&&u.onDeprecatedOption(o,s.deprecationMessage)}delete r[o]}for(const o in r)u.onUnknownOption(o);return n}e.parseArgs=R;function I(p,h){let u="";return h.args&&(Array.isArray(h.args)?u=` <${h.args.join("> <")}>`:u=` <${h.args}>`),h.alias?`-${h.alias} --${p}${u}`:`--${p}${u}`}function S(p,h){const u=[];for(const d in p){const y=p[d],b=I(d,y);u.push([b,y.description])}return P(u,h)}e.formatOptions=S;function P(p,h){const d=p.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(h-d<25)return p.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const y=h-d-1,b=[];for(const C of p){const t=C[0],a=m(C[1],y),i=v(d-t.length-2);b.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)b.push(v(d)+a[n])}return b}function v(p){return" ".repeat(p)}function m(p,h){const u=[];for(;p.length;){const d=p.length<h?p.length:p.lastIndexOf(" ",h),y=p.slice(0,d).trim();p=p.slice(d),u.push(y)}return u}function g(p,h,u,d,y){const b=process.stdout.isTTY&&process.stdout.columns||80,C=y?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",t=[`${p} ${u}`];t.push(""),t.push(`${(0,l.localize)(38,null)}: ${h} [${(0,l.localize)(39,null)}]${C}`),t.push(""),y?.noPipe!==!0&&(O.isWindows?t.push((0,l.localize)(40,null,h)):t.push((0,l.localize)(41,null,h)),t.push(""));const a={},i=[];for(const n in d){const r=d[n];if(r.type==="subcommand")r.description&&i.push({command:n,description:r.description});else if(r.description&&r.cat){let o=a[r.cat];o||(a[r.cat]=o={}),o[n]=r}}for(const n in a){const r=n,o=a[r];o&&(t.push(A[r]),t.push(...S(o,b)),t.push(""))}return i.length&&(t.push((0,l.localize)(42,null)),t.push(...P(i.map(n=>[n.command,n.description]),b)),t.push("")),t.join(`
`)}e.buildHelpMessage=g;function f(p,h){return`${p||(0,l.localize)(43,null)}
${h||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ne[190],se([0,1,293,157,189]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function L(m,g){const f=(b,C)=>{console.warn((0,O.localize)(0,null,b,C))},p=b=>{console.warn((0,O.localize)(1,null,b))},h=(b,C)=>{console.warn((0,O.localize)(2,null,b,C))},u=b=>({onUnknownOption:C=>{b!=="tunnel"&&console.warn((0,O.localize)(3,null,C,b))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:b!=="tunnel"?u:void 0}),d={onUnknownOption:b=>{console.warn((0,O.localize)(4,null,b))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:u},y=(0,l.parseArgs)(m,l.OPTIONS,g?d:void 0);return y.goto&&y._.forEach(b=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,O.localize)(5,null))),y["max-memory"]&&D(parseInt(y["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),y}function R(m){const g=m.findIndex(f=>!/^-/.test(f));if(g>-1)return[...m.slice(0,g),...m.slice(g+1)]}function I(m){let[,...g]=m;process.env.VSCODE_DEV&&(g=R(g)||[]);const f=!v(process.env);return L(g,f)}e.parseMainProcessArgv=I;function S(m){let[,,...g]=m;return process.env.VSCODE_DEV&&(g=R(g)||[]),L(g,!0)}e.parseCLIProcessArgv=S;function P(m,...g){const f=m.indexOf("--");return f===-1?m.push(...g):m.splice(f,0,...g),m}e.addArg=P;function v(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function Z(e,D,O){function l(L,R){const I=A(L,R),S=[I];return e.isAbsolute(I)||S.unshift(O),e.resolve(...S)}function A(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(v,"AppData","Roaming")}break;case"darwin":S=e.join(D.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:l}}if(typeof define=="function")define(ne[191],se([294,34,36]),function(e,D,O){return Z(e,D,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Z(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[192],se([0,1,34,95,191]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(R,I){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,l.getUserDataPath)(R,I.nameShort)},I)}}e.NativeEnvironmentService=A}),define(ne[193],se([0,1,10]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const O=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(h){const u=h.match(L);return u?u[1]:null}function P(h){if(h.indexOf("://")===-1){const u=h.match(O);return u?S(u[2]):null}try{const u=D.URI.parse(h);if(u.authority)return S(u.authority)}catch{}return null}function v(h,u){const d=new Set;let y;for(;y=R.exec(h);){const C=P(y[1]);C&&d.add(C)}const b=new Set(u);return Array.from(d).map(C=>b.has(C)?C:C.replace(I,"a"))}e.getDomainsOfRemotes=v;function m(h){const u=h.match(A);return u?u[2]:null}function g(h,u,d){return h&&u?(d&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${h}${u}`:`${h}/${u}`):null}function f(h,u){if(h.indexOf("://")===-1){const d=h.match(l);if(d)return g(d[2],d[3],u)}try{const d=D.URI.parse(h);if(d.authority)return g(m(d.authority),d.path,u)}catch{}return null}function p(h,u=!1){const d=[];let y;for(;y=R.exec(h);){const b=f(y[1],u);b&&d.push(b)}return d}e.getRemotes=p}),define(ne[194],se([0,1,12,160]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(L,R,I){try{A(L,R,I)}catch(S){console.error(S?.message??S)}return L}e.localizeManifest=l;function A(L,R,I){const S=(P,v,m)=>{const g=P[v];if((0,D.isString)(g)){const f=g,p=f.length;if(p>1&&f[0]==="%"&&f[p-1]==="%"){const h=f.substr(1,p-2);let u=R[h];u===void 0&&I&&(u=I[h]);const d=typeof u=="string"?u:u?.message,y=I?.[h],b=typeof y=="string"?y:y?.message;if(!d){b||console.warn(`[${L.name}]: ${(0,O.localize)(0,null,h)}`);return}if(m&&(v==="title"||v==="category")&&b&&b!==d){const C={value:d,original:b};P[v]=C}else P[v]=d}}else if((0,D.isObject)(g))for(const f in g)g.hasOwnProperty(f)&&(f==="commands"?S(g,f,!0):S(g,f,m));else if(Array.isArray(g))for(let f=0;f<g.length;f++)S(g,f,m)};for(const P in L)L.hasOwnProperty(P)&&S(L,P)}}),define(ne[195],se([0,1,8]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(A,L){this.a.set(A,L)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const L in A.contributes){const R=this.a.get(L);if(!R)continue;const I=A.contributes[L],S=Array.isArray(I)?I:[I];try{R(S,A.activationEvents)}catch(P){(0,D.onUnexpectedError)(P)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(ne[196],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,L,R,I){return this.a.call("promptImportantExtensionsInstallNotification",[A,L,R,I])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class O{constructor(A){this.a=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,R){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(ne[70],se([0,1,22,89,165,54]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function S(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=S;function P(u){if(!u)return null;const d=u.majorBase,y=u.majorMustEqual,b=u.minorBase;let C=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(d===0||(C=!1),a=!1);let i=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,r,o,s]=n;i=Date.UTC(Number(r),Number(o)-1,Number(s))}}return{majorBase:d,majorMustEqual:y,minorBase:b,minorMustEqual:C,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function v(u,d,y){let b;typeof u=="string"?b=P(S(u)):b=u;let C;d instanceof Date?C=d.getTime():typeof d=="string"&&(C=new Date(d).getTime());let t;if(typeof y=="string"?t=P(S(y)):t=y,!b||!t)return!1;const a=b.majorBase,i=b.minorBase,n=b.patchBase;let r=t.majorBase,o=t.minorBase,s=t.patchBase;const c=t.notBefore;let w=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>o?!0:i<o||C&&C<c?!1:n>=s:(a===1&&r===0&&(!w||!E||!k)&&(r=1,o=0,s=0,w=!0,E=!1,k=!1),a<r?!1:a>r?!w:i<o?!1:i>o?!E:n<s?!1:n>s?!k:!(C&&C<c))}e.isValidVersion=v;function m(u,d,y,b,C){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([O.default.Error,l.localize(0,null)]),t;if(typeof b.name!="string")return t.push([O.default.Error,l.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([O.default.Error,l.localize(2,null,"version")]),t;if(!b.engines)return t.push([O.default.Error,l.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([O.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!h(b.extensionDependencies))return t.push([O.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!h(b.activationEvents))return t.push([O.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([O.default.Error,l.localize(7,null,"activationEvents","main")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([O.default.Warning,l.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([O.default.Error,l.localize(9,null,"main")]),t;{const n=(0,D.joinPath)(y,b.main);(0,D.isEqualOrParent)(n,y)||t.push([O.default.Warning,l.localize(10,null,n.path,y.path)])}if(typeof b.activationEvents>"u")return t.push([O.default.Error,l.localize(11,null,"activationEvents","main")]),t}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([O.default.Error,l.localize(12,null,"browser")]),t;{const n=(0,D.joinPath)(y,b.browser);(0,D.isEqualOrParent)(n,y)||t.push([O.default.Warning,l.localize(13,null,n.path,y.path)])}if(typeof b.activationEvents>"u")return t.push([O.default.Error,l.localize(14,null,"activationEvents","browser")]),t}if(!A.valid(b.version))return t.push([O.default.Error,l.localize(15,null)]),t;const a=[];if(!g(u,d,b,C,a))for(const n of a)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=m;function g(u,d,y,b,C){return b||typeof y.main>"u"&&typeof y.browser>"u"?!0:p(u,d,y.engines.vscode,C)}e.isValidExtensionVersion=g;function f(u,d,y){return u==="*"||p(d,y,u)}e.isEngineValid=f;function p(u,d,y,b=[]){const C=P(S(y));if(!C)return b.push(l.localize(16,null,y)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return b.push(l.localize(17,null,y)),!1}else if(!C.majorMustEqual)return b.push(l.localize(18,null,y)),!1;return v(u,d,C)?!0:(b.push(l.localize(19,null,u,y)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let d=0,y=u.length;d<y;d++)if(typeof u[d]!="string")return!1;return!0}}),define(ne[44],se([0,1,17,31]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(A,L,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await L.readFile(A.serviceMachineIdResource)).value.toString();I=(0,O.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,O.generateUuid)();try{await L.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(ne[55],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(l,A=[],L=!1){this.ctor=l,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(ne[71],se([0,1,55]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function A(R,I,S){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(S))),O.push([R,I])}e.registerSingleton=A;function L(){return O}e.getSingletonServiceDescriptors=L}),define(ne[197],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class O{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const L of this.a.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const R=this.lookupOrInsertNode(A),I=this.lookupOrInsertNode(L);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(A){const L=this.b(A);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(A){const L=this.b(A);let R=this.a.get(L);return R||(R=new D(L,A),this.a.set(L,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[L,R]of this.a)A.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this.a){const R=new Set([A]),I=this.c(L,R);if(I)return I}}c(A,L){for(const[R,I]of A.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const S=this.c(I,L);if(S)return S;L.delete(R)}}}e.Graph=O}),define(ne[5],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function O(L,R,I){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:L,index:I}):(R[D.DI_DEPENDENCIES]=[{id:L,index:I}],R[D.DI_TARGET]=R)}function l(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const R=function(I,S,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,I,P)};return R.toString=()=>L,D.serviceIds.set(L,R),R}e.createDecorator=l;function A(L){return L}e.refineServiceDecorator=A}),define(ne[198],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[16],se([0,1,12,10,5]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationOverrides=A;function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=L;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(h,u){const d=Object.create(null);for(const y in h)P(d,y,h[y],u);return d}e.toValuesTree=S;function P(h,u,d,y){const b=u.split("."),C=b.pop();let t=h;for(let a=0;a<b.length;a++){const i=b[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${u} as ${b.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[C]=d}catch{y(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=P;function v(h,u){const d=u.split(".");m(h,d)}e.removeFromValueTree=v;function m(h,u){const d=u.shift();if(u.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const y=h[d];typeof y=="object"&&!Array.isArray(y)&&(m(y,u),Object.keys(y).length===0&&delete h[d])}}function g(h,u,d){function y(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const b=u.split("."),C=y(h,b);return typeof C>"u"?d:C}e.getConfigurationValue=g;function f(h,u,d){Object.keys(u).forEach(y=>{y!=="__proto__"&&(y in h?D.isObject(h[y])&&D.isObject(u[y])?f(h[y],u[y],d):d&&(h[y]=u[y]):h[y]=u[y])})}e.merge=f;function p(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ne[199],se([0,1,4,26,5]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",D.isEdge),A.set("isFirefox",D.isFirefox),A.set("isChrome",D.isChrome),A.set("isSafari",D.isSafari);const L=Object.prototype.hasOwnProperty;var R;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return v.INSTANCE}static true(){return m.INSTANCE}static has(T){return g.create(T)}static equals(T,B){return f.create(T,B)}static notEquals(T,B){return u.create(T,B)}static regex(T,B){return i.create(T,B)}static in(T,B){return p.create(T,B)}static notIn(T,B){return h.create(T,B)}static not(T){return d.create(T)}static and(...T){return o.create(T,null,!0)}static or(...T){return s.create(T,null,!0)}static greater(T,B){return b.create(T,B)}static greaterEquals(T,B){return C.create(T,B)}static smaller(T,B){return t.create(T,B)}static smallerEquals(T,B){return a.create(T,B)}static deserialize(T,B=!1){if(!!T)return this.c(T,B)}static c(T,B){const q=T.split("||");return s.create(q.map(G=>this.d(G,B)),null,!0)}static d(T,B){const q=T.split("&&");return o.create(q.map(G=>this.f(G,B)),null,!0)}static f(T,B){if(T=T.trim(),T.indexOf("!=")>=0){const q=T.split("!=");return u.create(q[0].trim(),this.g(q[1],B))}if(T.indexOf("==")>=0){const q=T.split("==");return f.create(q[0].trim(),this.g(q[1],B))}if(T.indexOf("=~")>=0){const q=T.split("=~");return i.create(q[0].trim(),this.h(q[1],B))}if(T.indexOf(" not in ")>=0){const q=T.split(" not in ");return h.create(q[0].trim(),this.g(q[1],B))}if(T.indexOf(" in ")>=0){const q=T.split(" in ");return p.create(q[0].trim(),this.g(q[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const q=T.split(">=");return C.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const q=T.split(">");return b.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const q=T.split("<=");return a.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const q=T.split("<");return t.create(q[0].trim(),q[1].trim())}return/^\!\s*/.test(T)?d.create(T.substr(1).trim()):g.create(T)}static g(T,B){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const q=/^'([^']*)'$/.exec(T);return q?q[1].trim():T}static h(T,B){if((0,O.isFalsyOrWhitespace)(T)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const q=T.indexOf("/"),G=T.lastIndexOf("/");if(q===G||q<0){if(B)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}const Q=T.slice(q+1,G),re=T[G+1]==="i"?"i":"";try{return new RegExp(Q,re)}catch(K){if(B)throw new Error(`bad regexp-value '${T}', parse error: ${K}`);return console.warn(`bad regexp-value '${T}', parse error: ${K}`),null}}}e.ContextKeyExpr=I;function S($,T){const B=$?$.substituteConstants():void 0,q=T?T.substituteConstants():void 0;return!B&&!q?!0:!B||!q?!1:B.equals(q)}e.expressionsAreEqualWithConstantSubstitution=S;function P($,T){return $.cmp(T)}class v{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return m.INSTANCE}}v.INSTANCE=new v,e.ContextKeyFalseExpr=v;class m{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return v.INSTANCE}}m.INSTANCE=new m,e.ContextKeyTrueExpr=m;class g{static create(T,B=null){const q=A.get(T);return typeof q=="boolean"?q?m.INSTANCE:v.INSTANCE:new g(T,B)}constructor(T,B){this.key=T,this.c=B,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:w(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=A.get(this.key);return typeof T=="boolean"?T?m.INSTANCE:v.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=g;class f{static create(T,B,q=null){if(typeof B=="boolean")return B?g.create(T,q):d.create(T,q);const G=A.get(T);return typeof G=="boolean"?B===(G?"true":"false")?m.INSTANCE:v.INSTANCE:new f(T,B,q)}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=A.get(this.c);if(typeof T=="boolean"){const B=T?"true":"false";return this.d===B?m.INSTANCE:v.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class p{static create(T,B){return new p(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:E(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const B=T.getValue(this.f),q=T.getValue(this.d);return Array.isArray(B)?B.includes(q):typeof q=="string"&&typeof B=="object"&&B!==null?L.call(B,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class h{static create(T,B){return new h(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=11,this.c=p.create(T,B)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=h;class u{static create(T,B,q=null){if(typeof B=="boolean")return B?d.create(T,q):g.create(T,q);const G=A.get(T);return typeof G=="boolean"?B===(G?"true":"false")?v.INSTANCE:m.INSTANCE:new u(T,B,q)}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=A.get(this.c);if(typeof T=="boolean"){const B=T?"true":"false";return this.d===B?v.INSTANCE:m.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class d{static create(T,B=null){const q=A.get(T);return typeof q=="boolean"?q?v.INSTANCE:m.INSTANCE:new d(T,B)}constructor(T,B){this.c=T,this.d=B,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:w(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=A.get(this.c);return typeof T=="boolean"?T?v.INSTANCE:m.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function y($,T){if(typeof $=="string"){const B=parseFloat($);isNaN(B)||($=B)}return typeof $=="string"||typeof $=="number"?T($):v.INSTANCE}class b{static create(T,B,q=null){return y(B,G=>new b(T,G,q))}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=b;class C{static create(T,B,q=null){return y(B,G=>new C(T,G,q))}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=C;class t{static create(T,B,q=null){return y(B,G=>new t(T,G,q))}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class a{static create(T,B,q=null){return y(B,G=>new a(T,G,q))}constructor(T,B,q){this.c=T,this.d=B,this.f=q,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:E(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=a;class i{static create(T,B){return new i(T,B)}constructor(T,B){this.d=T,this.f=B,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const B=this.f?this.f.source:"",q=T.f?T.f.source:"";return B<q?-1:B>q?1:0}equals(T){if(T.type===this.type){const B=this.f?this.f.source:"",q=T.f?T.f.source:"";return this.d===T.d&&B===q}return!1}substituteConstants(){return this}evaluate(T){const B=T.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=i;class n{static create(T){return new n(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new n(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function r($){let T=null;for(let B=0,q=$.length;B<q;B++){const G=$[B].substituteConstants();if($[B]!==G&&T===null){T=[];for(let Q=0;Q<B;Q++)T[Q]=$[Q]}T!==null&&(T[B]=G)}return T===null?$:T}class o{static create(T,B,q){return o.d(T,B,q)}constructor(T,B){this.expr=T,this.c=B,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let B=0,q=this.expr.length;B<q;B++){const G=P(this.expr[B],T.expr[B]);if(G!==0)return G}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let B=0,q=this.expr.length;B<q;B++)if(!this.expr[B].equals(T.expr[B]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:o.create(T,this.c,!1)}evaluate(T){for(let B=0,q=this.expr.length;B<q;B++)if(!this.expr[B].evaluate(T))return!1;return!0}static d(T,B,q){const G=[];let Q=!1;for(const re of T)if(!!re){if(re.type===1){Q=!0;continue}if(re.type===0)return v.INSTANCE;if(re.type===6){G.push(...re.expr);continue}G.push(re)}if(G.length===0&&Q)return m.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(P);for(let re=1;re<G.length;re++)G[re-1].equals(G[re])&&(G.splice(re,1),re--);if(G.length===1)return G[0];for(;G.length>1;){const re=G[G.length-1];if(re.type!==9)break;G.pop();const K=G.pop(),W=G.length===0,F=s.create(re.expr.map(J=>o.create([J,K],null,q)),null,W);F&&(G.push(F),G.sort(P))}if(G.length===1)return G[0];if(q){for(let re=0;re<G.length;re++)for(let K=re+1;K<G.length;K++)if(G[re].negate().equals(G[K]))return v.INSTANCE;if(G.length===1)return G[0]}return new o(G,B)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const B of this.expr)T.push(...B.keys());return T}map(T){return new o(this.expr.map(B=>B.map(T)),null)}negate(){if(!this.c){const T=[];for(const B of this.expr)T.push(B.negate());this.c=s.create(T,this,!0)}return this.c}}class s{static create(T,B,q){return s.d(T,B,q)}constructor(T,B){this.expr=T,this.c=B,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let B=0,q=this.expr.length;B<q;B++){const G=P(this.expr[B],T.expr[B]);if(G!==0)return G}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let B=0,q=this.expr.length;B<q;B++)if(!this.expr[B].equals(T.expr[B]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:s.create(T,this.c,!1)}evaluate(T){for(let B=0,q=this.expr.length;B<q;B++)if(this.expr[B].evaluate(T))return!0;return!1}static d(T,B,q){let G=[],Q=!1;if(T){for(let re=0,K=T.length;re<K;re++){const W=T[re];if(!!W){if(W.type===0){Q=!0;continue}if(W.type===1)return m.INSTANCE;if(W.type===9){G=G.concat(W.expr);continue}G.push(W)}}if(G.length===0&&Q)return v.INSTANCE;G.sort(P)}if(G.length!==0){if(G.length===1)return G[0];for(let re=1;re<G.length;re++)G[re-1].equals(G[re])&&(G.splice(re,1),re--);if(G.length===1)return G[0];if(q){for(let re=0;re<G.length;re++)for(let K=re+1;K<G.length;K++)if(G[re].negate().equals(G[K]))return m.INSTANCE;if(G.length===1)return G[0]}return new s(G,B)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const B of this.expr)T.push(...B.keys());return T}map(T){return new s(this.expr.map(B=>B.map(T)),null)}negate(){if(!this.c){const T=[];for(const B of this.expr)T.push(B.negate());for(;T.length>1;){const B=T.shift(),q=T.shift(),G=[];for(const Q of M(B))for(const re of M(q))G.push(o.create([Q,re],null,!1));T.unshift(s.create(G,null,!1))}this.c=s.create(T,this,!0)}return this.c}}class c extends g{static all(){return c.d.values()}constructor(T,B,q){super(T,null),this.f=B,typeof q=="object"?c.d.push({...q,key:T}):q!==!0&&c.d.push({key:T,description:q,type:B!=null?typeof B:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return f.create(this.key,T)}notEqualsTo(T){return u.create(this.key,T)}}c.d=[],e.RawContextKey=c,e.IContextKeyService=(0,l.createDecorator)("contextKeyService");function w($,T){return $<T?-1:$>T?1:0}function E($,T,B,q){return $<B?-1:$>B?1:T<q?-1:T>q?1:0}function k($,T){if($.type===0||T.type===1)return!0;if($.type===9)return T.type===9?N($.expr,T.expr):!1;if(T.type===9){for(const B of T.expr)if(k($,B))return!0;return!1}if($.type===6){if(T.type===6)return N(T.expr,$.expr);for(const B of $.expr)if(k(B,T))return!0;return!1}return $.equals(T)}e.implies=k;function N($,T){let B=0,q=0;for(;B<$.length&&q<T.length;){const G=$[B].cmp(T[q]);if(G<0)return!1;G===0&&B++,q++}return B===$.length}function M($){return $.type===9?$.expr:[$]}}),define(ne[96],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function O(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=O;class l{async getPerformanceInfo(L,R){return{}}async getSystemInfo(L,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,R){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=l}),define(ne[97],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[15],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],se([0,1,159,5]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function L(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function R(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,d,y){return R(d,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:S(y).includes(u)}e.isTargetPlatformCompatible=I;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(d,y){super(d),this.code=y,this.name=y}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ne[200],se([0,1,3,2,67,32,10,146,29]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(h,u){return L.URI.revive(u?u.transformIncoming(h):h)}function P(h,u){return u?u.transformOutgoingURI(h):h}function v(h,u){u=u||R.DefaultURITransformer;const d=h.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...h,manifest:void 0},u),manifest:d}}function m(h,u){return u?(0,A.cloneAndChange)(h,d=>d instanceof L.URI?u.transformOutgoingURI(d):void 0):h}class g{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const y=this.b(u);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,b=>b.map(C=>({...C,local:C.local?m(C.local,y):C.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(u,d,y){const b=this.b(u);switch(d){case"zip":return this.a.zip(v(y[0],b)).then(C=>P(C,b));case"unzip":return this.a.unzip(S(y[0],b));case"install":return this.a.install(S(y[0],b),(0,l.revive)(y[1]));case"installFromLocation":return this.a.installFromLocation(S(y[0],b),L.URI.revive(y[1]));case"getManifest":return this.a.getManifest(S(y[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(y[0]);case"installFromGallery":return this.a.installFromGallery(y[0],(0,l.revive)(y[1]));case"uninstall":return this.a.uninstall(v(y[0],b),(0,l.revive)(y[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(v(y[0],b));case"getInstalled":return this.a.getInstalled(y[0],L.URI.revive(y[1])).then(C=>C.map(t=>m(t,b)));case"getMetadata":return this.a.getMetadata(v(y[0],b),L.URI.revive(y[1]));case"updateMetadata":return this.a.updateMetadata(v(y[0],b),y[1],L.URI.revive(y[2])).then(C=>m(C,b));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(y[0],y[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class f extends O.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new D.Emitter),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=this.B(new D.Emitter),this.j=this.B(new D.Emitter),this.B(this.k.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.l(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(y=>({...y,local:y.local?v(y.local,null):y.local,source:this.l(y.source)?L.URI.revive(y.source):y.source,profileLocation:L.URI.revive(y.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(v(d,null))))}l(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.m||(this.m=this.k.call("getTargetPlatform")),this.m}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(y=>(0,I.isTargetPlatformCompatible)(y,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(d=>L.URI.revive(d)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,d){return Promise.resolve(this.k.call("install",[u,d])).then(y=>v(y,null))}installFromLocation(u,d){return Promise.resolve(this.k.call("installFromLocation",[u,d])).then(y=>v(y,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.k.call("installFromGallery",[u,d])).then(y=>v(y,null))}uninstall(u,d){return Promise.resolve(this.k.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(d=>v(d,null))}getInstalled(u=null,d){return Promise.resolve(this.k.call("getInstalled",[u,d])).then(y=>y.map(b=>v(b,null)))}getMetadata(u,d){return Promise.resolve(this.k.call("getMetadata",[u,d]))}updateMetadata(u,d,y){return Promise.resolve(this.k.call("updateMetadata",[u,d,y])).then(b=>v(b,null))}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,d){const y=await this.k.call("download",[u,d]);return L.URI.revive(y)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class p{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,y){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ne[98],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((A,L)=>Z(["node-vsce-sign"],async R=>A(R),L))),this.a}async verify(A,L){let R;try{R=await this.b()}catch{return!1}return R.verify(A,L)}}e.ExtensionSignatureVerificationService=O}),define(ne[99],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(O=e.RecommendationSource||(e.RecommendationSource={}));function l(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var A;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],se([0,1,49,13,26,12,10,167,5,4,21]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function v(F){return F.create===!0}e.isFileOpenForWriteOptions=v;var m;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var g;(function(F){F[F.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var f;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=p;function h(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=u;function d(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=y;function b(F){return p(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var C;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(J,ee){const oe=new t(J.toString(),ee);return n(oe,ee),oe}constructor(J,ee){super(J),this.code=ee}}e.FileSystemProviderError=t;function a(F,J){return t.create(F,J)}e.createFileSystemProviderError=a;function i(F){return F||a((0,R.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(F,J){return F.name=J?`${J} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=n;function r(F){if(!F)return C.Unknown;if(F instanceof t)return F.code;const J=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!J)return C.Unknown;switch(J[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=r;function o(F){if(F instanceof N)return F.fileOperationResult;switch(r(F)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(J,ee,oe){this.resource=J,this.operation=ee,this.target=oe}isOperation(J){return this.operation===J}}e.FileOperationEvent=c;var w;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class E{constructor(J,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const ce of J){const V=oe.get(ce.type);switch(V?V.push([ce.resource,ce]):oe.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,V]of oe)switch(ce){case 1:this.a=D.TernarySearchTree.forUris(()=>ee),this.a.fill(V);break;case 0:this.b=D.TernarySearchTree.forUris(()=>ee),this.b.fill(V);break;case 2:this.c=D.TernarySearchTree.forUris(()=>ee),this.c.fill(V);break}}contains(J,...ee){return this.d(J,{includeChildren:!1},...ee)}affects(J,...ee){return this.d(J,{includeChildren:!0},...ee)}d(J,ee,...oe){if(!J)return!1;const ce=oe.length>0;return!!((!ce||oe.includes(1))&&(this.a?.get(J)||ee.includeChildren&&this.a?.findSuperstr(J))||(!ce||oe.includes(0))&&(this.b?.get(J)||ee.includeChildren&&this.b?.findSuperstr(J))||(!ce||oe.includes(2))&&(this.c?.findSubstr(J)||ee.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function k(F,J,ee){return!F||!J||F===J||J.length>F.length?!1:(J.charAt(J.length-1)!==O.sep&&(J+=O.sep),ee?(0,l.startsWithIgnoreCase)(F,J):F.indexOf(J)===0)}e.isParent=k;class N extends Error{constructor(J,ee,oe){super(J),this.fileOperationResult=ee,this.options=oe}}e.FileOperationError=N;class M extends N{constructor(J,ee,oe,ce){super(J,ee,ce),this.fileOperationResult=ee,this.size=oe}}e.TooLargeFileOperationError=M;class $ extends N{constructor(J,ee,oe){super(J,2,oe),this.stat=ee}}e.NotModifiedSinceFileOperationError=$;var T;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=q;async function G(F,J){if(!J.hasProvider(L.URI.from({scheme:F.scheme})))return new Promise(ee=>{const oe=J.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===F.scheme&&ce.added&&(oe.dispose(),ee())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(J){return(0,A.isNumber)(J)||(J=0),J<Q.KB?(0,R.localize)(1,null,J.toFixed(0)):J<Q.MB?(0,R.localize)(2,null,(J/Q.KB).toFixed(2)):J<Q.GB?(0,R.localize)(3,null,(J/Q.MB).toFixed(2)):J<Q.TB?(0,R.localize)(4,null,(J/Q.GB).toFixed(2)):(0,R.localize)(5,null,(J/Q.TB).toFixed(2))}}Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB,e.ByteSize=Q;var re;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function K(F){return{maxFileSize:F===0?300*Q.MB:16*Q.GB,maxHeapSize:F===0?700*Q.MB:2*700*Q.MB}}e.getPlatformFileLimits=K;function W(F){const J=typeof F=="string"||F?.scheme===P.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===P.Schemas.file?1024*Q.MB:J?10*Q.MB:S.isWeb?50*Q.MB:1024*Q.MB}e.getLargeFileConfirmationLimit=W});var Y=this&&this.__param||function(Z,e){return function(D,O){e(D,O,Z)}};define(ne[201],se([0,1,100,43,14]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const I=(await this.a.readFileStream(R)).value;return new Promise((S,P)=>{const v=(0,D.createHash)("md5");(0,O.listenStream)(I,{onData:m=>v.update(m.buffer),onError:m=>P(m),onEnd:()=>S(v.digest("base64").replace(/=+$/,""))})})}};A=ye([Y(0,l.IFileService)],A),e.ChecksumService=A}),define(ne[202],se([0,1,17,38,8,3,2,43,10,31,14]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends L.Disposable{constructor(g,f){super(),this.a=g,this.b=f,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,f){const{buffer:p}=await this.a.call("readFile",[g,f]);return p}readFileStream(g,f,p){const h=(0,R.newWriteableStream)(d=>D.VSBuffer.concat(d.map(y=>D.VSBuffer.wrap(y))).buffer),u=this.a.listen("readFileStream",[g,f])(d=>{if(d instanceof D.VSBuffer)h.write(d.buffer);else{if(d==="end")h.end();else{let y;if(d instanceof Error)y=d;else{const b=d;y=(0,P.createFileSystemProviderError)(b.message??(0,O.toErrorMessage)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}h.error(y),h.end()}u.dispose()}});return p.onCancellationRequested(()=>{h.error((0,l.canceled)()),h.end(),u.dispose()}),h}writeFile(g,f,p){return this.a.call("writeFile",[g,D.VSBuffer.wrap(f),p])}open(g,f){return this.a.call("open",[g,f])}close(g){return this.a.call("close",[g])}async read(g,f,p,h,u){const[d,y]=await this.a.call("read",[g,f,u]);return p.set(d.buffer.slice(0,y),h),y}write(g,f,p,h,u){return this.a.call("write",[g,f,D.VSBuffer.wrap(p),h,u])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,f){return this.a.call("delete",[g,f])}rename(g,f,p){return this.a.call("rename",[g,f,p])}copy(g,f,p){return this.a.call("copy",[g,f,p])}cloneFile(g,f){return this.a.call("cloneFile",[g,f])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const f=g;this.f.fire(f.map(p=>({resource:I.URI.revive(p.resource),type:p.type})))}else{const f=g;this.g.fire(f)}}))}watch(g,f){const p=(0,S.generateUuid)();return this.a.call("watch",[this.h,p,g,f]),(0,L.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=v}),define(ne[101],se([0,1,17,8,168,14]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,v,m,g,f,p){let h;try{await R(P,v,m,g,f,p)}catch(u){h=u}finally{h&&f.errorTransformer&&(h=f.errorTransformer(h)),typeof h<"u"&&m.error(h),m.end()}}e.readFileIntoStream=L;async function R(P,v,m,g,f,p){I(p);const h=await P.open(v,{create:!1});try{I(p);let u=0,d=0,y=f&&typeof f.length=="number"?f.length:void 0,b=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof y=="number"?y:f.bufferSize)),C=f&&typeof f.position=="number"?f.position:0,t=0;do d=await P.read(h,C,b.buffer,t,b.byteLength-t),C+=d,t+=d,u+=d,typeof y=="number"&&(y-=d),t===b.byteLength&&(await m.write(g(b)),b=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof y=="number"?y:f.bufferSize)),t=0);while(d>0&&(typeof y!="number"||y>0)&&I(p)&&S(u,f));if(t>0){let a=t;typeof y=="number"&&(a=Math.min(t,y)),m.write(g(b.slice(0,a)))}}catch(u){throw(0,A.ensureFileSystemProviderError)(u)}finally{await P.close(h)}}function I(P){if(P.isCancellationRequested)throw(0,O.canceled)();return!0}function S(P,v){if(v?.limits){if(typeof v.limits.memory=="number"&&P>v.limits.memory)throw(0,A.createFileSystemProviderError)((0,l.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&P>v.limits.size)throw(0,A.createFileSystemProviderError)((0,l.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[56],se([0,1,90,2,13,4,10,14]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class S extends O.Disposable{constructor(d,y,b,C){super(),this.h=d,this.i=y,this.j=b,this.k=C,this.c=this.B(new O.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new O.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(y=>this.h(y))),d.add(this.b.onDidLogMessage(y=>this.i(y))),d.add(this.b.onDidError(y=>this.n(y)))}n(d){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}S.a=5,e.AbstractWatcherClient=S;class P extends S{constructor(d,y,b){super(d,y,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class v extends S{constructor(d,y,b){super(d,y,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function m(u){return u.map(d=>({type:d.type,resource:L.URI.file(d.path)}))}e.toFileChanges=m;function g(u){const d=new h;for(const y of u)d.processEvent(y);return d.coalesce()}e.coalesceEvents=g;function f(u,d){return typeof d=="string"&&!d.startsWith(D.GLOBSTAR)&&!(0,l.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=f;function p(u,d){const y=[];for(const b of d)y.push((0,D.parse)(f(u,b)));return y}e.parseWatcherPatterns=p;class h{constructor(){this.a=new Set,this.b=new Map}c(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const y=this.b.get(this.c(d));let b=!1;if(y){const C=y.type,t=d.type;y.path!==d.path&&(d.type===2||d.type===1)?b=!0:C===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(y)):C===2&&t===1?y.type=0:C===1&&t===0||(y.type=t)}else b=!0;b&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],y=[];return Array.from(this.a).filter(b=>b.type!==2?(d.push(b),!1):!0).sort((b,C)=>b.path.length-C.path.length).filter(b=>y.some(C=>(0,R.isParent)(b.path,C,!A.isLinux))?!1:(y.push(b.path),!0)).concat(d)}}}),define(ne[203],se([0,1,53,6,24,48,2,85,13,4,148,27,56]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends L.Disposable{constructor(h,u,d,y){super(),this.j=h,this.k=u,this.l=d,this.m=y,this.c=this.B(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new O.RunOnceWorker(b=>this.u(b),g.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const h=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await v.Promises.stat(h);this.B(await this.s(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.w(h):this.z(h)}}async r(h){let u=h.path;try{u=await v.Promises.realpath(h.path),h.path===u&&(u=await(0,P.realcase)(h.path)??h.path),h.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async s(h,u){if(S.isMacintosh&&(0,A.isEqualOrParent)(h,"/Volumes/",!0))return this.w(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const d=new l.CancellationTokenSource(this.i.token),y=new L.DisposableStore;try{const b=(0,I.basename)(h),C=(0,D.watch)(h);y.add((0,L.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${h}'`);const t=new Set;if(u)try{for(const i of await v.Promises.readdir(h))t.add(i)}catch(i){this.w(i)}const a=new Map;y.add((0,L.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),C.on("error",(i,n)=>{this.w(`Failed to watch ${h} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),C.on("change",(i,n)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let r="";if(n&&(r=n.toString(),S.isMacintosh&&(r=(0,R.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(r)?.dispose();const o=setTimeout(async()=>{if(a.delete(r),r===b&&!await v.Promises.exists(h)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,I.join)(h,r));if(d.token.isCancellationRequested)return;let c;s?t.has(r)?c=0:(c=1,t.add(r)):(t.delete(r),c=2),this.t({path:(0,I.join)(this.j.path,r),type:c})},g.a);a.set(r,(0,L.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(r)?o=0:(o=1,t.add(r)),this.t({path:(0,I.join)(this.j.path,r),type:o})}else if(i==="rename"||r!==b){const o=setTimeout(async()=>{const s=await v.Promises.exists(h);d.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),y.add(await this.s(h,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);y.clear(),y.add((0,L.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await v.Promises.exists(h)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${h} for changes using fs.watch() (${b.toString()})`)}return(0,L.toDisposable)(()=>{d.dispose(!0),y.dispose()})}t(h,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!u&&this.g.some(d=>d(h.path))?this.m&&this.z(` >> ignored (excluded) ${h.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(d=>d(h.path))?this.m&&this.z(` >> ignored (not included) ${h.path}`):this.f.work(h))}u(h){const u=(0,m.coalesceEvents)(h);if(u.length>0){if(this.m)for(const y of u)this.z(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(h){if(S.isLinux)return v.Promises.exists(h);try{const u=(0,I.basename)(h);return(await v.Promises.readdir((0,I.dirname)(h))).some(y=>y===u)}catch(u){return this.z(u),!1}}setVerboseLogging(h){this.m=h}w(h){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}y(h){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}z(h){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}g.a=100,g.b=75,e.NodeJSFileWatcherLibrary=g;async function f(p,h,u,d,y=512){const b=await v.Promises.open(p,"r"),C=Buffer.allocUnsafe(y),t=new l.CancellationTokenSource(d);let a,i=!1;const n={path:p,excludes:[],recursive:!1},r=new g(n,o=>{(async()=>{for(const{type:s}of o)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:c}=await v.Promises.read(b,C,0,y,null);if(!c||t.token.isCancellationRequested)break;h(C.slice(0,c))}}catch(c){a=new Error(c),t.dispose(!0)}finally{i=!1}}})()});return await r.ready,u(),new Promise((o,s)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await v.Promises.close(b)}catch(c){a=new Error(c)}a?s(a):o()})})}e.watchFileContents=f}),define(ne[204],se([0,1,3,90,2,4,203]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new D.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(S){const P=this.i(S),v=P.filter(g=>{const f=this.c.get(g.path);return f?!(0,O.patternsEquals)(f.request.excludes,g.excludes)||!(0,O.patternsEquals)(f.request.includes,g.includes):!0}),m=Array.from(this.c.values()).filter(({request:g})=>!P.find(f=>f.path===g.path&&(0,O.patternsEquals)(f.excludes,g.excludes)&&(0,O.patternsEquals)(f.includes,g.includes))).map(({request:g})=>g.path);v.length&&this.j(`Request to start watching: ${v.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const g of m)this.h(g);for(const g of v)this.g(g)}g(S){const P=new L.NodeJSFileWatcherLibrary(S,m=>this.a.fire(m),m=>this.b.fire(m),this.f),v={request:S,instance:P};this.c.set(S.path,v)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const P=this.c.get(S);P&&(this.c.delete(S),P.instance.dispose())}i(S){const P=new Map;for(const v of S){const m=A.isLinux?v.path:v.path.toLowerCase();P.set(m,v)}return Array.from(P.values())}async setVerboseLogging(S){this.f=S;for(const[,P]of this.c)P.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,P){return P?`[File Watcher (node.js)] ${S} (path: ${P.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(ne[205],se([0,1,56,204]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends D.AbstractNonRecursiveWatcherClient{constructor(L,R,I){super(L,R,I),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(ne[206],se([0,1,21,39,68,56]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends A.AbstractUniversalWatcherClient{constructor(I,S,P){super(I,S,P),this.m()}l(I){const S=I.add(new l.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:P,signal:v})=>this.n(`terminated by itself with code ${P}, signal: ${v}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(ne[72],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...l){this.a=new Map;for(const[A,L]of l)this.set(A,L)}set(l,A){const L=this.a.get(l);return this.a.set(l,A),L}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=D}),define(ne[207],se([0,1,6,8,2,55,197,5,72,84]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class v extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class m{constructor(h=new I.ServiceCollection,u=!1,d,y=P){this.f=h,this.g=u,this.h=d,this.i=y,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=y?d?._globalGraph??new L.Graph(b=>b):void 0}createChild(h){return new m(h,this.g,this,this.i)}invokeFunction(h,...u){const d=f.traceInvocation(this.i,h);let y=!1;try{return h({get:C=>{if(y)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(C,d);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...u)}finally{y=!0,d.stop()}}createInstance(h,...u){let d,y;return h instanceof A.SyncDescriptor?(d=f.traceCreation(this.i,h.ctor),y=this.j(h.ctor,h.staticArguments.concat(u),d)):(d=f.traceCreation(this.i,h),y=this.j(h,u,d)),d.stop(),y}j(h,u=[],d){const y=R._util.getServiceDependencies(h).sort((t,a)=>t.index-a.index),b=[];for(const t of y){const a=this.m(t.id,d);a||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const C=y.length>0?y[0].index:u.length;if(u.length!==C){console.trace(`[createInstance] First service dependency of ${h.name} at position ${C+1} conflicts with ${u.length} static arguments`);const t=C-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,C)}return Reflect.construct(h,u.concat(b))}k(h,u){if(this.f.get(h)instanceof A.SyncDescriptor)this.f.set(h,u);else if(this.h)this.h.k(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const u=this.f.get(h);return!u&&this.h?this.h.l(h):u}m(h,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const d=this.l(h);return d instanceof A.SyncDescriptor?this.q(h,d,u.branch(h,!0)):(u.branch(h,!1),d)}q(h,u,d){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,u,d)}finally{this.o.delete(h)}}r(h,u,d){const y=new L.Graph(t=>t.id.toString());let b=0;const C=[{id:h,desc:u,_trace:d}];for(;C.length;){const t=C.pop();if(y.lookupOrInsertNode(t),b++>1e3)throw new v(y);for(const a of R._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};y.insertEdge(t,n),C.push(n)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new v(y);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}y.removeNode(a)}}return this.l(h)}s(h,u,d=[],y,b){if(this.f.get(h)instanceof A.SyncDescriptor)return this.t(h,u,d,y,b);if(this.h)return this.h.s(h,u,d,y,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(h,u,d=[],y,b){if(y){const C=new m(void 0,this.g,this,this.i);C.c=String(h);const t=new Map,a=new D.IdleValue(()=>{const i=C.j(u,d,b);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const s of r)o.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new S.LinkedList,t.set(n,s)),(w,E,k)=>{const N=s.push([w,E,k]);return(0,l.toDisposable)(N)}}if(n in i)return i[n];const r=a.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,d,b)}u(h,u){if(u&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=m;var g;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(g||(g={}));class f{static traceInvocation(h,u){return h?new f(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(h,u){return h?new f(1,u.name):f.c}constructor(h,u){this.type=h,this.name=u,this.g=Date.now(),this.h=[]}branch(h,u){const d=new f(3,h.toString());return this.h.push([h,u,d]),d}stop(){const h=Date.now()-this.g;f.f+=h;let u=!1;function d(b,C){const t=[],a=new Array(b+1).join("	");for(const[i,n,r]of C.h)if(n&&r){u=!0,t.push(`${a}CREATES -> ${i}`);const o=d(b+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(h>2||u)&&f.all.add(y.join(`
`))}}f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0,e.Trace=f}),define(ne[208],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(l,A){this.a=l,this.b=A}getChannel(l){return this.a.getChannel(l,this.b)}registerChannel(l,A){this.a.registerChannel(l,A)}}e.MessagePortMainProcessService=D}),define(ne[57],se([0,1,39,55,71,5]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(g,f,p,h){const u=p.getChannel(g);return R(f)?h.createInstance(new O.SyncDescriptor(f.channelClientCtor,[u])):D.ProxyChannel.toService(u,f?.proxyOptions)}}function R(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let I=class extends L{constructor(g,f,p,h){super(g,f,p,h)}};I=ye([Y(2,e.IMainProcessService),Y(3,A.IInstantiationService)],I);function S(m,g,f){(0,l.registerSingleton)(m,new O.SyncDescriptor(I,[g,f],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let P=class extends L{constructor(g,f,p,h){super(g,f,p,h)}};P=ye([Y(2,e.ISharedProcessService),Y(3,A.IInstantiationService)],P);function v(m,g,f){(0,l.registerSingleton)(m,new O.SyncDescriptor(P,[g,f],!0))}e.registerSharedProcessRemoteService=v}),define(ne[73],se([0,1,24,2,4,170,29,5]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends O.Disposable{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new D.CancellationTokenSource;setTimeout(()=>v.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const f=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(h=>h.startsWith("lp-"))).map(p=>{const h=p.properties.localizedLanguages?.[0],u=I(p);return{...this.f(u,h,p),extensionId:p.identifier.id,galleryExtension:p}});return f.push(this.f("en","English")),f}f(v,m,g){const f=m??v;let p;if(f!==v&&(p=`(${v})`),v.toLowerCase()===l.language.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),g?.installCount){p??="";const h=g.installCount;let u;h>1e6?u=`${Math.floor(h/1e5)/10}M`:h>1e3?u=`${Math.floor(h/1e3)}K`:u=String(h),p+=` $(cloud-download) ${u}`}return{id:v,label:f,description:p}}};S=ye([Y(0,L.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(ne[209],se([0,1,2,73]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends D.Disposable{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};l=ye([Y(0,O.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(ne[11],se([0,1,38,3,2,37,4,12,10,5]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function P(){return new Date().toISOString()}function v(s){return(0,R.isNumber)(s)}e.isLogLevel=v;var m;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function g(s,c,w){switch(c){case m.Trace:s.trace(w);break;case m.Debug:s.debug(w);break;case m.Info:s.info(w);break;case m.Warning:s.warn(w);break;case m.Error:s.error(w);break;case m.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=g;function f(s){let c="";for(let w=0;w<s.length;w++){let E=s[w];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}c+=(w>0?" ":"")+E}return c}e.format=f;class p extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==m.Off&&this.b<=c}}e.AbstractLogger=p;class h extends p{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...w){this.f(m.Trace)&&this.g(m.Trace,f([c,...w]))}debug(c,...w){this.f(m.Debug)&&this.g(m.Debug,f([c,...w]))}info(c,...w){this.f(m.Info)&&this.g(m.Info,f([c,...w]))}warn(c,...w){this.f(m.Warning)&&this.g(m.Warning,f([c,...w]))}error(c,...w){if(this.f(m.Error))if(c instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=c.stack,this.g(m.Error,f(E))}else this.g(m.Error,f([c,...w]))}flush(){}}e.AbstractMessageLogger=h;class u extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!L.isWindows}trace(c,...w){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...w):console.log(`[main ${P()}]`,c,...w))}debug(c,...w){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...w):console.log(`[main ${P()}]`,c,...w))}info(c,...w){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...w):console.log(`[main ${P()}]`,c,...w))}warn(c,...w){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,c,...w):console.warn(`[main ${P()}]`,c,...w))}error(c,...w){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,c,...w):console.error(`[main ${P()}]`,c,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class d extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...w){this.f(m.Trace)&&console.log("%cTRACE","color: #888",c,...w)}debug(c,...w){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...w)}info(c,...w){this.f(m.Info)&&console.log("%c INFO","color: #33f",c,...w)}warn(c,...w){this.f(m.Warning)&&console.log("%c WARN","color: #993",c,...w)}error(c,...w){this.f(m.Error)&&console.log("%c  ERR","color: #f33",c,...w)}dispose(){}flush(){}}e.ConsoleLogger=d;class y extends p{constructor(c,w=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(w)}trace(c,...w){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(c),...w])}debug(c,...w){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(c),...w])}info(c,...w){this.f(m.Info)&&this.g.log(m.Info,[this.h(c),...w])}warn(c,...w){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(c),...w])}error(c,...w){this.f(m.Error)&&this.g.log(m.Error,[this.h(c),...w])}h(c){return typeof c=="string"?c:(0,D.toErrorMessage)(c,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=y;class b extends p{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const w of this.g)w.setLevel(c);super.setLevel(c)}trace(c,...w){for(const E of this.g)E.trace(c,...w)}debug(c,...w){for(const E of this.g)E.debug(c,...w)}info(c,...w){for(const E of this.g)E.info(c,...w)}warn(c,...w){for(const E of this.g)E.warn(c,...w)}error(c,...w){for(const E of this.g)E.error(c,...w)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=b;class C extends l.Disposable{constructor(c,w){if(super(),this.j=c,this.b=new A.ResourceMap,this.c=new A.ResourceMap,this.f=this.B(new O.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeVisibility=this.h.event,w)for(const E of w)this.c.set(E.resource,E)}getLogger(c){return this.b.get(c)}createLogger(c,w){let E=this.b.get(c);const k=w?.logLevel==="always"?m.Trace:w?.logLevel;return E||(E=this.k(c,k??this.getLogLevel(c)??this.j,w),this.b.set(c,E)),this.registerLogger({resource:c,id:w?.id??c.toString(),logLevel:k,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId}),E}setLogLevel(c,w){if(I.URI.isUri(c)){const E=c,k=w,N=this.c.get(E);N&&k!==N.logLevel&&(N.logLevel=k===this.j?void 0:k,this.b.get(E)?.setLevel(k),this.c.set(N.resource,N),this.g.fire([E,k]))}else{this.j=c;for(const[E,k]of this.b.entries())this.c.get(E)?.logLevel===void 0&&k.setLevel(this.j);this.g.fire(this.j)}}setVisibility(c,w){const E=this.c.get(c);E&&w!==!E.hidden&&(E.hidden=!w,this.c.set(E.resource,E),this.h.fire([c,w]))}getLogLevel(c){let w;return c&&(w=this.c.get(c)?.logLevel),w??this.j}registerLogger(c){const w=this.c.get(c.resource);w?w.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.c.set(c.resource,c),this.f.fire({added:[c],removed:[]}))}deregisterLogger(c){const w=this.c.get(c);if(w){this.c.delete(c);const E=this.b.get(c);E&&(this.b.delete(c),E.dispose()),this.f.fire({added:[],removed:[w]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(c){return this.c.get(c)}dispose(){this.b.forEach(c=>c.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=C;class t{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(c){}getLevel(){return m.Info}trace(c,...w){}debug(c,...w){}info(c,...w){}warn(c,...w){}error(c,...w){}critical(c,...w){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends C{constructor(){super(m.Info)}k(c,w,E){return new t}}e.NullLoggerService=i;function n(s){if(s.verbose)return m.Trace;if(typeof s.logLevel=="string"){const c=o(s.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(s){switch(s){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(s){switch(s){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(ne[210],se([0,1,6,8,2,13,27,15,11]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends l.Disposable{constructor(v,m){super(),this.a=v,this.b=m,this.B(new D.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const v=(0,A.basename)(this.a.logsPath),m=(0,A.dirname)(this.a.logsPath),p=(await L.Promises.readdir(m)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==v),h=p.slice(0,Math.max(0,p.length-9));h.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>L.Promises.rm((0,A.join)(m,u)))))}catch(v){(0,O.onUnexpectedError)(v)}}};S=ye([Y(0,R.IEnvironmentService),Y(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(ne[211],se([0,1,20,6,8,3,2,13,56,11]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends L.Disposable{constructor(m,g){super(),this.a=m,this.b=g,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(m,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(m,g):this.u(m,g)}l(m,g){const f={path:this.C(m),excludes:g.excludes,includes:g.includes,recursive:g.recursive},p=(0,D.insert)(this.j,f);return this.m(),(0,L.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,l.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,I.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const g of this.j)(0,I.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const g of this.j)(0,I.isRecursiveWatchRequest)(g)&&m.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,g){const f={path:this.C(m),excludes:g.excludes,includes:g.includes,recursive:!1},p=(0,D.insert)(this.s,f);return this.v(),(0,L.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,l.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,R.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[212],se([0,1,20,6,17,24,3,66,64,2,49,21,102,22,43,166,14,101,11,8]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends S.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new L.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new L.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new S.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new h.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,S.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return I.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new h.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new y.ErrorNoTelemetry;throw i.message=(0,p.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a)||(0,h.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,h.toFileSystemProviderErrorCode)(i)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,h.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,c=await i.stat(t);let w;return this.p(i,t,c,void 0,!!s,(E,k)=>(w||(w=P.TernarySearchTree.forUris(()=>!n),w.set(t,!0),r&&w.fill(!0,r)),w.get(E.resource)||w.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?k===1:!1))}async p(t,a,i,n,r,o){const{providerExtUri:s}=this.N(t),c={resource:a,name:s.basename(a),isFile:(i.type&h.FileType.File)!==0,isDirectory:(i.type&h.FileType.Directory)!==0,isSymbolicLink:(i.type&h.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&h.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,h.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(c.isDirectory&&o(c,n)){try{const w=await t.readdir(a),E=await O.Promises.settled(w.map(async([k,N])=>{try{const M=s.joinPath(a,k),$=r?await t.stat(M):{type:N};return await this.p(t,M,$,w.length,r,o)}catch(M){return this.b.trace(M),null}}));c.children=(0,D.coalesce)(E)}catch(w){this.b.trace(w),c.children=[]}return c}return c}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new h.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=l.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new h.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let s;if((0,h.hasReadWriteCapability)(n)&&!(a instanceof l.VSBuffer))if((0,f.isReadableStream)(a)){const c=await(0,f.peekStream)(a,3);c.ended?s=l.VSBuffer.concat(c.buffer):s=c}else s=(0,f.peekReadable)(a,c=>l.VSBuffer.concat(c),3);else s=a;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&s instanceof l.VSBuffer?await this.cb(n,t,i,s):await this.Y(n,t,i,s instanceof l.VSBuffer?(0,l.bufferToReadable)(s):s),this.m.fire(new h.FileOperationEvent(t,4))}catch(o){throw new h.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,h.ensureFileSystemProviderError)(o).toString()),(0,h.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,p.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==h.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,h.etag)({mtime:i.mtime,size:r.size}))throw new h.FileOperationError((0,p.localize)(7,null),3,i);return r}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,a,i,n);r(s)}catch(s){o(s)}})})}async u(t,a,i,n){const r=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,l.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const r=new A.CancellationTokenSource(n),o=this.F(a,i).then(c=>c,c=>{throw r.cancel(),c});let s;try{return typeof i?.etag=="string"&&i.etag!==h.ETAG_DISABLED&&await o,i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)||!((0,h.hasOpenReadWriteCloseCapability)(t)||(0,h.hasFileReadStreamCapability)(t))||(0,h.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,a,i):(0,h.hasFileReadStreamCapability)(t)?s=this.z(t,a,r.token,i):s=this.C(t,a,r.token,i),{...await o,value:s}}catch(c){throw s&&await(0,f.consumeStream)(s),this.w(c,a,i)}}w(t,a,i){const n=(0,p.localize)(8,null,this.nb(a),(0,h.ensureFileSystemProviderError)(t).toString());return t instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new h.FileOperationError(n,(0,h.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,f.transform)(r,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.w(o,a,n)},o=>l.VSBuffer.concat(o))}C(t,a,i,n=Object.create(null)){const r=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,a,n)},i),r}D(t,a,i){const n=(0,f.newWriteableStream)(r=>l.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(a,r.byteLength,i),n.end(l.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new h.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==h.ETAG_DISABLED&&a.etag===i.etag)throw new h.NotModifiedSinceFileOperationError((0,p.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&a>i.limits.size&&(n=7),typeof n=="number")throw new h.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),n,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"move",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,o==="move"?2:3,s)),s}async copy(t,a,i){const n=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"copy",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,o==="copy"?3:2,s)),s}async I(t,a,i,n,r,o){if(a.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.M(t,a,i,n,r,o);if(s&&!c&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,h.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:o});else{const w=await this.resolve(a);w.isDirectory?await this.L(t,w,i,n):await this.J(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:o}),r):(await this.I(t,a,i,n,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,a,i,n,r,o){let s=!1;if(t===i){const{providerExtUri:w,isPathCaseSensitive:E}=this.N(t);if(E||(s=w.isEqual(a,n)),s&&r==="copy")throw new Error((0,p.localize)(12,null,this.nb(a),this.nb(n)));if(!s&&w.isEqualOrParent(n,a))throw new Error((0,p.localize)(13,null,this.nb(a),this.nb(n)))}const c=await this.exists(n);if(c&&!s){if(!o)throw new h.FileOperationError((0,p.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(a,n))throw new Error((0,p.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}N(t){const a=this.O(t);return{providerExtUri:a?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(((await t.stat(a)).type&h.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(a)));break}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(o){if((0,h.toFileSystemProviderErrorCode)(o)!==h.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new h.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,r=!!a?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new h.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,h.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,h.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new S.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,S.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);n?(0,S.dispose)(o):r=()=>(0,S.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,a){const i=await this.j(t),n=(0,R.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.U.set(n,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,S.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,i){let n=0,r;if((0,f.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=l.VSBuffer.concat(i.buffer);await this.bb(t,a,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,s)=>{(0,f.listenStream)(r,{onData:async c=>{r.pause();try{await this.bb(t,a,c,c.byteLength,n,0)}catch(w){return s(w)}n+=c.byteLength,setTimeout(()=>r.resume())},onError:c=>s(c),onEnd:()=>o()})})}async ab(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,a,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,a,i,n,r,o){let s=0;for(;s<n;)s+=await t.write(a,r+s,i.buffer,o+s,n-s)}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let r;n instanceof l.VSBuffer?r=n:(0,f.isReadableStream)(n)?r=await(0,l.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?r=await(0,l.bufferedStreamToBuffer)(n):r=(0,l.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let r,o;try{r=await t.open(a,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const s=l.VSBuffer.alloc(this.a);let c=0,w=0,E=0;do E=await t.read(r,c,s.buffer,w,s.byteLength-w),await this.bb(i,o,s,E,c,w),c+=E,w+=E,w===s.byteLength&&(w=0);while(E>0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(i,r,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,a,i,n){const r=await(0,l.streamToBuffer)(this.C(t,a,A.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new h.FileOperationError((0,p.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};b=ye([Y(0,d.ILogService)],b),e.FileService=b}),define(ne[213],se([0,1,53,295,6,37,17,3,48,2,13,4,22,43,27,169,14,101,211,38,206,205]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=R.Event.None,this.H=new A.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await f.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await f.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let s;o.isSymbolicLink()?s=(await this.stat((0,m.joinPath)(i,o.name))).type:s=this.G(o),r.push([o.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=h.FileType.Unknown:i.isFile()?r=h.FileType.File:i.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new l.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await f.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,g.newWriteableStream)(s=>L.VSBuffer.concat(s.map(c=>L.VSBuffer.wrap(c))).buffer);return(0,u.readFileIntoStream)(this,i,o,s=>s.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const s=this.C(i);if(!r.create||!r.overwrite){if(await f.Promises.exists(s)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,h.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let s;try{if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await f.SymlinkSupport.stat(r);w.mode&128||await f.Promises.chmod(r,w.mode|128)}catch(w){this.a.trace(w)}let c;if((0,h.isFileOpenForWriteOptions)(n)){if(v.isWindows)try{await f.Promises.truncate(r,0),c="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}c||(c="w")}else c="r";s=await f.Promises.open(r,c)}catch(c){throw o?.dispose(),(0,h.isFileOpenForWriteOptions)(n)?await this.Z(i,c):this.Y(c)}if(this.L.set(s,0),(0,h.isFileOpenForWriteOptions)(n)&&this.N.set(s,i),o){const c=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.M.set(s,o),c&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),c.dispose())}return s}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await f.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await f.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,s){const c=this.P(i,n);let w=null;try{w=(await f.Promises.read(i,r,o,s,c)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(i,c,w)}return w}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,s){return(0,l.retry)(()=>this.R(i,n,r,o,s),100,3)}async R(i,n,r,o,s){const c=this.P(i,n);let w=null;try{w=(await f.Promises.write(i,r,o,s,c)).bytesWritten}catch(E){throw await this.Z(this.N.get(i),E)}finally{this.Q(i,c,w)}return w}async mkdir(i){try{await f.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"move",r.overwrite),await f.Promises.move(o,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,p.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(s)),c.toString()))),this.Y(c)}}async copy(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"copy",r.overwrite),await f.Promises.copy(o,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,p.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(s)),c.toString()))),this.Y(c)}}async S(i,n,r,o){const s=this.C(i),c=this.C(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(s,c,!0)),w&&r==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!w&&await f.Promises.exists(c)){if(!o)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),s=this.C(n),c=!!(this.capabilities&1024);if((0,I.isEqual)(o,s,!c))return;const w=new S.DisposableStore;try{const[E,k]=await Promise.all([this.I(i),this.I(n)]);w.add(E),w.add(k),r&&await f.Promises.mkdir((0,P.dirname)(s),{recursive:!0}),await f.Promises.copyFile(o,s)}catch(E){if(E.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(E)}finally{w.dispose()}}p(i,n,r){return new b.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new C.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof h.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ne[103],se([0,1,3,2,5,11]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("lifecycleSharedProcessService");let L=class extends O.Disposable{constructor(I){super(),this.b=I,this.a=this.B(new D.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};L=ye([Y(0,A.ILogService)],L),e.SharedProcessLifecycleService=L}),define(ne[104],se([0,1,10,3,11,2]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class L extends l.AbstractLoggerService{constructor(v,m,g,f){super(m,g),this.l=v,this.m=f,this.B(f.listen("onDidChangeLogLevel",v)(p=>{(0,l.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(D.URI.revive(p[0]),p[1])})),this.B(f.listen("onDidChangeVisibility",v)(([p,h])=>super.setVisibility(D.URI.revive(p),h))),this.B(f.listen("onDidChangeLoggers",v)(({added:p,removed:h})=>{for(const u of p)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(v,m)=>{this.m.call("consoleLog",[v,m])}})}registerLogger(v){super.registerLogger(v),this.m.call("registerLogger",[v,this.l])}deregisterLogger(v){super.deregisterLogger(v),this.m.call("deregisterLogger",[v,this.l])}setLogLevel(v,m){super.setLogLevel(v,m),this.m.call("setLogLevel",[v,m])}setVisibility(v,m){super.setVisibility(v,m),this.m.call("setVisibility",[v,m])}k(v,m,g){return new R(this.m,v,m,g,this.l)}static setLogLevel(v,m,g){return v.call("setLogLevel",[m,g])}}e.LoggerChannelClient=L;class R extends l.AbstractMessageLogger{constructor(v,m,g,f,p){super(f?.logLevel==="always"),this.m=v,this.n=m,this.k=!1,this.l=[],this.setLevel(g),this.m.call("createLogger",[m,f,p]).then(()=>{this.r(this.l),this.k=!0})}g(v,m){const g=[[v,m]];this.k?this.r(g):this.l.push(...g)}r(v){this.m.call("log",[this.n,v])}}class I{constructor(v,m){this.a=v,this.b=m}listen(v,m){const g=this.b(v);switch(m){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(p=>this.c(p,g)),removed:[...f.removed].map(p=>this.c(p,g))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,f=>[g.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,f=>(0,l.isLogLevel)(f)?f:[g.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(v,m,g){const f=this.b(v);switch(m){case"setLogLevel":return(0,l.isLogLevel)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(D.URI.revive(f.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,f)))}throw new Error(`Call not found: ${m}`)}c(v,m){return{...v,resource:m.transformOutgoingURI(v.resource)}}}e.LoggerChannel=I;class S extends A.Disposable{constructor(v,m){super(),m.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(g=>m.call("setLogLevel",[g]))),m.call("getRegisteredLoggers").then(g=>{for(const f of g)v.registerLogger({...f,resource:D.URI.revive(f.resource)})}),this.B(m.listen("onDidChangeVisibility")(([g,f])=>v.setVisibility(D.URI.revive(g),f))),this.B(m.listen("onDidChangeLoggers")(({added:g,removed:f})=>{for(const p of g)v.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of f)v.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=S}),define(ne[214],se([0,1,2,11]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends D.Disposable{constructor(L,R=[]){super(),this.a=new O.MultiplexLogger([L,...R]),this.B(L.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.LogService=l}),define(ne[58],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[59],se([0,1,3,64,2,5]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class L extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const P=Object.keys(this.f).length;return this.f={...S,...this.f},P!==Object.keys(this.f).length&&await this.i(S),O.Iterable.reduce(this.g.entries(),(v,[m,g])=>({...v,[m]:g}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(S,[P,v])=>({...S,[P]:{definition:v,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=L;class R{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(ne[215],se([0,1,3,2,59]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(I){this.b=I,this.a=new O.DisposableStore}listen(I,S){switch(S){case"onDidChange":return D.Event.map(this.b.onDidChange,P=>P.reduce((v,m)=>({...v,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,P){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class L extends l.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const P in I){const{definition:v,value:m}=I[P];this.f[P]=v,m!==void 0&&this.g.set(P,m)}this.a.listen("onDidChange")(P=>{for(const v in P){const m=P[v];m===null?this.g.delete(v):this.g.set(v,m)}this.h.fire(Object.keys(P))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const P in S)this.g.set(P,S[P])}}e.PolicyChannelClient=L}),define(ne[105],se([0,1,4,36]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const A=D.globals.vscode.context.configuration();if(A)l=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:A.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ne[25],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[216],se([0,1,6,8,2,13,27,11,25]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends l.Disposable{constructor(v,m,g){super(),this.b=m,this.c=g,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new D.RunOnceScheduler(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),g=(0,A.dirname)(v),f=(0,A.basename)(v),p=await L.Promises.readdir(g);await Promise.all(p.map(async h=>{if(h===f)return;const u=(0,A.join)(g,h),d=await L.Promises.stat(u);if(d.isDirectory()&&m-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${h}.`),L.Promises.rm(u)}))}catch(m){(0,O.onUnexpectedError)(m)}}};S=ye([Y(1,I.IProductService),Y(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(ne[217],se([0,1,6,8,2,13,27,15,11,25]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends l.Disposable{constructor(m,g,f){super(),this.b=m,this.c=g,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),g=JSON.parse(await L.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(g)){const y=g[d];m[`${y.hash}.${d}`]=!0}const f=(0,A.join)(this.b.userDataPath,"clp");if(!await L.Promises.exists(f))return;const h=await L.Promises.readdir(f);for(const d of h){if(m[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await L.Promises.rm((0,A.join)(f,d))}const u=Date.now();for(const d of Object.keys(m)){const y=(0,A.join)(f,d),b=await L.Promises.readdir(y);for(const C of b){if(C==="tcf.json")continue;const t=(0,A.join)(y,C),a=await L.Promises.stat(t);a.isDirectory()&&u-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,C)}`),await L.Promises.rm(t))}}}catch(m){(0,O.onUnexpectedError)(m)}}};P=ye([Y(0,R.INativeEnvironmentService),Y(1,I.ILogService),Y(2,S.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[218],se([0,1,20,2,22,193,14,25]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends O.Disposable{constructor(P,v){super(),this.b=P,this.c=v,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(P){return this.f(P)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(P){const v=[];for(const[m,g]of this.a)if(!(g.configScheme&&g.configScheme!==P.scheme))try{const f=await this.b.readFile((0,l.joinPath)(P,m)),p=new Map;Object.entries(g.recommendations).forEach(([u,d])=>{if((0,D.isNonEmptyArray)(d.remotes))for(const y of d.remotes)p.set(y,{extensionId:u,extensionName:d.name,configName:g.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else v.push({extensionId:u,extensionName:d.name,configName:g.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const h=(0,A.getDomainsOfRemotes)(f.value.toString(),[...p.keys()]);for(const u of h){const d=p.get(u);d&&v.push(d)}}catch{}return v}};I=ye([Y(0,L.IFileService),Y(1,R.IProductService)],I),e.ExtensionTipsService=I}),define(ne[219],se([0,1,13,5]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var l;(function(A){function L(I){return Boolean(I.samples&&I.timeDeltas)}A.isValidProfile=L;function R(I,S="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,D.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,D.join)(S,(0,D.basename)(P.callFrame.url)));return I}A.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(ne[220],se([0,1,31]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((S,P)=>{Z(["v8-inspect-profiler"],S,P)})).startProfiling({port:A.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this.a.set(I,R),I}async stopProfiling(A){const L=this.a.get(A);if(!L)throw new Error(`UNKNOWN session '${A}'`);const R=await L.stop();return this.a.delete(A),R.profile}}e.InspectProfilingService=O}),define(ne[40],se([0,1,128,12]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(L,R){D.ok(O.isString(L)),D.ok(O.isObject(R)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new l}),define(ne[106],se([0,1,3,40]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new D.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[l(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const L=new A;O.Registry.add(e.Extensions.JSONContribution,L)}),define(ne[45],se([0,1,20,3,12,155,16,106,40]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=I.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s=this.a.get(o),c=s?.valuesSources??new Map;if(r)for(const N of Object.keys(n[o]))c.set(N,r);const w={...s?.value||{},...n[o]};this.a.set(o,{source:r,value:w,valuesSources:c});const E=(0,L.getLanguageTagSettingPlainKey)(o),k={type:"object",default:w,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:l.isString(r)?void 0:r,defaultValueSource:r};i.push(...p(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:n[o],source:r});const s=this.d[o];s&&(this.w(o,s),this.r(o,s))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),s=l.isString(n)?n:n?.id,c=l.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const w=this.d[r];w&&(this.w(r,w),this.r(r,w))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,i,n,r=3,o){r=l.isUndefinedOrNull(t.scope)?r:t.scope;const s=t.properties;if(s)for(const w in s){const E=s[w];if(a&&y(w,E)){delete s[w];continue}if(E.source=i,E.defaultDefaultValue=s[w].default,this.w(w,E),e.OVERRIDE_PROPERTY_REGEX.test(w)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!n?.includes(w):E.restricted),s[w].hasOwnProperty("included")&&!s[w].included){this.f[w]=s[w],delete s[w];continue}else this.d[w]=s[w],s[w].policy?.name&&this.e.set(s[w].policy.name,w);!s[w].deprecationMessage&&s[w].markdownDeprecationMessage&&(s[w].deprecationMessage=s[w].markdownDeprecationMessage),o.add(w)}const c=t.allOf;if(c)for(const w of c)this.p(w,a,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,r=i?.source;l.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),l.isUndefined(n)&&(n=u(a.type)),a.default=n,a.defaultValueSource=r}}const g="\\[([^\\]]+)\\]",f=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let a=f.exec(C);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=f.exec(C)}}return(0,D.distinct)(t)}e.overrideIdentifiersFromKey=p;function h(C){return C.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=h;function u(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new m;I.Registry.add(e.Extensions.Configuration,d);function y(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?A.localize(7,null,C):d.getConfigurationProperties()[C]!==void 0?A.localize(8,null,C):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,C,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=y;function b(){const C=[],t=d.getConfigurationProperties();for(const a of Object.keys(t))C.push([a,t[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=b}),define(ne[74],se([0,1,20,3,35,2,37,32,12,10,16,45,40]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(a){return Object.isFrozen(a)?a:R.deepFreeze(a)}class f{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof f)return n;const r=new p("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:s}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,P.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return D.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of i)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(n,c.contents);for(const w of c.overrides){const[E]=r.filter(k=>D.equals(k.identifiers,w.identifiers));E?(this.h(E.contents,w.contents),E.keys.push(...w.keys),E.keys=D.distinct(E.keys)):r.push(R.deepClone(w))}for(const w of c.keys)o.indexOf(w)===-1&&o.push(w)}return new f(n,o,r,s.every(c=>c instanceof f)?void 0:s)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o];const c=n[o];c&&(typeof s=="object"&&typeof c=="object"?(s=R.deepClone(s),this.h(s,c)):s=c),r[o]=s}return new f(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&I.isObject(i[r])&&I.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=R.deepClone(n[r])}}i(i){let n=null,r=null;const o=s=>{s&&(r?this.h(r,s):r=R.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&o(s.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>D.equals(r.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,P.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=f;class p{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!I.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:s,restricted:c,hasExcludedProperties:w}=this.h(i,n);this.b=new f(r,o,s,w?[i]:void 0),this.c=c||[]}g(i){let n={},r=null,o=[];const s=[],c=[];function w(k){Array.isArray(o)?o.push(k):r!==null&&(o[r]=k)}const E={onObjectBegin:()=>{const k={};w(k),s.push(o),o=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const k=[];w(k),s.push(o),o=k,r=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:w,onError:(k,N,M)=>{c.push({error:k,offset:N,length:M})}};if(i)try{l.visit(i,E),n=o[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return n}h(i,n){const r=m.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const s=(0,P.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),c=Object.keys(i),w=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:s,keys:c,overrides:w,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let s=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const c={},w=[];for(const E in i)if(v.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const k=this.i(i[E],n,!1,o);c[E]=k.raw,s=s||k.hasExcludedProperties,w.push(...k.restricted)}else{const k=n[E],N=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&w.push(E),(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&!(o.skipRestricted&&k?.restricted)?c[E]=i[E]:s=!0}return{raw:c,restricted:w,hasExcludedProperties:s}}j(i,n){const r=[];for(const o of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(o)){const s={};for(const c in i[o])s[c]=i[o][c];r.push({identifiers:(0,v.overrideIdentifiersFromKey)(o),keys:Object.keys(s),contents:(0,P.toValuesTree)(s,n)})}return r}}e.ConfigurationModelParser=p;class h extends A.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class u{constructor(i,n,r,o,s,c,w,E,k,N,M,$,T){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=s,this.f=c,this.g=w,this.h=E,this.i=k,this.j=N,this.k=M,this.l=$,this.m=T}get value(){return g(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return g(o.value)},get override(){return g(o.override)},get merged(){return g(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(i,n,r,o,s=new f,c=new f,w=new L.ResourceMap,E=new f,k=new L.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=s,this.i=c,this.j=w,this.l=E,this.m=k,this.a=null,this.b=new L.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new f,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),s=this.u(n.resource,r),c=n.resource?this.m.get(n.resource)||this.l:this.l,w=new Set;for(const E of o.overrides)for(const k of E.identifiers)o.getOverrideValue(i,k)!==void 0&&w.add(k);return new u(i,n,o.getValue(i),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,s||void 0,c)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:s,removed:c}=C(this.c,i);n=[...o,...s,...c]}for(const o of n)for(const s of(0,v.overrideIdentifiersFromKey)(o)){const c=this.c.getKeysForOverrideIdentifier(s),w=i.getKeysForOverrideIdentifier(s),E=[...w.filter(k=>c.indexOf(k)===-1),...c.filter(k=>w.indexOf(k)===-1),...c.filter(k=>!R.equals(this.c.override(s).getValue(k),i.override(s).getValue(k)))];r.push([s,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=C(this.d,i),s=[...n,...r,...o];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.applicationConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.localUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.remoteUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.workspaceConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:s,removed:c,overrides:w}=C(r,n),E=[...o,...s,...c];return(E.length||!r)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:w}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:s,overrides:c}=C(n,void 0);return{keys:[...r,...o,...s],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const s=this.m.get(i);s&&(r=r.merge(s))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:s}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),s=this.x(i.user),c=this.x(i.workspace),w=i.folders.reduce((E,k)=>(E.set(S.URI.revive(k[0]),this.x(k[1])),E),new L.ResourceMap);return new d(n,r,o,s,new f,c,w,new f,new L.ResourceMap)}static x(i){return new f(i.contents,i.keys,i.overrides)}}e.Configuration=d;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(s=>i.add(s)),o.overrides.forEach(([s,c])=>{const w=(0,L.getOrSet)(n,s,new Set);c.forEach(E=>w.add(E))});const r=[];return n.forEach((o,s)=>r.push([s,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class b{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const c of s)this.affectedKeys.add(c);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const s=o+r.length;if(s>=this.d.length)return!1;const c=this.d.charCodeAt(s);if(c!==this.b&&c!==this.c)return!1;if(n){const w=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!R.equals(w,E)}return!0}}e.ConfigurationChangeEvent=b;function C(a,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),s=[],c=a?.getAllOverrideIdentifiers()||[],w=i?.getAllOverrideIdentifiers()||[];if(i){const E=w.filter(k=>!c.includes(k));for(const k of E)s.push([k,i.getKeysForOverrideIdentifier(k)])}if(a){const E=c.filter(k=>!w.includes(k));for(const k of E)s.push([k,a.getKeysForOverrideIdentifier(k)])}if(i&&a){for(const E of c)if(w.includes(E)){const k=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});s.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:n,removed:r,updated:o,overrides:s}}function t(a,i){const n=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],o=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,P.getConfigurationValue)(i.contents,s),w=(0,P.getConfigurationValue)(a.contents,s);R.equals(c,w)||o.push(s)}}return{added:n,removed:r,updated:o}}}),define(ne[221],se([0,1,20,3,2,32,12,74,45,11,59,40]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:u})=>this.c(Array.from(h),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(h,u){this.h(h,v.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:h})}f(){return{}}g(){this.b=new R.ConfigurationModel;const h=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(h),h)}h(h,u){const d=this.f();for(const y of h){const b=d[y],C=u[y];b!==void 0?this.b.addValue(y,b):C?this.b.addValue(y,C.default):this.b.removeValue(y)}}}e.DefaultConfiguration=m;class g{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let f=class extends l.Disposable{get configurationModel(){return this.b}constructor(h,u,d){super(),this.c=h,this.f=u,this.g=d,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.i(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.j(await this.h(h),!0))),this.b}async h(h){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",h);const u={},d=[],y=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const b of h){const C=y[b];if(!C){d.push(b);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}d.push(b),u[C.policy.name]={type:C.type}}}return(0,L.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),d}i(h){this.g.trace("PolicyConfiguration#onDidChangePolicies",h);const u=v.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(h.map(y=>u.get(y)));this.j(d,!0)}j(h,u){this.g.trace("PolicyConfiguration#update",h);const d=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),y=[],b=this.b.isEmpty();for(const C of h){const t=d[C]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(b?a!==void 0:!(0,A.equals)(this.b.getValue(C),a))&&y.push([C,a])}else this.b.getValue(C)!==void 0&&y.push([C,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const C=this.b;this.b=new R.ConfigurationModel;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,a]of y)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};f=ye([Y(1,P.IPolicyService),Y(2,S.ILogService)],f),e.PolicyConfiguration=f}),define(ne[222],se([0,1,6,3,2,22,16,74,221,59]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends l.Disposable{constructor(m,g,f,p){super(),this.i=m,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=f instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,f,p)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,g)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:u})=>this.k(h,u))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,g,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(m,g,new R.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(m,g){const f=typeof m=="string"?m:void 0,p=(0,L.isConfigurationOverrides)(m)?m:(0,L.isConfigurationOverrides)(g)?g:{};return this.a.getValue(f,p,void 0)}updateValue(m,g,f,p){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const g=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(f,g,2)}k(m,g){const f=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(m,g);this.m(p,f,7)}l(m){const g=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(m);this.m(f,g,7)}m(m,g,f){const p=new R.ConfigurationChangeEvent(m,{data:g},this.a);p.source=f,p.sourceConfig=this.n(f),this.h.fire(p)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[223],se([0,1,8,5]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends D.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof A&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof A&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof A&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof A&&I.isHandled}constructor(I,S=l.Unknown,P){super(I),this._message=I,this._code=S,this._detail=P,this.isHandled=S===l.NotAvailable&&P===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function L(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.getRemoteAuthorityPrefix=L}),define(ne[75],se([0,1,21]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(S){return S.scheme===D.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=O;function l(S){if(!S)return;const P=S.indexOf("+");return P<0?S:S.substr(0,P)}e.getRemoteName=l;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function L(S){const{host:P,port:v}=I(S);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:v}}e.parseAuthorityWithPort=L;function R(S,P){let{host:v,port:m}=I(S);return typeof m>"u"&&(m=P),{host:v,port:m}}e.parseAuthorityWithOptionalPort=R;function I(S){const P=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const v=S.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const m=S.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:S,port:void 0}}}),define(ne[46],se([0,1,26,5,75]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));var R;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,p){if(typeof f>"u"||f===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof f=="string"||typeof p=="string"){const h=typeof f=="string"?f:f.value,u=typeof p=="string"?p:p.value;return D.equalsIgnoreCase(h,u)}return f.c===p.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=I;function S(g){return P(g)}e.isApplicationScopedExtension=S;function P(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function v(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function m(g,f){if(f){const p=`onResolveRemoteAuthority:${(0,l.getRemoteName)(f)}`;return g.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[224],se([0,1,2,13,27,46]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(I,S){super(),this.b=I,this.a=(0,O.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(P=>this.c(P))),this.B(S.onDidUninstallExtension(P=>this.f(P)))}c(I){I.some(S=>!!S.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(ne[225],se([0,1,6,17,24,8,3,2,102,88,31,93,223,75]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function h(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const z=new l.CancellationTokenSource;return setTimeout(()=>z.cancel(),U),z.token}function d(U,z){if(U.isCancellationRequested||z.isCancellationRequested)return l.CancellationToken.Cancelled;const x=new l.CancellationTokenSource;return U.onCancellationRequested(()=>x.cancel()),z.onCancellationRequested(()=>x.cancel()),x.token}class y{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((x,_)=>{this.f=x,this.g=_}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function b(U,z){const x=new y(z);return x.registerDisposable(U.onControlMessage(_=>{const H=JSON.parse(_.toString()),X=J(H);X?x.reject(X):x.resolve(H)})),x.promise}function C(U,z,x,_,H,X,te,le,he){const me=new y(he),pe=S.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${te}`),z.connect(x,_,H,X,le,(Se,Ee)=>{me.didTimeout?(I.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) finished after ${pe.elapsed()} ms, but this is too late and has timed out already.`),Se&&U.error(Se),Ee?.dispose()):Se||!Ee?(I.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) returned an error after ${pe.elapsed()} ms.`),me.reject(Se)):(I.mark(`code/didCreateSocketOK/${te}`),U.info(`Creating a socket (${le}) was successful after ${pe.elapsed()} ms.`),me.resolve(Ee))}),me.promise}function t(U,z){const x=new y(z);return U.then(_=>{x.didTimeout||x.resolve(_)},_=>{x.didTimeout||x.reject(_)}),x.promise}async function a(U,z,x,_){const H=V(U,z);U.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let X;try{X=await C(U.logService,U.socketFactory,U.host,U.port,(0,g.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,h(z),`renderer-${h(z)}-${U.reconnectionToken}`,_)}catch(pe){throw U.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),U.logService.error(pe),pe}U.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let te,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(X,null),te=U.reconnectionProtocol,le=!1):(te=new v.PersistentProtocol({socket:X,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const he=await t(U.signService.createNewMessage((0,P.generateUuid)()),_),me={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};te.sendControl(O.VSBuffer.fromString(JSON.stringify(me)));try{const pe=await b(te,d(_,u(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(U.signService.validate(he,pe.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ee=await t(U.signService.sign(pe.data),_),De={type:"connectionType",commit:U.commit,signedData:Ee,desiredConnectionType:z};return x&&(De.args=x),U.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(O.VSBuffer.fromString(JSON.stringify(De))),{protocol:te,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(U.logService.error(`${H} the handshake timed out. Error:`),U.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(pe)),le&&F(te),pe}}async function i(U,z,x,_){const H=Date.now(),X=V(U,z),{protocol:te,ownsProtocol:le}=await a(U,z,x,_),he=new y(_);return he.registerDisposable(te.onControlMessage(me=>{const pe=JSON.parse(me.toString()),Se=J(pe);Se?(U.logService.error(`${X} received error control message when negotiating connection. Error:`),U.logService.error(Se),le&&F(te),he.reject(Se)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${j(H)}!`),he.resolve({protocol:te,firstMessage:pe}))})),he.promise}async function n(U,z){const{protocol:x}=await i(U,1,void 0,z);return{protocol:x}}async function r(U,z,x){const{protocol:_,firstMessage:H}=await i(U,2,z,x),X=H&&H.debugPort;return{protocol:_,debugPort:X}}async function o(U,z,x){const _=Date.now(),H=V(U,3),{protocol:X}=await a(U,3,z,x);return U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${j(_)}!`),X}async function s(U,z,x){const{host:_,port:H,connectionToken:X}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:_,port:H,connectionToken:X,reconnectionToken:z,reconnectionProtocol:x,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function c(U,z,x){return E(U,async _=>{const{protocol:H}=await n(_,l.CancellationToken.None);return new K(U,z,x,_.reconnectionToken,H)})}e.connectRemoteAgentManagement=c;async function w(U,z){return E(U,async x=>{const{protocol:_,debugPort:H}=await r(x,z,l.CancellationToken.None);return new W(U,z,x.reconnectionToken,_,H)})}e.connectRemoteAgentExtensionHost=w;async function E(U,z){for(let _=1;;_++)try{const H=(0,P.generateUuid)(),X=await s(U,H,null);return await z(X)}catch(H){if(_<5)U.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(H);else throw U.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(H),re.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(H)),H}}async function k(U,z,x){const _=await s(U,(0,P.generateUuid)(),null);return await o(_,{host:z,port:x},l.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function N(U){return(0,D.createCancelablePromise)(z=>new Promise((x,_)=>{const H=setTimeout(x,U*1e3);z.onCancellationRequested(()=>{clearTimeout(H),x()})}))}var M;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class ${constructor(z,x){this.reconnectionToken=z,this.millisSinceLastIncomingData=x,this.type=0}}e.ConnectionLostEvent=$;class T{constructor(z,x,_,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=x,this.durationSeconds=_,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=T;class B{constructor(z,x,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=x,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=B;class q{constructor(z,x,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=x,this.attempt=_,this.type=4}}e.ConnectionGainEvent=q;class G{constructor(z,x){this.reconnectionToken=z,this.connectionHealth=x,this.type=5}}e.ConnectionHealthChangedEvent=G;class Q{constructor(z,x,_,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=x,this.attempt=_,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class re extends R.Disposable{static triggerPermanentFailure(z,x,_){this._permanentFailure=!0,this.f=z,this.g=x,this.h=_,this.i.forEach(H=>H.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(z=>z.r())}static debugPauseSocketWriting(){this.i.forEach(z=>z.v())}get k(){return this.c||re._permanentFailure}constructor(z,x,_,H,X){super(),this.m=z,this.n=x,this.reconnectionToken=_,this.protocol=H,this.p=X,this.j=this.B(new L.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new q(this.reconnectionToken,0,0)),this.B(H.onSocketClose(te=>{const le=ce(this.m,this.reconnectionToken,!0);te?te.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${te.hadError}).`),te.error&&this.n.logService.error(te.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.n.logService.error(te.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(H.onSocketTimeout(te=>{const le=ce(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(H.onHighRoundTripTime(te=>{const le=oe(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(H.onDidChangeConnectionHealth(te=>{this.j.fire(new G(this.reconnectionToken,te))})),re.i.push(this),this.B((0,R.toDisposable)(()=>{const te=re.i.indexOf(this);te>=0&&re.i.splice(te,1)})),this.k&&this.u(re.f,re.g,re.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const z=ce(this.m,this.reconnectionToken,!0);this.n.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const x=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const H=_<x.length?x[_]:x[x.length-1];try{if(H>0){const te=N(H);this.j.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,te)),this.n.logService.info(`${z} waiting for ${H} seconds before reconnecting...`);try{await te}catch{}}if(this.k){this.n.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.n.logService.info(`${z} resolving connection...`);const X=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${z} connecting to ${X.host}:${X.port}...`),await this.w(X,u(f)),this.n.logService.info(`${z} reconnected!`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.n.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this.n.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.n.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((0,A.isCancellationError)(X)){this.n.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if(X instanceof m.RemoteAuthorityResolverError){this.n.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,m.RemoteAuthorityResolverError.isHandled(X));break}this.n.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k)}t(z,x,_){this.p?re.triggerPermanentFailure(z,x,_):this.u(z,x,_)}u(z,x,_){this.j.fire(new Q(this.reconnectionToken,z,x,_)),F(this.protocol)}v(){this.protocol.pauseSocketWriting()}}re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[],e.PersistentConnection=re;class K extends re{constructor(z,x,_,H,X){super(1,z,H,X,!0),this.client=this.B(new v.Client(X,{remoteAuthority:x,clientId:_},z.ipcLogger))}async w(z,x){await n(z,x)}}e.ManagementPersistentConnection=K;class W extends re{constructor(z,x,_,H,X){super(2,z,_,H,!1),this.y=x,this.debugPort=X}async w(z,x){await r(z,this.y,x)}}e.ExtensionHostPersistentConnection=W;function F(U){try{U.acceptDisconnect();const z=U.getSocket();U.dispose(),z.dispose()}catch(z){(0,A.onUnexpectedError)(z)}}function J(U){if(U&&U.type==="error"){const z=new Error(`Connection error: ${U.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function ee(U,z){for(;U.length<z;)U+=" ";return U}function oe(U,z){return`[remote-connection][${ee(h(U),13)}][${z.substr(0,5)}\u2026]`}function ce(U,z,x){return`${oe(U,z)}[${x?"reconnect":"initial"}]`}function V(U,z){return`${ce(z,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function j(U){return`${Date.now()-U} ms`}}),define(ne[226],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[227],se([0,1,86,153]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,A,L,R,I,S){const P=m=>S(m,void 0),v=D.createConnection({host:l,port:A},()=>{v.removeListener("error",P);const m=Buffer.alloc(16);for(let h=0;h<16;h++)m[h]=Math.round(Math.random()*256);const g=m.toString("base64"),f=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${A}${L}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];v.write(f.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",p),S(void 0,new O.NodeSocket(v,I)))};v.on("data",p)});v.setNoDelay(!0),v.once("error",P)}}}),define(ne[107],se([0,1,5,171]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var l;(function(A){A.disconnected={type:"disconnected"},A.uninitialized={type:"uninitialized"},A.connected=L=>({type:"connected",info:L}),A.connecting=L=>({type:"connecting",progress:L})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,O.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(ne[228],se([0,1,137,16,11]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,I){this.a=R,this.b=I}async request(R,I){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,D.request)(R,I);return this.b.trace("RequestService#request (browser) - success",R.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",R.url,S),S}}async resolveProxy(R){}};A=ye([Y(0,O.IConfigurationService),Y(1,l.ILogService)],A),e.RequestService=A}),define(ne[60],se([0,1,17,173,45,5,40]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=R;function I(p){return p.res.statusCode===204}async function S(p){return I(p)?null:(await(0,D.streamToBuffer)(p.stream)).toString()}e.asText=S;async function P(p){if(!R(p))throw new Error("Server returned "+p.res.statusCode);return S(p)}e.asTextOrError=P;async function v(p){if(!R(p))throw new Error("Server returned "+p.res.statusCode);if(I(p))return null;const u=(await(0,D.streamToBuffer)(p.stream)).toString();try{return JSON.parse(u)}catch(d){throw d.message+=`:
`+u,d}}e.asJson=v;function m(p){f(p)}e.updateProxyConfigurationsScope=m;let g;function f(p){const h=L.Registry.as(l.Extensions.Configuration),u=g;g={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[g],remove:u?[u]:[]})}f(2)}),define(ne[229],se([0,1,24,21,14,60]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,P=D.CancellationToken.None){if(I.scheme===O.Schemas.file||I.scheme===O.Schemas.vscodeRemote){await this.b.copy(I,S);return}const v={type:"GET",url:I.toString(!0)},m=await this.a.request(v,P);if(m.res.statusCode===200)await this.b.writeFile(S,m.stream);else{const g=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${g}`)}}};L=ye([Y(0,A.IRequestService),Y(1,l.IFileService)],L),e.DownloadService=L}),define(ne[230],se([0,1,17,24]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.a=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,S,P=O.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],P).then(async({res:v,stream:m})=>{const g=await(0,D.streamToBuffer)(m);return[{statusCode:v.statusCode,headers:v.headers},g]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class A{constructor(R){this.a=R}async request(R,I){const[S,P]=await this.a.call("request",[R],I);return{res:S,stream:(0,D.bufferToStream)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(ne[231],se([0,1,12,228,230]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(R,I,S,P){this.c=I,this.d=S,this.e=P,this.a=new O.RequestService(I,P),this.b=new l.RequestChannelClient(R.getChannel("request"))}request(R,I){return this.f().request(R,I)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,D.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(ne[108],se([0,1,66,5]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function l(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,O.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[232],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(O){O.Spawn="vscode:shared-process->shared-process-worker=spawn",O.Terminate="vscode:shared-process->shared-process-worker=terminate",O.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",O.Ready="vscode:shared-process-worker->shared-process=ready",O.Ack="vscode:shared-process-worker->shared-process=ack",O.Trace="vscode:shared-process-worker->shared-process=trace",O.Info="vscode:shared-process-worker->shared-process=info",O.Warn="vscode:shared-process-worker->shared-process=warn",O.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[233],se([0,1,94,6,24,3,2,21,31,11,108,232]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(p){this.d=p,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(p){const h=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${h})`);const u=(0,P.hash)(p);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${h})`),this.f(p));const d=new l.CancellationTokenSource;let y,b,C;this.b.set(u,n=>{d.dispose(!0),y?.terminate(p,l.CancellationToken.None),b?.close(),C?.close(),this.b.delete(u);const r=this.c.get(u);r&&(this.c.delete(u),r({reason:n}))}),y=await this.e(p);const t=new Promise(n=>{this.c.set(u,n)});if(d.token.isCancellationRequested)return t;const{port1:a,port2:i}=new MessageChannel;return b=a,C=i,await y.spawn(p,C,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${h})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[b])),t}e(p){let h=this.a.get(p.process.moduleId);if(!h){this.d.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const u=new g(p.process.type,this.d);h=u.init(),u.onDidProcessSelfTerminate(({configuration:d,reason:y})=>{this.f(d,y)}),this.a.set(p.process.moduleId,h)}return h}async disposeWorker(p){return this.f(p)}f(p,h){const u=this.b.get((0,P.hash)(p));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),u(h))}};m=ye([Y(0,S.ILogService)],m),e.SharedProcessWorkerService=m;class g extends L.Disposable{constructor(p,h){super(),this.f=p,this.g=h,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const p=new O.DeferredPromise,h=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return h.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},h.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},h.onmessage=u=>{const{id:d,message:y,configuration:b,nonce:C}=u.data;switch(d){case v.SharedProcessWorkerMessages.Ready:p.complete(h);break;case v.SharedProcessWorkerMessages.Ack:if(C){const t=this.c.get(C);t&&(this.c.delete(C),t())}break;case v.SharedProcessWorkerMessages.SelfTerminated:b&&y&&this.a.fire({configuration:b,reason:JSON.parse(y)});break;case v.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,y);break;case v.SharedProcessWorkerMessages.Info:y&&this.g.info(y);break;case v.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,y);break;case v.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,y);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},h.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async i(p,h,u){const d=await this.b;if(!h.isCancellationRequested)return new Promise(y=>{const b=(0,I.generateUuid)();this.c.set(b,y);const C={...p,nonce:b};u?d.postMessage(C,[u]):d.postMessage(C),h.onCancellationRequested(()=>{this.c.delete(b)&&y()})})}spawn(p,h,u){const d={id:v.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,u,h)}terminate(p,h){const u={id:v.SharedProcessWorkerMessages.Terminate,configuration:p};return this.i(u,h)}}}),define(ne[234],se([0,1,63,21,192]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}ye([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(ne[235],se([0,1,50,13,174,24,38,8,4,31,150,190,6,130]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let f;async function p(u,d,y,b){return y["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(b)&&!y["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(b)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(C,t)=>{const a=new A.CancellationTokenSource;let i=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,g.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,l.localize)(0,null)))},i);try{C(await h(d,a.token))}catch(o){!(0,R.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,l.localize)(1,null,(0,L.toErrorMessage)(o)))):C({})}finally{clearTimeout(r),a.dispose()}})),f)}e.getResolvedShellEnv=p;async function h(u,d){const y=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",y);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",b);const C=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(I.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(d.isCancellationRequested)return r(new R.CancellationError);const o=(0,O.basename)(i);let s,c;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(s=`& '${process.execPath}' ${w} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,c=["-Login","-Command"]):(s=`'${process.execPath}' ${w} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,o==="tcsh"||o==="csh"?c=["-ic"]:c=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),s);const E=(0,D.spawn)(i,[...c,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});d.onCancellationRequested(()=>(E.kill(),r(new R.CancellationError))),E.on("error",M=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(M)),r(M)});const k=[];E.stdout.on("data",M=>k.push(M));const N=[];E.stderr.on("data",M=>N.push(M)),E.on("close",(M,$)=>{const T=Buffer.concat(k).toString("utf8");u.trace("getUnixShellEnvironment#raw",T);const B=Buffer.concat(N).toString("utf8");if(B.trim()&&u.trace("getUnixShellEnvironment#stderr",B),M||$)return r(new Error((0,l.localize)(2,null,M,$)));const q=t.exec(T),G=q?q[1]:"{}";try{const Q=JSON.parse(G);y?Q.ELECTRON_RUN_AS_NODE=y:delete Q.ELECTRON_RUN_AS_NODE,b?Q.ELECTRON_NO_ATTACH_CONSOLE=b:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",Q),n(Q)}catch(Q){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(Q)),r(Q)}})})}}),define(ne[109],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[236],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.b=new Map}c(){return new Promise((l,A)=>Z(["vsda"],l,A))}async createNewMessage(l){try{const A=await this.c(),L=new A.validator;if(L){const R=String(D.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,A){if(!l.id)return!0;const L=this.b.get(l.id);if(!L)return!1;this.b.delete(l.id);try{return L.validate(A)==="ok"}catch{return!1}}async sign(l){try{const A=await this.c(),L=new A.signer;if(L)return L.sign(l)}catch{}return l}}D.a=1,e.SignService=D}),define(ne[76],se([0,1,3,2]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends O.Disposable{constructor(v,m,g){super(),this.a=v,this.b=m,this.c=g}async getItems(){const v={profile:this.b,workspace:this.c},m=await this.a.call("getItems",v);return new Map(m)}updateItems(v){const m={profile:this.b,workspace:this.c};return v.insert&&(m.insert=Array.from(v.insert.entries())),v.delete&&(m.delete=Array.from(v.delete.values())),this.a.call("updateItems",m)}}class A extends l{constructor(v,m){super(v,m,void 0),this.f=this.B(new D.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class L extends A{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class R extends A{constructor(v,m){super(v,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends l{constructor(v,m){super(v,void 0,m),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(v){this.a=v}isUsed(v){const m={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=S}),define(ne[110],se([0,1,4,36,10,31]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(S){if(D.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,P,v,m,g,f,p,h,u,d){const y=Object.create(null);y["common.machineId"]=p,y.sessionID=(0,A.generateUuid)()+Date.now(),y.commitHash=g,y.version=f,y["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=O.platform,y["common.nodeArch"]=m,y["common.product"]=d||"desktop",h&&(y["common.msftInternal"]=h);let b=0;const C=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const t=L(v);t&&(y["common.platformDetail"]=t);try{const a=await S.readFile(l.URI.file(u));y["common.source"]=a.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function I(S){const P=O.env.USERDNSDOMAIN;if(!P)return!1;const v=P.toLowerCase();return S.some(m=>v===m)}e.verifyMicrosoftInternalDomain=I}),define(ne[18],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[237],se([0,1,34,6,35,21,13,4,10,147,27,149,96,14,25,18]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,n=h.get(i);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,s=new Map,c=2e4;function w(k,N,M,$){const T=N.substring(k.length+1);return O.Promises.withAsyncBody(async B=>{let q;try{q=await P.Promises.readdir(N,{withFileTypes:!0})}catch{B();return}if($.count>=c){$.count+=q.length,$.maxReached=!0,B();return}let G=q.length;if(G===0){B();return}let Q=q;$.count+q.length>c&&($.maxReached=!0,G=c-$.count,Q=q.slice(0,G)),$.count+=q.length;for(const re of Q)if(re.isDirectory()){if(M.includes(re.name)||await w(k,(0,L.join)(N,re.name),M,$),--G===0){B();return}}else{const K=re.name.lastIndexOf(".");if(K>=0){const W=re.name.substring(K+1);W&&o.set(W,(o.get(W)??0)+1)}for(const W of r)W.relativePathPattern?.test(T)!==!1&&W.filePattern.test(re.name)&&s.set(W.tag,(s.get(W.tag)??0)+1);if(--G===0){B();return}}})}const E=O.Promises.withAsyncBody(async k=>{const N={count:0,maxReached:!1};await w(t,t,a,N);const M=await b(t);k({configFiles:d(s),fileTypes:d(o),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:M})});return h.set(i,E),E}e.collectWorkspaceStats=u;function d(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function y(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=y;async function b(t){try{const a=new Map,i=(0,L.join)(t,".vscode","launch.json"),n=await P.Promises.readFile(i),r=[],o=(0,l.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const s of o.configurations){const c=s.type;c&&(a.has(c)?a.set(c,a.get(c)+1):a.set(c,1))}return d(a)}catch{return[]}}e.collectLaunchConfigs=b;let C=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||i.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,v.listProcesses)(a.mainPID),this.k(a)]).then(async n=>{let[r,o]=n,s=this.m(a,r);return i.forEach(c=>{if((0,m.isRemoteDiagnosticError)(c))s+=`
${c.errorMessage}`,o+=`
${c.errorMessage}`;else if(s+=`

Remote: ${c.hostName}`,c.processes&&(s+=`
${this.m(a,c.processes)}`),c.workspaceMetadata){o+=`
|  Remote: ${c.hostName}`;for(const w of Object.keys(c.workspaceMetadata)){const E=c.workspaceMetadata[w];let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${w}): ${k}`,o+=this.h(E)}}}),{processInfo:s,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:o,cpus:s}=y(),c={os:o,memory:n,cpus:s,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return R.isWindows||(c.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(a,i){const n=[];return(0,v.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(o=>{if((0,m.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.f(o.machineInfo)),o.processes&&n.push(this.m(a,o.processes)),o.workspaceMetadata)for(const s of Object.keys(o.workspaceMetadata)){const c=o.workspaceMetadata[s];let w=`${c.fileCount} files`;c.maxFilesReached&&(w=`more than ${w}`),n.push(`Folder (${s}): ${w}`),n.push(this.h(c))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let r=0;const o=(E,k)=>{const N=` ${E}(${k})`;r+N.length>60?(i.push(s),s="|                 ",r=s.length):r+=N.length,s+=N};let s="|      File types:";const c=10,w=a.fileTypes.length>c?c:a.fileTypes.length;for(let E=0;E<w;E++){const k=a.fileTypes[E];o(k.name,k.count)}if(i.push(s),a.configFiles.length>=0&&(s="|      Conf files:",r=0,a.configFiles.forEach(E=>{o(E.name,E.count)}),i.push(s)),a.launchConfigFiles.length>0){let E="|      Launch Configs:";a.launchConfigFiles.forEach(k=>{E+=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`}),i.push(E)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const s=I.URI.revive(o);if(s.scheme===A.Schemas.file){const c=s.fsPath;n.push(u(c,["node_modules",".git"]).then(w=>{let E=`${w.fileCount} files`;w.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,L.basename)(c)}): ${E}`),i.push(this.h(w))}).catch(w=>{i.push(`|      Error: Unable to collect workspace stats for folder ${c} (${w.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(a,i){const n=new Map;a.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,r,i,0),r.join(`
`)}n(a,i,n,r,o){const s=o===0;let c;s?c=r.pid===a?`${this.d.applicationName} main`:"remote agent":(c=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(c=`${c} (${i.get(r.pid)})`));const w=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(w/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(r.children)&&r.children.forEach(E=>this.n(a,i,n,E,o+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const r=I.URI.revive(n);if(r.scheme!==A.Schemas.file)continue;const o=r.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(c=>i.add(c.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=I.URI.revive(i);if(n.scheme!==A.Schemas.file)continue;const r=n.fsPath;try{const o=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};C=ye([Y(0,p.ITelemetryService),Y(1,f.IProductService)],C),e.DiagnosticsService=C}),define(ne[238],se([0,1,107,3,18,15,2,11,13,50,25,4,6,103,16,172,34,10]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const d=[D.CONFIGURATION_KEY_HOST_NAME,D.CONFIGURATION_KEY_PREVENT_SLEEP];let y=class extends L.Disposable{constructor(C,t,a,i,n,r){super(),this.r=C,this.s=t,this.t=a,this.u=r,this.b=new O.Emitter,this.onDidTokenFailed=this.b.event,this.f=new O.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new O.Emitter,this.onDidChangeAccount=this.g.event,this.k=D.TunnelStates.disconnected;const o=u.URI.file((0,I.join)(a.logsPath,D.LOG_FILE_NAME));this.h=this.B(i.createLogger(o,{name:D.LOGGER_NAME,id:D.LOG_CHANNEL_ID})),this.n=new m.Delayer(100),this.B(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(s)))),this.B(n.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(r.onDidChangeConfiguration(s=>{d.some(c=>s.affectsConfiguration(c))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(C){if(C&&this.i?C.token!==this.i.token||C.providerId!==this.i.providerId:C!==this.i){this.i=C,this.g.fire(C),C?this.h.info(`Account updated: ${C.accountLabel} (${C.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!C});try{await this.n.trigger(()=>this.w())}catch(t){this.h.error(t)}}return this.k}v(){if(!this.p){let C;v.isMacintosh?C=this.t.appRoot:C=(0,I.dirname)((0,I.dirname)(this.t.appRoot)),this.p=(0,I.join)(C,"bin",`${this.s.tunnelApplicationName}${v.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(D.TunnelStates.disconnected);return}const{token:C,providerId:t,accountLabel:a}=this.i;this.y(D.TunnelStates.connecting((0,p.localize)(0,null,a,t)));const i=(c,w)=>{c=c.replaceAll(C,"*".repeat(4)),w?this.h.error(c):this.h.info(c),!this.t.isBuilt&&c.startsWith("   Compiling")&&this.y(D.TunnelStates.connecting((0,p.localize)(1,null)))},n=this.z("login",["user","login","--provider",t,"--access-token",C,"--log",(0,R.LogLevelToString)(this.h.getLevel())],i);this.j=n;try{if(await n,this.j!==n)return}catch(c){this.h.error(c),this.j=void 0,this.b.fire(!0),this.y(D.TunnelStates.disconnected);return}const r=this.D();r?this.y(D.TunnelStates.connecting((0,p.localize)(2,null,r))):this.y(D.TunnelStates.connecting((0,p.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];r?o.push("--name",r):o.push("--random-name"),this.C()&&o.push("--no-sleep");const s=this.z("tunnel",o,(c,w)=>{w?this.h.error(c):this.h.info(c);const E=c.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const k={link:E[1],domain:E[2],hostName:E[4]};this.y(D.TunnelStates.connected(k))}else c.match(/error refreshing token/)&&(s.cancel(),this.b.fire(!0),this.y(D.TunnelStates.disconnected))});this.j=s,s.finally(()=>{s===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(C){this.k=C,this.f.fire(C)}z(C,t,a=()=>{}){return(0,m.createCancelablePromise)(i=>new Promise((n,r)=>{i.isCancellationRequested&&n();let o;if(i.onCancellationRequested(()=>{o&&(this.h.info(`${C} terminating(${o.pid})`),o.kill())}),!this.t.isBuilt)a("Building tunnel CLI from sources and run",!1),a(`${C} Spawning: cargo run -- tunnel ${t.join(" ")}`,!1),o=(0,S.spawn)("cargo",["run","--","tunnel",...t],{cwd:(0,I.join)(this.t.appRoot,"cli")});else{a("Running tunnel CLI",!1);const s=this.v();a(`${C} Spawning: ${s} tunnel ${t.join(" ")}`,!1),o=(0,S.spawn)(s,["tunnel",...t],{cwd:(0,h.homedir)()})}o.stdout.on("data",s=>{if(o){const c=s.toString();a(c,!1)}}),o.stderr.on("data",s=>{if(o){const c=s.toString();a(c,!0)}}),o.on("exit",s=>{o&&(a(`${C} exit(${o.pid}): + ${s} `,!1),o=void 0,s===0?n():r())}),o.on("error",s=>{o&&(a(`${C} error(${o.pid}): + ${s} `,!0),o=void 0,r())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(D.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let C=this.u.getValue(D.CONFIGURATION_KEY_HOST_NAME)||(0,h.hostname)();return C=C.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),C||void 0}};y=ye([Y(0,l.ITelemetryService),Y(1,P.IProductService),Y(2,A.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,g.ISharedProcessLifecycleService),Y(5,f.IConfigurationService)],y),e.RemoteTunnelService=y}),define(ne[111],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.b=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,{eventName:R,data:I}){return this.b.forEach(S=>S.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class O{constructor(A){this.b=A}log(A,L){return this.b.call("log",{eventName:A,data:L}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(ne[47],se([0,1,32,12,3,16,75,110,18]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(s){this.value=s}}e.TelemetryTrustedValue=S;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,c){return Promise.resolve(void 0)}publicLog2(s,c){return this.publicLog(s,c)}publicLogError(s,c){return Promise.resolve(void 0)}publicLogError2(s,c){return this.publicLogError(s,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class v{async publicLog(s,c,w){}async publicLogError(s,c,w){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(o,s){return l.Event.debounce(s.onDidChangeConfiguration,(w,E)=>{const k=w?new Set([...w.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:k}},1e3,!0)(w=>{w.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(w.source),configurationKeys:b(w.affectedKeys)})})}e.configurationTelemetry=m;function g(o,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!o.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=g;function f(o,s){return!(s.isBuilt||s.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=f;function p(o){const s=o.getValue(I.TELEMETRY_SETTING_ID),c=o.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function h(o){const s={},c={},w={};y(o,w);for(let E in w){E=E.length>150?E.substr(E.length-149):E;const k=w[E];typeof k=="number"?c[E]=k:typeof k=="boolean"?c[E]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${k.length}`),s[E]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(s[E]=k)}return{properties:s,measurements:c}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(o){if(!o)return"none";const s=(0,L.getRemoteName)(o);return u.has(s)?s:"other"}e.cleanRemoteAuthority=d;function y(o,s,c=0,w){if(!!o)for(const E of Object.getOwnPropertyNames(o)){const k=o[E],N=w?w+E:E;Array.isArray(k)?s[N]=(0,D.safeStringify)(k):k instanceof Date?s[N]=k.toISOString():(0,O.isObject)(k)?c<2?y(k,s,c+1,N+"."):s[N]=(0,D.safeStringify)(k):s[N]=k}}function b(o){if(!o)return[];const s=[];return C(s,"",o),s}function C(o,s,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(w=>C(o,s?`${s}.${w}`:w,c[w])):o.push(s)}function t(o,s){const c=o.msftInternalDomains||[],w=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(c)||w}e.isInternalTelemetry=t;function a(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(o,s){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let c=o;const w=[];for(const M of s)for(;;){const $=M.exec(o);if(!$)break;w.push([$.index,M.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(c="";;){const M=k.exec(o);if(!M)break;const $=w.some(([T,B])=>M.index<B&&T<k.lastIndex);!E.test(M[0])&&!$&&(c+=o.substring(N,M.index)+"<REDACTED: user-file-path>",N=k.lastIndex)}return N<o.length&&(c+=o.substr(N)),c}function n(o){if(!o)return o;const s=o.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of c)if(w.regex.test(s))return`<REDACTED: ${w.label}>`;return o}function r(o,s){return(0,D.cloneAndChange)(o,c=>{if(c instanceof S)return c.value;if(typeof c=="string"){let w=c.replaceAll("%20"," ");w=i(w,s);for(const E of s)w=w.replace(E,"");return w=n(w),w}})}e.cleanData=r}),define(ne[33],se([0,1,26,29,46,4,10,8,36,47]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,D.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=P;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,r,o)}static parse(n){const r=v.exec(n);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(i){const n=g.exec(i);return n&&n[1]?[h(n[1]),n[2]]:[h(i),void 0]}e.getIdAndVersion=f;function p(i,n){return`${i}.${n}`}e.getExtensionId=p;function h(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(i,n){return h(p(i,n))}e.getGalleryExtensionId=u;function d(i,n){const r=[],o=s=>{for(const c of r)if(c.some(w=>P(n(w),n(s))))return c;return null};for(const s of i){const c=o(s);c?c.push(s):r.push([s])}return r}e.groupByExtension=d;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function b(i){return{id:new S.TelemetryTrustedValue(i.identifier.id),name:new S.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function C(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const s=o.shift();if(s&&r.every(c=>!P(c.identifier,{id:s}))){const c=i.filter(w=>P(w.identifier,{id:s}));c.length===1&&(r.push(c[0]),o.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=C;async function t(i,n){if(!A.isLinux)return!1;let r;try{r=(await i.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const r=await t(i,n),o=(0,O.getTargetPlatform)(r?"alpine":A.platform,I.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ne[239],se([0,1,24,33]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(A,L,R,I,S){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const v=await A.getInstalled(1);for(const[m,g]of Object.entries(P.deprecated)){if(!g?.extension)continue;const{id:f,autoMigrate:p,preRelease:h}=g.extension;if(!p)continue;const u=v.find(y=>(0,O.areSameExtensions)(y.identifier,{id:m}));if(!u)continue;const d=(await L.getExtensions([{id:f,preRelease:h}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const y=!I.getDisabledExtensions().some(C=>(0,O.areSameExtensions)(C,u.identifier));await A.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let b=v.find(C=>(0,O.areSameExtensions)(C.identifier,{id:f}));(!b||!b.isPreReleaseVersion&&y)&&(b=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${b.identifier.id}'`),y||(await I.disableExtension(b.identifier),S.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,O.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,O.getExtensionId)(b.manifest.publisher,b.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(y){S.error(y)}}}catch(P){S.error(P)}}e.migrateUnsupportedExtensions=l}),define(ne[240],se([0,1,6,8,2,21,4,22,54,12,31,27,16,15,29,33,98,14,11]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class mt extends l.Disposable{constructor(C,t,a,i,n,r){super(),this.h=t,this.i=a,this.j=i,this.k=n,this.l=r,this.extensionsDownloadDir=C.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(C,t){await this.g;const a=(0,R.joinPath)(this.extensionsDownloadDir,this.v(C));try{await this.r(C,a,n=>this.i.download(C,n,t))}catch(n){throw new f.ExtensionManagementError(n.message,f.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.m(C)){const n=await this.n(C);try{await this.k.verify(a.fsPath,n.fsPath)&&(i="Verified"),this.l.info(`Extension signature verification: ${C.identifier.id}. Verification status: ${i}.`)}catch(r){const o=r,s=o.code;if(s==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${C.identifier.id}. Verification status: ${i}.`);else if(!o.didExecute)this.l.warn(`Extension signature verification: ${C.identifier.id}. Verification status: ${i} (${s})`);else throw await this.delete(n),await this.delete(a),new f.ExtensionManagementError(s,f.ExtensionManagementErrorCode.Signature)}}return{location:a,verificationStatus:i}}async m(C){if(!C.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(t)?t:!0}async n(C){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,`${this.v(C)}${mt.c}`);return await this.r(C,t,a=>this.i.downloadSignatureArchive(C,a)),t}async r(C,t,a){if(await this.h.exists(t))return;if(t.scheme!==A.Schemas.file){await a(t);return}const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await a(i);try{await this.t(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",C.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,O.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(C){await this.g,await this.h.del(C)}async t(C,t,a){try{await v.Promises.rename(C.fsPath,t.fsPath)}catch(i){if(L.isWindows&&i&&i.code==="EPERM"&&Date.now()<a)return this.l.info(`Failed renaming ${C} to ${t} with 'EPERM' error. Trying again...`),this.t(C,t,a);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const C=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(C.children){const t=[],a=[],i=[];for(const o of C.children)if(o.name.endsWith(mt.c))i.push(o.resource);else{const s=p.ExtensionKey.parse(o.name);s&&a.push([s,o])}const n=(0,p.groupByExtension)(a,([o])=>o),r=[];for(const o of n)o.sort((s,c)=>I.rcompare(s[0].version,c[0].version)),t.push(...o.slice(1).map(s=>s[1].resource)),r.push(o[0][1]);r.sort((o,s)=>o.mtime-s.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),t.push(...i),await D.Promises.settled(t.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(C){this.l.error(C)}}v(C){return this.f?p.ExtensionKey.create(C).toString().toLowerCase():(0,P.generateUuid)()}};y.c=".sigzip",y=ye([Y(0,g.INativeEnvironmentService),Y(1,u.IFileService),Y(2,f.IExtensionGalleryService),Y(3,m.IConfigurationService),Y(4,h.IExtensionSignatureVerificationService),Y(5,d.ILogService)],y),e.ExtensionsDownloader=y}),define(ne[241],se([0,1,3,2,37,33,46]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(S,P,v,m,g,f,p){super(),this.f=S,this.g=P,this.h=v,this.i=m,this.j=g,this.k=f,this.l=p,this.a=this.B(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,h=>p.error(h))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,P){try{await Promise.all(P.map(v=>(this.c.deleteAndDispose(v.id),this.z(v.extensionsResource)))),S.length&&await Promise.all(S.map(v=>(this.c.set(v.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(v.extensionsResource)),this.k.watch(v.extensionsResource))),this.y(v.extensionsResource))))}catch(v){throw this.l.error(v),v}}async r(S){for(const P of S.extensions)this.D(this.G(P.identifier,P.version),S.profileLocation)}async s(S){for(const P of S.extensions){const v=this.G(P.identifier,P.version);S.error?this.F(v,S.profileLocation):this.D(v,S.profileLocation)}}async t(S){for(const P of S.extensions)this.F(this.G(P.identifier,P.version),S.profileLocation)}async u(S){const P=[],v=[];for(const m of S.extensions){const g=this.G(m.identifier,m.version);S.error?this.D(g,S.profileLocation):(this.F(g,S.profileLocation),this.b.has(g)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),v.push(this.f.scanInstalledExtensionAtLocation(m.location).then(f=>{f?P.push(f):this.l.info("Extension not found at the location",m.location.toString())},f=>this.l.error(f)))))}try{await Promise.all(v),P.length&&await this.C(P)}catch(m){this.l.error(m)}}v(S){for(const P of this.h.profiles)S.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(S){const P=[],v=[],m=await this.i.scanProfileExtensions(S),g=new Set,f=new Set;for(const[p,h]of this.b)h.has(S)&&f.add(p);for(const p of m){const h=this.G(p.identifier,p.version);g.add(h),f.has(h)||(P.push(p.identifier),this.D(h,S))}for(const p of f)if(!g.has(p)){const h=this.H(p);h&&(v.push(h.identifier),this.F(p,S))}(P.length||v.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:S}:void 0,removed:v.length?{extensions:v,profileLocation:S}:void 0})}async y(S){const P=await this.i.scanProfileExtensions(S);for(const v of P)this.D(this.G(v.identifier,v.version),S)}async z(S){for(const P of[...this.b.keys()])this.F(P,S);await this.C()}async C(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.G(v.identifier,v.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}D(S,P){let v=this.b.get(S);v||this.b.set(S,v=new l.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),v.add(P)}F(S,P){const v=this.b.get(S);v&&v.delete(P),v?.size||this.b.delete(S)}G(S,P){return`${L.ExtensionIdentifier.toKey(S.id)}@${P}`}H(S){const[P,v]=(0,A.getIdAndVersion)(S);return v?{identifier:{id:P},version:v}:void 0}}e.ExtensionsWatcher=R}),define(ne[242],se([0,1,44,47]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(A,L,R,I,S,P,v){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${L.nameShort})`};if((0,O.supportsTelemetry)(L,R)&&(0,O.getTelemetryLevel)(I)===3){const g=await(0,D.getServiceMachineId)(R,S,P),{machineId:f}=await v.getTelemetryInfo();m["X-Market-User-Id"]=g,m["VSCode-SessionId"]=f||g}return m}e.resolveMarketplaceHeaders=l}),define(ne[243],se([0,1,100,20,6,2,21,13,27,15,29,33,11,73,4,10]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends g.LanguagePackBaseService{constructor(b,C,t,a){super(t),this.h=b,this.i=a,this.g=this.B(new u(C,a)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(b){const t=(await this.g.getLanguagePacks())[f.Language.value()];if(!t){this.i.warn(`No language pack found for ${f.Language.value()}`);return}const a=t.translations[b];return a?p.URI.file(a):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),C=Object.keys(b).map(t=>{const a=b[t];return{...this.f(t,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return C.push(this.f("en","English")),C.sort((t,a)=>t.label.localeCompare(a.label)),C}async j(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",b.identifier.id),await this.update())}async k(b){const C=await this.g.getLanguagePacks();Object.keys(C).some(t=>C[t]&&C[t].extensions.some(a=>(0,v.areSameExtensions)(a.extensionIdentifier,b.identifier)))&&(this.i.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,C]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(C);return!(0,O.equals)(Object.keys(b),Object.keys(t))}};h=ye([Y(0,P.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,P.IExtensionGalleryService),Y(3,m.ILogService)],h),e.NativeLanguagePackService=h;let u=class extends A.Disposable{constructor(b,C){super(),this.i=C,this.c={},this.f=(0,R.join)(b.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.m(C=>{Object.keys(C).forEach(t=>delete C[t]),this.j(C,...b)}).then(()=>this.c)}j(b,...C){for(const t of C)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(b,t);Object.keys(b).forEach(t=>this.l(b[t]))}k(b,C){const t=C.identifier,a=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const i of a)if(C.location.scheme===L.Schemas.file&&d(i)){let n=b[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},b[i.languageId]=n);const r=n.extensions.filter(o=>(0,v.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=C.manifest.version:n.extensions.push({extensionIdentifier:t,version:C.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,R.join)(C.location.fsPath,o.path)}}l(b){if(b){const C=(0,D.createHash)("md5");for(const t of b.extensions)C.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);b.hash=C.digest("hex")}}m(b=()=>null){return this.g.queue(()=>{let C=null;return I.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(C=b(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const a=JSON.stringify(this.c);return this.i.debug("Writing language packs",a),I.Promises.writeFile(this.f,a)}).then(()=>C,t=>this.i.error(t))})}};u=ye([Y(0,S.INativeEnvironmentService),Y(1,m.ILogService)],u);function d(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const b of y.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}}),define(ne[244],se([0,1,8,32,47]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",L="https://mobile.events.data.microsoft.com/ping";async function R(S,P,v){const m=await new Promise((u,d)=>{Z(["@microsoft/1ds-core-js"],u,d)}),g=await new Promise((u,d)=>{Z(["@microsoft/1ds-post-js"],u,d)}),f=new m.AppInsightsCore,p=new g.PostChannel,h={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(v){h.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};h.extensionConfig[p.identifier]=u}return f.initialize(h,[]),f.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),f}class I{constructor(P,v,m,g,f){this.e=P,this.f=v,this.g=m,this.h=f,this.c=A,this.d=L,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(v=>{P(v)},v=>{(0,D.onUnexpectedError)(v),console.error(v)})}}log(P,v){if(!this.a)return;v=(0,O.mixin)(v,this.g),v=(0,l.validateTelemetryData)(v);const m=this.f+"/"+P;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:m,baseData:{name:m,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(ne[112],se([0,1,2,175,15,11,25,47]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends D.Disposable{constructor(P,v,m,g,f=""){super(),this.b=f;const p=v.getLogger(m.telemetryLogResource);if(p)this.a=this.B(p);else{const u=(0,R.isLoggingOnly)(g,m)?" (Not Sent)":"",d=m.telemetryLogResource,y=()=>(0,R.supportsTelemetry)(g,m)&&P.getLevel()===A.LogLevel.Trace;this.a=this.B(v.createLogger(d,{id:R.telemetryLogChannelId,name:(0,O.localize)(0,null,u),hidden:!y()})),this.B(P.onDidChangeLogLevel(()=>v.setVisibility(d,y()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,v){this.a.trace(`${this.b}telemetry/${P}`,(0,R.validateTelemetryData)(v))}};I=ye([Y(0,A.ILogService),Y(1,A.ILoggerService),Y(2,l.IEnvironmentService),Y(3,L.IProductService)],I),e.TelemetryLogAppender=I}),define(ne[113],se([0,1,2,32,4,26,176,16,45,105,25,40,18,47]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,d,y){this.k=d,this.l=y,this.d={},this.i=new D.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.TELEMETRY_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,g.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const y=d.usage?3:d.error?2:0;u=Math.min(u,y)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,d=u.sessionID,y=u["common.machineId"],b=u["common.firstSessionDate"],C=u["common.msftInternal"];return{sessionId:d,machineId:y,firstSessionDate:b,msftInternal:C}}dispose(){this.i.dispose()}n(u,d,y){return this.g<d?Promise.resolve(void 0):this.c.then(b=>{y=(0,O.mixin)(y,this.d),y=(0,g.cleanData)(y,this.j),y=(0,O.mixin)(y,b),this.b.forEach(C=>C.log(u,y))},b=>{console.error(b)})}publicLog(u,d){return this.n(u,3,d)}publicLog2(u,d){return this.publicLog(u,d)}publicLogError(u,d){return this.h?this.n(u,2,d):Promise.resolve(void 0)}publicLogError2(u,d){return this.publicLogError(u,d)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=ye([Y(1,R.IConfigurationService),Y(2,P.IProductService)],f),e.TelemetryService=f;function p(){const h=(0,L.localize)(0,null,S.default.nameLong),u=S.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=l.isWeb?"":(0,L.localize)(3,null),y=(0,L.localize)(4,null),b=(0,L.localize)(5,null),C=(0,L.localize)(6,null),t=(0,L.localize)(7,null),a=`
|       | ${y} | ${b} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,L.localize)(8,null);return`
${h} ${u} ${d}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,L.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[245],se([0,1,296,244]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends O.AbstractOneDataSystemAppender{constructor(L,R,I,S){const P={sendPOST:(v,m)=>{const g={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const f=D.request(v.urlString,g,p=>{p.on("data",function(h){m(p.statusCode??200,p.headers,h.toString())}),p.on("error",function(h){m(0,{})})});f.write(v.data),f.end()}catch{m(0,{})}}};super(L,R,I,S,P)}}e.OneDataSystemAppender=l}),define(ne[246],se([0,1,21,68,16,15,11,25,18,111,112,113]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(f,p,h,u,d,y){this.b=f,this.c=p,this.d=h,this.e=u,this.f=d,this.g=y,this.a=new Map}async h(f){if(!this.a.has(f.id)){const{machineId:p,sessionId:h}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=p,u["common.vscodesessionid"]=h;const d=[f.id,JSON.stringify(u),f.aiKey],b=new O.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=[new S.TelemetryAppenderClient(b),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${f.id}] `)];this.a.set(f.id,new v.TelemetryService({appenders:C,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.g))}return this.a.get(f.id)}async publicLog(f,p,h){await(await this.h(f)).publicLog(p,h)}async publicLogError(f,p,h){await(await this.h(f)).publicLogError(p,h)}};m=ye([Y(0,l.IConfigurationService),Y(1,I.ITelemetryService),Y(2,L.ILogService),Y(3,L.ILoggerService),Y(4,A.IEnvironmentService),Y(5,R.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[114],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var D;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(D=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ne[247],se([0,1,4,114]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(I){this.collections=I,this.map=new Map,I.forEach((S,P)=>{const v=S.map.entries();let m=v.next();for(;!m.done;){const g=m.value[0];let f=this.map.get(g);if(f||(f=[],this.map.set(g,f)),f.length>0&&f[0].type===O.EnvironmentVariableMutatorType.Replace){m=v.next();continue}const p=m.value[1];f.unshift({extensionIdentifier:P,value:p.value,type:p.type}),m=v.next()}})}async applyToProcessEnvironment(I,S){let P;D.isWindows&&(P={},Object.keys(I).forEach(v=>P[v.toLowerCase()]=v));for(const[v,m]of this.map){const g=D.isWindows&&P[v.toLowerCase()]||v;for(const f of m){const p=S?await S(f.value):f.value;switch(f.type){case O.EnvironmentVariableMutatorType.Append:I[g]=(I[g]||"")+p;break;case O.EnvironmentVariableMutatorType.Prepend:I[g]=p+(I[g]||"");break;case O.EnvironmentVariableMutatorType.Replace:I[g]=p;break}}}}diff(I){const S=new Map,P=new Map,v=new Map;if(I.map.forEach((m,g)=>{const f=this.map.get(g),p=A(m,f);p&&S.set(g,p)}),this.map.forEach((m,g)=>{const f=I.map.get(g),p=A(m,f);p&&v.set(g,p)}),this.map.forEach((m,g)=>{const f=I.map.get(g),p=L(m,f);p&&P.set(g,p)}),!(S.size===0&&P.size===0&&v.size===0))return{added:S,changed:P,removed:v}}}e.MergedEnvironmentVariableCollection=l;function A(R,I){if(!I)return R;const S=new Set;I.forEach(v=>S.add(v.extensionIdentifier));const P=[];return R.forEach(v=>{S.has(v.extensionIdentifier)||P.push(v)}),P.length===0?void 0:P}function L(R,I){if(!I)return;const S=new Map;I.forEach(v=>S.set(v.extensionIdentifier,v));const P=[];return R.forEach(v=>{const m=S.get(v.extensionIdentifier);m&&(v.type!==m.type||v.value!==m.value)&&P.push(m)}),P.length===0?void 0:P}}),define(ne[248],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function D(L){return[...L.entries()]}e.serializeEnvironmentVariableCollection=D;function O(L){return new Map(L)}e.deserializeEnvironmentVariableCollection=O;function l(L){return Array.from(L.entries()).map(R=>[R[0],D(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function A(L){return new Map(L.map(R=>[R[0],{map:O(R[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(ne[249],se([0,1,6,24,3,2,11]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(S,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((P,v)=>{const m=++this.a;this.c.set(m,P),this.g.fire({requestId:m,...S});const g=new O.CancellationTokenSource;(0,D.timeout)(this.b,g.token).then(()=>v(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,A.toDisposable)(()=>g.cancel())])})}acceptReply(S,P){const v=this.c.get(S);v?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),v(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=ye([Y(1,L.ILogService)],R),e.RequestStore=R}),define(ne[115],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var O;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(O=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsDefaultColor="terminal.integrated.tabs.defaultColor",y.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.TabStopWidth="terminal.integrated.tabStopWidth",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoEnabled="terminal.integrated.localEchoEnabled",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",y.AutoReplies="terminal.integrated.autoReplies",y.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",y.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",y.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",y.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",y.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",y.SmoothScrolling="terminal.integrated.smoothScrolling",y.AccessibleBufferContentEditable="terminal.integrated.accessibleBufferContentEditable"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(y){y.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(y){y.PowerShell="pwsh",y.Bash="bash",y.Fish="fish",y.Sh="sh",y.Csh="csh",y.Ksh="ksh",y.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var R;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Logger="logger",y.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var P;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions",y.FailedShellIntegrationActivation="failedShellIntegrationActivation",y.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var v;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var g;(function(y){y.TerminalView="view",y.Editor="editor"})(g=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}));var u;(function(y){y[y.Off=0]="Off",y[y.FinalTerm=1]="FinalTerm",y[y.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(y){y[y.Unknown=0]="Unknown",y[y.Shutdown=1]="Shutdown",y[y.Process=2]="Process",y[y.User=3]="User",y[y.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[250],se([0,1,52,10,178,133]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(m,g){const f=[{name:null,description:(0,l.localize)(0,null)}];return f.push(...m.map(p=>({name:p.profileName,description:R(p)}))),g&&f.push(...g.map(p=>({name:p.title,description:I(p)}))),{values:f.map(p=>p.name),markdownDescriptions:f.map(p=>p.description)}}e.createProfileSchemaEnums=L;function R(m){let g=`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?g+=`
- args: "${m.args}"`:g+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(g+=`
- overrideName: ${m.overrideName}`),m.color&&(g+=`
- color: ${m.color}`),m.env&&(g+=`
- env: ${JSON.stringify(m.env)}`),g}function I(m){return`$(${A.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:D.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function S(m,g){if(!m&&!g)return!0;if(typeof m=="string"&&typeof g=="string")return m===g;if(Array.isArray(m)&&Array.isArray(g)){if(m.length!==g.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==g[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function P(m,g){if(!m&&!g)return!0;if(!m||!g)return!1;if(A.ThemeIcon.isThemeIcon(m)&&A.ThemeIcon.isThemeIcon(g))return m.id===g.id&&m.color===g.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof g=="object"&&"light"in g&&"dark"in g){const f=m,p=g;if((O.URI.isUri(f.light)||v(f.light))&&(O.URI.isUri(f.dark)||v(f.dark))&&(O.URI.isUri(p.light)||v(p.light))&&(O.URI.isUri(p.dark)||v(p.dark)))return f.light.path===p.light.path&&f.dark.path===p.dark.path}if(O.URI.isUri(m)&&O.URI.isUri(g)||v(m)||v(g)){const f=m,p=g;return f.path===p.path&&f.scheme===p.scheme}return!1}e.terminalIconsEqual=P;function v(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=v}),define(ne[251],se([0,1,52,177,45,40,250]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,D.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,D.getAllCodicons)(),b=>`$(${b.id})`)};const R={args:{description:(0,O.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,O.localize)(1,null),type:"boolean"},icon:{description:(0,O.localize)(2,null),...e.terminalIconSchema},color:{description:(0,O.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,O.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,O.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),v=(0,O.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,O.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g=(0,O.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,O.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,O.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,O.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:v},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,O.localize)(26,null)}},{type:"string",markdownDescription:(0,O.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,O.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(30,null),type:"string"},id:{description:(0,O.localize)(31,null),type:"string"},title:{description:(0,O.localize)(32,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(34,null),type:"string"},id:{description:(0,O.localize)(35,null),type:"string"},title:{description:(0,O.localize)(36,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(38,null),type:"string"},id:{description:(0,O.localize)(39,null),type:"string"},title:{description:(0,O.localize)(40,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,O.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,O.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,O.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,O.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,O.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){A.Registry.as(l.Extensions.Configuration).registerConfiguration(h),y()}e.registerTerminalPlatformConfiguration=u;let d;function y(b,C){const t=A.Registry.as(l.Extensions.Configuration);let a;b&&(a=(0,L.createProfileSchemaEnums)(b?.profiles,C));const i=d;d={id:"terminal",order:100,title:(0,O.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?a?.values:void 0,markdownEnumDescriptions:b?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?a?.values:void 0,markdownEnumDescriptions:b?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?a?.values:void 0,markdownEnumDescriptions:b?.os===1?a?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[d],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(ne[252],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[253],se([0,1,34,21,32,13,4,36,26,12,27,114,248,247]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let r=0;return n&&n.length===4&&(r=parseInt(n[3])),r}e.getWindowsBuildNumber=f;async function p(n,r,o,s=R.env,c=P.Promises.exists){if(A.isAbsolute(n))return await c(n)?n:void 0;if(r===void 0&&(r=R.cwd()),A.dirname(n)!=="."){const N=A.join(r,n);return await c(N)?N:void 0}const E=(0,l.getCaseInsensitive)(s,"PATH");if(o===void 0&&(0,S.isString)(E)&&(o=E.split(A.delimiter)),o===void 0||o.length===0){const N=A.join(r,n);return await c(N)?N:void 0}for(const N of o){let M;if(A.isAbsolute(N)?M=A.join(N,n):M=A.join(r,N,n),await c(M))return M;if(L.isWindows){let $=M+".com";if(await c($)||($=M+".exe",await c($)))return $}}const k=A.join(r,n);return await c(k)?k:void 0}e.findExecutable=p;function h(n,r,o,s,c){const w=L.isWindows&&(!r.windowsEnableConpty||f()<18309);if(!r.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||w)return;const E=n.args,k=R.platform==="win32"?A.basename(n.executable).toLowerCase():A.basename(n.executable),N=A.dirname(O.FileAccess.asFileUri("").fsPath);let M;const $={VSCODE_INJECTION:"1"};if(L.isWindows){if(k==="pwsh.exe"||k==="powershell.exe")return!E||a(E)?M=y.get(d.WindowsPwsh):t(E)&&(M=y.get(d.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N,""),r.shellIntegration.suggestEnabled&&($.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:$}):void 0;s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(k){case"bash":return!E||E.length===0?M=y.get(d.Bash):i(E)&&($.VSCODE_SHELL_LOGIN="1",u(r,$),M=y.get(d.Bash)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N),{newArgs:M,envMixin:$}):void 0;case"fish":{const T=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",B=A.join(N,"out/vs/workbench/contrib/xdg_data");return $.XDG_DATA_DIRS=`${T}:${B}`,u(r,$),{newArgs:void 0,envMixin:$}}case"pwsh":return!E||a(E)?M=y.get(d.Pwsh):t(E)&&(M=y.get(d.PwshLogin)),M?(r.shellIntegration.suggestEnabled&&($.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N,""),{newArgs:M,envMixin:$}):void 0;case"zsh":{if(!E||E.length===0?M=y.get(d.Zsh):i(E)?(M=y.get(d.ZshLogin),u(r,$)):(E===y.get(d.Zsh)||E===y.get(d.ZshLogin))&&(M=E),!M)return;M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N);let T;try{T=D.userInfo().username}catch{T="unknown"}const B=A.join(D.tmpdir(),`${T}-${c.applicationName}-zsh`);$.ZDOTDIR=B;const q=o?.ZDOTDIR??D.homedir()??"~";$.USER_ZDOTDIR=q;const G=[];return G.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(B,".zshrc")}),G.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(B,".zprofile")}),G.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(B,".zshenv")}),G.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(B,".zlogin")}),{newArgs:M,envMixin:$,filesToCopy:G}}}s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=h;function u(n,r){if(L.isMacintosh&&n.environmentVariableCollections){const o=(0,m.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),c=new g.MergedEnvironmentVariableCollection(o).map.get("PATH"),w=[];if(c)for(const E of c)E.type===v.EnvironmentVariableMutatorType.Prepend&&w.push(E.value);w.length>0&&(r.VSCODE_PATH_PREFIX=w.join(""))}}var d;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(d||(d={}));const y=new Map;y.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(d.Zsh,["-i"]),y.set(d.ZshLogin,["-il"]),y.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],C=["-nol","-nologo"];function t(n){return typeof n=="string"?b.includes(n.toLowerCase()):n.length===1&&b.includes(n[0].toLowerCase())||n.length===2&&(b.includes(n[0].toLowerCase())||b.includes(n[1].toLowerCase()))&&(C.includes(n[0].toLowerCase())||C.includes(n[1].toLowerCase()))}function a(n){return typeof n=="string"?C.includes(n.toLowerCase()):n.length===0||n?.length===1&&C.includes(n[0].toLowerCase())}function i(n){return n==="string"&&b.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&b.includes(n[0].toLowerCase())}}),define(ne[254],se([0,1,50,52,13,4,12,27,91,253]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,v=!0;function m(a,i,n,r,o=process.env,s,c,w,E){return s=s||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},A.isWindows?g(n,s,o,c,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),E,w):b(s,c,n,a&&typeof a=="object"?{...a}:r.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,w,o)}e.detectAvailableProfiles=m;async function g(a,i,n,r,o,s,c,w,E){const k=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${k?"Sysnative":"System32"}`;let M=!1;(0,S.getWindowsBuildNumber)()>=16299&&(M=!0),await h(w);const $=new Map;if(a){$.set("PowerShell",{source:"PowerShell",icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:O.Codicon.terminalCmd,isAutoDetected:!0}),$.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),$.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.Codicon.terminalBash,isAutoDetected:!0});const B=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;$.set("Cmder",{path:`${N}\\cmd.exe`,args:["/K",B],requiresPath:process.env.CMDER_ROOT?B:{path:B,isUnsafe:!0},isAutoDetected:!0})}C(s,$);const T=await f($.entries(),c,i,n,r,E);if(a||o)try{const B=await d(`${N}\\${M?"wsl":"bash"}.exe`,c);for(const q of B)(!s||!(q.profileName in s))&&T.push(q)}catch{v&&(r?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return T}async function f(a,i,n,r=process.env,o,s){const c=[];for(const[w,E]of a){if(E===null)continue;let k,N,M;if("source"in E){const q=P?.get(E.source);if(!q)continue;k=q.paths,N=E.args||q.args,E.icon?M=p(E.icon):q.icon&&(M=q.icon)}else k=Array.isArray(E.path)?E.path:[E.path],N=A.isWindows||Array.isArray(E.args)?E.args:void 0,M=p(E.icon);let $;if(s){const q=k.map(Q=>typeof Q=="string"?Q:Q.path),G=await s(q);$=new Array(k.length);for(let Q=0;Q<k.length;Q++)typeof k[Q]=="string"?$[Q]=G[Q]:$[Q]={path:G[Q],isUnsafe:!0}}else $=k.slice();let T;if(E.requiresPath){let q;if((0,L.isString)(E.requiresPath)?q=E.requiresPath:(q=E.requiresPath.path,E.requiresPath.isUnsafe&&(T=q)),!await n.existsFile(q))continue}const B=await t(w,i,$,n,r,N,E.env,E.overrideName,E.isAutoDetected,T);B?(B.isAutoDetected=E.isAutoDetected,B.icon=M,B.color=E.color,c.push(B)):o?.debug("Terminal profile not validated",w,k)}return o?.debug("Validated terminal profiles",c),c}function p(a){return typeof a=="string"?{id:a}:a}async function h(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await u(),icon:O.Codicon.terminalPowershell}))}async function u(){const a=[];for await(const i of(0,I.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function d(a,i){const n=[],r=await new Promise((c,w)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,k)=>{if(E)return w("Problem occurred when getting wsl distros");c(k)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),s=r.split(o).filter(c=>c.trim().length>0&&c!=="");for(const c of s){if(c===""||c.startsWith("docker-desktop"))continue;const w=`${c} (WSL)`,E={profileName:w,path:a,args:["-d",`${c}`],isDefault:w===i,icon:y(c),isAutoDetected:!1};n.push(E)}return n}function y(a){return a.includes("Ubuntu")?O.Codicon.terminalUbuntu:a.includes("Debian")?O.Codicon.terminalDebian:O.Codicon.terminalLinux}async function b(a,i,n,r,o,s,c,w){const E=new Map;if(n){const k=(await a.readFile("/etc/shells")).toString(),N=s||k.split(`
`).filter($=>$.trim().includes("#")&&$.trim().length>0),M=new Map;for(const $ of N){let T=(0,l.basename)($),B=M.get(T)||0;B++,B>1&&(T=`${T} (${B})`),M.set(T,B),E.set(T,{path:$,isAutoDetected:!0})}}return C(r,E),await f(E.entries(),o,a,w,i,c)}function C(a,i){if(!!a)for(const[n,r]of Object.entries(a))r===null||typeof r!="object"||!("path"in r)&&!("source"in r)?i.delete(n):(r.icon=r.icon||i.get(n)?.icon,i.set(n,r))}async function t(a,i,n,r,o,s,c,w,E,k){if(n.length===0)return Promise.resolve(void 0);const N=n.shift();if(N==="")return t(a,i,n,r,o,s,c,w,E);const M=typeof N!="string"&&N.isUnsafe,$=typeof N=="string"?N:N.path,T={profileName:a,path:$,args:s,env:c,overrideName:w,isAutoDetected:E,isDefault:a===i,isUnsafePath:M,requiresUnsafePath:k};if((0,l.basename)($)===$){const q=o.PATH?o.PATH.split(l.delimiter):void 0,G=await(0,S.findExecutable)($,void 0,q,void 0,r.existsFile);return G?(T.path=G,T.isFromPath=!0,T):t(a,i,n,r,o,s)}return await r.existsFile((0,l.normalize)($))?T:t(a,i,n,r,o,s,c,w,E)}}),define(ne[255],se([0,1,3,2,21,4,39,68,16,15,95,235,11,249,115,251,254,104]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(C){C[C.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let y=0,b=class extends O.Disposable{constructor(t,a,i,n,r,o){super(),this.C=t,this.D=a,this.F=i,this.G=n,this.H=r,this.I=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new D.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new D.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new D.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new D.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new D.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new D.Emitter),this.onProcessData=this.s.event,this.t=this.B(new D.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new D.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new D.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new D.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new D.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new D.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,O.toDisposable)(()=>this.O())),this.f=this.B(new g.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(A.isWindows)return process.env;try{return await(0,v.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:y,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},a=(0,P.parsePtyHostPort)(this.G.args,this.G.isBuilt);a&&(a.break&&a.port?t.debugBrk=a.port:!a.break&&a.port&&(t.debug=a.port));const i=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),L.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(i.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=d.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this.B(new u.RemoteLoggerChannelClient(this.I,i.getChannel(f.TerminalIpcChannels.Logger)));const r=L.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(o=>this.s.fire(o))),this.B(r.onProcessReady(o=>this.t.fire(o))),this.B(r.onProcessExit(o=>this.z.fire(o))),this.B(r.onDidChangeProperty(o=>this.y.fire(o))),this.B(r.onProcessReplay(o=>this.u.fire(o))),this.B(r.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(r.onDidRequestDetach(o=>this.w.fire(o))),[i,r]}dispose(){this.i=!0,super.dispose()}async createProcess(t,a,i,n,r,o,s,c,w,E,k){const N=setTimeout(()=>this.S(),f.HeartbeatConstants.CreateProcessTimeout),M=await this.b.createProcess(t,a,i,n,r,o,s,c,w,E,k);return clearTimeout(N),y=Math.max(y,M),M}updateTitle(t,a,i){return this.b.updateTitle(t,a,i)}updateIcon(t,a,i,n){return this.b.updateIcon(t,a,i,n)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,a){return this.b.detachFromProcess(t,a)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,a){return this.b.shutdown(t,a)}input(t,a){return this.b.input(t,a)}processBinary(t,a){return this.b.processBinary(t,a)}resize(t,a,i){return this.b.resize(t,a,i)}acknowledgeDataEvent(t,a){return this.b.acknowledgeDataEvent(t,a)}setUnicodeVersion(t,a){return this.b.setUnicodeVersion(t,a)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,a){return this.b.installAutoReply(t,a)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,a,i,n=!1){const r=await this.c;return(0,h.detectAvailableProfiles)(a,i,n,this.F,r,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,a){return this.b.getWslPath(t,a)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,a){return this.b.requestDetachInstance(t,a)}async acceptDetachInstanceReply(t,a){return this.b.acceptDetachInstanceReply(t,a)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,a){return this.b.reviveTerminalProcesses(t,a)}async refreshProperty(t,a){return this.b.refreshProperty(t,a)}async updateProperty(t,a,i){return this.b.updateProperty(t,a,i)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,a){return this.f.createRequest({workspaceId:t,originalText:a})}async acceptPtyHostResolvedVariables(t,a){this.f.acceptReply(t,a)}};b=ye([Y(2,I.IConfigurationService),Y(3,S.IEnvironmentService),Y(4,m.ILogService),Y(5,m.ILoggerService)],b),e.PtyHostService=b}),define(ne[77],se([0,1,3,16,5,11]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var L;(function(p){p.Http="http",p.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=v;function m(p,h,u,d){if(u===1)return!1;if(u===2&&v(h)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(y?.length===4&&parseInt(y[1])>=18)return!1}return p<1024}e.isPortPrivileged=m;class g{constructor(h,u,d){this.remoteAddress=h,this.localAddress=u,this.b=d,this.a=new D.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let f=class{constructor(h,u){this.i=h,this.j=u,this.a=new D.Emitter,this.onTunnelOpened=this.a.event,this.b=new D.Emitter,this.onTunnelClosed=this.b.event,this.c=new D.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],u=Array.from(this.d.values());for(const d of u){const y=Array.from(d.values());for(const b of y){const C=await b.value;C&&h.push(C)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:u}of h.values())await u.then(d=>d?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,u,d,y,b){this.o(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:d,privacy:y,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(v(h)||P(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const d=this.q(h,u);if(d)return++d.refcount,d.value}openTunnel(h,u,d,y,b,C=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${d} on local port ${b}.`),!h)return;if(u||(u="localhost"),y||(y=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(h,u,d,y,b,C,t,a);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this.d.get(h.tunnelRemoteHost);if(u){const d=u.get(h.tunnelRemotePort);d&&(d.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,d))}}}}async n(h,u,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const y=d.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(u),y}}async closeTunnel(h,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const d=this.d.get(h);if(d&&d.has(u)){const y=d.get(u);y.refcount=0,await this.n(h,u,y)}}o(h,u,d){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(u,{refcount:1,value:d})}async p(h,u){const d=this.d.get(h);d&&(await d.get(u)||d.delete(u),d.size===0&&this.d.delete(h))}q(h,u){const d=[h];P(h)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):v(h)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const y=d.map(b=>this.d.get(b));for(const b of y){const C=b?.get(u);if(C)return C}}canTunnel(h){return!!S(h)}s(h,u,d,y,b,C,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${d} on local port ${y}.`);const a=d;this.h.add(a);const i=y===void 0?d:y,n={elevationRequired:b?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:d},localAddressPort:y,privacy:C,public:C?C!==R.Private:void 0,protocol:t},o=h.forwardPort(r,n);return o?(this.o(u,d,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),o}};f=ye([Y(0,A.ILogService),Y(1,O.IConfigurationService)],f),e.AbstractTunnelService=f}),define(ne[256],se([0,1,11,77,2,8,6]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let I=class Dt extends l.Disposable{constructor(P,v){super(),this.f=P,this.g=v,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(P,v,m,g,f,p,h){const u=new R,d=await Promise.resolve(this.f.openTunnel(P,u,m,g,f,p,h));if(!d)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${g} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(v))throw this.c.delete(v),u.dispose(),await d.dispose(),(0,A.canceled)();return u.setTunnel(d),this.b.set(v,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${v}: ${d.localAddress} (local) to ${m}:${g} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(P,v){const m=this.b.get(P);!m||m.setAddress(v)}async destroyTunnel(P){const v=this.b.get(P);if(v){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await v.dispose();return}this.c.add(P)}};I.a=0,I=ye([Y(0,O.ISharedTunnelsService),Y(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(ne[257],se([0,1,86,34,135,227,6,2,16,11,25,225,77,109,4]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(b,C,t,a,i){let n;for(let r=3;r&&(n?.dispose(),n=await new h(b,C,t,a,i).waitForReady(),!(i&&l.BROWSER_RESTRICTED_PORTS[i]||!l.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class h extends R.Disposable{constructor(C,t,a,i,n){super(),this.j=t,this.k=n,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=D.createServer(),this.c=new L.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,l.findFreePortFaster)(C,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(C){C.pause();const t=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&C.write(n.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),i.end()})}}let u=class extends m.AbstractTunnelService{constructor(C,t,a,i,n){super(t,n),this.t=C,this.u=a,this.v=i}isPortPrivileged(C){return(0,m.isPortPrivileged)(C,this.k,f.OS,O.release())}r(C,t,a,i,n,r,o,s){const c=this.q(t,a);if(c)return++c.refcount,c.value;if(this.e)return this.s(this.e,t,a,n,r,o,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const w={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:C,signService:this.u,logService:this.i,ipcLogger:null},E=p(w,i,t,a,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,E),E}}};u=ye([Y(1,S.ILogService),Y(2,g.ISignService),Y(3,P.IProductService),Y(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let d=class extends u{constructor(C,t,a,i){super(A.nodeSocketFactory,C,t,a,i)}};d=ye([Y(0,S.ILogService),Y(1,g.ISignService),Y(2,P.IProductService),Y(3,I.IConfigurationService)],d),e.TunnelService=d;let y=class extends R.Disposable{constructor(C,t,a,i){super(),this.b=C,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(C,t,a,i,n,r,o,s,c){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${r}.`),!this.a.has(C)){const w=new d(this.b,this.f,this.c,this.g);this.B(w),this.a.set(C,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,a,i,n,r,o,s,c)}};y=ye([Y(0,S.ILogService),Y(1,P.IProductService),Y(2,g.ISignService),Y(3,I.IConfigurationService)],y),e.SharedTunnelsService=y}),define(ne[30],se([0,1,5]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[258],se([0,1,30,71,14,22,131,3,2]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(m){this.uri=m,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let P=class{constructor(m){this.g=m,this.c=new I.DisposableStore,this.f=2**16;const g=new Map,f=p=>{let h=g.get(p.scheme);return h===void 0&&(h=m.hasProvider(p)&&!this.g.hasCapability(p,1024),g.set(p.scheme,h)),h};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{g.delete(p.scheme)})),this.extUri=new A.ExtUri(f),this.d=new L.SkipList((p,h)=>this.extUri.compare(p,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.normalizePath)(m));const g=this.d.get(m);return g?g.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new S(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((f,p)=>f[1].touch<p[1].touch?1:f[1].touch>p[1].touch?-1:0);S._clock=0,this.d.clear();const g=this.f*.5;for(let f=0;f<g;f++)this.d.set(m[f][0],m[f][1].touch())}};P=ye([Y(0,l.IFileService)],P),e.UriIdentityService=P,(0,O.registerSingleton)(D.IUriIdentityService,P,1)}),define(ne[259],se([0,1,3,2,14,43,49,17]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends O.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,v,m,g){super(),this.c=P,this.f=v,this.g=m,this.h=g,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(f=>this.i(f)))}watch(P,v){this.b.set(P,P);const m=this.f.watch(this.j(P),v);return(0,O.toDisposable)(()=>{this.b.delete(P),m.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,v,m){return this.f.rename(this.j(P),this.j(v),m)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,v,m){const g=(0,A.newWriteableStream)(f=>R.VSBuffer.concat(f.map(p=>R.VSBuffer.wrap(p))).buffer);return(async()=>{try{const f=await this.readFile(P);g.end(f)}catch(f){g.error(f),g.end()}})(),g}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,v,m){return this.f.writeFile(this.j(P),v,m)}delete(P,v){return this.f.delete(this.j(P),v)}copy(P,v,m){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(v),m);throw new Error("copy not supported")}i(P){const v=[];for(const m of P){if(m.resource.scheme!==this.c)continue;const g=this.k(m.resource);this.b.findSubstr(g)&&v.push({resource:g,type:m.type})}v.length&&(this.h.debug("User data changed"),this.a.fire(v))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(ne[61],se([0,1,83]),function(Z,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(L,R,I,S){const P=(0,D.setProperty)(L,R,I,S)[0];return P&&(L=L.substring(0,P.offset)+P.content+L.substring(P.offset+P.length)),L}e.edit=O;function l(L,R,I){let S=I;for(;S>=0;){if(L.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&L.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=l;function A(L,R,I){let S=I;for(;S>=0;)if(L.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&L.charAt(S)===R.charAt(1)))return S;return L.length-1}e.getLineEndOffset=A}),define(ne[260],se([0,1,32,54,12]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(g,f,p,h,u,d){const y=[],b=[],C=[];if(!f){const B=g.filter(({identifier:q})=>u.every(G=>G.toLowerCase()!==q.id.toLowerCase()));return{local:{added:y,removed:b,updated:C},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}g=g.map(v),f=f.map(v),p=p?p.map(v):null;const t=new Map,a=B=>{B.uuid&&t.set(B.id.toLowerCase(),B.uuid)};g.forEach(({identifier:B})=>a(B)),f.forEach(({identifier:B})=>a(B)),p?.forEach(({identifier:B})=>a(B));const i=B=>{const q=B.identifier.uuid||t.get(B.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${B.identifier.id.toLowerCase()}`},n=(B,q)=>(B.set(i(q),q),B),r=g.reduce(n,new Map),o=f.reduce(n,new Map),s=f.reduce((B,q)=>n(B,(0,D.deepClone)(q)),new Map),c=p?p.reduce(n,new Map):null,w=h.reduce(n,new Map),E=u.reduce((B,q)=>{const G=t.get(q.toLowerCase());return B.add(G?`uuid:${G}`:`id:${q.toLowerCase()}`)},new Set),k=d?d.reduce((B,{id:q,uuid:G})=>(G=G??t.get(q.toLowerCase()),B.add(G?`uuid:${G}`:`id:${q.toLowerCase()}`)),new Set):null,N=L(r,o,E,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const B=L(c,r,E,!1),q=L(c,o,E,!0),G=(Q,re,K,W)=>{let F,J,ee;return re.installed?(F=W.pinned,ee=W.preRelease,F&&(J=W.version)):(F=K.pinned,ee=K.preRelease,F&&(J=K.version)),F===void 0&&(F=re.pinned,F&&(J=re.version)),ee===void 0&&(ee=re.preRelease),{...W,installed:re.installed||K.installed,pinned:F,preRelease:ee,version:J??(K.version&&(!re.installed||O.gt(K.version,re.version))?K.version:re.version),state:I(re,K,c?.get(Q))}};for(const Q of q.removed.values()){const re=r.get(Q);if(!re)continue;const K=(0,l.assertIsDefined)(c?.get(Q)),W=k&&!k.has(Q)&&K.installed;re.installed&&W?b.push(re.identifier):s.set(Q,re)}for(const Q of q.added.values()){const re=(0,l.assertIsDefined)(o.get(Q)),K=r.get(Q);if(K){if(N.updated.has(Q)){const W=G(Q,K,re,re);R(K,re,!1,!1)||C.push(m(W,Q)),s.set(Q,W)}}else re.installed&&y.push(m(re,Q))}for(const Q of q.updated.values()){const re=(0,l.assertIsDefined)(o.get(Q)),K=(0,l.assertIsDefined)(c?.get(Q)),W=r.get(Q);if(W)if(k&&!k.has(Q)&&K.installed&&W.installed&&!re.installed)b.push(W.identifier);else{const J=G(Q,W,re,re);C.push(m(J,Q)),s.set(Q,J)}else re.installed&&y.push(m(re,Q))}for(const Q of B.added.values())q.added.has(Q)||s.set(Q,(0,l.assertIsDefined)(r.get(Q)));for(const Q of B.updated.values()){if(q.removed.has(Q)||q.updated.has(Q))continue;const re=(0,l.assertIsDefined)(r.get(Q)),K=(0,l.assertIsDefined)(o.get(Q));s.set(Q,G(Q,re,K,re))}for(const Q of B.removed.values())q.updated.has(Q)||q.removed.has(Q)||w.has(Q)||!(0,l.assertIsDefined)(o.get(Q)).installed||!k||k.has(Q)||!(0,l.assertIsDefined)(c?.get(Q)).installed||s.delete(Q)}const M=[],$=L(o,s,new Set,!0),T=$.added.size>0||$.updated.size>0||$.removed.size>0;return T&&s.forEach((B,q)=>M.push(m(B,q))),{local:{added:y,removed:b,updated:C},remote:T?{added:[...$.added].map(B=>s.get(B)),updated:[...$.updated].map(B=>s.get(B)),removed:[...$.removed].map(B=>o.get(B)),all:M}:null}}e.merge=A;function L(g,f,p,h){const u=g?[...g.keys()].filter(t=>!p.has(t)):[],d=[...f.keys()].filter(t=>!p.has(t)),y=d.filter(t=>u.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),b=u.filter(t=>d.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),C=new Set;for(const t of u){if(b.has(t))continue;const a=g.get(t),i=f.get(t);(!i||!R(a,i,h,!0))&&C.add(t)}return{added:y,removed:b,updated:C}}function R(g,f,p,h){return!(g.disabled!==f.disabled||h&&g.installed!==f.installed||g.installed&&f.installed&&(g.preRelease!==f.preRelease||g.pinned!==f.pinned||f.pinned&&g.version!==f.version)||!P(g.state,f.state)||p&&g.version!==f.version)}function I(g,f,p){const h=g.state,u=f.state,d=p?.state;if(!f.version||h&&O.gt(g.version,f.version))return h;if(u&&O.gt(f.version,g.version)||!h)return u;if(!u)return h;const y=(0,D.deepClone)(h),b=d?S(d,u):{added:Object.keys(u).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},C=d?S(d,h):{added:Object.keys(h).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])y[t]=u[t];for(const t of b.removed.values())C.updated.has(t)||delete y[t];return y}function S(g,f){const p=Object.keys(g),h=Object.keys(f),u=h.filter(b=>p.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),d=p.filter(b=>h.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),y=new Set;for(const b of p){if(d.has(b))continue;const C=g[b],t=f[b];(0,D.equals)(C,t)||y.add(b)}return{added:u,removed:d,updated:y}}function P(g={},f={}){const{added:p,removed:h,updated:u}=S(g,f);return p.size===0&&h.size===0&&u.size===0}function v(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function m(g,f){const p={identifier:{id:g.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},version:g.version,preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled&&(p.disabled=!0),g.installed&&(p.installed=!0),g.state&&(p.state=g.state),p}}),define(ne[116],se([0,1,20,16,5]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==R&&P!==`-${R}`),I&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return S=S.filter(P=>P!==R&&P!==`-${R}`),I&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const I=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.b().map(m=>m.toLowerCase()),P=[],v=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?v.push(m.substring(1)):P.push(m);return(0,D.distinct)([...I,...P].filter(m=>v.indexOf(m)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};A=ye([Y(0,O.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(ne[261],se([0,1,20,35,32,199,61]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(b){return(0,O.parse)(b)||[]}async function I(b,C,t,a,i){const n=R(b),r=R(C),o=t?R(t):null,s=[...n,...r,...o||[]].map(G=>G.key),c=await i.resolveUserBindings(s),w=P(n,r,o,c);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const E=m(n),k=m(r),N=o?m(o):null,M=f(E,k,c),$=N?f(N,E,c):{added:[...E.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},T=N?f(N,k,c):{added:[...k.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},B=S(M,$,T);let q=b;for(const G of B.removed.values())B.conflicts.has(G)||(q=d(q,G,a));for(const G of B.added.values()){if(B.conflicts.has(G))continue;const Q=k.get(G);if(Q.some(re=>re.command!==`-${G}`&&w.conflicts.has(c[re.key]))){B.conflicts.add(G);continue}q=u(q,Q,a)}for(const G of B.updated.values()){if(B.conflicts.has(G))continue;const Q=k.get(G);if(Q.some(re=>re.command!==`-${G}`&&w.conflicts.has(c[re.key]))){B.conflicts.add(G);continue}q=y(q,G,Q,a)}return{mergeContent:q,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=I;function S(b,C,t){const a=new Set,i=new Set,n=new Set,r=new Set;for(const o of C.removed.values())t.updated.has(o)&&r.add(o);for(const o of t.removed.values())r.has(o)||(C.updated.has(o)?r.add(o):i.add(o));for(const o of C.added.values())r.has(o)||t.added.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.added.values())r.has(o)||(C.added.has(o)?b.updated.has(o)&&r.add(o):a.add(o));for(const o of C.updated.values())r.has(o)||t.updated.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.updated.values())r.has(o)||(C.updated.has(o)?b.updated.has(o)&&r.add(o):n.add(o));return{added:a,removed:i,updated:n,conflicts:r}}function P(b,C,t,a){const i=new Set,n=v(b,a),r=v(C,a),o=t?v(t,a):null,s=g(n,r);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const c=o?g(o,n):{added:[...n.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=o?g(o,r):{added:[...r.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:E,removed:k,updated:N,conflicts:M}=S(s,c,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:k,updated:N,conflicts:M}}function v(b,C){const t=new Map;for(const a of b){const i=C[a.key];let n=t.get(i);n||(n=[],t.set(i,n)),n.push(a)}return t}function m(b){const C=new Map;for(const t of b){const a=t.command[0]==="-"?t.command.substring(1):t.command;let i=C.get(a);i||(i=[],C.set(a,i)),i.push(t)}return C}function g(b,C){const t=[...b.keys()],a=[...C.keys()],i=a.filter(o=>t.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),n=t.filter(o=>a.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),r=new Set;for(const o of t){if(n.has(o))continue;const s=b.get(o).map(w=>({...w,key:o})),c=C.get(o).map(w=>({...w,key:o}));(0,D.equals)(s,c,(w,E)=>h(w,E))||r.add(o)}return{added:i,removed:n,updated:r}}function f(b,C,t){const a=[...b.keys()],i=[...C.keys()],n=i.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),r=a.filter(s=>i.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of a){if(r.has(s))continue;const c=b.get(s).map(E=>({...E,key:t[E.key]})),w=C.get(s).map(E=>({...E,key:t[E.key]}));p(c,w)||o.add(s)}return{added:n,removed:r,updated:o}}function p(b,C){return!(!(0,D.equals)(b.filter(({command:t})=>t[0]!=="-"),C.filter(({command:t})=>t[0]!=="-"),(t,a)=>h(t,a))||!(0,D.equals)(b.filter(({command:t})=>t[0]==="-"),C.filter(({command:t})=>t[0]==="-"),(t,a)=>h(t,a)))}function h(b,C){if(b.command!==C.command||b.key!==C.key)return!1;const t=A.ContextKeyExpr.deserialize(b.when),a=A.ContextKeyExpr.deserialize(C.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!l.equals(b.args,C.args))}function u(b,C,t){for(const a of C)b=L.edit(b,[-1],a,t);return b}function d(b,C,t){const a=R(b);for(let i=a.length-1;i>=0;i--)(a[i].command===C||a[i].command===`-${C}`)&&(b=L.edit(b,[i],void 0,t));return b}function y(b,C,t,a){const i=R(b),n=i.findIndex(r=>r.command===C||r.command===`-${C}`);for(let r=i.length-1;r>=0;r--)(i[r].command===C||i[r].command===`-${C}`)&&(b=L.edit(b,[r],void 0,a));for(let r=t.length-1;r>=0;r--)b=L.edit(b,[n],t[r],a);return b}}),define(ne[262],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,L,R){const I={},S={},P=new Set;if(!L)return{local:{added:I,updated:S,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const v=O(A,L);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:I,updated:S,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=O(R,A),g=O(R,L),f={},p={},h=new Set,u=new Set;for(const d of m.removed.values())g.updated.has(d)?I[d]=L[d]:h.add(d);for(const d of g.removed.values())u.has(d)||(m.updated.has(d)?u.add(d):P.add(d));for(const d of m.updated.values())u.has(d)||(g.updated.has(d)?v.updated.has(d)&&u.add(d):p[d]=A[d]);for(const d of g.updated.values())u.has(d)||(m.updated.has(d)?v.updated.has(d)&&u.add(d):A[d]!==void 0&&(S[d]=L[d]));for(const d of m.added.values())u.has(d)||(g.added.has(d)?v.updated.has(d)&&u.add(d):f[d]=A[d]);for(const d of g.added.values())u.has(d)||(m.added.has(d)?v.updated.has(d)&&u.add(d):I[d]=L[d]);return{local:{added:I,removed:[...P.values()],updated:S},remote:{added:f,removed:[...h.values()],updated:p},conflicts:[...u.values()]}}e.merge=D;function O(A,L){const R=A?Object.keys(A):[],I=L?Object.keys(L):[],S=I.filter(m=>R.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),P=R.filter(m=>I.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),v=new Set;for(const m of R){if(P.has(m))continue;const g=A[m],f=L[m];g!==f&&v.add(m)}return{added:S,removed:P,updated:v}}function l(A,L){const{added:R,removed:I,updated:S}=O(A,L);return R.size===0&&I.size===0&&S.size===0}e.areSame=l}),define(ne[263],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(l,A,L,R){const I={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const v=l.filter(({id:m})=>!R.includes(m));return v.length?S.added=v:S=null,{local:I,remote:S}}const P=O(l,A,R);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const v=O(L,l,R),m=O(L,A,R);for(const g of m.removed){const f=l.find(p=>p.id===g);f&&I.removed.push(f)}for(const g of m.added){const f=A.find(p=>p.id===g);v.added.includes(g)?P.updated.includes(g)&&I.updated.push(f):I.added.push(f)}for(const g of m.updated)I.updated.push(A.find(f=>f.id===g));for(const g of v.added)m.added.includes(g)||S.added.push(l.find(f=>f.id===g));for(const g of v.updated)m.removed.includes(g)||m.updated.includes(g)||S.updated.push(l.find(f=>f.id===g));for(const g of v.removed){const f=A.find(p=>p.id===g);f&&S.removed.push(f)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:I,remote:S}}e.merge=D;function O(l,A,L){l=l?l.filter(({id:m})=>!L.includes(m)):[],A=A.filter(({id:m})=>!L.includes(m));const R=l.map(({id:m})=>m),I=A.map(({id:m})=>m),S=I.filter(m=>R.indexOf(m)===-1),P=R.filter(m=>I.indexOf(m)===-1),v=[];for(const{id:m,name:g,shortName:f}of l){if(P.includes(m))continue;const p=A.find(h=>h.id===m);(!p||p.name!==g||p.shortName!==f)&&v.push(m)}return{added:S,removed:P,updated:v}}}),define(ne[23],se([0,1,20,12,184,45,29,5,106,40]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(o=>!!r[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function v(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(r).filter(w=>!!r[w].ignoreSync),s=Object.keys(r).filter(w=>r[w].scope===2||r[w].scope===6),c=P();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...s,...c])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const r="vscode://schemas/ignoredSettings",o=S.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const s=S.Registry.as(I.Extensions.JSONContribution),c=()=>{const w=P(),E=v().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),k=Object.keys(A.allSettings.properties).filter($=>E.indexOf($)===-1),N=E.filter($=>w.indexOf($)===-1),M={items:{type:"string",enum:[...k,...N.map($=>`-${$}`)]}};s.registerSchema(r,M)};return o.onDidUpdateConfiguration(()=>c())}e.registerConfiguration=m;function g(r){return r&&(0,O.isObject)(r)&&(0,O.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=g;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(r,...o){return r?[r,...o]:o}e.getPathSegments=p;function h(r,o,s,c){return c.joinPath(s.userDataSyncHome,...p(r,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=h,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const o={};return o[e.HEADER_EXECUTION_ID]=r,o}e.createSyncHeaders=u;var d;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(o,s,c,w){super(o),this.code=s,this.resource=c,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class b extends y{constructor(o,s,c,w,E){super(o,c,void 0,E),this.url=s,this.serverCode=w}}e.UserDataSyncStoreError=b;class C extends y{constructor(o,s){super(o,s)}}e.UserDataAutoSyncError=C,function(r){function o(s){if(s instanceof r)return s;const c=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(s.name);if(c&&c[1]){const w=c[2]==="unknown"?void 0:c[2],E=c[3]==="unknown"?void 0:c[3];return new r(s.message,c[1],w,E)}return new r(s.message,"Unknown")}r.toUserDataSyncError=o}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var a;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[264],se([0,1,32,23]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(L,R,I,S,P){if(!R)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const v=A(L,R);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=I?A(I,R):{added:Object.keys(R).reduce((d,y)=>(d.add(y),d),new Set),removed:new Set,updated:new Set},g=I?A(I,L):{added:Object.keys(L).reduce((d,y)=>(d.add(y),d),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},p=D.deepClone(R),h=!I;for(const d of g.added.values())d!==O.SYNC_SERVICE_URL_TYPE&&h&&m.added.has(d)||(p[d]=L[d]);for(const d of g.updated.values())p[d]=L[d];for(const d of g.removed.values())S.unregistered.includes(d)||delete p[d];for(const d of m.added.values()){const y=R[d];if(S.machine.includes(d)){P.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&g.added.has(d))continue;const b=L[d];b&&b.value===y.value||d===O.SYNC_SERVICE_URL_TYPE&&h&&g.added.has(d)||(b?f.updated[d]=y:f.added[d]=y)}for(const d of m.updated.values()){const y=R[d];if(S.machine.includes(d)){P.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(d)||g.removed.has(d))continue;const b=L[d];b&&b.value===y.value||(f.updated[d]=y)}for(const d of m.removed.values()){if(S.machine.includes(d)){P.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}g.updated.has(d)||g.removed.has(d)||f.removed.push(d)}const u=A(R,p);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}e.merge=l;function A(L,R){const I=Object.keys(L),S=Object.keys(R),P=S.filter(g=>I.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),v=I.filter(g=>S.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),m=new Set;for(const g of I){if(v.has(g))continue;const f=L[g],p=R[g];D.equals(f,p)||m.add(g)}return{added:P,removed:v,updated:m}}}),define(ne[265],se([0,1,20,35,83,42,32,61,23]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(s,c,w){let E=[];w?E=v(w):E=P(c);const k=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const M of E)M.startsWith("-")?N.push(M.substring(1)):k.push(M);return(0,D.distinct)([...s,...k].filter(M=>N.indexOf(M)===-1))}e.getIgnoredSettings=S;function P(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function v(s){const c=(0,O.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function m(s,c){const w=(0,O.parse)(s)||{};let E="{}";for(const k of Object.keys(w)){const N=(0,l.setProperty)(E,[k],w[k],c);E=(0,l.applyEdits)(E,N)}return E}e.removeComments=m;function g(s,c,w,E){if(w.length){const k=o(c),N=(0,O.parse)(c)||{},M=(0,O.parse)(s);if(!M)return s;const $=[];for(const T of w){const B=N[T],q=M[T];B===void 0?s=R.edit(s,[T],void 0,E):q!==void 0?s=R.edit(s,[T],B,E):$.push(t(T,k))}$.sort((T,B)=>T.startOffset-B.startOffset),$.forEach(T=>s=d(T.setting.key,c,s,E))}return s}e.updateIgnoredSettings=g;function f(s,c,w,E,k,N){const M=g(s,c,E,N),$=w!==M,T=w!==c;if(!$&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!T)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(T&&!$)return{conflictsSettings:[],localContent:g(c,s,E,N),remoteContent:null,hasConflicts:!1};if(w===null&&h(s)){const z=p(s,c,E)?null:g(c,s,E,N);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let B=s,q=c;const G=(0,O.parse)(s),Q=(0,O.parse)(c),re=w?(0,O.parse)(w):null,K=E.reduce((z,x)=>(z.add(x),z),new Set),W=u(G,Q,K),F=u(re,G,K),J=u(re,Q,K),ee=new Map,oe=new Set,ce=z=>{oe.add(z);const x=k.filter(({key:_})=>_===z)[0];x?(B=R.edit(B,[z],x.value,N),q=R.edit(q,[z],x.value,N)):ee.set(z,{key:z,localValue:G[z],remoteValue:Q[z]})};for(const z of F.removed.values())J.updated.has(z)?ce(z):q=R.edit(q,[z],void 0,N);for(const z of J.removed.values())oe.has(z)||(F.updated.has(z)?ce(z):B=R.edit(B,[z],void 0,N));for(const z of F.updated.values())oe.has(z)||(J.updated.has(z)?W.updated.has(z)&&ce(z):q=R.edit(q,[z],G[z],N));for(const z of J.updated.values())oe.has(z)||(F.updated.has(z)?W.updated.has(z)&&ce(z):B=R.edit(B,[z],Q[z],N));for(const z of F.added.values())oe.has(z)||(J.added.has(z)?W.updated.has(z)&&ce(z):q=d(z,B,q,N));for(const z of J.added.values())oe.has(z)||(F.added.has(z)?W.updated.has(z)&&ce(z):B=d(z,q,B,N));const V=ee.size>0||!p(B,q,E),j=V||!p(B,s,[]),U=V||!p(q,c,[]);return{localContent:j?B:null,remoteContent:U?q:null,conflictsSettings:[...ee.values()],hasConflicts:V}}e.merge=f;function p(s,c,w){if(s===c)return!0;const E=(0,O.parse)(s),k=(0,O.parse)(c),N=w.reduce((T,B)=>(T.add(B),T),new Set),M=o(s).filter(T=>!(T.setting&&N.has(T.setting.key))),$=o(c).filter(T=>!(T.setting&&N.has(T.setting.key)));if(M.length!==$.length)return!1;for(let T=0;T<M.length;T++){const B=M[T],q=$[T];if(B.setting&&q.setting){if(B.setting.key!==q.setting.key||!L.equals(E[B.setting.key],k[B.setting.key]))return!1}else if(!B.setting&&!q.setting){if(B.value!==q.value)return!1}else return!1}return!0}function h(s){return s?o(s).length===0:!0}e.isEmpty=h;function u(s,c,w){const E=s?Object.keys(s).filter(T=>!w.has(T)):[],k=Object.keys(c).filter(T=>!w.has(T)),N=k.filter(T=>E.indexOf(T)===-1).reduce((T,B)=>(T.add(B),T),new Set),M=E.filter(T=>k.indexOf(T)===-1).reduce((T,B)=>(T.add(B),T),new Set),$=new Set;if(s)for(const T of E){if(M.has(T))continue;const B=s[T],q=c[T];L.equals(B,q)||$.add(T)}return{added:N,removed:M,updated:$}}function d(s,c,w,E){const k=(0,O.parse)(c),N=o(c),M=o(w),$=y(s,N,M);return b(w,s,k[s],$,M,E)}e.addSetting=d;function y(s,c,w){const E=c.findIndex(N=>N.setting?.key===s),k=c[E-1];if(k){if(k.setting){const M=t(k.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=a(E,c);if(M){const $=t(M.setting.key,w);if($){const T=i(w.indexOf($),w),B=n(c,M,c[E]);if(T){const q=n(w,$,T),G=r(B,q);return G?{index:w.indexOf(G),insertAfter:!0}:{index:w.indexOf(T),insertAfter:!1}}else{const q=n(w,$,w[w.length-1]),G=r(B,q);return G?{index:w.indexOf(G),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const N=c[E+1];if(N)if(N.setting){const M=t(N.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=i(E,c);if(M){const $=t(M.setting.key,w);if($){const T=a(w.indexOf($),w),B=n(c,c[E],M);if(T){const q=n(w,T,$),G=r(B.reverse(),q.reverse());return G?{index:w.indexOf(G),insertAfter:!1}:{index:w.indexOf(T),insertAfter:!0}}else{const q=n(w,w[0],$),G=r(B.reverse(),q.reverse());return G?{index:w.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function b(s,c,w,E,k,N){let M;return E.index===-1?M=(0,l.setProperty)(s,[c],w,N):M=C(s,c,w,E,k,N).map($=>(0,l.withFormatting)(s,$,N)[0]),(0,l.applyEdits)(s,M)}function C(s,c,w,E,k,N){const M=`${JSON.stringify(c)}: ${JSON.stringify(w)}`,$=(0,A.getEOL)(N,s),T=k[E.index];if(E.insertAfter){const B=[];if(T.setting)B.push({offset:T.endOffset,length:0,content:","+M});else{const q=i(E.index,k),G=a(E.index,k),Q=G?.setting?.commaOffset;G&&Q===void 0&&B.push({offset:G.endOffset,length:0,content:","});const re=Q!==void 0&&Q>T.endOffset;B.push({offset:re?Q+1:T.endOffset,length:0,content:q?$+M+",":$+M})}return B}else{if(T.setting)return[{offset:T.startOffset,length:0,content:M+","}];const B=(k[E.index-1]&&!k[E.index-1].setting?$:"")+M+(i(E.index,k)?",":"")+$;return[{offset:T.startOffset,length:0,content:B}]}}function t(s,c){return c.filter(w=>w.setting?.key===s)[0]}function a(s,c){for(let w=s-1;w>=0;w--)if(c[w].setting)return c[w]}function i(s,c){for(let w=s+1;w<c.length;w++)if(c[w].setting)return c[w]}function n(s,c,w){const E=s.indexOf(c),k=s.indexOf(w);return s.filter((N,M)=>E<M&&M<k)}function r(s,c){if(s.length&&c.length){let w=0;for(;w<c.length&&w<s.length;w++)if(s[w].value!==c[w].value)return c[w-1];return c[w-1]}}function o(s){const c=[];let w=-1,E,k;const N={onObjectBegin:M=>{w++},onObjectProperty:(M,$,T)=>{w===0&&(E=$,k=M)},onObjectEnd:(M,$)=>{w--,w===0&&c.push({startOffset:E,endOffset:M+$,value:s.substring(E,M+$),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(M,$)=>{w++},onArrayEnd:(M,$)=>{w--,w===0&&c.push({startOffset:E,endOffset:M+$,value:s.substring(E,M+$),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(M,$,T)=>{w===0&&c.push({startOffset:E,endOffset:$+T,value:s.substring(E,$+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(M,$,T)=>{if(w===0&&M===","){let B=c.length-1;for(;B>=0&&!c[B].setting;B--);const q=c[B];q&&c.splice(B,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:$}})}},onComment:(M,$)=>{w===0&&c.push({startOffset:M,endOffset:M+$,value:s.substring(M,M+$)})}};return(0,O.visit)(s,N),c}}),define(ne[78],se([0,1,3,2,5,23]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let L=class extends O.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new D.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};L=ye([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(ne[266],se([0,1,2,10]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(m){this.a=m}listen(m,g){switch(g){case"onError":return this.a.onError}throw new Error(`Event not found: ${g}`)}call(m,g,f){switch(g){case"triggerSync":return this.a.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class A{constructor(m){this.a=m}listen(m,g){throw new Error(`Event not found: ${g}`)}call(m,g,f){switch(g){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(O.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class L{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=L;class R{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${g}`)}async call(m,g,f){switch(g){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(f[0],f[1]);case"setEnablements":return this.a.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(m,g,f){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(m,g,f){switch(g){case"switch":return this.a.switch(f[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class P extends D.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:O.URI.revive(m.url),type:m.type,defaultUrl:O.URI.revive(m.defaultUrl),insidersUrl:O.URI.revive(m.insidersUrl),stableUrl:O.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[267],se([0,1,185,15,11,23]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends l.AbstractLogger{constructor(I,S){super(),this.g=this.B(I.createLogger(S.userDataSyncLogResource,{id:A.USER_DATA_SYNC_LOG_ID,name:(0,D.localize)(0,null)}))}trace(I,...S){this.g.trace(I,...S)}debug(I,...S){this.g.debug(I,...S)}info(I,...S){this.g.info(I,...S)}warn(I,...S){this.g.warn(I,...S)}error(I,...S){this.g.error(I,...S)}flush(){this.g.flush()}};L=ye([Y(0,l.ILoggerService),Y(1,O.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[268],se([0,1,6,3,2]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new l.DisposableStore),O.Event.latch(O.Event.any(R,I))(this.f,this,this.a),this.b=(0,D.createCancelablePromise)(()=>S()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(ne[117],se([0,1,188,13,49,22,10,5,21]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(i){const n=i;return typeof n?.id=="string"&&L.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=S;function P(i){return typeof i?.id=="string"&&!S(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=v;function m(i){const n=i;return typeof n?.id=="string"&&L.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function g(i){const n=i;if(n?.uri)return{id:n.id,uri:L.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function h(i){const n=i;return!!(n&&typeof n=="object"&&L.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(n,r,o,s,c){this.h=n,this.j=o,this.k=s,this.l=c,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function y(i){return new d({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(i,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function C(i){let n;return L.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=C;function t(i,n){return!b(i,n)&&!C(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,O.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ne[28],se([0,1,66,3,2,22,10,179,15,14,5,11,117,37,30,6,31,26,12]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&L.URI.isUri(n.location)&&L.URI.isUri(n.globalStorageHome)&&L.URI.isUri(n.settingsResource)&&L.URI.isUri(n.keybindingsResource)&&L.URI.isUri(n.tasksResource)&&L.URI.isUri(n.snippetsHome)&&L.URI.isUri(n.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function b(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:L.URI.revive(i.location).with({scheme:n}),globalStorageHome:L.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:L.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:L.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:L.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:L.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:L.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=b;function C(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:(0,A.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=C;let t=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,s){super(),this.m=n,this.n=r,this.r=o,this.s=s,this.f=!0,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const c of this.I()){if(!c.name||!(0,d.isString)(c.name)||!c.location){this.s.warn("Skipping the invalid stored profile",c.location||c.name);continue}n.push(C((0,A.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags}))}}catch(c){this.s.error(c)}const r=new g.ResourceMap,o=new Map,s=this.v();if(n.unshift({...s,extensionsResource:this.N()??s.extensionsResource,isDefault:!0}),n.length)try{const c=this.L();if(c.workspaces)for(const[w,E]of Object.entries(c.workspaces)){const k=L.URI.parse(w),N=n.find(M=>M.id===E);N&&r.set(k,N)}if(c.emptyWindows)for(const[w,E]of Object.entries(c.emptyWindows)){const k=n.find(N=>N.id===E);k&&o.set(w,k)}}catch(c){this.s.error(c)}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}v(){return C("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const w of this.profiles){const E=o.exec(w.name),k=E?parseInt(E[1]):0;s=k>s?k:s}const c=`${r} ${s+1}`;return this.createProfile((0,D.hash)((0,h.generateUuid)()).toString(16),c,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,D.hash)((0,h.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=await this.w(n,r,o);return s&&await this.setProfileForWorkspace(s,c),c}async w(n,r,o){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(r);return s||(s=(async()=>{try{const c=this.profiles.find(k=>k.name===r||k.id===n);if(c)return c;const w=C(n,r,(0,A.joinPath)(this.profilesHome,n),o);await this.n.createFolder(w.location);const E=[];return this.h.fire({profile:w,join(k){E.push(k)}}),await p.Promises.settled(E),this.C([w],[],[]),w}finally{this.k.delete(r)}})(),this.k.set(r,s)),s}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(s=>s.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=C(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(s){o.push(s)}});try{await Promise.allSettled(o)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(s=>s.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return L.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,o){const s=[...this.profiles,...n],c=[];this.l.profiles=[];for(let w of s)w.isDefault||r.some(E=>w.id===E.id)||(w=o.find(E=>w.id===E.id)??w,w.isTransient?this.l.profiles.push(w):c.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.J(c),this.t=void 0,this.D(n,r,o)}D(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}F(n,r,o){o=r?.isTransient?!0:o,o||this.F(n,void 0,!0);const s=this.y(n),c=o?this.l:this.u;L.URI.isUri(s)?(c.workspaces.delete(s),r&&c.workspaces.set(s,r)):(c.emptyWindows.delete(s),r&&c.emptyWindows.set(s,r)),o||this.G()}G(){const n={};for(const[o,s]of this.u.workspaces.entries())n[o.toString()]=s.id;const r={};for(const[o,s]of this.u.emptyWindows.entries())r[o.toString()]=s.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},o=this.v();if(n.workspaces)for(const[c,w]of Object.entries(n.workspaces)){const E=L.URI.parse(w);r[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}const s={};if(n.emptyWindows)for(const[c,w]of Object.entries(n.emptyWindows)){const E=L.URI.parse(w);s[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}return{workspaces:r,emptyWindows:s}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([Y(0,I.IEnvironmentService),Y(1,S.IFileService),Y(2,f.IUriIdentityService),Y(3,v.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=a}),define(ne[269],se([0,1,6,2,28]),function(Z,e,D,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends O.Disposable{constructor(R){super(),this.B(new D.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=ye([Y(0,l.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(ne[270],se([0,1,20,6,24,8,3,2,4,10,158,29,33,46,11,25,18,28]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let y=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,s,c){super(),this.t=n,this.u=r,this.v=o,this.w=s,this.y=c,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new v.ExtensionManagementError(P.localize(0,null),v.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),C(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const s={...o,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,g.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},c=$=>`${m.ExtensionKey.create($).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!S.URI.isUri(r)){const $=this.j.get(c(r));if($)return this.v.info("Extensions is already requested to install",r.identifier.id),$.task.waitUntilTaskIsFinished()}const w=[],E=[],k=[],N=this.Q(n,r,s);S.URI.isUri(r)||this.j.set(c(r),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:r,profileLocation:s.profileLocation}),this.v.info("Installing extension:",N.identifier.id),w.push({task:N,manifest:n});let M=!1;try{if(s.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const T=await this.F(N.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),B=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:q,manifest:G}of(0,D.distinct)(T,({gallery:Q})=>Q.identifier.id)){M=M||!!G.extensionDependencies?.some(K=>(0,m.areSameExtensions)({id:K},N.identifier));const Q=c(q),re=this.j.get(Q);if(re){if(this.C(N,re.task)){const K=re.task.identifier;this.v.info("Waiting for already requested installing extension",K.id,N.identifier.id),re.waitingTasks.push(N),E.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,W=>W.some(F=>(0,m.areSameExtensions)(F.identifier,K)))).then(W=>{if(this.v.info("Finished waiting for already requested installing extension",K.id,N.identifier.id),!W.find(J=>(0,m.areSameExtensions)(J.identifier,K))?.local)throw new Error(`Extension ${K.id} is not installed`)}))}}else if(!B.some(({identifier:K})=>(0,m.areSameExtensions)(K,q.identifier))){const K=this.Q(G,q,{...s,donotIncludePackAndDependencies:!0});this.j.set(Q,{task:K,waitingTasks:[N]}),this.l.fire({identifier:K.identifier,source:q,profileLocation:s.profileLocation}),this.v.info("Installing extension:",K.identifier.id,N.identifier.id),w.push({task:K,manifest:G})}}}catch(T){if(S.URI.isUri(N.source))(0,D.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,T.message),(0,D.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,T.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),T}const $=w.reduce((T,{task:B,manifest:q})=>(T.set(B.identifier.id.toLowerCase(),{task:B,manifest:q}),T),new Map);for(;$.size;){let T;const B=[...$.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(G=>$.has(G.toLowerCase())));B.length?T=$.size===1?B:B.filter(({task:q})=>!(q===N&&!M)):(this.v.info("Found extensions with circular dependencies",B.map(({task:q})=>q.identifier.id)),T=[...$.values()]),await this.D(T.map(async({task:q})=>{const G=new Date().getTime();try{const Q=await q.run();if(await this.D(this.s.map(re=>re.postInstall(Q,q.source,s,l.CancellationToken.None))),!S.URI.isUri(q.source)){const re=q.operation===3,K=re?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(t(this.u,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:K}),I.isWeb&&q.operation!==3)try{await this.t.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}k.push({local:Q,identifier:q.identifier,operation:q.operation,source:q.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw S.URI.isUri(q.source)||t(this.u,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-G,error:Q}),this.v.error("Error while installing the extension:",q.identifier.id),Q}finally{$.delete(q.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),k.forEach(({identifier:T})=>this.v.info("Extension installed successfully:",T.id)),this.m.fire(k),k.filter(({identifier:T})=>(0,m.areSameExtensions)(T,N.identifier))[0].local}catch($){if(w.forEach(({task:T})=>T.cancel()),k.length)try{const T=await Promise.allSettled(k.map(({local:B})=>this.R(B,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let B=0;B<T.length;B++){const q=T[B],{identifier:G}=k[B];q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",G.id):this.v.warn("Rollback: Error while uninstalling extension",G.id,(0,A.getErrorMessage)(q.reason))}}catch(T){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(T),k.map(({identifier:B})=>B.id))}throw this.m.fire(w.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source,context:s.context,profileLocation:s.profileLocation}))),$}finally{for(const{task:$}of w)$.source&&!S.URI.isUri($.source)&&this.j.delete(c($.source))}}C(n,r){for(const[,{task:o,waitingTasks:s}]of this.j.entries())if(o===n&&(s.includes(r)||s.some(c=>this.C(c,r)))||o===r&&s[0]&&!this.C(n,s[0]))return!1;return!0}async D(n){const r=[],o=[],s=await Promise.allSettled(n);for(const c of s)c.status==="fulfilled"?r.push(c.value):o.push(c.reason);if(o.length)throw b(o);return r}async F(n,r,o,s,c){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,c),E=[],k=[],N=async(M,$)=>{E.push(M);const T=$.extensionDependencies||[],B=[...T];if($.extensionPack){const q=o?w.find(G=>(0,m.areSameExtensions)(G.identifier,M)):void 0;for(const G of $.extensionPack)q&&q.manifest.extensionPack&&q.manifest.extensionPack.some(Q=>(0,m.areSameExtensions)({id:Q},{id:G}))||B.every(Q=>!(0,m.areSameExtensions)({id:Q},{id:G}))&&B.push(G)}if(B.length){const q=B.filter(G=>E.every(Q=>!(0,m.areSameExtensions)(Q,{id:G})));if(q.length){const G=await this.t.getExtensions(q.map(Q=>({id:Q,preRelease:s})),l.CancellationToken.None);for(const Q of G){if(E.find(W=>(0,m.areSameExtensions)(W,Q.identifier)))continue;const re=T.some(W=>(0,m.areSameExtensions)({id:W},Q.identifier));let K;try{K=await this.G(Q,!1,s)}catch(W){if(W instanceof v.ExtensionManagementError&&W.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!re){this.v.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw W}k.push({gallery:K.extension,manifest:K.manifest}),await N(K.extension.identifier,K.manifest)}}}};return await N(n,r),k}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,m.areSameExtensions)(n.identifier,E)))throw new v.ExtensionManagementError(P.localize(1,null,n.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const E=await this.getTargetPlatform();throw new v.ExtensionManagementError(P.localize(2,null,n.identifier.id,this.w.nameLong,(0,v.TargetPlatformToString)(E)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.H(n,r,o);if(c){if(o&&!r&&n.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(P.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],l.CancellationToken.None))[0]?new v.ExtensionManagementError(P.localize(4,null,n.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(P.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",c.identifier.id);const w=await this.t.getManifest(c,l.CancellationToken.None);if(w===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(w.version!==c.version)throw new v.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:w}}async H(n,r,o){const s=await this.getTargetPlatform();let c=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(c=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null),!c&&await this.t.isExtensionCompatible(n,o,s)&&(c=n),c||(r?c=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null:c=await this.t.getCompatibleExtension(n,o,s)),c}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},s=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,c=this.k.get(s(n.identifier));if(c)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),c.waitUntilTaskIsFinished();const w=M=>{const $=this.R(M,o);return this.k.set(s($.extension.identifier),$),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),$},E=(M,$)=>{$?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),$.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,$.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(M),error:$}),this.p.fire({identifier:M.identifier,error:$?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},k=[],N=[];try{k.push(w(n));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const $=this.M(n,M);for(const T of $)this.k.has(s(T.identifier))?this.v.info("Extensions is already requested to uninstall",T.identifier.id):k.push(w(T))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(k.map($=>$.extension),M,n),await this.D(k.map(async $=>{try{if(await $.run(),await this.D(this.s.map(T=>T.postUninstall($.extension,o,l.CancellationToken.None))),$.extension.identifier.uuid)try{await this.t.reportStatistic($.extension.manifest.publisher,$.extension.manifest.name,$.extension.manifest.version,"uninstall")}catch{}E($.extension)}catch(T){const B=T instanceof v.ExtensionManagementError?T:new v.ExtensionManagementError((0,A.getErrorMessage)(T),v.ExtensionManagementErrorCode.Internal);throw E($.extension,B),B}finally{N.push($)}}))}catch(M){const $=M instanceof v.ExtensionManagementError?M:new v.ExtensionManagementError((0,A.getErrorMessage)(M),v.ExtensionManagementErrorCode.Internal);for(const T of k){try{T.cancel()}catch{}N.includes(T)||E(T.extension,$)}throw $}finally{for(const M of k)this.k.delete(s(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(n,r,o){for(const s of n){const c=this.N(s,r);if(c.length){const w=c.filter(E=>!n.some(k=>(0,m.areSameExtensions)(k.identifier,E.identifier)));if(w.length)throw new Error(this.L(s,w,o))}}}L(n,r,o){return o===n?r.length===1?P.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const s=n.manifest.extensionPack?n.manifest.extensionPack:[];if(s.length){const c=r.filter(E=>!E.isBuiltin&&s.some(k=>(0,m.areSameExtensions)({id:k},E.identifier))),w=[];for(const E of c)w.push(...this.M(E,r,o));return[...c,...w]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};y=ye([Y(0,v.IExtensionGalleryService),Y(1,h.ITelemetryService),Y(2,f.ILogService),Y(3,p.IProductService),Y(4,u.IUserDataProfilesService)],y),e.AbstractExtensionManagementService=y;function b(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=b;function C(i){if(i instanceof v.ExtensionManagementError)return i;const n=new v.ExtensionManagementError(i.message,v.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:s,error:c,durationSinceUpdate:w}){let E,k;c&&(c instanceof v.ExtensionManagementError?(E=c.code,c.code===v.ExtensionManagementErrorCode.Signature&&(k=c.message)):E=v.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!c,duration:s,errorcode:E,errorcodeDetail:k,durationSinceUpdate:w})}class a{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((r,o)=>{const s=n.onCancellationRequested(()=>{s.dispose(),o(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(ne[51],se([0,1,6,17,2,3,37,10,29,33,14,5,11,28,30,12,8,18]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class y extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let b=class extends l.Disposable{constructor(i,n,r,o,s,c){super(),this.i=i,this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new L.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.p(n,s=>{const c=[];for(const w of s)i.some(([E])=>(0,S.areSameExtensions)(E.identifier,w.identifier)&&E.manifest.version!==w.version)?r.push(w):c.push(w);for(const[w,E]of i)if(!c.some(k=>(0,S.areSameExtensions)(k.identifier,w.identifier)&&k.version===w.manifest.version)){const k={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:E};o.push(k),c.push(k)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),c}),o.length&&this.c.fire({extensions:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),o}catch(s){throw o.length&&this.c.fire({extensions:o,error:s,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:s,profileLocation:n}),s}}async updateMetadata(i,n){const r=[];return await this.p(n,o=>{const s=[];for(const c of o){const w=i.find(([E])=>(0,S.areSameExtensions)(E.identifier,c.identifier)&&E.manifest.version===c.version);w&&(c.metadata={...c.metadata,...w[1]},r.push(c)),s.push(c)}return s}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,o=>{const s=[];for(const c of o)(0,S.areSameExtensions)(c.identifier,i.identifier)?r.push(c):s.push(c);return r.length&&this.f.fire({extensions:r,profileLocation:n}),s}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async p(i,n,r){return this.w(i).queue(async()=>{let o=[],s;try{const c=await this.j.readFile(i);s=JSON.parse(c.value.toString().trim()||"[]")}catch(c){if((0,P.toFileOperationResult)(c)!==1)throw c;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&r?.bailOutWhenFileNotFound)throw new y((0,h.getErrorMessage)(c),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(i);let c=!1;for(const w of s){C(w)||this.r(i);let E;if((0,p.isString)(w.relativeLocation))E=this.t(w.relativeLocation);else if((0,p.isString)(w.location))E=this.t(w.location),c=!0,w.relativeLocation=w.location,w.location=E.toJSON();else{E=R.URI.revive(w.location);const k=this.s(E);k&&(c=!0,w.relativeLocation=k)}o.push({identifier:w.identifier,location:E,version:w.version,metadata:w.metadata})}c&&await this.j.writeFile(i,O.VSBuffer.fromString(JSON.stringify(s)))}if(n){o=n(o);const c=o.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(i,O.VSBuffer.fromString(JSON.stringify(c)))}return o})}r(i){const n=new y(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqualOrParent(i,this.i)?this.l.extUri.relativePath(this.i,i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(s){if((0,P.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const s=JSON.parse(r);Array.isArray(s)&&s.every(c=>C(c))?o=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,P.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(i)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(n)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.n.error(s)}return o})()),this.u}w(i){let n=this.h.get(i);return n||(n=new D.Queue,this.h.set(i,n)),n}};b=ye([Y(1,P.IFileService),Y(2,g.IUserDataProfilesService),Y(3,f.IUriIdentityService),Y(4,u.ITelemetryService),Y(5,m.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function C(a){return(0,p.isObject)(a)&&(0,I.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,p.isString)(a.location))&&((0,p.isUndefined)(a.relativeLocation)||(0,p.isString)(a.relativeLocation))&&a.version&&(0,p.isString)(a.version)}function t(a){return a?(0,p.isString)(a.path)&&(0,p.isString)(a.scheme):!1}}),define(ne[79],se([0,1,20,6,32,17,8,35,141,2,21,13,4,22,54,89,12,10,161,15,33,46,70,14,5,11,25,3,67,51,28,30,194,195]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t,a,i,n,r,o,s,c,w,E,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(re){function K(W,F){if(W===F)return!0;const J=Object.keys(W),ee=new Set;for(const oe of Object.keys(F))ee.add(oe);if(J.length!==ee.size)return!1;for(const oe of J){if(W[oe]!==F[oe])return!1;ee.delete(oe)}return ee.size===0}re.equals=K})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=class extends S.Disposable{constructor(K,W,F,J,ee,oe,ce,V,j,U,z,x){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=W,this.l=F,this.m=J,this.n=ee,this.p=oe,this.r=ce,this.s=V,this.t=j,this.u=U,this.v=z,this.w=x,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(q,(0,g.joinPath)(this.m,C.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(q,(0,g.joinPath)(this.m,C.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(B,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,b.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(K,W,F){const[J,ee]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(W)]),oe=F?await this.scanExtensionsUnderDevelopment(K,[...J,...ee]):[];return this.F(J,ee,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const W=[];W.push(this.G(!!K.useCache,K.language)),W.push(this.H(K.language,!!K.checkControlFile));const[F,J]=await Promise.all(W);return this.D([...F,...J],0,K,!1)}async scanUserExtensions(K){const W=K.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",W);const F=this.v.extUri.isEqual(K.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.J(W,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,F),ee=K.useCache&&!J.devMode&&J.excludeObsolete?this.j:this.k;let oe;try{oe=await ee.scanExtensions(J)}catch(ce){if(ce instanceof c.ExtensionsProfileScanningError&&ce.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await ee.scanExtensions(J);else throw ce}return oe=await this.D(oe,1,K,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(K,W){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const F=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(J=>J.scheme===P.Schemas.file).map(async J=>{const ee=await this.J(J,!1,1,!0,K.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=W.find(V=>(0,b.areSameExtensions)(V.identifier,ce.identifier))?.type??ce.type,this.k.validate(ce,ee)))}))).flat();return this.D(F,"development",K,!0)}return[]}async scanExistingExtension(K,W,F){const J=await this.J(K,!1,W,!0,F.language,!0,void 0),ee=await this.k.scanExtension(J);return!ee||!F.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(K,W,F){const J=await this.J(K,!1,W,!0,F.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(J);return this.D(ee,W,F,!0)}async scanMetadata(K){const W=(0,g.joinPath)(K,"package.json"),F=(await this.r.readFile(W)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(K,W){const F=(0,g.joinPath)(K,"package.json"),J=(await this.r.readFile(F)).value.toString(),ee=JSON.parse(J);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,ee.__metadata={...ee.__metadata,...W},await this.r.writeFile((0,g.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof c.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw K}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.p.addExtensionsToProfile(K.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,a.toFileOperationResult)(W)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(W))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.s.error(K)}finally{this.z=void 0}})()),this.z}async D(K,W,F,J){return F.includeAllVersions||(K=this.F(W===0?K:void 0,W===1?K:void 0,W==="development"?K:void 0,await this.getTargetPlatform(),J)),F.includeInvalid||(K=K.filter(ee=>ee.isValid)),K.sort((ee,oe)=>{const ce=v.basename(ee.location.fsPath),V=v.basename(oe.location.fsPath);return ce<V?-1:ce>V?1:0})}F(K,W,F,J,ee){const oe=(V,j,U)=>{if(V.isValid&&!j.isValid)return!1;if(V.isValid===j.isValid){if(ee&&f.gt(V.manifest.version,j.manifest.version))return this.s.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,j.manifest.version)){if(V.type===0)return this.s.debug(`Skipping extension ${j.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===J)return this.s.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${V.location.path} with ${j.location.path}.`):this.s.debug(`Overwriting user extension ${V.location.path} with ${j.location.path}.`),!0},ce=new Map;return K?.forEach(V=>{const j=C.ExtensionIdentifier.toKey(V.identifier.id),U=ce.get(j);(!U||oe(U,V,!1))&&ce.set(j,V)}),W?.forEach(V=>{const j=C.ExtensionIdentifier.toKey(V.identifier.id),U=ce.get(j);if(!U&&K&&V.type===0){this.s.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!U||oe(U,V,!1))&&ce.set(j,V)}),F?.forEach(V=>{const j=C.ExtensionIdentifier.toKey(V.identifier.id),U=ce.get(j);(!U||oe(U,V,!0))&&ce.set(j,V),ce.set(j,V)}),[...ce.values()]}async G(K,W){this.s.trace("Started scanning system extensions");const F=await this.J(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),ee=await(K&&!F.devMode?this.i:this.k).scanExtensions(F);return this.s.trace("Scanned system extensions:",ee.length),ee}async H(K,W){const F=this.t.isBuilt?[]:this.u.builtInExtensions;if(!F?.length)return[];this.s.trace("Started scanning dev system extensions");const J=W?await this.I():{},ee=[],oe=u.URI.file(v.normalize(v.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of F){const j=J[V.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":ee.push((0,g.joinPath)(oe,V.name));break;default:ee.push(u.URI.file(j));break}}const ce=await Promise.all(ee.map(async V=>this.k.scanExtension(await this.J(V,!1,0,!0,K,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ce.length),(0,D.coalesce)(ce)}async I(){try{const K=await this.r.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async J(K,W,F,J,ee,oe,ce){const V=await this.f(ee??m.language),j=await this.L(K),U=W&&!this.v.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,z=U?await this.L(U):void 0;return new T(K,j,U,z,W,ce,F,J,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ee,V)}async L(K){try{const W=await this.r.stat(K);if(typeof W.mtime=="number")return W.mtime}catch{}}};$=ye([Y(4,w.IUserDataProfilesService),Y(5,c.IExtensionsProfileScannerService),Y(6,a.IFileService),Y(7,n.ILogService),Y(8,y.IEnvironmentService),Y(9,r.IProductService),Y(10,E.IUriIdentityService),Y(11,i.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class T{constructor(K,W,F,J,ee,oe,ce,V,j,U,z,x,_,H,X){this.location=K,this.mtime=W,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=J,this.profile=ee,this.profileScanOptions=oe,this.type=ce,this.excludeObsolete=V,this.validate=j,this.productVersion=U,this.productDate=z,this.productCommit=x,this.devMode=_,this.language=H,this.translations=X}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,W){return(0,g.isEqual)(K.location,W.location)&&K.mtime===W.mtime&&(0,g.isEqual)(K.applicationExtensionslocation,W.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&K.profile===W.profile&&l.equals(K.profileScanOptions,W.profileScanOptions)&&K.type===W.type&&K.excludeObsolete===W.excludeObsolete&&K.validate===W.validate&&K.productVersion===W.productVersion&&K.productDate===W.productDate&&K.productCommit===W.productCommit&&K.devMode===W.devMode&&K.language===W.language&&M.equals(K.translations,W.translations)}}e.ExtensionScannerInput=T;let B=class extends S.Disposable{constructor(K,W,F,J,ee){super(),this.f=K,this.g=W,this.h=F,this.i=J,this.j=ee}async scanExtensions(K){const W=K.profile?await this.l(K):await this.k(K);let F={};if(K.excludeObsolete&&K.type===1)try{const J=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(J)}catch{}return(0,h.isEmptyObject)(F)?W:W.filter(J=>!F[b.ExtensionKey.create(J).toString()])}async k(K){const W=await this.i.resolve(K.location);if(!W.children?.length)return[];const F=await Promise.all(W.children.map(async J=>{if(!J.isDirectory||K.type===1&&(0,g.basename)(J.resource).indexOf(".")===0)return null;const ee=new T(J.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(F).sort((J,ee)=>J.location.path<ee.location.path?-1:1)}async l(K){let W=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){W=W.filter(J=>!J.metadata?.isApplicationScoped);const F=await this.m(K.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,K);W.push(...F)}return W}async m(K,W,F){const J=await this.g.scanProfileExtensions(K,F.profileScanOptions);if(!J.length)return[];const ee=await Promise.all(J.map(async oe=>{if(W(oe)){const ce=new T(oe.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(ce,oe.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,g.joinPath)(K.location,"package.json"))){const W=await this.scanExtension(K);return W?[W]:[]}else return await this.scanExtensions(K)}catch(W){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,L.getErrorMessage)(W)),[]}}async scanExtension(K,W){try{let F=await this.scanExtensionManifest(K.location);if(F){F.publisher||(F.publisher=C.UNDEFINED_PUBLISHER),W=W??F.__metadata,delete F.__metadata;const J=(0,b.getGalleryExtensionId)(F.publisher,F.name),ee=W?.id?{id:J,uuid:W.id}:{id:J},oe=W?.isSystem?0:K.type,ce=oe===0||!!W?.isBuiltin;N.ImplicitActivationEvents.updateManifest(F),F=await this.n(K.location,F,T.createNlsConfiguration(K));const V={type:oe,identifier:ee,manifest:F,location:K.location,isBuiltin:ce,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return K.validate?this.validate(V,K):V}}catch(F){K.type!==0&&this.j.error(F)}return null}validate(K,W){let F=!0;const J=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,K.manifest,K.isBuiltin);for(const[ee,oe]of J)ee===p.default.Error&&(F=!1,this.j.error(this.t(W.location,oe)));return K.isValid=F,K.validations=J,K}async scanExtensionManifest(K){const W=(0,g.joinPath)(K,"package.json");let F;try{F=(await this.i.readFile(W)).value.toString()}catch(ee){return(0,a.toFileOperationResult)(ee)!==1&&this.j.error(this.t(K,(0,d.localize)(0,null,W.path,ee.message))),null}let J;try{J=JSON.parse(F)}catch{const oe=[];(0,R.parse)(F,oe);for(const ce of oe)this.j.error(this.t(K,(0,d.localize)(1,null,W.path,ce.offset,ce.length,(0,I.getParseErrorMessage)(ce.error))));return null}return(0,R.getNodeType)(J)!=="object"?(this.j.error(this.t(K,(0,d.localize)(2,null,W.path))),null):J}async n(K,W,F){const J=await this.p(K,W,F);if(J)try{const ee=[],oe=await this.r(J.default,ee);if(ee.length>0)return ee.forEach(V=>{this.j.error(this.t(K,(0,d.localize)(3,null,J.default?.path,(0,I.getParseErrorMessage)(V.error))))}),W;if((0,R.getNodeType)(J)!=="object")return this.j.error(this.t(K,(0,d.localize)(4,null,J.default?.path))),W;const ce=J.values||Object.create(null);return(0,k.localizeManifest)(W,ce,oe)}catch{}return W}async p(K,W,F){const J=(0,g.joinPath)(K,"package.nls.json"),ee=(j,U)=>{U.forEach(z=>{this.j.error(this.t(K,(0,d.localize)(5,null,j?.path,(0,I.getParseErrorMessage)(z.error))))})},oe=j=>{this.j.error(this.t(K,(0,d.localize)(6,null,j?.path)))},ce=`${W.publisher}.${W.name}`,V=F.translations[ce];if(V)try{const j=u.URI.file(V),U=(await this.i.readFile(j)).value.toString(),z=[],x=(0,R.parse)(U,z);return z.length>0?(ee(j,z),{values:void 0,default:J}):(0,R.getNodeType)(x)!=="object"?(oe(j),{values:void 0,default:J}):{values:x.contents?x.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.i.exists(J))return;let U;try{U=await this.s(K,F)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const z=(await this.i.readFile(U.localized)).value.toString(),x=[],_=(0,R.parse)(z,x);return x.length>0?(ee(U.localized,x),{values:void 0,default:U.original}):(0,R.getNodeType)(_)!=="object"?(oe(U.localized),{values:void 0,default:U.original}):{values:_,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(K,W){if(K)try{const F=(await this.i.readFile(K)).value.toString();return(0,R.parse)(F,W)}catch{}}s(K,W){return new Promise((F,J)=>{const ee=oe=>{const ce=(0,g.joinPath)(K,`package.nls.${oe}.json`);this.i.exists(ce).then(V=>{V&&F({localized:ce,original:(0,g.joinPath)(K,"package.nls.json")});const j=oe.lastIndexOf("-");j===-1?F({localized:(0,g.joinPath)(K,"package.nls.json"),original:null}):(oe=oe.substring(0,j),ee(oe))})};if(W.devMode||W.pseudo||!W.language)return F({localized:(0,g.joinPath)(K,"package.nls.json"),original:null});ee(W.language)})}t(K,W){return`[${K.path}]: ${W}`}};B=ye([Y(1,c.IExtensionsProfileScannerService),Y(2,E.IUriIdentityService),Y(3,a.IFileService),Y(4,n.ILogService)],B);let q=class extends B{constructor(K,W,F,J,ee,oe){super(W,F,J,ee,oe),this.y=K,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(K){const W=await this.z();if(this.u=K,W&&W.input&&T.equals(W.input,this.u))return this.j.debug("Using cached extensions scan result",K.location.toString()),this.v.trigger(()=>this.D()),W.result.map(J=>(J.location=u.URI.revive(J.location),J));const F=await super.scanExtensions(K);return await this.C({input:K,result:F}),F}async z(){try{const K=await this.i.readFile(this.y),W=JSON.parse(K.value.toString());return{result:W.result,input:(0,s.revive)(W.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,L.getErrorMessage)(K))}return null}async C(K){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(K)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,L.getErrorMessage)(W))}}async D(){if(!this.u)return;const K=await this.z();if(!K)return;const W=K.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(F,W))try{await this.i.del(this.y),this.w.fire()}catch(J){this.j.error(J)}}};q=ye([Y(2,c.IExtensionsProfileScannerService),Y(3,E.IUriIdentityService),Y(4,a.IFileService),Y(5,n.ILogService)],q);function G(re,K){const W=(0,b.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:W,identifier:new C.ExtensionIdentifier(W),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:K,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.toExtensionDescription=G;class Q extends ${constructor(K,W,F,J,ee,oe,ce,V,j,U,z,x){super(K,W,(0,g.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(J,C.MANIFEST_CACHE_FOLDER),ee,oe,ce,V,j,U,z,x),this.M=(async()=>{if(m.translationsConfigFile)try{const _=await this.r.readFile(u.URI.file(m.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(K){return this.M}}e.NativeExtensionsScannerService=Q}),define(ne[271],se([0,1,11,28,30,18,51,14,15,10]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends L.AbstractExtensionsProfileScannerService{constructor(m,g,f,p,h,u){super(S.URI.file(m.extensionsPath),g,f,p,h,u)}};P=ye([Y(0,I.INativeEnvironmentService),Y(1,R.IFileService),Y(2,O.IUserDataProfilesService),Y(3,l.IUriIdentityService),Y(4,A.ITelemetryService),Y(5,D.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(ne[272],se([0,1,50,6,38,3,2,21,13,27,11,28]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends L.Disposable{constructor(f,p){super(),this.b=f,this.f=p,this.a=new O.Limiter(5)}async postUninstall(f){const p=this.g(f,"uninstall");p&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,f),this.f.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(h){this.f.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.f.error(h)}}));try{await S.Promises.rm(this.j(f))}catch(h){this.f.error("Error while removing extension storage path",f.identifier.id),this.f.error(h)}}g(f,p){const h=`vscode:${p}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[h]=="string"){const u=f.manifest.scripts[h].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${h} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(f,p,h,u,d){return new Promise((y,b)=>{const C=this.i(f,p,h,d);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?b(i):y(void 0)};C.on("error",i=>{a((0,l.toErrorMessage)(i)||"Unknown")}),C.on("exit",(i,n)=>{a(i?`post-${p} process exited with code ${i}`:void 0)}),u&&(t=setTimeout(()=>{t=null,C.kill(),b("timed out")},5e3))})}i(f,p,h,u){const d={silent:!0,execArgv:void 0},y=(0,D.fork)(f,[`--type=extension-post-${p}`,...h],d);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const b=A.Event.fromNodeEventEmitter(y.stdout,"data"),C=A.Event.fromNodeEventEmitter(y.stderr,"data");b(i=>this.f.info(u.identifier.id,u.manifest.version,`post-${p}`,i)),C(i=>this.f.error(u.identifier.id,u.manifest.version,`post-${p}`,i));const t=A.Event.any(A.Event.map(b,i=>({data:`%c${i}`,format:[""]})),A.Event.map(C,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}j(f){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};m=ye([Y(0,v.IUserDataProfilesService),Y(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[273],se([0,1,10,15,51,79,14,5,11,25,30,28]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends A.NativeExtensionsScannerService{constructor(f,p,h,u,d,y,b,C){super(D.URI.file(d.builtinExtensionsPath),D.URI.file(d.extensionsPath),d.userHome,D.URI.file(d.userDataPath),f,p,h,u,d,y,b,C)}};m=ye([Y(0,v.IUserDataProfilesService),Y(1,l.IExtensionsProfileScannerService),Y(2,L.IFileService),Y(3,I.ILogService),Y(4,O.INativeEnvironmentService),Y(5,S.IProductService),Y(6,P.IUriIdentityService),Y(7,R.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(ne[19],se([0,1,6,3,2,102,12,69,5,28]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function g(d){const y=d.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=g;class f extends l.Disposable{constructor(y={flushInterval:f.a}){super(),this.j=y,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new D.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,D.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(y,b){if(b===e.TARGET_KEY){switch(y){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:y})}else this.b.fire({scope:y,key:b,target:this.F(y)[b]})}r(y){this.f.fire({reason:y})}get(y,b,C){return this.L(b)?.get(y,C)}getBoolean(y,b,C){return this.L(b)?.getBoolean(y,C)}getNumber(y,b,C){return this.L(b)?.getNumber(y,C)}store(y,b,C,t){if((0,L.isUndefinedOrNull)(b)){this.remove(y,C);return}this.t(()=>{this.u(y,C,t),this.L(C)?.set(y,b)})}remove(y,b){this.t(()=>{this.u(y,b,void 0),this.L(b)?.delete(y)})}t(y){this.b.pause(),this.c.pause();try{y()}finally{this.b.resume(),this.c.resume()}}keys(y,b){const C=[],t=this.F(y);for(const a of Object.keys(t))t[a]===b&&C.push(a);return C}u(y,b,C){const t=this.F(b);typeof C=="number"?t[y]!==C&&(t[y]=C,this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(y){switch(y){case-1:return this.D;case 0:return this.z;default:return this.w}}G(y){const b=this.L(y);return b?g(b):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=P.NONE){this.f.fire({reason:y});const b=this.L(-1),C=this.L(0),t=this.L(1);switch(y){case P.NONE:await D.Promises.settled([b?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([b?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return u(y,b,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(y,b){return this.r(P.NONE),(0,S.isUserDataProfile)(y)?this.N(y,b):this.O(y,b)}H(y,b){return!(y.id===b.id||p(b)&&p(y))}I(y,b,C,t){this.t(()=>{if(t)for(const[a,i]of y)b.set(a,i);else{const a=new Set;for(const[i,n]of y)a.add(i),b.get(i)!==n&&this.n(C,i);for(const[i]of b.items)a.has(i)||this.n(C,i)}})}}f.a=60*1e3,e.AbstractStorageService=f;function p(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class h extends f{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(y=>this.n(1,y))),this.B(this.P.onDidChangeStorage(y=>this.n(0,y))),this.B(this.p.onDidChangeStorage(y=>this.n(-1,y)))}L(y){switch(y){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(y){return!1}}e.InMemoryStorageService=h;async function u(d,y,b,C,t,a){const i=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,r=new Map;d.forEach((N,M)=>{n.set(M,N),r.set(M,i(N))});const o=new Map,s=new Map;y.forEach((N,M)=>{o.set(M,N),s.set(M,i(N))});const c=new Map,w=new Map;b.forEach((N,M)=>{c.set(M,N),w.set(M,i(N))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const E=[];if(n.forEach((N,M)=>{E.push({key:M,value:N})}),console.table(E),console.groupEnd(),console.log(r),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];o.forEach((M,$)=>{N.push({key:$,value:M})}),console.table(N),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${a})`);const k=[];c.forEach((N,M)=>{k.push({key:M,value:N})}),console.table(k),console.groupEnd(),console.log(w)}e.logStorage=u}),define(ne[118],se([0,1,3,2,12,29,33,19]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends O.Disposable{constructor(v,m){super(),this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(v)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(m.onDidInstallExtensions(g=>g.forEach(({local:f,operation:p})=>{f&&p===4&&this.f(f.identifier)})))}async enableExtension(v,m){return this.f(v)?(this.a.fire({extensions:[v],source:m}),!0):!1}async disableExtension(v,m){return this.c(v)?(this.a.fire({extensions:[v],source:m}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const m=this.getDisabledExtensions();return m.every(g=>!(0,L.areSameExtensions)(g,v))?(m.push(v),this.g(m),!0):!1}f(v){const m=this.getDisabledExtensions();for(let g=0;g<m.length;g++){const f=m[g];if((0,L.areSameExtensions)(f,v))return m.splice(g,1),this.g(m),!0}return!1}g(v){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,v)}h(v){return this.b.get(v,0)}i(v,m){this.b.set(v,m,0)}};I=ye([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends O.Disposable{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new D.Emitter),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(m=>this.f(m)))}get(v,m){let g;return m===0?((0,l.isUndefinedOrNull)(this.a[v])&&(this.a[v]=this.g(v,m)),g=this.a[v]):g=this.g(v,m),JSON.parse(g)}set(v,m,g){const f=JSON.stringify(m.map(({id:h,uuid:u})=>({id:h,uuid:u})));this.g(v,g)!==f&&(g===0&&(m.length?this.a[v]=f:delete this.a[v]),this.h(v,m.length?f:void 0,g))}f(v){if(v.scope===0&&!(0,l.isUndefinedOrNull)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const g=this.get(v.key,v.scope);delete this.a[v.key];const f=this.get(v.key,v.scope),p=g.filter(u=>!f.some(d=>(0,L.areSameExtensions)(u,d))),h=f.filter(u=>!g.some(d=>(0,L.areSameExtensions)(d,u)));(p.length||h.length)&&this.b.fire([...p,...h])}}g(v,m){return this.c.get(v,m,"[]")}h(v,m,g){m?this.c.store(v,m,g,1):this.c.remove(v,g)}}e.StorageManager=S}),define(ne[274],se([0,1,20,24,8,4,36,12,10,16,15,29,33,70,14,11,25,60,242,19,18]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const C=A.isWeb?"web":(0,v.getTargetPlatform)(A.platform,L.arch),t="X-Market-Search-Activity-Id";var a;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...j){return String(j.reduce((U,z)=>U|z,0))}var n;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class w{constructor(U=c){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,z=this.d.pageSize){return new w({...this.d,pageNumber:U,pageSize:z})}withFilter(U,...z){const x=[...this.d.criteria,...z.length?z.map(_=>({filterType:U,value:_})):[{filterType:U}]];return new w({...this.d,criteria:x})}withSortBy(U){return new w({...this.d,sortBy:U})}withSortOrder(U){return new w({...this.d,sortOrder:U})}withFlags(...U){return new w({...this.d,flags:U.reduce((z,x)=>z|x,0)})}withAssetTypes(...U){return new w({...this.d,assetTypes:U})}withSource(U){return new w({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:z,pageSize:x,sortBy:_,sortOrder:H,flags:X,assetTypes:te}=this.d;return{filters:[{criteria:U,pageNumber:z,pageSize:x,sortBy:_,sortOrder:H}],assetTypes:te,flags:X}}get searchText(){const U=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(j,U){const z=(j||[]).filter(x=>x.statisticName===U)[0];return z?z.value:0}function k(j){const U="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(x=>x.assetType.indexOf(U)===0).reduce((x,_)=>{const H=$(j,_.assetType);return H&&x.push([_.assetType.substring(U.length),H]),x},[])}function N(j){if(j.properties){const U=j.properties.filter(_=>_.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=U.filter(_=>z.test(_.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return $(j,r.Repository)}function M(j){return{uri:`${j.fallbackAssetUri}/${r.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${r.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function $(j,U){return j.files.filter(x=>x.assetType===U)[0]?{uri:`${j.assetUri}/${U}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${U}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function T(j,U){const z=j.properties?j.properties.filter(_=>_.key===U):[],x=z.length>0&&z[0].value;return x?x.split(",").map(_=>(0,m.adoptToGalleryExtensionId)(_)):[]}function B(j){const U=j.properties?j.properties.filter(z=>z.key===o.Engine):[];return U.length>0&&U[0].value||""}function q(j){const U=j.properties?j.properties.filter(z=>z.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function G(j){const U=j.properties?j.properties.filter(x=>x.key===o.LocalizedLanguages):[],z=U.length>0&&U[0].value||"";return z?z.split(","):[]}function Q(j){return j.properties?.find(U=>U.key===o.SponsorLink)?.value}function re(j){return j.indexOf("preview")!==-1}function K(j){return j.targetPlatform?(0,v.toTargetPlatform)(j.targetPlatform):"undefined"}function W(j){const U=(0,D.distinct)(j.versions.map(K)),z=!!j.tags?.includes(v.WEB_EXTENSION_TAG),x=U.indexOf("web");return z?x===-1&&U.push("web"):x!==-1&&U.splice(x,1),U}function F(j,U){const z=(0,v.getFallbackTargetPlarforms)(U);for(let x=0;x<j.length;x++){const _=j[x];if(_.version===j[x-1]?.version){let H=x;const X=K(_);if(X===U)for(;H>0&&j[H-1].version===_.version;)H--;else if(z.includes(X))for(;H>0&&j[H-1].version===_.version&&K(j[H-1])!==U;)H--;H!==x&&(j.splice(x,1),j.splice(H,0,_))}}return j}e.sortExtensionVersions=F;function J(j,U,z){j.telemetryData={index:U,querySource:z,queryActivityId:j.queryContext?.[t]}}function ee(j,U,z,x){const _=j.versions[0],H={manifest:$(U,r.Manifest),readme:$(U,r.Details),changelog:$(U,r.Changelog),license:$(U,r.License),repository:N(U),download:M(U),icon:$(U,r.Icon),signature:$(U,r.Signature),coreTranslations:k(U)};return{identifier:{id:(0,m.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:U.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(_),description:j.shortDescription||"",installCount:E(j.statistics,"install"),rating:E(j.statistics,"averagerating"),ratingCount:E(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:z,assets:H,properties:{dependencies:T(U,o.Dependency),extensionPack:T(U,o.ExtensionPack),engine:B(U),localizedLanguages:G(U),targetPlatform:K(U),isPreReleaseVersion:q(U)},hasPreReleaseVersion:q(_),hasReleaseVersion:!0,preview:re(j.flags),isSigned:!!H.signature,queryContext:x}}let oe=class{constructor(U,z,x,_,H,X,te,le){this.k=z,this.l=x,this.n=_,this.o=H,this.q=X,this.u=te,this.w=le;const he=te.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=me?he.servicePPEUrl:he?.serviceUrl,this.g=me?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,z,x){const _=O.CancellationToken.isCancellationToken(z)?{}:z,H=O.CancellationToken.isCancellationToken(z)?z:x,X=[],te=[],le=[],he=[];let me=!0;for(const Ee of U){Ee.uuid?te.push(Ee.uuid):X.push(Ee.id);const De=!!(Ee.version||Ee.preRelease);le.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:De}),Ee.version&&he.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),me=me&&!!Ee.hasPreRelease&&!De}if(!te.length&&!X.length)return[];let pe=new w().withPage(1,U.length);te.length&&(pe=pe.withFilter(n.ExtensionId,...te)),X.length&&(pe=pe.withFilter(n.ExtensionName,...X)),(_.queryAllVersions||me)&&(pe=pe.withFlags(pe.flags,a.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:Se}=await this.z(pe,{targetPlatform:_.targetPlatform??C,includePreRelease:le,versions:he,compatible:!!_.compatible},H);return _.source&&Se.forEach((Ee,De)=>J(Ee,De,_.source)),Se}async getCompatibleExtension(U,z,x){if((0,v.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(U,z,x))return U;const _=new w().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:H}=await this.z(_,{targetPlatform:x,compatible:!0,includePreRelease:z},O.CancellationToken.None);return H[0]||null}async isExtensionCompatible(U,z,x){if(!(0,v.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,x)||!z&&U.properties.isPreReleaseVersion)return!1;let _=U.properties.engine;if(!_){const H=await this.getManifest(U,O.CancellationToken.None);if(!H)throw new Error("Manifest was not found");_=H.engines.vscode}return(0,g.isEngineValid)(_,this.u.version,this.u.date)}async y(U,z,x,_,H){if(!(0,v.isTargetPlatformCompatible)(K(U),_,H)||z!=="any"&&q(U)!==(z==="prerelease"))return!1;if(x)try{const X=await this.E(U);if(!(0,g.isEngineValid)(X,this.u.version,this.u.date))return!1}catch(X){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,l.getErrorMessage)(X)),!1}return!0}async query(U,z){let x=U.text||"";const _=U.pageSize??50;let H=new w().withPage(1,_);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(H=H.withFilter(n.Category,Se||pe),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(H=H.withFilter(n.Tag,Se||pe),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),H=H.withFilter(n.SearchText,x)),H=H.withSortBy(0)):U.ids?H=H.withFilter(n.ExtensionId,...U.ids):U.names?H=H.withFilter(n.ExtensionName,...U.names):H=H.withSortBy(4),typeof U.sortBy=="number"&&(H=H.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(H=H.withSortOrder(U.sortOrder)),U.source&&(H=H.withSource(U.source));const X=async(me,pe)=>{const{extensions:Se,total:Ee}=await this.z(me,{targetPlatform:C,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return Se.forEach((De,ke)=>J(De,(me.pageNumber-1)*me.pageSize+ke,U.source)),{extensions:Se,total:Ee}},{extensions:te,total:le}=await X(H,z),he=async(me,pe)=>{if(pe.isCancellationRequested)throw new l.CancellationError;const{extensions:Se}=await X(H.withPage(me+1),pe);return Se};return{firstPage:te,total:le,pageSize:H.pageSize,getPage:he}}async z(U,z,x){const _=U.flags;!!(U.flags&a.IncludeLatestVersionOnly)&&!!(U.flags&a.IncludeVersions)&&(U=U.withFlags(U.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(U.flags&a.IncludeLatestVersionOnly)&&!(U.flags&a.IncludeVersions)&&(U=U.withFlags(U.flags,a.IncludeLatestVersionOnly)),z.versions?.length&&(U=U.withFlags(U.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),U=U.withFlags(U.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:H,total:X,context:te}=await this.B(U,x);if(!(U.flags&a.IncludeLatestVersionOnly)){const pe=[];for(const Se of H){const Ee=await this.A(Se,z,te);Ee&&pe.push(Ee)}return{extensions:pe,total:X}}const he=[],me=new Map;for(let pe=0;pe<H.length;pe++){const Se=H[pe],Ee={id:(0,m.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},De=(0,R.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(We=>(0,m.areSameExtensions)(We,Ee))?.includePreRelease;if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(W(Se),z.targetPlatform))continue;const ke=await this.A(Se,z,te);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?me.set(Se.extensionId,pe):he.push([pe,ke])}if(me.size){const pe=new Date().getTime(),Se=new w().withFlags(_&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:Ee}=await this.z(Se,z,x);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const De of Ee){const ke=me.get(De.identifier.uuid);he.push([ke,De])}}return{extensions:he.sort((pe,Se)=>pe[0]-Se[0]).map(([,pe])=>pe),total:X}}async A(U,z,x){const _={id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},H=z.versions?.find(he=>(0,m.areSameExtensions)(he,_))?.version,X=(0,R.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(he=>(0,m.areSameExtensions)(he,_))?.includePreRelease,te=W(U),le=F(U.versions,z.targetPlatform);if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(te,z.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(H&&me.version!==H)){if(await this.y(me,X?"any":"release",z.compatible,te,z.targetPlatform))return ee(U,me,te,x);if(H&&me.version===H)return null}}return H||z.compatible?null:ee(U,U.versions[0],te)}async B(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const x=await this.j,_=JSON.stringify(U.raw),H={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},X=new Date().getTime();let te,le,he=0;try{if(te=await this.k.request({type:"POST",url:this.g&&U.criteria.some(pe=>pe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:H},z),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(te);if(me){const pe=me.results[0],Se=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ee&&Ee.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:he,context:{[t]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-X,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,z,x,_){if(!this.isEnabled())return;const H=A.isWeb?this.x(`/itemName/${U}.${z}/version/${x}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${z}/${x}/stats?statType=${_}`),X=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:H,headers:le},O.CancellationToken.None)}catch{}}async download(U,z,x){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const _=(0,m.getGalleryExtensionTelemetryData)(U),H=new Date().getTime(),X=pe=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:pe}),te=x===2?"install":x===3?"update":"",le=te?{uri:`${U.assets.download.uri}${I.URI.parse(U.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${U.assets.download.fallbackUri}${I.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:U.assets.download,he=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,me=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile(z,me.stream),X(new Date().getTime()-H)}async downloadSignatureArchive(U,z){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const x=await this.D(U.assets.signature);await this.q.writeFile(z,x.stream)}async getReadme(U,z){if(U.assets.readme){const x=await this.D(U.assets.readme,{},z);return await(0,u.asTextOrError)(x)||""}return""}async getManifest(U,z){if(U.assets.manifest){const x=await this.D(U.assets.manifest,{},z),_=await(0,u.asTextOrError)(x);return _?JSON.parse(_):null}return null}async C(U,z){const x=$(U,r.Manifest);if(!x)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},H=await this.D(x,{headers:_});return await(0,u.asJson)(H)}async getCoreTranslation(U,z){const x=U.assets.coreTranslations.filter(_=>_[0]===z.toUpperCase())[0];if(x){const _=await this.D(x[1]),H=await(0,u.asTextOrError)(_);return H?JSON.parse(H):null}return null}async getChangelog(U,z){if(U.assets.changelog){const x=await this.D(U.assets.changelog,{},z);return await(0,u.asTextOrError)(x)||""}return""}async getAllCompatibleVersions(U,z,x){let _=new w().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?_=_.withFilter(n.ExtensionId,U.identifier.uuid):_=_.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:H}=await this.B(_,O.CancellationToken.None);if(!H.length)return[];const X=W(H[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(X,x))return[];const te=[];await Promise.all(H[0].versions.map(async me=>{try{await this.y(me,z?"any":"release",!0,X,x)&&te.push(me)}catch{}}));const le=[],he=new Set;for(const me of F(te,x))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:q(me)}));return le}async D(U,z={},x=O.CancellationToken.None){const _=await this.j,H={type:"GET"},X={..._,...z.headers||{}};z={...z,...H,headers:X};const te=U.uri,le=U.fallbackUri,he={...z,url:te};try{const me=await this.k.request(he,x);if(me.res.statusCode===200)return me;const pe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,l.isCancellationError)(me))throw me;const pe=(0,l.getErrorMessage)(me);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:pe});const Se={...z,url:le};return this.k.request(Se,x)}}async E(U){let z=B(U);if(!z){const x=await this.C(U,O.CancellationToken.None);if(!x)throw new Error("Manifest was not found");z=x.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.asJson)(U),x=[],_={};if(z){for(const H of z.malicious)x.push({id:H});if(z.migrateToPreRelease)for(const[H,X]of Object.entries(z.migrateToPreRelease))(!X.engine||(0,g.isEngineValid)(X.engine,this.u.version,this.u.date))&&(_[H.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[H,X]of Object.entries(z.deprecated))X&&(_[H.toLowerCase()]=(0,R.isBoolean)(X)?{}:X)}return{malicious:x,deprecated:_}}};oe=ye([Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,f.IFileService),Y(6,h.IProductService),Y(7,S.IConfigurationService)],oe);let ce=class extends oe{constructor(U,z,x,_,H,X,te,le){super(U,z,x,_,H,X,te,le)}};ce=ye([Y(0,y.IStorageService),Y(1,u.IRequestService),Y(2,p.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,f.IFileService),Y(6,h.IProductService),Y(7,S.IConfigurationService)],ce),e.ExtensionGalleryService=ce;let V=class extends oe{constructor(U,z,x,_,H,X,te){super(void 0,U,z,x,_,H,X,te)}};V=ye([Y(0,u.IRequestService),Y(1,p.ILogService),Y(2,P.IEnvironmentService),Y(3,b.ITelemetryService),Y(4,f.IFileService),Y(5,h.IProductService),Y(6,S.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[80],se([0,1,5,3,2,19,33,25,20,11,12]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Xe extends l.Disposable{static b(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static c(f){const p=v.exec(f);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(f,p){const h=await f.getInstalled(),u=[];for(const[d,y]of Xe.f(p)){const b=h.find(C=>(0,L.areSameExtensions)(C.identifier,{id:d}))?.manifest.version;for(const C of y)b!==C&&u.push(Xe.b({id:d,version:C}))}for(const d of u)p.remove(d,0)}static f(f){const p=new Map,h=f.keys(0,1);for(const u of h){const d=Xe.c(u);if(d){let y=p.get(d.id.toLowerCase());y||p.set(d.id.toLowerCase(),y=[]),y.push(d.version)}}return p}constructor(f,p,h){super(),this.i=f,this.j=p,this.k=h,this.g=this.B(new O.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(f),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(f){if(f.scope!==0)return;if(this.h.has(f.key.toLowerCase())){this.g.fire();return}const p=Xe.c(f.key);if(p){if(this.i.get(f.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let h=this.h.get(p.id.toLowerCase());h||this.h.set(p.id.toLowerCase(),h=[]),h.push(p.version),this.g.fire()}return}}m(f){if((0,P.isString)(f))return f;const p=f.manifest?f.manifest.publisher:f.publisher,h=f.manifest?f.manifest.name:f.name;return(0,L.getExtensionId)(p,h)}getExtensionState(f,p){const h=this.m(f),u=this.getExtensionStateRaw(f,p);if(u)try{return JSON.parse(u)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${p}): ${d}`)}}getExtensionStateRaw(f,p){const h=this.m(f),u=this.i.get(h,p?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${p}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(f,p,h){const u=this.m(f);p===void 0?this.i.remove(u,h?0:1):this.i.store(u,JSON.stringify(p),h?0:1,1)}setKeysForSync(f,p){this.i.store(Xe.b(f),JSON.stringify(p),0,1)}getKeysForSync(f){const p=this.j.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.i.get(Xe.b(f),0),u=h?JSON.parse(h):void 0;return u&&p?(0,I.distinct)([...u,...p]):u||p}addToMigrationList(f,p){if(f!==p){const h=this.n.filter(u=>!u.includes(f)&&!u.includes(p));h.push([f,p]),this.n=h}}getSourceExtensionToMigrate(f){const p=this.n.find(([,h])=>f===h);return p?p[0]:void 0}get n(){const f=this.i.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(f);if(Array.isArray(p))return p}catch{}return[]}set n(f){f.length?this.i.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,S.ILogService)],m),e.ExtensionStorageService=m}),define(ne[275],se([0,1,20,6,3,13,4,36,10,162,15,29,33,218,99,14,58,25,19,18]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",C="extensionTips/lastPromptedMediumImpExeTime";let t=class extends g.ExtensionTipsService{constructor(i,n,r,o,s,c,w,E){super(w,E),this.m=i,this.n=n,this.p=r,this.r=o,this.s=s,this.t=c,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([k,N])=>{const M=[],$=[],T=[];Object.entries(N.recommendations).forEach(([B,q])=>{q.important?N.important?M.push({extensionId:B,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):$.push({extensionId:B,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):T.push({extensionId:B,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),M.length&&this.g.set(k,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:M}),$.length&&this.h.set(k,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:$}),T.length&&this.j.set(k,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:T})}),(0,O.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const i=await this.I(this.g),n=await this.I(this.h);return[...i,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const i=await this.I(this.g),n=await this.I(this.h),r=await this.p.getInstalled();this.k=this.v(i,r),this.l=this.v(n,r)}v(i,n){const r=new Map;i.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:o,uninstalled:s}=this.H([...r.keys()],n);for(const E of o){const k=r.get(E);k&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:k.exeName})}for(const E of s){const k=r.get(E);k&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:k.exeName})}const c=this.F(),w=new Map;for(const E of s){const k=r.get(E);if(k&&(!c[k.exeName]||!c[k.exeName].includes(k.extensionId))){let N=w.get(k.exeName);N||(N=[],w.set(k.exeName,N)),N.push(k)}}return w}w(){if(this.k.size===0)return;const[i,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(i);break;case"incompatibleWindow":{const o=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(o(()=>this.w()));break}case"toomany":{const o=this.B((0,O.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const i=this.C(),n=Date.now()-i,r=7*24*60*60*1e3;if(n<r){const c=this.B((0,O.disposableTimeout)(()=>{c.dispose(),this.y()},r-n));return}const[o,s]=[...this.l.entries()][0];this.z(s).then(c=>{switch(c){case"reacted":{this.D(Date.now()),this.l.delete(o),this.G(s[0].exeName,s);const w=this.B((0,O.disposableTimeout)(()=>{w.dispose(),this.y()},r));break}case"ignored":this.l.delete(o),this.y();break;case"incompatibleWindow":{const w=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(w(()=>this.y()));break}case"toomany":{const w=this.B((0,O.disposableTimeout)(()=>{w.dispose(),this.y()},36e5));break}}})}async z(i){const n=await this.p.getInstalled(1),r=i.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(c=>n.every(w=>!(0,m.areSameExtensions)(w.identifier,{id:c})))).map(({extensionId:s})=>s.toLowerCase()),o=(0,S.localize)(0,null,i[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,o,`@exe:"${i[0].exeName}"`,3)}C(){let i=this.r.getNumber(C,-1);return i||(i=Date.now(),this.D(i)),i}D(i){this.r.store(C,i,-1,1)}F(){return JSON.parse(this.r.get(b,-1,"{}"))}G(i,n){const r=this.F();r[i]=n.map(({extensionId:o})=>o.toLowerCase()),this.r.store(b,JSON.stringify(r),-1,0)}H(i,n){const r=[],o=[],s=n.reduce((c,w)=>(c.add(w.identifier.id.toLowerCase()),c),new Set);return i.forEach(c=>{s.has(c.toLowerCase())?r.push(c):o.push(c)}),{installed:r,uninstalled:o}}async I(i){const n=[],r=new Map;for(const o of i.keys()){const s=i.get(o);if(!s||!(0,D.isNonEmptyArray)(s.recommendations))continue;const c=[];L.isWindows?s.windowsPath&&c.push(s.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(c.push((0,A.join)("/usr/local/bin",o)),c.push((0,A.join)("/usr/bin",o)),c.push((0,A.join)(this.m.userHome.fsPath,o)));for(const w of c){let E=r.get(w);if(E===void 0&&(E=await this.b.exists(I.URI.file(w)),r.set(w,E)),E)for(const{extensionId:k,extensionName:N,isExtensionPack:M,whenNotInstalled:$}of s.recommendations)n.push({extensionId:k,extensionName:N,isExtensionPack:M,exeName:o,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:$})}}return n}};t=ye([Y(0,P.INativeEnvironmentService),Y(1,y.ITelemetryService),Y(2,v.IExtensionManagementService),Y(3,d.IStorageService),Y(4,h.INativeHostService),Y(5,f.IExtensionRecommendationNotificationService),Y(6,p.IFileService),Y(7,u.IProductService)],t),e.ExtensionTipsService=t}),define(ne[276],se([0,1,6,2,22,69,19,76,28]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends L.AbstractStorageService{constructor(v,m,g,f){super(),this.X=v,this.Y=m,this.Z=g,this.ab=f,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new O.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new O.DisposableStore),this.W=this.db(this.X)}bb(){const v=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new A.Storage(v));return this.B(m.onDidChangeStorage(g=>this.n(-1,g))),m}cb(v){this.Q.clear(),this.P=v;let m;if((0,L.isProfileUsingDefaultStorage)(v))m=this.s;else{const g=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),v));m=this.Q.add(new A.Storage(g))}return this.Q.add(m.onDidChangeStorage(g=>this.n(0,g))),m}db(v){this.U.clear(),this.S=v?.id;let m;if(v){const g=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),v));m=this.U.add(new A.Storage(g)),this.U.add(m.onDidChangeStorage(f=>this.n(1,f)))}return m}async J(){await D.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(v){switch(v){case-1:return this.s;case 0:return this.R;default:return this.W}}M(v){switch(v){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(L.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(v,m){if(!this.H(this.P,v))return;const g=this.R,f=g.items;g!==this.s&&await g.close(),this.R=this.cb(v),await this.R.init(),this.I(f,this.R,0,m)}async O(v,m){const g=this.W,f=g?.items??new Map;await g?.close(),this.W=this.db(v),await this.W.init(),this.I(f,this.W,1,m)}hasScope(v){return(0,I.isUserDataProfile)(v)?this.P.id===v.id:this.S===v.id}}e.NativeStorageService=S}),define(ne[62],se([0,1,2,69,5,19]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let L=class extends D.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async P=>this.b(P))}async updateStorageData(S,P,v){return this.withProfileScopedStorageService(S,async m=>this.c(m,P,v))}async withProfileScopedStorageService(S,P){if(this.a.hasScope(S))return P(this.a);const v=await this.g(S),m=new R(v);try{await m.initialize();const g=await P(m);return await m.flush(),g}finally{m.dispose(),await this.f(v)}}b(S){const P=new Map,v=m=>{for(const g of S.keys(0,m))P.set(g,{value:S.get(g,0),target:m})};return v(0),v(1),P}c(S,P,v){for(const[m,g]of P)S.store(m,g,0,v)}async f(S){try{await S.close()}finally{(0,D.isDisposable)(S)&&S.dispose()}}};L=ye([Y(0,A.IStorageService)],L),e.AbstractUserDataProfileStorageService=L;class R extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new O.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(ne[277],se([0,1,3,2,22,15,57,28]),function(Z,e,D,O,l,A,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(P,v,m){super(),this.b=[],this.c=this.B(new D.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=v.getChannel("userDataProfiles"),this.profilesHome=(0,l.joinPath)(m.userRoamingDataHome,"profiles"),this.b=P.map(g=>(0,R.reviveProfile)(g,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(g=>{const f=g.added.map(u=>(0,R.reviveProfile)(u,this.profilesHome.scheme)),p=g.removed.map(u=>(0,R.reviveProfile)(u,this.profilesHome.scheme)),h=g.updated.map(u=>(0,R.reviveProfile)(u,this.profilesHome.scheme));this.b=g.all.map(u=>(0,R.reviveProfile)(u,this.profilesHome.scheme)),this.c.fire({added:f,removed:p,updated:h,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(P){this.f=P}isEnabled(){return this.f}async createNamedProfile(P,v,m){const g=await this.a.call("createNamedProfile",[P,v,m]);return(0,R.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(P,v,m,g){const f=await this.a.call("createProfile",[P,v,m,g]);return(0,R.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(P){const v=await this.a.call("createTransientProfile",[P]);return(0,R.reviveProfile)(v,this.profilesHome.scheme)}async setProfileForWorkspace(P,v){await this.a.call("setProfileForWorkspace",[P,v])}removeProfile(P){return this.a.call("removeProfile",[P])}async updateProfile(P,v){const m=await this.a.call("updateProfile",[P,v]);return(0,R.reviveProfile)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=ye([Y(1,L.IMainProcessService),Y(2,A.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(ne[278],se([0,1,3,2,57,11,62,19,76,28,71]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let v=class extends L.AbstractUserDataProfileStorageService{constructor(g,f,p,h){super(p),this.i=g;const u=g.getChannel("profileStorageListener"),d=this.B(new O.MutableDisposable);this.h=this.B(new D.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(y=>{h.trace("profile storage changes",y),this.h.fire({targetChanges:y.targetChanges.map(b=>(0,S.reviveProfile)(b,f.profilesHome.scheme)),valueChanges:y.valueChanges.map(b=>({...b,profile:(0,S.reviveProfile)(b.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(g){const f=this.i.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(g)?new I.ApplicationStorageDatabaseClient(f):new I.ProfileStorageDatabaseClient(f,g)}};v=ye([Y(0,l.IMainProcessService),Y(1,S.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,A.ILogService)],v),e.UserDataProfileStorageService=v,(0,P.registerSingleton)(L.IUserDataProfileStorageService,v,1)}),define(ne[41],se([0,1,20,6,17,24,3,35,2,26,12,180,16,15,14,44,19,18,30,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function b(r){return!!(r&&r.ref!==void 0&&typeof r.ref=="string"&&r.ref!==""&&r.syncData!==void 0&&(r.syncData===null||C(r.syncData)))}e.isRemoteUserData=b;function C(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&(Object.keys(r).length===2||Object.keys(r).length===3&&r.machineId!==void 0&&typeof r.machineId=="string"))}e.isSyncData=C;function t(r,o){return`${(0,S.uppercaseFirstLetter)(r)}${o.isDefault?"":` (${o.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends I.Disposable{get status(){return this.j}get conflicts(){return{...this.syncResource,conflicts:this.l}}constructor(o,s,c,w,E,k,N,M,$,T,B,q){super(),this.syncResource=o,this.collection=s,this.z=c,this.C=w,this.D=E,this.F=k,this.G=N,this.H=M,this.I=$,this.J=T,this.L=B,this.c=null,this.j="idle",this.k=this.B(new L.Emitter),this.onDidChangeStatus=this.k.event,this.l=[],this.m=this.B(new L.Emitter),this.onDidChangeConflicts=this.m.event,this.n=new O.ThrottledDelayer(50),this.s=this.B(new L.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=t(o.syncResource,o.profile),this.h=q.extUri,this.f=this.h.joinPath(w.userDataSyncHome,...(0,y.getPathSegments)(o.profile.isDefault?void 0:o.profile.id,o.syncResource)),this.g=this.h.joinPath(this.f,y.PREVIEW_DIR_NAME),this.t=(0,y.getLastSyncResourceUri)(o.profile.isDefault?void 0:o.profile.id,o.syncResource,w,this.h),this.i=(0,p.getServiceMachineId)(w,c,E)}M(){this.n.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.J.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const o=await this.c;this.c=null;const s=await this.S(o.remoteUserData,o.lastSyncUserData,!0,this.lb());this.O(s)}else{this.J.trace(`${this.w}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?await this.rb(o):!0)&&this.s.fire()}}O(o){this.j!==o&&(this.j=o,this.k.fire(o))}async sync(o,s={}){await this.P(o,!0,this.lb(),s)}async preview(o,s,c={}){return this.P(o,!1,s,c)}async apply(o,s={}){try{this.y={...s};const c=await this.X(o);return this.O(c),this.c}finally{this.y={}}}async P(o,s,c,w){try{if(this.y={...w},this.status==="hasConflicts")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.J.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let E="idle";try{const k=await this.getLastSyncUserData(),N=await this.R(o,k);return E=await this.S(N,k,s,c),E==="hasConflicts"?this.J.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.J.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(E)}}finally{this.y={}}}async replace(o){const s=this.hb(o);if(!s)return!1;await this.stop();try{this.J.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const c=await this.getLastSyncUserData(),w=await this.R(null,c),E=await this.Q(w),k=await this.nb({ref:w.ref,syncData:s},c,E,this.lb(),A.CancellationToken.None),N=[];for(const M of k){const $=await this.pb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:T}=await this.pb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);N.push([M,{...$,remoteChange:T!==0?T:2}])}await this.qb(w,c,N,!1),this.J.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(o){const s=await this.i;return!!o.syncData?.machineId&&o.syncData.machineId===s}async R(o,s){if(s){const c=o?o[this.resource]:void 0;if(s.ref===c||c===void 0&&s.syncData===null)return s}return this.getRemoteUserData(s)}async S(o,s,c,w){if(o.syncData&&o.syncData.version>this.mb)throw this.I.publicLog2("sync/incompatible",{source:this.resource}),new y.UserDataSyncError((0,v.localize)(0,null,this.resource,this.mb,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(o,s,c,w)}catch(E){if(E instanceof y.UserDataSyncError)switch(E.code){case"LocalPreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.S(o,s,c,w);case"Conflict":case"PreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),s=await this.getLastSyncUserData(),this.S(o,s,c,w)}throw E}}async U(o,s,c,w){try{const E=await this.Q(o),k=!E&&s===null&&this.db()!==void 0,N=c&&!k;this.c||(this.c=(0,O.createCancelablePromise)($=>this.bb(o,s,E,N,w,$)));let M=await this.c;if(c&&k){this.J.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const $ of M.resourcePreviews)M=await this.accept($.remoteResource)||M}return this.Z(M.resourcePreviews),M.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":c?await this.X(!1):"syncing"}catch(E){throw this.c=null,E}}async merge(o){return await this.W(o,async s=>{const c=await this.ob(s,A.CancellationToken.None);await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c?.content||""));const w=c&&!c.hasConflicts?await this.pb(s,s.previewResource,void 0,A.CancellationToken.None):void 0;return s.acceptResult=w,s.mergeState=c.hasConflicts?"conflict":w?"accepted":"preview",s.localChange=w?w.localChange:c.localChange,s.remoteChange=w?w.remoteChange:c.remoteChange,s}),this.c}async accept(o,s){return await this.W(o,async c=>{const w=await this.pb(c,o,s,A.CancellationToken.None);return c.acceptResult=w,c.mergeState="accepted",c.localChange=w.localChange,c.remoteChange=w.remoteChange,c}),this.c}async discard(o){return await this.W(o,async s=>{const c=await this.ob(s,A.CancellationToken.None);return await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c.content||"")),s.acceptResult=void 0,s.mergeState="preview",s.localChange=c.localChange,s.remoteChange=c.remoteChange,s}),this.c}async W(o,s){if(!this.c)return;let c=await this.c;const w=c.resourcePreviews.findIndex(({localResource:E,remoteResource:k,previewResource:N})=>this.h.isEqual(E,o)||this.h.isEqual(k,o)||this.h.isEqual(N,o));w!==-1&&(this.c=(0,O.createCancelablePromise)(async E=>{const k=[...c.resourcePreviews];return k[w]=await s(k[w]),{...c,resourcePreviews:k}}),c=await this.c,this.Z(c.resourcePreviews),c.resourcePreviews.some(({mergeState:E})=>E==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(o){if(!this.c)return"idle";const s=await this.c;return s.resourcePreviews.some(({mergeState:c})=>c==="conflict")?"hasConflicts":s.resourcePreviews.some(({mergeState:c})=>c!=="accepted")?"syncing":(await this.qb(s.remoteUserData,s.lastSyncUserData,s.resourcePreviews.map(c=>[c,c.acceptResult]),o),this.c=null,await this.Y(),"idle")}async Y(){try{await this.z.del(this.g,{recursive:!0})}catch{}}Z(o){const s=o.filter(({mergeState:c})=>c==="conflict");(0,D.equals)(this.l,s,(c,w)=>this.h.isEqual(c.previewResource,w.previewResource))||(this.l=s,this.m.fire(this.conflicts))}async hasPreviouslySynced(){const o=await this.getLastSyncUserData();return!!o&&o.syncData!==null}async ab(o){const s=this.c?await this.c:null;if(s)for(const c of s.resourcePreviews){if(this.h.isEqual(c.acceptedResource,o))return c.acceptResult?c.acceptResult.content:null;if(this.h.isEqual(c.remoteResource,o))return c.remoteContent;if(this.h.isEqual(c.localResource,o))return c.localContent;if(this.h.isEqual(c.baseResource,o))return c.baseContent}return null}async resetLocal(){this.D.remove(this.u,-1);try{await this.z.del(this.t)}catch(o){(0,f.toFileOperationResult)(o)!==1&&this.J.error(o)}}async bb(o,s,c,w,E,k){const N=await this.nb(o,s,c,E,k),M=[];for(const $ of N){const T=$.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)M.push({...$,acceptedResource:T,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const B=w?await this.ob($,k):void 0;if(k.isCancellationRequested)break;await this.z.writeFile($.previewResource,l.VSBuffer.fromString(B?.content||""));const q=B&&!B.hasConflicts?await this.pb($,$.previewResource,void 0,k):void 0;M.push({...$,acceptResult:q,mergeState:B?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:B?B.localChange:$.localChange,remoteChange:q?q.remoteChange:B?B.remoteChange:$.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:o,lastSyncUserData:s,resourcePreviews:M,isLastSyncFromCurrentMachine:c}}async getLastSyncUserData(){let o=this.db();if(o||(o=await this.gb()),!o)return this.J.info(`${this.w}: Last sync data state does not exist.`),null;const s=JSON.parse(o),c=this.H.getResourceSyncStateVersion(this.resource);if(this.v=!!s.version&&!!c&&s.version!==c,this.v)return this.J.info(`${this.w}: Reset last sync state because last sync state version ${s.version} is not compatible with current sync state version ${c}.`),await this.resetLocal(),null;let w,E=1;for(;w===void 0&&E++<6;)try{const k=await this.eb();k&&(k.ref===s.ref?w=k.syncData:this.J.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(k){if(k instanceof f.FileOperationError&&k.fileOperationResult===1){this.J.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(k instanceof y.UserDataSyncError)throw k;this.J.error(k,E)}}if(w===void 0)try{const k=await this.F.resolveResourceContent(this.resource,s.ref,this.collection,this.y);w=k===null?null:this.hb(k),await this.fb({ref:s.ref,syncData:w})}catch(k){if(k instanceof y.UserDataSyncError&&k.code==="NotFound")this.J.info(`${this.w}: Last sync resource does not exist remotely.`);else throw k}return w===void 0?null:{...s,syncData:w}}async cb(o,s={}){if(s.ref||s.version)throw new Error("Cannot have core properties as additional");const c=this.H.getResourceSyncStateVersion(this.resource),w={ref:o.ref,version:c,...s};this.D.store(this.u,JSON.stringify(w),-1,1),await this.fb(o)}db(){return this.D.get(this.u,-1)}async eb(){const o=(await this.z.readFile(this.t)).value.toString();try{const s=o?JSON.parse(o):void 0;if(b(s))return s}catch(s){this.J.error(s)}}async fb(o){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(o)))}async gb(){try{const o=await this.z.readFile(this.t),s=JSON.parse(o.value.toString());await this.z.del(this.t),s.ref&&s.content!==void 0?(this.D.store(this.u,JSON.stringify({...s,content:void 0}),-1,1),await this.fb({ref:s.ref,syncData:s.content===null?null:JSON.parse(s.content)})):this.J.info(`${this.w}: Migrating last sync user data. Invalid data.`,s)}catch(o){o instanceof f.FileOperationError&&o.fileOperationResult===1?this.J.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.J.error(o)}return this.D.get(this.u,-1)}async getRemoteUserData(o){const{ref:s,content:c}=await this.ib(o);let w=null;return c!==null&&(w=this.hb(c)),{ref:s,syncData:w}}hb(o){try{const s=JSON.parse(o);if(C(s))return s}catch(s){this.J.error(s)}throw new y.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(o){const s=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.F.readResource(this.resource,s,this.collection,this.y)}async jb(o,s){const c=await this.i,w={version:this.mb,machineId:c,content:o};try{return s=await this.F.writeResource(this.resource,JSON.stringify(w),s,this.collection,this.y),{ref:s,syncData:w}}catch(E){throw E instanceof y.UserDataSyncError&&E.code==="TooLarge"&&(E=new y.UserDataSyncError(E.message,E.code,this.resource)),E}}async kb(o){const s={version:this.mb,content:o};return this.G.backup(this.syncResource.profile,this.resource,JSON.stringify(s))}async stop(){this.status!=="idle"&&(this.J.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.J.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.L.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=ye([Y(2,f.IFileService),Y(3,g.IEnvironmentService),Y(4,h.IStorageService),Y(5,y.IUserDataSyncStoreService),Y(6,y.IUserDataSyncBackupStoreService),Y(7,y.IUserDataSyncEnablementService),Y(8,u.ITelemetryService),Y(9,y.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,d.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(o,s,c,w,E,k,N,M,$,T,B,q,G){super(s,c,w,E,k,N,M,$,T,B,q,G),this.p=o,this.B(this.z.watch(this.h.dirname(o))),this.B(this.z.onDidFilesChange(Q=>this.ub(Q)))}async r(){try{return await this.z.readFile(this.p)}catch{return null}}async sb(o,s,c){try{s?await this.z.writeFile(this.p,l.VSBuffer.fromString(o),c?void 0:s):await this.z.createFile(this.p,l.VSBuffer.fromString(o),{overwrite:c})}catch(w){throw w instanceof f.FileOperationError&&w.fileOperationResult===1||w instanceof f.FileOperationError&&w.fileOperationResult===3?new y.UserDataSyncError(w.message,"LocalPreconditionFailed"):w}}async tb(){try{await this.z.del(this.p)}catch(o){if(!(o instanceof f.FileOperationError&&o.fileOperationResult===1))throw o}}ub(o){!o.contains(this.p)||this.M()}};i=ye([Y(3,f.IFileService),Y(4,g.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,d.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let n=class extends i{constructor(o,s,c,w,E,k,N,M,$,T,B,q,G,Q){super(o,s,c,w,E,k,N,M,$,T,B,G,Q),this.vb=q,this.xb=void 0}wb(o,s){const c=[],w=(0,R.parse)(o,c,{allowEmptyContent:!0,allowTrailingComma:!0});return c.length>0||!(0,P.isUndefined)(w)&&s!==Array.isArray(w)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.p)),this.xb}};n=ye([Y(3,f.IFileService),Y(4,g.IEnvironmentService),Y(5,h.IStorageService),Y(6,y.IUserDataSyncStoreService),Y(7,y.IUserDataSyncBackupStoreService),Y(8,y.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,y.IUserDataSyncLogService),Y(11,y.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,d.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n}),define(ne[119],se([0,1,6,24,8,3,42,2,26,16,15,118,29,33,80,14,5,72,19,18,30,41,260,116,23,62]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(E,k){const N=JSON.parse(E.content);if(E.version===1||E.version===2){const M=(await k.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of N)E.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),E.version===2&&M.every(T=>!(0,g.areSameExtensions)(T.identifier,$.identifier))&&($.installed=!0)}return N}function o(E){return JSON.parse(E.content)}e.parseExtensions=o;function s(E,k){return E.sort((N,M)=>!N.identifier.uuid&&M.identifier.uuid?-1:N.identifier.uuid&&!M.identifier.uuid?1:(0,I.compare)(N.identifier.id,M.identifier.id)),k?(0,L.toFormattedString)(E,{}):JSON.stringify(E)}e.stringify=s;let c=class extends C.AbstractSynchroniser{constructor(k,N,M,$,T,B,q,G,Q,re,K,W,F,J,ee,oe,ce){super({syncResource:"extensions",profile:k},N,$,M,T,B,q,W,F,re,K,ee),this.yb=G,this.zb=Q,this.Ab=ce,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(w),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,V=>V.some(({local:j})=>!!j)),A.Event.filter(this.yb.onDidUninstallExtension,V=>!V.error),A.Event.filter(oe.onDidChange,V=>V.valueChanges.some(({profile:j,changes:U})=>this.syncResource.profile.id===j.id&&U.some(z=>z.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),J.onDidChangeExtensionStorageToSync)(()=>this.M()))}async nb(k,N){const M=k.syncData?await r(k.syncData,this.yb):null,$=N?.skippedExtensions??[],T=N?.builtinExtensions??null,B=N?.syncData?await r(N.syncData,this.yb):null,{localExtensions:q,ignoredExtensions:G}=await this.xb.getLocalExtensions(this.syncResource.profile);M?this.J.trace(`${this.w}: Merging remote extensions with local extensions...`):this.J.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:Q,remote:re}=(0,t.merge)(q,M,B,$,G,T),K={local:Q,remote:re,content:this.Db(q,Q.added,Q.updated,Q.removed),localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:re!==null?2:0},W=this.Kb(q,!1);return[{skippedExtensions:$,builtinExtensions:T,baseResource:this.tb,baseContent:B?this.Kb(B,!1):W,localResource:this.ub,localContent:W,localExtensions:q,remoteResource:this.vb,remoteExtensions:M,remoteContent:M?this.Kb(M,!1):null,previewResource:this.sb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.wb}]}async rb(k){const N=k.syncData?await r(k.syncData,this.yb):null,{localExtensions:M,ignoredExtensions:$}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:T}=(0,t.merge)(M,N,N,k.skippedExtensions||[],$,k.builtinExtensions||[]);return T!==null}Db(k,N,M,$){const T=[...N,...M],B=new Set,q=G=>{B.add(G.id.toLowerCase()),G.uuid&&B.add(G.uuid)};T.forEach(({identifier:G})=>q(G)),$.forEach(q);for(const G of k)B.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&B.has(G.identifier.uuid)||T.push(G);return this.Kb(T,!1)}async ob(k,N){return{...k.previewResult,hasConflicts:!1}}async pb(k,N,M,$){if(this.h.isEqual(N,this.ub))return this.Gb(k);if(this.h.isEqual(N,this.vb))return this.Hb(k);if(this.h.isEqual(N,this.sb))return k.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(k){const N=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(N),$=(0,t.merge)(k.localExtensions,null,null,k.skippedExtensions,M,k.builtinExtensions),{local:T,remote:B}=$;return{content:k.localContent,local:T,remote:B,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:B!==null?2:0}}async Hb(k){const N=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(N),$=k.remoteContent?JSON.parse(k.remoteContent):null;if($!==null){const T=(0,t.merge)(k.localExtensions,$,k.localExtensions,[],M,k.builtinExtensions),{local:B,remote:q}=T;return{content:k.remoteContent,local:B,remote:q,localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:k.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(k,N,M,$){let{skippedExtensions:T,builtinExtensions:B,localExtensions:q}=M[0][0];const{local:G,remote:Q,localChange:re,remoteChange:K}=M[0][1];if(re===0&&K===0&&this.J.info(`${this.w}: No changes found during synchronizing extensions.`),re!==0&&(await this.kb(JSON.stringify(q)),T=await this.xb.updateLocalExtensions(G.added,G.removed,G.updated,T,this.syncResource.profile)),Q){this.J.trace(`${this.w}: Updating remote extensions...`);const W=JSON.stringify(Q.all);k=await this.jb(W,$?null:k.ref),this.J.info(`${this.w}: Updated remote extensions.${Q.added.length?` Added: ${JSON.stringify(Q.added.map(F=>F.identifier.id))}.`:""}${Q.updated.length?` Updated: ${JSON.stringify(Q.updated.map(F=>F.identifier.id))}.`:""}${Q.removed.length?` Removed: ${JSON.stringify(Q.removed.map(F=>F.identifier.id))}.`:""}`)}N?.ref!==k.ref&&(this.J.trace(`${this.w}: Updating last synchronized extensions...`),B=this.Jb(q,B),await this.cb(k,{skippedExtensions:T,builtinExtensions:B}),this.J.info(`${this.w}: Updated last synchronized extensions.${T.length?` Skipped: ${JSON.stringify(T.map(W=>W.identifier.id))}.`:""}`))}Jb(k,N){const M=new Set,$=[];for(const T of k)M.add(T.identifier.id.toLowerCase()),T.installed||$.push(T.identifier);if(N)for(const T of N)M.has(T.id.toLowerCase())||$.push(T);return $}async resolveContent(k){if(this.h.isEqual(this.vb,k)||this.h.isEqual(this.tb,k)||this.h.isEqual(this.ub,k)||this.h.isEqual(this.wb,k)){const N=await this.ab(k);return N&&this.Kb(JSON.parse(N),!0)}return null}Kb(k,N){return s(k,N)}async hasLocalData(){try{const{localExtensions:k}=await this.xb.getLocalExtensions(this.syncResource.profile);if(k.some(N=>N.installed||N.disabled))return!0}catch{}return!1}};c=ye([Y(2,P.IEnvironmentService),Y(3,p.IFileService),Y(4,d.IStorageService),Y(5,i.IUserDataSyncStoreService),Y(6,i.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,a.IIgnoredExtensionsManagementService),Y(9,i.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,i.IUserDataSyncEnablementService),Y(12,y.ITelemetryService),Y(13,f.IExtensionStorageService),Y(14,b.IUriIdentityService),Y(15,n.IUserDataProfileStorageService),Y(16,h.IInstantiationService)],c),e.ExtensionsSynchroniser=c;let w=class{constructor(k,N,M,$,T,B){this.a=k,this.b=N,this.c=M,this.d=$,this.f=T,this.g=B}async getLocalExtensions(k){const N=await this.a.getInstalled(void 0,k.extensionsResource),M=this.d.getIgnoredExtensions(N);return{localExtensions:await this.i(k,async(T,B)=>{const q=T.getDisabledExtensions();return N.map(G=>{const{identifier:Q,isBuiltin:re,manifest:K,preRelease:W,pinned:F}=G,J={identifier:Q,preRelease:W,version:K.version,pinned:!!F};q.some(ee=>(0,g.areSameExtensions)(ee,Q))&&(J.disabled=!0),re||(J.installed=!0);try{const ee=B.getKeysForSync({id:Q.id,version:K.version});if(ee){const oe=B.getExtensionState(G,!0)||{};J.state=Object.keys(oe).reduce((ce,V)=>(ee.includes(V)&&(ce[V]=oe[V]),ce),{})}}catch(ee){this.g.info(`${(0,C.getSyncResourceLogLabel)("extensions",k)}: Error while parsing extension state`,(0,l.getErrorMessage)(ee))}return J})}),ignoredExtensions:M}}async updateLocalExtensions(k,N,M,$,T){const B=(0,C.getSyncResourceLogLabel)("extensions",T),q=[],G=[],Q=[],re=await this.a.getInstalled(void 0,T.extensionsResource);if((k.length||M.length)&&await this.i(T,async(W,F)=>{await D.Promises.settled([...k,...M].map(async J=>{const ee=re.find(V=>(0,g.areSameExtensions)(V.identifier,J.identifier));if(ee&&ee.isBuiltin){J.state&&ee.manifest.version===J.version&&this.h(J.state,ee,ee.manifest.version,F),W.getDisabledExtensions().some(j=>(0,g.areSameExtensions)(j,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${B}: Disabling extension...`,J.identifier.id),await W.disableExtension(J.identifier),this.g.info(`${B}: Disabled extension`,J.identifier.id)):(this.g.trace(`${B}: Enabling extension...`,J.identifier.id),await W.enableExtension(J.identifier),this.g.info(`${B}: Enabled extension`,J.identifier.id))),G.push(J.identifier);return}const oe=J.pinned?J.version:void 0,ce=(await this.c.getExtensions([{...J.identifier,version:oe,preRelease:oe?void 0:J.preRelease}],O.CancellationToken.None))[0];if(J.state&&(ee?ee.manifest.version===J.version:!!ce)&&this.h(J.state,ee||ce,ee?.manifest.version,F),ce)try{W.getDisabledExtensions().some(j=>(0,g.areSameExtensions)(j,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${B}: Disabling extension...`,J.identifier.id,ce.version),await W.disableExtension(ce.identifier),this.g.info(`${B}: Disabled extension`,J.identifier.id,ce.version)):(this.g.trace(`${B}: Enabling extension...`,J.identifier.id,ce.version),await W.enableExtension(ce.identifier),this.g.info(`${B}: Enabled extension`,J.identifier.id,ce.version))),(!ee||ee.preRelease!==J.preRelease||ee.pinned!==J.pinned||oe&&ee.manifest.version!==oe)&&(await this.a.canInstall(ce)?q.push([J,ce]):(this.g.info(`${B}: Skipped synchronizing extension because it cannot be installed.`,ce.displayName||ce.identifier.id),Q.push(J)))}catch(V){Q.push(J),this.g.error(V),this.g.info(`${B}: Skipped synchronizing extension`,ce.displayName||ce.identifier.id)}else Q.push(J),this.g.info(`${B}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}))}),N.length){const W=re.filter(({identifier:F,isBuiltin:J})=>!J&&N.some(ee=>(0,g.areSameExtensions)(F,ee)));await D.Promises.settled(W.map(async F=>{this.g.trace(`${B}: Uninstalling local extension...`,F.identifier.id),await this.a.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:T.extensionsResource}),this.g.info(`${B}: Uninstalled local extension.`,F.identifier.id),G.push(F.identifier)}))}for(const[W,F]of q)try{this.g.trace(`${B}: Installing extension...`,F.identifier.id,F.version),await this.a.installFromGallery(F,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:W.pinned&&!!W.version,installPreReleaseVersion:W.preRelease,profileLocation:T.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${B}: Installed extension.`,F.identifier.id,F.version),G.push(F.identifier)}catch(J){Q.push(W),J instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.g.info(`${B}: Skipped synchronizing extension because the compatible extension is not found.`,F.displayName||F.identifier.id):(this.g.error(J),this.g.info(`${B}: Skipped synchronizing extension`,F.displayName||F.identifier.id))}const K=[];for(const W of $)G.some(F=>(0,g.areSameExtensions)(F,W.identifier))||K.push(W);for(const W of Q)K.some(F=>(0,g.areSameExtensions)(F.identifier,W.identifier))||K.push(W);return K}h(k,N,M,$){const T=$.getExtensionState(N,!0)||{},B=M?$.getKeysForSync({id:N.identifier.id,version:M}):void 0;B?B.forEach(q=>{T[q]=k[q]}):Object.keys(k).forEach(q=>T[q]=k[q]),$.setExtensionState(N,T,!0)}async i(k,N){return this.b.withProfileScopedStorageService(k,async M=>{const $=new R.DisposableStore,T=this.f.createChild(new u.ServiceCollection([d.IStorageService,M])),B=$.add(T.createInstance(v.GlobalExtensionEnablementService)),q=$.add(T.createInstance(f.ExtensionStorageService));try{return await N(B,q)}finally{$.dispose()}})}};w=ye([Y(0,m.IExtensionManagementService),Y(1,n.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,a.IIgnoredExtensionsManagementService),Y(4,h.IInstantiationService),Y(5,i.IUserDataSyncLogService)],w),e.LocalExtensionsProvider=w}),define(ne[120],se([0,1,17,8,3,35,42,4,31,16,15,14,11,44,19,18,30,41,61,264,23,62,5]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const a="globalState.argv.",i=["locale"];function n(w,E){const k=w.storage?Object.keys(w.storage).sort():[],N={};return k.forEach(M=>N[M]=w.storage[M]),w.storage=N,E?(0,L.toFormattedString)(w,{}):JSON.stringify(w)}e.stringify=n;const r=1;let o=class extends u.AbstractSynchroniser{constructor(E,k,N,M,$,T,B,q,G,Q,re,K,W,F){super({syncResource:"globalState",profile:E},k,M,q,K,$,T,G,Q,B,re,W),this.xb=N,this.mb=r,this.r=this.h.joinPath(this.g,"globalState.json"),this.sb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=F.createInstance(s),this.B(M.watch(this.h.dirname(this.C.argvResource))),this.B(l.Event.any(l.Event.filter(M.onDidFilesChange,J=>J.contains(this.C.argvResource)),l.Event.filter(N.onDidChange,J=>!!(J.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||J.valueChanges.some(({profile:ee,changes:oe})=>this.syncResource.profile.id===ee.id&&oe.some(ce=>ce.target===0)))))(()=>this.M()))}async nb(E,k,N){const M=E.syncData?JSON.parse(E.syncData.content):null;k=k===null&&N?E:k;const $=k&&k.syncData?JSON.parse(k.syncData.content):null,T=await this.wb.getLocalGlobalState(this.syncResource.profile);M?this.J.trace(`${this.w}: Merging remote ui state with local ui state...`):this.J.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=await this.Fb($),{local:q,remote:G}=(0,y.merge)(T.storage,M?M.storage:null,$?$.storage:null,B,this.J),Q={content:null,local:q,remote:G,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:G.all!==null?2:0},re=n(T,!1);return[{baseResource:this.sb,baseContent:$?n($,!1):re,localResource:this.tb,localContent:re,localUserData:T,remoteResource:this.ub,remoteContent:M?n(M,!1):null,previewResource:this.r,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.vb,storageKeys:B}]}async rb(E){const k=E.syncData?JSON.parse(E.syncData.content):null;if(k===null)return!0;const N=await this.wb.getLocalGlobalState(this.syncResource.profile),M=await this.Fb(k),{remote:$}=(0,y.merge)(N.storage,k.storage,k.storage,M,this.J);return $.all!==null}async ob(E,k){return{...E.previewResult,hasConflicts:!1}}async pb(E,k,N,M){if(this.h.isEqual(k,this.tb))return this.Cb(E);if(this.h.isEqual(k,this.ub))return this.Db(E);if(this.h.isEqual(k,this.r))return E.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async Cb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:0,remoteChange:2}}async Db(E){if(E.remoteContent!==null){const k=JSON.parse(E.remoteContent),{local:N,remote:M}=(0,y.merge)(E.localUserData.storage,k.storage,null,E.storageKeys,this.J);return{content:E.remoteContent,local:N,remote:M,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(E,k,N,M){const{localUserData:$}=N[0][0],{local:T,remote:B,localChange:q,remoteChange:G}=N[0][1];if(q===0&&G===0&&this.J.info(`${this.w}: No changes found during synchronizing ui state.`),q!==0&&(this.J.trace(`${this.w}: Updating local ui state...`),await this.kb(JSON.stringify($)),await this.wb.writeLocalGlobalState(T,this.syncResource.profile),this.J.info(`${this.w}: Updated local ui state`)),G!==0){this.J.trace(`${this.w}: Updating remote ui state...`);const Q=JSON.stringify({storage:B.all});E=await this.jb(Q,M?null:E.ref),this.J.info(`${this.w}: Updated remote ui state.${B.added.length?` Added: ${B.added}.`:""}${B.updated.length?` Updated: ${B.updated}.`:""}${B.removed.length?` Removed: ${B.removed}.`:""}`)}k?.ref!==E.ref&&(this.J.trace(`${this.w}: Updating last synchronized ui state...`),await this.cb(E),this.J.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.ub,E)||this.h.isEqual(this.sb,E)||this.h.isEqual(this.tb,E)||this.h.isEqual(this.vb,E)){const k=await this.ab(E);return k&&n(JSON.parse(k),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(E){const k=await this.xb.readStorageData(this.syncResource.profile),N=[],M=[];for(const[B,q]of k)q.target===0?N.push(B):q.target===1&&M.push(B);const $=[...N,...M],T=E?.storage?Object.keys(E.storage).filter(B=>!B.startsWith(a)&&!$.includes(B)&&k.get(B)!==void 0):[];if(!R.isWeb){const B=[...b.ALL_SYNC_RESOURCES.map(q=>(0,b.getEnablementKey)(q)),b.SYNC_SERVICE_URL_TYPE];T.push(...B),M.push(...B)}return{user:N,machine:M,unregistered:T}}};o=ye([Y(2,C.IUserDataProfileStorageService),Y(3,v.IFileService),Y(4,b.IUserDataSyncStoreService),Y(5,b.IUserDataSyncBackupStoreService),Y(6,b.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,b.IUserDataSyncEnablementService),Y(9,p.ITelemetryService),Y(10,S.IConfigurationService),Y(11,f.IStorageService),Y(12,h.IUriIdentityService),Y(13,t.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let s=class{constructor(E,k,N,M){this.a=E,this.b=k,this.c=N,this.d=M}async getLocalGlobalState(E){const k={};if(E.isDefault){const M=await this.f(),$=(0,A.parse)(M);for(const T of i)$[T]!==void 0&&(k[`${a}${T}`]={version:1,value:$[T]})}const N=await this.c.readStorageData(E);for(const[M,$]of N)$.value&&$.target===0&&(k[M]={version:1,value:$.value});return{storage:k}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,O.getErrorMessage)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:k,updated:N},M){const $=(0,u.getSyncResourceLogLabel)("globalState",M),T={},B=new Map,q=await this.c.readStorageData(M),G=(Q,re)=>{for(const K of Q){if(K.startsWith(a)){T[K.substring(a.length)]=re?re[K].value:void 0;continue}if(re){const W=re[K];W.value!==q.get(K)?.value&&B.set(K,W.value)}else q.get(K)!==void 0&&B.set(K,void 0)}};if(G(Object.keys(E),E),G(Object.keys(N),N),G(k),Object.keys(T).length){this.d.trace(`${$}: Updating locale...`);const Q=await this.f();let re=Q;for(const K of Object.keys(T))re=(0,d.edit)(re,[K],T[K],{});Q!==re&&(this.d.trace(`${$}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.VSBuffer.fromString(re)),this.d.info(`${$}: Updated locale.`)),this.d.info(`${$}: Updated locale`)}B.size&&(this.d.trace(`${$}: Updating global state...`),await this.c.updateStorageData(M,B,0),this.d.info(`${$}: Updated global state`,[...B.keys()]))}};s=ye([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,C.IUserDataProfileStorageService),Y(3,b.IUserDataSyncLogService)],s),e.LocalGlobalStateProvider=s;let c=class{constructor(E,k,N,M,$){this.a=E,this.b=k,this.c=N,this.d=M,this.f=$}getSyncStoreType(E){return this.h(E)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(E){const k=(0,b.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(E,k)}catch(N){if(N instanceof b.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,k)}throw N}}async g(E,k){const N=await this.a.readResource("globalState",null,void 0,k),M=this.h(N)||{storage:{}};M.storage[b.SYNC_SERVICE_URL_TYPE]={value:E,version:r};const $=await(0,g.getServiceMachineId)(this.c,this.d,this.b),T={version:r,machineId:$,content:n(M,!1)};await this.a.writeResource("globalState",JSON.stringify(T),N.ref,void 0,k)}h({content:E}){if(!E)return null;const k=JSON.parse(E);if((0,u.isSyncData)(k))return k?JSON.parse(k.content):null;throw new Error("Invalid remote data")}};c=ye([Y(1,f.IStorageService),Y(2,P.IEnvironmentService),Y(3,v.IFileService),Y(4,m.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[121],se([0,1,20,3,35,4,12,181,16,15,14,19,18,30,41,261,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(y,b,C){try{const t=JSON.parse(y);if(!b)return(0,L.isUndefined)(t.all)?null:t.all;switch(A.OS){case 2:return(0,L.isUndefined)(t.mac)?null:t.mac;case 3:return(0,L.isUndefined)(t.linux)?null:t.linux;case 1:return(0,L.isUndefined)(t.windows)?null:t.windows}}catch(t){return C.error(t),null}}e.getKeybindingsContentFromSyncContent=u;let d=class extends f.AbstractJsonFileSynchroniser{constructor(b,C,t,a,i,n,r,o,s,c,w,E,k){super(b.keybindingsResource,{syncResource:"keybindings",profile:b},C,o,s,c,t,a,r,E,i,w,n,k),this.mb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(O.Event.filter(n.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.M()))}async nb(b,C,t,a){const i=b.syncData?u(b.syncData.content,a.keybindingsPerPlatform??this.Mb(),this.J):null;C=C===null&&t?b:C;const n=C?this.Kb(C):null,r=await this.r(),o=await this.yb();let s=null,c=!1,w=!1,E=!1;if(i){let M=r?r.value.toString():"[]";if(M=M||"[]",this.wb(M,!0))throw new h.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource);if(!n||n!==M||n!==i){this.J.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const $=await(0,p.merge)(M,i,n,o,this.vb);$.hasChanges&&(s=$.mergeContent,E=$.hasConflicts,c=E||$.mergeContent!==M,w=E||$.mergeContent!==i)}}else r&&(this.J.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),s=r.value.toString(),w=!0);const k={content:E?n:s,localChange:c?r?2:1:0,remoteChange:w?2:0,hasConflicts:E},N=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:n,localResource:this.Cb,localContent:N,localChange:k.localChange,remoteResource:this.Db,remoteContent:i,remoteChange:k.remoteChange,previewResource:this.Ab,previewResult:k,acceptedResource:this.Eb}]}async rb(b){const C=this.Kb(b);if(C===null)return!0;const t=await this.r(),a=t?t.value.toString():"",i=await this.yb(),n=await(0,p.merge)(a||"[]",C,C,i,this.vb);return n.hasConflicts||n.mergeContent!==C}async ob(b,C){return b.previewResult}async pb(b,C,t,a){if(this.h.isEqual(C,this.Cb))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(C,this.Db))return{content:b.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(C,this.Ab))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async qb(b,C,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing keybindings.`),n!==null&&(n=n.trim(),n=n||"[]",this.wb(n,!0)))throw new h.UserDataSyncError((0,R.localize)(1,null),"LocalInvalidContent",this.resource);if(r!==0&&(this.J.trace(`${this.w}: Updating local keybindings...`),i&&await this.kb(this.Lb(i.value.toString())),await this.sb(n||"[]",i,a),this.J.info(`${this.w}: Updated local keybindings`)),o!==0){this.J.trace(`${this.w}: Updating remote keybindings...`);const s=this.Lb(n||"[]",b.syncData?.content);b=await this.jb(s,a?null:b.ref),this.J.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}C?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized keybindings...`),await this.cb(b,{platformSpecific:this.Mb()}),this.J.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const b=await this.r();if(b){const C=(0,l.parse)(b.value.toString());if((0,D.isNonEmptyArray)(C))return!0}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.Db,b)||this.h.isEqual(this.Bb,b)||this.h.isEqual(this.Cb,b)||this.h.isEqual(this.Eb,b)?this.ab(b):null}Kb(b){return!b.syncData||b.platformSpecific!==void 0&&b.platformSpecific!==this.Mb()?null:u(b.syncData.content,this.Mb(),this.J)}Lb(b,C){let t={};try{t=JSON.parse(C||"{}")}catch(a){this.J.error(a)}switch(this.Mb()?delete t.all:t.all=b,A.OS){case 2:t.mac=b;break;case 3:t.linux=b;break;case 1:t.windows=b;break}return JSON.stringify(t)}Mb(){return!!this.L.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};d=ye([Y(2,h.IUserDataSyncStoreService),Y(3,h.IUserDataSyncBackupStoreService),Y(4,h.IUserDataSyncLogService),Y(5,I.IConfigurationService),Y(6,h.IUserDataSyncEnablementService),Y(7,P.IFileService),Y(8,S.IEnvironmentService),Y(9,v.IStorageService),Y(10,h.IUserDataSyncUtilService),Y(11,m.ITelemetryService),Y(12,g.IUriIdentityService)],d),e.KeybindingsSynchroniser=d}),define(ne[122],se([0,1,3,182,16,74,15,29,14,19,18,30,41,61,265,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(y){return y&&y.settings&&typeof y.settings=="string"&&Object.keys(y).length===1}function u(y){const b=JSON.parse(y);return h(b)?b:{settings:y}}e.parseSettingsSyncContent=u;let d=class extends m.AbstractJsonFileSynchroniser{constructor(b,C,t,a,i,n,r,o,s,c,w,E,k,N){super(b.settingsResource,{syncResource:"settings",profile:b},C,t,a,i,n,r,w,E,o,s,c,N),this.Ab=k,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(b){const C=await this.getLastSyncUserData(),t=await this.R(b,C),a=this.Hb(t),i=new A.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&i.parse(a.settings),i.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(b,C,t){const a=await this.r(),i=await this.yb(),n=this.Hb(b);C=C===null&&t?b:C;const r=C?this.Hb(C):null,o=await this.Lb();let s=null,c=!1,w=!1,E=!1;if(n){let $=a?a.value.toString().trim():"{}";$=$||"{}",this.Mb($),this.J.trace(`${this.w}: Merging remote settings with local settings...`);const T=(0,f.merge)($,n.settings,r?r.settings:null,o,[],i);s=T.localContent||T.remoteContent,c=T.localContent!==null,w=T.remoteContent!==null,E=T.hasConflicts}else a&&(this.J.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),s=a.value.toString().trim()||"{}",this.Mb(s),w=!0);const k=a?a.value.toString():null,N=r?.settings??null,M={content:E?N:s,localChange:c?2:0,remoteChange:w?2:0,hasConflicts:E};return[{fileContent:a,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:k,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:n?n.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async rb(b){const C=this.Hb(b);if(C===null)return!0;const t=await this.r(),a=t?t.value.toString().trim():"",i=await this.Lb(),n=await this.yb();return(0,f.merge)(a||"{}",C.settings,C.settings,i,[],n).remoteContent!==null}async ob(b,C){const t=await this.yb(),a=await this.Lb();return{...b.previewResult,content:b.previewResult.content?(0,f.updateIgnoredSettings)(b.previewResult.content,"{}",a,t):null}}async pb(b,C,t,a){const i=await this.yb(),n=await this.Lb();if(this.h.isEqual(C,this.localResource))return{content:b.fileContent?(0,f.updateIgnoredSettings)(b.fileContent.value.toString(),"{}",n,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(C,this.remoteResource))return{content:b.remoteContent!==null?(0,f.updateIgnoredSettings)(b.remoteContent,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(C,this.previewResource))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t!==null?(0,f.updateIgnoredSettings)(t,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async qb(b,C,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing settings.`),n=n?n.trim():"{}",n=n||"{}",this.Mb(n),r!==0&&(this.J.trace(`${this.w}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Jb(i.value.toString()))),await this.sb(n,i,a),await this.L.reloadConfiguration(3),this.J.info(`${this.w}: Updated local settings`)),o!==0){const s=await this.yb(),c=this.Hb(b),w=await this.Lb(n);n=(0,f.updateIgnoredSettings)(n,c?c.settings:"{}",w,s),this.J.trace(`${this.w}: Updating remote settings...`),b=await this.jb(JSON.stringify(this.Jb(n)),a?null:b.ref),this.J.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}C?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized settings...`),await this.cb(b),this.J.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const b=await this.r();if(b){const C=await this.yb(),t=(0,g.edit)(b.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,C);return!(0,f.isEmpty)(t)}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.remoteResource,b)||this.h.isEqual(this.localResource,b)||this.h.isEqual(this.acceptedResource,b)||this.h.isEqual(this.baseResource,b)?this.ab(b):null}async ab(b){let C=await super.ab(b);if(C){const t=await this.yb(),a=await this.Lb();C=(0,f.updateIgnoredSettings)(C,"{}",a,t)}return C}Hb(b){return b.syncData?this.Ib(b.syncData.content):null}Ib(b){try{return u(b)}catch(C){this.J.error(C)}return null}Jb(b){return{settings:b}}async Lb(b){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const t=D.Event.any(D.Event.filter(this.Ab.onDidInstallExtensions,a=>a.some(({local:i})=>!!i)),D.Event.filter(this.Ab.onDidUninstallExtension,a=>!a.error))(()=>{t.dispose(),this.Kb=void 0})}const C=await this.Kb;return(0,f.getIgnoredSettings)(C,this.L,b)}Mb(b){if(this.wb(b,!1))throw new p.UserDataSyncError((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};d=ye([Y(2,I.IFileService),Y(3,L.IEnvironmentService),Y(4,S.IStorageService),Y(5,p.IUserDataSyncStoreService),Y(6,p.IUserDataSyncBackupStoreService),Y(7,p.IUserDataSyncLogService),Y(8,p.IUserDataSyncUtilService),Y(9,l.IConfigurationService),Y(10,p.IUserDataSyncEnablementService),Y(11,P.ITelemetryService),Y(12,R.IExtensionManagementService),Y(13,v.IUriIdentityService)],d),e.SettingsSynchroniser=d}),define(ne[123],se([0,1,17,3,32,16,15,14,19,18,30,41,262,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsSynchroniser=e.parseSnippets=void 0;function f(h){return JSON.parse(h.content)}e.parseSnippets=f;let p=class extends v.AbstractSynchroniser{constructor(u,d,y,b,C,t,a,i,n,r,o,s){super({syncResource:"snippets",profile:u},d,b,y,C,t,a,r,o,i,n,s),this.mb=1,this.r=u.snippetsHome,this.B(this.z.watch(y.userRoamingDataHome)),this.B(this.z.watch(this.r)),this.B(O.Event.filter(this.z.onDidFilesChange,c=>c.affects(this.r))(()=>this.M()))}async nb(u,d,y){const b=await this.Db(),C=this.Cb(b),t=u.syncData?this.Bb(u.syncData):null;d=d===null&&y?u:d;const a=d&&d.syncData?this.Bb(d.syncData):null;t?this.J.trace(`${this.w}: Merging remote snippets with local snippets...`):this.J.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,m.merge)(C,t,a);return this.xb(i,b,t||{},a||{})}async rb(u){const d=u.syncData?this.Bb(u.syncData):null;if(d===null)return!0;const y=await this.Db(),b=this.Cb(y),C=(0,m.merge)(b,d,d);return Object.keys(C.remote.added).length>0||Object.keys(C.remote.updated).length>0||C.remote.removed.length>0||C.conflicts.length>0}async ob(u,d){return u.previewResult}async pb(u,d,y,b){if(this.h.isEqualOrParent(d,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return y===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:y,localChange:y===null?u.fileContent!==null?3:0:2,remoteChange:y===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(u,d,y,b){const C=y.map(([t,a])=>({...t,acceptResult:a}));C.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.J.info(`${this.w}: No changes found during synchronizing snippets.`),C.some(({localChange:t})=>t!==0)&&(await this.yb(C),await this.zb(C,b)),C.some(({remoteChange:t})=>t!==0)&&(u=await this.Ab(C,u,b)),d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized snippets...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:t}of C)try{await this.z.del(t)}catch{}}xb(u,d,y,b){const C=new Map;for(const t of Object.keys(u.local.added)){const a={content:u.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.local.updated)){const a={content:u.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.added)){const a={content:u.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.updated)){const a={content:u.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.conflicts){const a={content:b[t]??null,hasConflicts:!0,localChange:d[t]?2:1,remoteChange:y[t]?2:1},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d))if(!C.has(t)){const a={content:d[t]?d[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...C.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(u):null}async hasLocalData(){try{const u=await this.Db();if(Object.keys(u).length)return!0}catch{}return!1}async yb(u){const d={};for(const y of u)y.fileContent&&(d[this.h.basename(y.localResource)]=y.fileContent);await this.kb(JSON.stringify(this.Cb(d)))}async zb(u,d){for(const{fileContent:y,acceptResult:b,localResource:C,remoteResource:t,localChange:a}of u)if(a!==0){const i=t?this.h.basename(t):this.h.basename(C),n=this.h.joinPath(this.r,i);a===3?(this.J.trace(`${this.w}: Deleting snippet...`,this.h.basename(n)),await this.z.del(n),this.J.info(`${this.w}: Deleted snippet`,this.h.basename(n))):a===1?(this.J.trace(`${this.w}: Creating snippet...`,this.h.basename(n)),await this.z.createFile(n,D.VSBuffer.fromString(b.content),{overwrite:d}),this.J.info(`${this.w}: Created snippet`,this.h.basename(n))):(this.J.trace(`${this.w}: Updating snippet...`,this.h.basename(n)),await this.z.writeFile(n,D.VSBuffer.fromString(b.content),d?void 0:y),this.J.info(`${this.w}: Updated snippet`,this.h.basename(n)))}}async Ab(u,d,y){const b=d.syncData?this.Bb(d.syncData):{},C=(0,l.deepClone)(b);for(const{acceptResult:t,localResource:a,remoteResource:i,remoteChange:n}of u)if(n!==0){const r=a?this.h.basename(a):this.h.basename(i);n===3?delete C[r]:C[r]=t.content}return(0,m.areSame)(b,C)||(this.J.trace(`${this.w}: Updating remote snippets...`),d=await this.jb(JSON.stringify(C),y?null:d.ref),this.J.info(`${this.w}: Updated remote snippets`)),d}Bb(u){return f(u)}Cb(u){const d={};for(const y of Object.keys(u))d[y]=u[y].value.toString();return d}async Db(){const u={};let d;try{d=await this.z.resolve(this.r)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return u;throw y}for(const y of d.children||[]){const b=y.resource,C=this.h.extname(b);if(C===".json"||C===".code-snippets"){const t=this.h.relativePath(this.r,b),a=await this.z.readFile(b);u[t]=a}}return u}};p=ye([Y(2,L.IEnvironmentService),Y(3,R.IFileService),Y(4,I.IStorageService),Y(5,g.IUserDataSyncStoreService),Y(6,g.IUserDataSyncBackupStoreService),Y(7,g.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,g.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,P.IUriIdentityService)],p),e.SnippetsSynchroniser=p}),define(ne[124],se([0,1,16,15,14,19,18,30,41,23]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function P(g,f){try{return JSON.parse(g).tasks??null}catch(p){return f.error(p),null}}e.getTasksContentFromSyncContent=P;let v=class extends I.AbstractFileSynchroniser{constructor(f,p,h,u,d,y,b,C,t,a,i,n){super(f.tasksResource,{syncResource:"tasks",profile:f},p,C,t,a,h,u,b,i,d,y,n),this.mb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(f,p,h,u){const d=f.syncData?P(f.syncData.content,this.J):null;p=p===null&&h?f:p;const y=p?.syncData?P(p.syncData.content,this.J):null,b=await this.r();let C=null,t=!1,a=!1,i=!1;if(f.syncData){const o=b?b.value.toString():null;if(!y||y!==o||y!==d){this.J.trace(`${this.w}: Merging remote tasks with local tasks...`);const s=m(o,d,y);C=s.content,i=s.hasConflicts,t=s.hasLocalChanged,a=s.hasRemoteChanged}}else b&&(this.J.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),C=b.value.toString(),a=!0);const n={content:i?y:C,localChange:t?b?2:1:0,remoteChange:a?2:0,hasConflicts:i},r=b?b.value.toString():null;return[{fileContent:b,baseResource:this.xb,baseContent:y,localResource:this.yb,localContent:r,localChange:n.localChange,remoteResource:this.zb,remoteContent:d,remoteChange:n.remoteChange,previewResource:this.wb,previewResult:n,acceptedResource:this.Ab}]}async rb(f){const p=f?.syncData?P(f.syncData.content,this.J):null;if(p===null)return!0;const h=await this.r(),u=h?h.value.toString():null,d=m(u,p,p);return d.hasLocalChanged||d.hasRemoteChanged}async ob(f,p){return f.previewResult}async pb(f,p,h,u){if(this.h.isEqual(p,this.yb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(p,this.zb))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(p,this.wb))return h===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async qb(f,p,h,u){const{fileContent:d}=h[0][0],{content:y,localChange:b,remoteChange:C}=h[0][1];if(b===0&&C===0&&this.J.info(`${this.w}: No changes found during synchronizing tasks.`),b!==0&&(this.J.trace(`${this.w}: Updating local tasks...`),d&&await this.kb(JSON.stringify(this.Gb(d.value.toString()))),y?await this.sb(y,d,u):await this.tb(),this.J.info(`${this.w}: Updated local tasks`)),C!==0){this.J.trace(`${this.w}: Updating remote tasks...`);const t=JSON.stringify(this.Gb(y));f=await this.jb(t,u?null:f.ref),this.J.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}p?.ref!==f.ref&&(this.J.trace(`${this.w}: Updating last synchronized tasks...`),await this.cb(f),this.J.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.p)}async resolveContent(f){return this.h.isEqual(this.zb,f)||this.h.isEqual(this.xb,f)||this.h.isEqual(this.yb,f)||this.h.isEqual(this.Ab,f)?this.ab(f):null}Gb(f){return f?{tasks:f}:{}}};v=ye([Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncBackupStoreService),Y(4,S.IUserDataSyncLogService),Y(5,D.IConfigurationService),Y(6,S.IUserDataSyncEnablementService),Y(7,l.IFileService),Y(8,O.IEnvironmentService),Y(9,A.IStorageService),Y(10,L.ITelemetryService),Y(11,R.IUriIdentityService)],v),e.TasksSynchroniser=v;function m(g,f,p){if(g===null&&f===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=p!==g,u=p!==f;return!h&&!u?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!u?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:u&&!h?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[125],se([0,1,42,16,15,14,19,18,30,28,41,263,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let g=class extends P.AbstractSynchroniser{constructor(u,d,y,b,C,t,a,i,n,r,o,s,c){super({syncResource:"profiles",profile:u},d,b,C,t,a,i,o,s,n,r,c),this.sb=y,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),y=await this.R(u,d);return y?.syncData?p(y.syncData):null}async nb(u,d,y){if(!this.sb.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=u.syncData?p(u.syncData):null,C=d?.syncData?p(d.syncData):null,t=this.Ab(),{local:a,remote:i}=(0,v.merge)(t,b,C,[]),n={local:a,remote:i,content:C?this.Bb(C):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:i!==null?2:0},r=f(t,!1);return[{baseResource:this.baseResource,baseContent:C?this.Bb(C):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:b?this.Bb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(u){const d=u?.syncData?p(u.syncData):null,y=this.Ab(),{remote:b}=(0,v.merge)(y,d,d,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async ob(u,d){return{...u.previewResult,hasConflicts:!1}}async pb(u,d,y,b){if(this.h.isEqual(d,this.localResource))return this.xb(u);if(this.h.isEqual(d,this.remoteResource))return this.yb(u);if(this.h.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async xb(u){const d=this.Ab(),y=(0,v.merge)(d,null,null,[]),{local:b,remote:C}=y;return{content:u.localContent,local:b,remote:C,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:C!==null?2:0}}async yb(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,y=[],b=[];for(const C of this.Ab()){const t=d?.find(a=>a.id===C.id);t&&(y.push({id:C.id,name:C.name,collection:t.collection}),b.push(C))}if(d!==null){const C=(0,v.merge)(b,d,y,[]),{local:t,remote:a}=C;return{content:u.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(u,d,y,b){const{local:C,remote:t,localChange:a,remoteChange:i}=y[0][1];a===0&&i===0&&this.J.info(`${this.w}: No changes found during synchronizing profiles.`);const n=y[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.kb(f(this.Ab(),!1));const r=[];for(const o of C.added)r.push((async()=>{this.J.trace(`${this.w}: Creating '${o.name}' profile...`),await this.sb.createProfile(o.id,o.name,{shortName:o.shortName}),this.J.info(`${this.w}: Created profile '${o.name}'.`)})());for(const o of C.removed)r.push((async()=>{this.J.trace(`${this.w}: Removing '${o.name}' profile...`),await this.sb.removeProfile(o),this.J.info(`${this.w}: Removed profile '${o.name}'.`)})());for(const o of C.updated){const s=this.sb.profiles.find(c=>c.id===o.id);s?r.push((async()=>{this.J.trace(`${this.w}: Updating '${o.name}' profile...`),await this.sb.updateProfile(s,{name:o.name,shortName:o.shortName}),this.J.info(`${this.w}: Updated profile '${o.name}'.`)})()):this.J.info(`${this.w}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(r)}if(i!==0){this.J.trace(`${this.w}: Updating remote profiles...`);const r=[],o=n.length+(t?.added.length??0)<=20;if(o)for(const s of t?.added||[]){const c=await this.F.createCollection(this.y);r.push(c),n.push({id:s.id,name:s.name,collection:c,shortName:s.shortName})}else this.J.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const s of t?.removed||[])n.splice(n.findIndex(({id:c})=>s.id===c),1);for(const s of t?.updated||[]){const c=n.find(({id:w})=>s.id===w);c&&n.splice(n.indexOf(c),1,{id:s.id,name:s.name,collection:c.collection,shortName:s.shortName})}try{u=await this.updateRemoteProfiles(n,b?null:u.ref),this.J.info(`${this.w}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(s=>s.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(s=>s.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(s=>s.name))}.`:""}`)}catch(s){if(r.length){this.J.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const c of r)await this.F.deleteCollection(c,this.y)}throw s}for(const s of t?.removed||[])await this.F.deleteCollection(s.collection,this.y)}d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized profiles...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.jb(this.Bb(u),d)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const d=await this.ab(u);return d&&(0,D.toFormattedString)(JSON.parse(d),{})}return null}Ab(){return this.sb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((d,y)=>d.name.localeCompare(y.name)))}};g=ye([Y(2,S.IUserDataProfilesService),Y(3,A.IFileService),Y(4,l.IEnvironmentService),Y(5,L.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,O.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,I.IUriIdentityService)],g),e.UserDataProfilesManifestSynchroniser=g;function f(h,u){const d=[...h].sort((y,b)=>y.name.localeCompare(b.name)).map(y=>({id:y.id,name:y.name}));return u?(0,D.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=f;function p(h){return JSON.parse(h.content)}e.parseUserDataProfilesManifest=p}),define(ne[279],se([0,1,6,17,65,2,22,16,15,14,28,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends A.Disposable{constructor(f,p,h,u,d){super(),this.a=f,this.b=p,this.c=h,this.f=u,this.g=d,this.h()}async h(){for(const p of this.g.profiles)for(const h of v.ALL_SYNC_RESOURCES)try{await this.j(this.i(p,h))}catch(u){this.f.error(u)}let f;try{f=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,S.toFileOperationResult)(p)!==1&&this.f.error(p);return}if(f.children){for(const p of f.children)if(p.isDirectory&&!this.g.profiles.some(h=>h.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(h){this.f.error(h)}}}async getAllRefs(f,p){const h=this.i(f,p);try{const u=await this.b.resolve(h);if(u.children)return u.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.k(y)}))}catch(u){if((0,S.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(f,p,h){const u=this.i(f,p),d=(0,L.joinPath)(u,h);try{return(await this.b.readFile(d)).value.toString()}catch(y){return this.f.error(y),null}}async backup(f,p,h){const u=this.i(f,p),d=(0,L.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,O.VSBuffer.fromString(h))}catch(y){this.f.error(y)}try{this.j(u)}catch{}}i(f,p){return(0,L.joinPath)(this.a.userDataSyncHome,...f.isDefault?[p]:[f.id,p])}async j(f){try{try{if(!await this.b.exists(f))return}catch{return}const p=await this.b.resolve(f);if(p.children){const h=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=h.filter(b=>Date.now()-this.k(b)>u);const y=h.length-d.length;y<10&&(d=d.slice(10-y)),await D.Promises.settled(d.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(p){this.f.error(p)}}k(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};m=ye([Y(0,I.IEnvironmentService),Y(1,S.IFileService),Y(2,R.IConfigurationService),Y(3,v.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(ne[280],se([0,1,3,2,4,15,19,18,23]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let P=class extends O.Disposable{constructor(m,g,f,p){super(),this.c=m,this.f=g,this.g=f,this.h=p,this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new D.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(h=>this.j(h)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:m}),this.c.store(S,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,I.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,g){if(this.isResourceEnabled(m)!==g){const f=(0,I.getEnablementKey)(m);this.i(f,g)}}getResourceSyncStateVersion(m){}i(m,g){this.c.store(m,g,-1,l.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(S===m.key){this.a.fire(this.isEnabled());return}const g=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===m.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};P=ye([Y(0,L.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[81],se([0,1,3,2,4,26,186,15,14,5,25,44,19,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",p="Safari",h="Chrome",u="Edge",d="Firefox",y="Android";function b(a){switch(a){case p:case h:case u:case d:case y:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function C(){return l.isSafari?p:l.isChrome?h:l.isEdge?u:l.isFirefox?d:l.isAndroid?y:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let t=class it extends O.Disposable{constructor(i,n,r,o,s,c){super(),this.h=r,this.i=o,this.j=s,this.k=c,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.getServiceMachineId)(i,n,r)}async getMachines(i){const n=await this.f;return(await this.m(i)).machines.map(o=>({...o,isCurrent:o.id===n}))}async addCurrentMachine(i){const n=await this.f,r=await this.m(i);r.machines.some(({id:o})=>o===n)||(r.machines.push({id:n,name:this.l(r.machines),platform:C()}),await this.n(r))}async removeCurrentMachine(i){const n=await this.f,r=await this.m(i),o=r.machines.filter(({id:s})=>s!==n);o.length!==r.machines.length&&(r.machines=o,await this.n(r))}async renameMachine(i,n,r){const o=await this.m(r),s=o.machines.find(({id:c})=>c===i);if(s){s.name=n,await this.n(o);const c=await this.f;i===c&&this.h.store(f,n,-1,1)}}async setEnablements(i){const n=await this.m();for(const[r,o]of i){const s=n.machines.find(c=>c.id===r);s&&(s.disabled=o?void 0:!0)}await this.n(n)}l(i){const n=this.h.get(f,-1);if(n)return n;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${C()} (${this.k.nameShort})`,o=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let s=0;for(const c of i){const w=o.exec(c.name),E=w?parseInt(w[1]):0;s=E>s?E:s}return`${r} #${s+1}`}async m(i){this.g=await this.p(i);const n=this.r(this.g);if(n.version!==it.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return n}async n(i){const n=JSON.stringify(i),r=await this.i.writeResource(it.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async p(i){if(this.g){const n=i&&i.latest?i.latest[it.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.j.error(n)}return{version:it.a,machines:[]}}};t.a=1,t.b="machines",t=ye([Y(0,R.IEnvironmentService),Y(1,I.IFileService),Y(2,m.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,P.IProductService)],t),e.UserDataSyncMachinesService=t}),define(ne[281],se([0,1,6,65,38,8,3,2,4,22,10,183,25,19,18,23,78,81]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",y="sync.sessionId",b="sync.storeUrl",C="sync.productQuality";let t=class extends R.Disposable{get j(){const n=this.z.get(b,-1);return n?P.URI.parse(n):void 0}set j(n){n?this.z.store(b,n.toString(),-1,1):this.z.remove(b,-1)}get l(){return this.z.get(C,-1)}set l(n){n?this.z.store(C,n,-1,1):this.z.remove(C,-1)}constructor(n,r,o,s,c,w,E,k,N,M){super(),this.n=r,this.p=o,this.r=s,this.s=c,this.u=w,this.v=E,this.w=k,this.y=N,this.z=M,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new D.ThrottledDelayer(this.O())),this.i=this.j,this.j=r.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(r.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,r.userDataSyncStore?.url)||(this.i=this.j,this.j=r.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(c.onDidChangeLocal($=>this.triggerSync([$],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:r}=this.F();n?this.a.value===void 0&&(this.a.value=new a(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(r&&this.u.info(r),this.a.clear()):r&&this.r.isEnabled()&&this.u.info(r))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,r,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(y,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(s){if(this.u.error(s),r)this.G(!1);else throw s}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const r=p.UserDataSyncError.toUserDataSyncError(n);r instanceof p.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:r.code,service:this.n.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?I.isWeb&&r.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(r),this.b++),this.h.fire(r)}async J(){this.z.store(d,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(n,r,o){if(this.a.value===void 0)return this.f.cancel();if(r&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const s=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:s}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};t=ye([Y(0,m.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncEnablementService),Y(4,p.IUserDataSyncService),Y(5,p.IUserDataSyncLogService),Y(6,h.IUserDataSyncAccountService),Y(7,f.ITelemetryService),Y(8,u.IUserDataSyncMachinesService),Y(9,g.IStorageService)],t),e.UserDataAutoSyncService=t;class a extends R.Disposable{constructor(n,r,o,s,c,w,E,k){super(),this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.p=w,this.r=E,this.s=k,this.b=this.B(new R.MutableDisposable),this.c=this.B(new L.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new L.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}u(){this.b.value=(0,D.disposableTimeout)(()=>this.sync(a.a,!1),this.k)}sync(n,r){const o=(0,D.createCancelablePromise)(async s=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(c){if((0,A.isCancellationError)(c))return}return this.y(n,r,s)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),r=this.l.userDataSyncStore;return!!r&&!!n&&(!(0,S.isEqual)(r.defaultUrl,n.defaultUrl)||!(0,S.isEqual)(r.insidersUrl,n.insidersUrl)||!(0,S.isEqual)(r.stableUrl,n.stableUrl))}async y(n,r,o){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let s;try{await this.z(r,o)}catch(c){if(this.r.error(c),s=c,p.UserDataSyncError.toUserDataSyncError(c).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(r,o),s=void 0}catch(w){this.r.error(w),s=w}}this.f.fire(s)}async z(n,r){if(this.h=await this.n.createSyncTask(this.g,n),r.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new p.UserDataAutoSyncError((0,v.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,v.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,v.localize)(2,null),"TurnedOff");const o=this.s.get(y,-1);if(o&&this.g&&o!==this.g.session)throw this.v()?await this.w()?new p.UserDataAutoSyncError((0,v.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,v.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,v.localize)(5,null),"SessionExpired");const s=await this.p.getMachines(this.g||void 0);if(r.isCancellationRequested)return;const c=s.find(w=>w.isCurrent);if(c?.disabled)throw new p.UserDataAutoSyncError((0,v.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(w){throw new p.UserDataAutoSyncError((0,l.toErrorMessage)(w),w instanceof p.UserDataSyncError?w.code:"Unknown")}this.g&&this.g.session!==o&&this.s.store(y,this.g.session,-1,1),!r.isCancellationRequested&&(c||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}a.a="Interval"}),define(ne[282],se([0,1,10,187,15,14,44,19,30,23,28,41,123,122,121,16,124,119,120,5,125,42]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let t=class xe{constructor(i,n,r,o,s,c,w,E,k,N){this.e=i,this.f=n,this.g=r,this.h=s,this.i=c,this.j=w,this.k=E,this.l=k,this.m=N,this.d=o.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const n=this.K(i.content,"profiles");return(0,b.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(i,n){return(await this.e.getAllResourceRefs(i,n?.collection)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!0,syncResource:i,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:s,node:void 0})}))}async getLocalSyncResourceHandles(i,n){return(await this.f.getAllRefs(n,i)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!1,syncResource:i,profile:n.id,collection:void 0,ref:s,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const n=this.J(i),r=n?this.k.profiles.find(o=>o.id===n.profile):void 0;return n&&r?{profile:r,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:i}){const n=this.J(i);if(!n)return[];const r=this.k.profiles.find(o=>o.id===n.profile);switch(n.syncResource){case"settings":return this.r(i,r);case"keybindings":return this.t(i,r);case"tasks":return this.v(i,r);case"snippets":return this.x(i,r);case"globalState":return this.C(i,r);case"extensions":return this.z(i,r);case"profiles":return this.F(i,r)}}async getMachineId({uri:i}){const n=this.J(i);if(!!n){if(n.remote){if(n.ref){const{content:r}=await this.L(n.syncResource,n.ref,n.collection);if(r)return this.K(r,n.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(i){const n=this.J(i);if(!n||n.node===xe.a)return null;if(n.ref){const r=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&r?this.o(n.syncResource,r,n.node):r}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(i,n,r,o,s){if(i){const{content:w}=await this.L(n,s,o);return w}const c=this.k.profiles.find(w=>w.id===r);return c?this.f.resolveContent(c,n,s):null}o(i,n,r){const o=this.K(n,i);switch(i){case"settings":return this.s(o,r);case"keybindings":return this.u(o,r);case"tasks":return this.w(o,r);case"snippets":return this.y(o,r);case"globalState":return this.D(o,r);case"extensions":return this.A(o,r);case"profiles":return this.G(o,r)}}async q(i,n){const r=this.k.profiles.find(o=>o.id===n);if(!r)return null;switch(i){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(i,n){const r=this.d.joinPath(i,"settings.json"),o=n?n.settingsResource:this.d.joinPath(i,xe.a);return[{resource:r,comparableResource:o}]}s(i,n){switch(n){case"settings.json":return(0,g.parseSettingsSyncContent)(i.content).settings}return null}t(i,n){const r=this.d.joinPath(i,"keybindings.json"),o=n?n.keybindingsResource:this.d.joinPath(i,xe.a);return[{resource:r,comparableResource:o}]}u(i,n){switch(n){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(i.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(i,n){const r=this.d.joinPath(i,"tasks.json"),o=n?n.tasksResource:this.d.joinPath(i,xe.a);return[{resource:r,comparableResource:o}]}w(i,n){switch(n){case"tasks.json":return(0,h.getTasksContentFromSyncContent)(i.content,this.g)}return null}async x(i,n){const r=await this.resolveContent(i);if(r){const o=this.K(r,"snippets");if(o){const s=(0,m.parseSnippets)(o),c=[];for(const w of Object.keys(s)){const E=this.d.joinPath(i,w),k=n?this.d.joinPath(n.snippetsHome,w):this.d.joinPath(i,xe.a);c.push({resource:E,comparableResource:k})}return c}}return[]}y(i,n){return(0,m.parseSnippets)(i)[n]||null}z(i,n){const r=this.d.joinPath(i,"extensions.json"),o=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,xe.a);return[{resource:r,comparableResource:o}]}A(i,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async B(i){const{localExtensions:n}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(n,!0)}C(i,n){const r=this.d.joinPath(i,"globalState.json"),o=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,xe.a);return[{resource:r,comparableResource:o}]}D(i,n){switch(n){case"globalState.json":return(0,d.stringify)(JSON.parse(i.content),!0)}return null}async E(i){const n=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,d.stringify)(n,!0)}F(i,n){const r=this.d.joinPath(i,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:o}]}G(i,n){switch(n){case"profiles.json":return(0,C.toFormattedString)(JSON.parse(i.content),{})}return null}async H(i){return(0,b.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(i){const n=i.remote?xe.b:xe.c,r=[i.syncResource,i.profile];return i.collection&&r.push(`collection:${i.collection}`),i.ref&&r.push(`ref:${i.ref}`),i.node&&r.push(i.node),this.d.joinPath(D.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...r)}J(i){if(i.scheme!==S.USER_DATA_SYNC_SCHEME||i.authority!==xe.c&&i.authority!==xe.b)return;const n=[];for(;i.path!=="/";)n.unshift(this.d.basename(i)),i=this.d.dirname(i);if(n.length<2)return;const r=i.authority===xe.b,o=n.shift(),s=n.shift();let c,w,E;for(;n.length;){const k=n.shift();k.startsWith("collection:")?c=k.substring(11):k.startsWith("ref:")?w=k.substring(4):E=k}return{remote:r,syncResource:o,profile:s,collection:c,ref:w,node:E}}K(i,n){try{const r=JSON.parse(i);if((0,v.isSyncData)(r))return r}catch(r){this.g.error(r)}throw new S.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",n)}async L(i,n,r){const o=await this.e.resolveResourceContent(i,n,r);return{ref:n,content:o}}};t.a="not-existing-resource",t.b="remote-backup",t.c="local-backup",t=ye([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,I.IUriIdentityService),Y(4,l.IEnvironmentService),Y(5,R.IStorageService),Y(6,A.IFileService),Y(7,P.IUserDataProfilesService),Y(8,p.IConfigurationService),Y(9,y.IInstantiationService)],t),e.UserDataSyncResourceProviderService=t}),define(ne[283],se([0,1,20,6,24,38,3,2,22,12,31,16,29,5,19,18,28,119,120,121,122,123,124,125,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,k,N,M,$,T,B,q,G){super(),this.v=E,this.w=k,this.y=N,this.z=M,this.C=$,this.D=T,this.F=B,this.G=q,this.H=G,this.f="uninitialized",this.g=this.B(new L.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new L.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new L.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new L.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=k.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(E,k){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),M=(0,P.generateUuid)();try{const q=(0,i.createSyncHeaders)(M);k&&(q["Cache-Control"]="no-cache"),E=await this.v.manifest(E,q)}catch(q){const G=i.UserDataSyncError.toUserDataSyncError(q);throw c(G,M,this.w,this.C),G}const $=!1,T=this;let B;return{manifest:E,async run(){if($)throw new Error("Can run a task only once");B=(0,O.createCancelablePromise)(q=>T.I(E,!1,M,q)),await B.finally(()=>B=void 0),T.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),T.S()},stop(){return B?.cancel(),T.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),k=(0,P.generateUuid)(),N=(0,i.createSyncHeaders)(k);let M;try{M=await this.v.manifest(null,N)}catch(B){const q=i.UserDataSyncError.toUserDataSyncError(B);throw c(q,k,this.w,this.C),q}await this.resetLocal();const $=this,T=new l.CancellationTokenSource;return{id:k,async merge(){return $.I(M,!0,k,T.token)},async apply(){try{try{await $.L(M,k,T.token)}catch(B){if(i.UserDataSyncError.toUserDataSyncError(B).code==="MethodNotFound")$.z.info("Client is making invalid requests. Cleaning up data..."),await $.cleanUpRemoteData(),$.z.info("Applying manual sync again..."),await $.L(M,k,T.token);else throw B}}catch(B){throw $.z.error(B),B}$.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),$.S()},async stop(){T.cancel(),await $.N(),await $.resetLocal()}}}async I(E,k,N,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M($,E,k,N,M));const T=$.enabled.find(B=>B.resource==="profiles");if(T){const B=await T.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(B,E,k,N,M)}}finally{this.l.fire(this.k)}}async J(E,k,N,M,$){for(const T of E){if($.isCancellationRequested)return;const B=this.G.profiles.find(G=>G.id===T.id);if(!B){this.z.error(`Profile with id:${T.id} and name: ${T.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",T.name);const q=this.getOrCreateActiveProfileSynchronizer(B,T);this.k.push(...await this.M(q,k,N,M,$))}for(const[T,B]of this.u.entries())this.G.profiles.some(q=>q.id===B[0].profile.id)||(B[1].dispose(),this.u.delete(T))}async L(E,k,N){const M=this.U();for(const G of M){if(N.isCancellationRequested)return;await G.apply(k,N)}const $=M.find(G=>G.profile.isDefault);if(!$)return;const T=$.enabled.find(G=>G.resource==="profiles");if(!T)return;const q=(await T.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(G=>M.every(Q=>Q.profile.id!==G.id));q.length&&await this.J(q,E,!1,k,N)}async M(E,k,N,M,$){return(await E.sync(k,N,M,$)).map(([B,q])=>({profile:E.profile,syncResource:B,error:q}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const k=await this.H.resolveContent(E);if(k)return k;for(const N of this.U())for(const M of N.enabled){const $=await M.resolveContent(E);if($)return $}return null}async replace(E){this.X();const k=this.H.resolveUserDataSyncResource(E);if(!k)return;const N=await this.resolveContent(E.uri);!N||await this.O(k.profile,async M=>{if(k.syncResource===M.resource)return await M.replace(N),!0})}async accept(E,k,N,M){this.X(),await this.O(E.profile,async $=>{if(E.syncResource===$.resource)return await $.accept(k,N),M&&await $.apply((0,S.isBoolean)(M)?!1:M.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,k){return this.H.getRemoteSyncResourceHandles(E,k)}async getLocalSyncResourceHandles(E,k){return this.H.getLocalSyncResourceHandles(E,k??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(k){this.z.error(k)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),k=E.map(T=>T.collection),N=await this.v.getAllCollections(),M=N.filter(T=>!k.includes(T));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(T=>this.v.deleteCollection(T))),this.z.info("Deleted redundant collections on server"));const $=E.filter(T=>N.includes(T.collection));if($.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const T=this.y.createInstance(a.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await T.updateRemoteProfiles($,null),this.z.info("Updated remote profiles on server")}finally{T.dispose()}}}async O(E,k){const N=new R.DisposableStore;try{const M=this.u.get(E.id);if(M){const G=await this.P(M[0],k,N);return(0,S.isUndefined)(G)?null:G}if(E.isDefault){const G=N.add(this.y.createInstance(o,E,void 0)),Q=await this.P(G,k,N);return(0,S.isUndefined)(Q)?null:Q}if(this.G.isEnabled())return null;const $=N.add(this.y.createInstance(a.UserDataProfilesManifestSynchroniser,E,void 0)),T=await this.v.manifest(null),q=(await $.getRemoteSyncedProfiles(T?.latest??null)||[]).find(G=>G.id===E.id);if(q){const G=N.add(this.y.createInstance(o,E,q.collection)),Q=await this.P(G,k,N);return(0,S.isUndefined)(Q)?null:Q}return null}finally{N.dispose()}}async P(E,k,N){const M=[...E.enabled,...E.disabled.map($=>N.add(E.createSynchronizer($)))];for(const $ of M){const T=await k($);if(!(0,S.isUndefined)(T))return T}}Q(E){const k=this.f;this.f!==E&&(this.f=E,this.g.fire(E),k==="hasConflicts"&&this.S())}R(){const E=this.U().map(k=>k.conflicts).flat();(0,D.equals)(this.i,E,(k,N)=>k.profile.id===N.profile.id&&k.syncResource===N.syncResource&&(0,D.equals)(k.conflicts,N.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,k){let N=this.u.get(E.id);if(N&&N[0].collection!==k?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(E.id)),!N){const M=new R.DisposableStore,$=M.add(this.y.createInstance(o,E,k?.collection));M.add($.onDidChangeStatus(T=>this.Q(T))),M.add($.onDidChangeConflicts(T=>this.R())),M.add($.onDidChangeLocal(T=>this.h.fire(T))),this.u.set(E.id,N=[$,M])}return N[0]}U(){const E=[];for(const[k]of this.u.values())E.push(k);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};r=ye([Y(0,i.IUserDataSyncStoreService),Y(1,i.IUserDataSyncStoreManagementService),Y(2,g.IInstantiationService),Y(3,i.IUserDataSyncLogService),Y(4,p.ITelemetryService),Y(5,f.IStorageService),Y(6,i.IUserDataSyncEnablementService),Y(7,h.IUserDataProfilesService),Y(8,i.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let o=class extends R.Disposable{get enabled(){return this.f.sort((E,k)=>E[1]-k[1]).map(([E])=>E)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,k,N,M,$,T,B,q,G,Q){super(),this.profile=E,this.collection=k,this.l=N,this.m=M,this.n=$,this.r=T,this.t=B,this.u=q,this.v=G,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new L.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new L.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new L.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([re,K])=>this.y(re,K))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,re])=>re.dispose())));for(const re of i.ALL_SYNC_RESOURCES)N.isResourceEnabled(re)&&this.z(re)}y(E,k){k?this.z(E):this.C(E)}z(E){if(this.f.some(([$])=>$.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const k=new R.DisposableStore,N=k.add(this.createSynchronizer(E));k.add(N.onDidChangeStatus(()=>this.G())),k.add(N.onDidChangeConflicts(()=>this.H())),k.add(N.onDidChangeLocal(()=>this.i.fire(E)));const M=this.I(E);this.f.push([N,M,k])}C(E){const k=this.f.findIndex(([N])=>N.resource===E);if(k!==-1){const[[N,,M]]=this.f.splice(k,1);M.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,$=>this.u.error($))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(y.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(C.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(a.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,k,N,M){if(M.isCancellationRequested)return[];const $=this.enabled;if(!$.length)return[];try{const T=[],B=(0,i.createSyncHeaders)(N),q=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,G=k?await this.D(q):{};for(const Q of $){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(k){const re=await Q.preview(q,G,B);if(re)for(const K of re.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await Q.merge(K.previewResource)}else await Q.sync(q,B)}catch(re){const K=i.UserDataSyncError.toUserDataSyncError(re);if(c(K,N,this.r,this.t),s(re))throw K;this.u.error(re),this.u.error(`${Q.resource}: ${(0,A.toErrorMessage)(re)}`),T.push([Q.resource,K])}}return T}finally{this.G()}}async apply(E,k){const N=(0,i.createSyncHeaders)(E);for(const M of this.enabled){if(k.isCancellationRequested)return;try{await M.apply(!1,N)}catch($){const T=i.UserDataSyncError.toUserDataSyncError($);if(c(T,E,this.r,this.t),s($))throw T;this.u.error($),this.u.error(`${M.resource}: ${(0,A.toErrorMessage)($)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(k){this.u.error(k)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(k){this.u.error(`${E.resource}: ${(0,A.toErrorMessage)(k)}`),this.u.error(k)}}async D(E){if(!this.profile.isDefault)return{};const k=this.w.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(M=>M instanceof b.SettingsSynchroniser);if(N){const M=await N.getRemoteUserDataSyncConfiguration(E);return{...k,...M}}return k}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,D.equals)(this.j,E,(k,N)=>k.syncResource===N.syncResource&&(0,D.equals)(k.conflicts,N.conflicts,(M,$)=>(0,I.isEqual)(M.previewResource,$.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ye([Y(2,i.IUserDataSyncEnablementService),Y(3,g.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,i.IUserDataSyncStoreManagementService),Y(6,p.ITelemetryService),Y(7,i.IUserDataSyncLogService),Y(8,h.IUserDataProfilesService),Y(9,v.IConfigurationService)],o);function s(w){if(w instanceof i.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function c(w,E,k,N){N.publicLog2("sync/error",{code:w.code,serverCode:w instanceof i.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof i.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:E,service:k.userDataSyncStore.url.toString()})}}),define(ne[284],se([0,1,3,2,10,28,23]),function(Z,e,D,O,l,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(m,g){return{...m,profile:(0,A.reviveProfile)(m.profile,g.profilesHome.scheme)}}function I(m){return{created:m.created,uri:l.URI.revive(m.uri)}}class S{constructor(g,f,p){this.c=g,this.d=f,this.f=p,this.a=new Map,this.b=new D.Emitter}listen(g,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${f}`)}async call(g,f,p){try{return await this.g(g,f,p)}catch(h){throw this.f.error(h),h}}async g(g,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),l.URI.revive(p[1]),p[2],p[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(p[0],p[1]?(0,A.reviveProfile)(p[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(p[0],p[1]);case"replace":return this.c.replace(I(p[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(p[0]));case"getMachineId":return this.c.getMachineId(I(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const h=f.substring(11),u=p[0],d=this.h(u);switch(p=p.slice(1),h){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(g){const f=this.a.get(this.j(g));if(!f)throw new Error(`Manual sync taks not found: ${g}`);return f}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.UserDataSyncChannel=S;let P=class extends O.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,f){super(),this.k=f,this.b="uninitialized",this.c=this.B(new D.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new D.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new D.Emitter),this.onSyncErrors=this.j.event,this.a={call(p,h,u){return g.call(p,h,u).then(null,d=>{throw L.UserDataSyncError.toUserDataSyncError(d)})},listen(p,h){return g.listen(p,h)}},this.a.call("_getInitialData").then(([p,h,u])=>{this.l(p),this.m(h),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.m(p))),this.B(this.a.listen("onSyncErrors")(p=>this.j.fire(p.map(h=>({...h,error:L.UserDataSyncError.toUserDataSyncError(h.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),f=this;return new v(g,{async call(h,u,d){return f.a.call(`manualSync/${h}`,[g,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,f,p,h){return this.a.call("accept",[g,f,p,h])}resolveContent(g){return this.a.call("resolveContent",[g])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(g,f){return(await this.a.call("getLocalSyncResourceHandles",[g,f])).map(({created:h,uri:u})=>({created:h,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(g,f){return(await this.a.call("getRemoteSyncResourceHandles",[g,f])).map(({created:h,uri:u})=>({created:h,uri:l.URI.revive(u)}))}async getAssociatedResources(g){return(await this.a.call("getAssociatedResources",[g])).map(({resource:p,comparableResource:h})=>({resource:l.URI.revive(p),comparableResource:l.URI.revive(h)}))}getMachineId(g){return this.a.call("getMachineId",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}async l(g){this.b=g,this.c.fire(g)}async m(g){this.f=g.map(f=>({syncResource:f.syncResource,profile:(0,A.reviveProfile)(f.profile,this.k.profilesHome.scheme),conflicts:f.conflicts.map(p=>({...p,baseResource:l.URI.revive(p.baseResource),localResource:l.URI.revive(p.localResource),remoteResource:l.URI.revive(p.remoteResource),previewResource:l.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}n(g){this.h!==g&&(this.h=g,this.i.fire(g))}};P=ye([Y(1,A.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class v extends O.Disposable{constructor(g,f){super(),this.id=g,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ne[285],se([0,1,6,24,8,3,2,143,4,22,12,10,31,16,15,14,25,60,44,19,23]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const C="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",n=100,r=1e3*60*5;let o=class extends L.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(b.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,M,$){super(),this.f=N,this.g=M,this.h=$,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter($.onDidChangeValue,T=>T.key===b.SYNC_SERVICE_URL_TYPE&&T.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[b.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,M){N=I.isWeb&&N?.web?{...N,...N.web}:N;const $={...N||{},...M||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(T=>Array.isArray($.authenticationProviders[T].scopes))){const T=$,B=!!T.canSwitch&&!M?.url,q=T.url===T.insidersUrl?"insiders":"stable",G=(B?this.c:void 0)||q,Q=M?.url||(G==="insiders"?T.insidersUrl:G==="stable"?T.stableUrl:T.url);return{url:v.URI.parse(Q),type:G,defaultType:q,defaultUrl:v.URI.parse(T.url),stableUrl:v.URI.parse(T.stableUrl),insidersUrl:v.URI.parse(T.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(T.authenticationProviders).reduce((re,K)=>(re.push({id:K,scopes:T.authenticationProviders[K].scopes}),re),[])}}}};o=ye([Y(0,h.IProductService),Y(1,g.IConfigurationService),Y(2,y.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let s=class extends o{constructor(N,M,$){super(N,M,$);const T=this.h.get(C,-1);T&&(this.k=JSON.parse(T));const B=this.f[b.CONFIGURATION_SYNC_STORE_KEY];B?this.h.store(C,JSON.stringify(B),-1,1):this.h.remove(C,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};s=ye([Y(0,h.IProductService),Y(1,g.IConfigurationService),Y(2,y.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let c=class extends L.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,M,$,T,B,q,G){super(),this.k=$,this.l=T,this.n=G,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)(B,q,G).then(Q=>{const re={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(re["X-Client-Commit"]=M.commit),re}),this.f=new E(n,r,this.k,this.l),this.r(),this.B((0,L.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,M){this.b={token:N,type:M}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(t,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(t,this.i.getTime(),-1,1),this.s=(0,D.createCancelablePromise)(M=>(0,D.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.t(void 0))),this.s.then(null,M=>null)):this.n.remove(t,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const $=await this.w(M,{type:"GET",headers:N},[],O.CancellationToken.None);return(await(0,u.asJson)($))?.map(({id:T})=>T)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const $=await this.w(M,{type:"POST",headers:N},[],O.CancellationToken.None),T=await(0,u.asTextOrError)($);if(!T)throw new b.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",$.res.statusCode,$.res.headers[b.HEADER_OPERATION_ID]);return T}async deleteCollection(N,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();M={...M},await this.w($,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async getAllResourceRefs(N,M){if(!this.a)throw new Error("No settings sync store url configured.");const $=this.u(this.a,M,N),T={},B=await this.w($.toString(),{type:"GET",headers:T},[],O.CancellationToken.None);return(await(0,u.asJson)(B)||[]).map(({url:G,created:Q})=>({ref:(0,S.relativePath)($,$.with({path:G})),created:Q*1e3}))}async resolveResourceContent(N,M,$,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=(0,S.joinPath)(this.u(this.a,$,N),M).toString();T={...T},T["Cache-Control"]="no-cache";const q=await this.w(B,{type:"GET",headers:T},[],O.CancellationToken.None);return await(0,u.asTextOrError)(q)}async deleteResource(N,M,$){if(!this.a)throw new Error("No settings sync store url configured.");const T=M!==null?(0,S.joinPath)(this.u(this.a,$,N),M).toString():this.u(this.a,$,N).toString(),B={};await this.w(T,{type:"DELETE",headers:B},[],O.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async readResource(N,M,$,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=(0,S.joinPath)(this.u(this.a,$,N),"latest").toString();T={...T},T["Cache-Control"]="no-cache",M&&(T["If-None-Match"]=M.ref);const q=await this.w(B,{type:"GET",headers:T},[304],O.CancellationToken.None);let G=null;if(q.res.statusCode===304&&(G=M),G===null){const Q=q.res.headers.etag;if(!Q)throw new b.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",q.res.statusCode,q.res.headers[b.HEADER_OPERATION_ID]);const re=await(0,u.asTextOrError)(q);if(!re&&q.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",B,"EmptyResponse",q.res.statusCode,q.res.headers[b.HEADER_OPERATION_ID]);G={ref:Q,content:re}}return G}async writeResource(N,M,$,T,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=this.u(this.a,T,N).toString();B={...B},B["Content-Type"]=R.Mimes.text,$&&(B["If-Match"]=$);const G=await this.w(q,{type:"POST",data:M,headers:B},[],O.CancellationToken.None),Q=G.res.headers.etag;if(!Q)throw new b.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",G.res.statusCode,G.res.headers[b.HEADER_OPERATION_ID]);return Q}async manifest(N,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",N&&(M["If-None-Match"]=N.ref);const T=await this.w($,{type:"GET",headers:M},[304],O.CancellationToken.None);let B=null;if(T.res.statusCode===304&&(B=N),!B){const G=T.res.headers.etag;if(!G)throw new b.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",T.res.statusCode,T.res.headers[b.HEADER_OPERATION_ID]);const Q=await(0,u.asTextOrError)(T);if(!Q&&T.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",$,"EmptyResponse",T.res.statusCode,T.res.headers[b.HEADER_OPERATION_ID]);Q&&(B={...JSON.parse(Q),ref:G})}const q=this.n.get(a,-1);return q&&B&&q!==B.session&&this.v(),B===null&&q&&this.v(),B&&this.n.store(a,B.session,-1,1),B}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,M,$){return M?(0,S.joinPath)(N,"collection",M,"resource",$):(0,S.joinPath)(N,"resource",$)}v(){this.n.remove(a,-1),this.n.remove(i,-1)}async w(N,M,$,T){if(!this.b)throw new b.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const B=await this.c;M.headers={...M.headers||{},...B,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(M.headers),this.l.trace("Sending request to server",{url:N,type:M.type,headers:{...M.headers,authorization:void 0}});let q;try{q=await this.f.request(N,M,T)}catch(W){if(!(W instanceof b.UserDataSyncStoreError)){let F="RequestFailed";const J=(0,l.getErrorMessage)(W).toLowerCase();J.includes("xhr timeout")?F="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?F="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":J.includes("headers must be an object")?F="RequestHeadersNotObject":(0,l.isCancellationError)(W)&&(F="RequestCanceled"),W=new b.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,F,void 0,void 0)}throw this.l.info("Request failed",N),W}const G=q.res.headers[b.HEADER_OPERATION_ID],Q={url:N,status:q.res.statusCode,"execution-id":M.headers[b.HEADER_EXECUTION_ID],"operation-id":G},re=(0,u.isSuccess)(q)||q.res.statusCode&&$.indexOf(q.res.statusCode)!==-1;let K="";if(re?this.l.trace("Request succeeded",Q):(this.l.info("Request failed",Q),K=await(0,u.asText)(q)||""),q.res.statusCode===401)throw this.b=void 0,this.g.fire(),new b.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",q.res.statusCode,G);if(this.h.fire(),q.res.statusCode===404)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",q.res.statusCode,G);if(q.res.statusCode===405)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested endpoint is not found (405). ${K}`,N,"MethodNotFound",q.res.statusCode,G);if(q.res.statusCode===409)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",q.res.statusCode,G);if(q.res.statusCode===410)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",q.res.statusCode,G);if(q.res.statusCode===412)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",q.res.statusCode,G);if(q.res.statusCode===413)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",q.res.statusCode,G);if(q.res.statusCode===426)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",q.res.statusCode,G);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.t(new Date(Date.now()+parseInt(W)*1e3)),new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",q.res.statusCode,G)):new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",q.res.statusCode,G)}if(!re)throw new b.UserDataSyncStoreError("Server returned "+q.res.statusCode,N,"Unknown",q.res.statusCode,G);return q}y(N){let M=this.n.get(i,-1);M===void 0&&(M=(0,m.generateUuid)(),this.n.store(i,M,-1,1)),N["X-Machine-Session-Id"]=M;const $=this.n.get(a,-1);$!==void 0&&(N["X-User-Session-Id"]=$)}};c=ye([Y(1,h.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,p.IFileService),Y(6,y.IStorageService)],c),e.UserDataSyncStoreClient=c;let w=class extends c{constructor(N,M,$,T,B,q,G){super(N.userDataSyncStore?.url,M,$,T,B,q,G),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};w=ye([Y(0,b.IUserDataSyncStoreManagementService),Y(1,h.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,p.IFileService),Y(6,y.IStorageService)],w),e.UserDataSyncStoreService=w;class E{constructor(N,M,$,T){this.c=N,this.d=M,this.f=$,this.g=T,this.a=[],this.b=void 0}request(N,M,$){if(this.h()&&this.i(),M.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(M,$)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(ne[286],se([0,1,3,58,25,19,18,281,23,78,81]),function(Z,e,D,O,l,A,L,R,I,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let v=class extends R.UserDataAutoSyncService{constructor(g,f,p,h,u,d,y,b,C,t,a){super(g,f,p,h,u,y,b,C,t,a),this.B(D.Event.debounce(D.Event.any(D.Event.map(d.onDidFocusWindow,()=>"windowFocus"),D.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(i,n)=>i?[...i,n]:[n],1e3)(i=>this.triggerSync(i,!0,!1)))}};v=ye([Y(0,l.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,L.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,A.IStorageService)],v),e.UserDataAutoSyncService=v}),define(ne[287],se([0,1,100,21,4,22]),function(Z,e,D,O,l,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(S){function P(){let v=S.scheme===O.Schemas.file?(0,A.originalFSPath)(S):S.toString();return l.isLinux||(v=v.toLowerCase()),(0,D.createHash)("md5").update(v).digest("hex")}return{id:P(),configPath:S}}e.getWorkspaceIdentifier=L;function R(S,P){function v(){if(S.scheme!==O.Schemas.file)return(0,D.createHash)("md5").update(S.toString()).digest("hex");if(!P)return;let g;return l.isLinux?g=P.ino:l.isMacintosh?g=P.birthtime.getTime():l.isWindows&&(typeof P.birthtimeMs=="number"?g=Math.floor(P.birthtimeMs):g=P.birthtime.getTime()),(0,D.createHash)("md5").update(S.fsPath).update(g?String(g):"").digest("hex")}const m=v();if(typeof m=="string")return{id:m,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(ne[288],se([0,1,6,8,2,13,27,15,57,11,58,76,117,287]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends l.Disposable{constructor(h,u,d,y){super(),this.a=h,this.b=u,this.c=d,this.f=y,this.B(new D.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new v.StorageClient(this.f.getChannel("storage"));await Promise.all(h.map(async d=>{const y=(0,A.join)(this.a.workspaceStorageHome.fsPath,d);d.length===g.NON_EMPTY_WORKSPACE_ID_LENGTH||d===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(t=>t.workspace?.id===d)||await u.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await L.Promises.rm(y))}))}catch(h){(0,O.onUnexpectedError)(h)}}};f=ye([Y(0,R.INativeEnvironmentService),Y(1,S.ILogService),Y(2,P.INativeHostService),Y(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(ne[126],se([0,1,53,6,13,12,27,154,297,298]),function(Z,e,D,O,l,A,L,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(t,a){let i=a.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=a}}e.ExtractError=P;function v(C){const t=C.externalFileAttributes>>16||33188;return[448,56,7].map(a=>t&a).reduce((a,i)=>a+i,t&61440)}function m(C){if(C instanceof P)return C;let t;return/end of central directory record signature not found/.test(C.message)&&(t="CorruptZip"),new P(t,C)}function g(C,t,a,i,n,r){const o=l.dirname(t),s=l.join(i,o);if(!s.startsWith(i))return Promise.reject(new Error(R.localize(0,null,t)));const c=l.join(i,t);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(L.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((E,k)=>{if(!r.isCancellationRequested)try{w=(0,D.createWriteStream)(c,{mode:a}),w.once("close",()=>E()),w.once("error",k),C.once("error",k),C.pipe(w)}catch(N){k(N)}}))}function f(C,t,a,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),C.close()}),new Promise((o,s)=>{const c=new O.Sequencer,w=E=>{E.isCancellationRequested||(r++,C.readEntry())};C.once("error",s),C.once("close",()=>n.then(()=>{i.isCancellationRequested||C.entryCount===r?o():s(new P("Incomplete",new Error(R.localize(1,null,r,C.entryCount))))},s)),C.readEntry(),C.on("entry",E=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(E.fileName)){w(i);return}const k=E.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(k)){const $=l.join(t,k);n=(0,O.createCancelablePromise)(T=>L.Promises.mkdir($,{recursive:!0}).then(()=>w(T)).then(void 0,s));return}const N=h(C,E),M=v(E);n=(0,O.createCancelablePromise)($=>c.queue(()=>N.then(T=>g(T,k,M,t,a,$).then(()=>w($)))).then(null,s))})})}function p(C,t=!1){return new Promise((a,i)=>{(0,I.open)(C,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(m(n)):a((0,A.assertIsDefined)(r))})})}function h(C,t){return new Promise((a,i)=>{C.openReadStream(t,(n,r)=>{n?i(m(n)):a((0,A.assertIsDefined)(r))})})}function u(C,t){return new Promise((a,i)=>{const n=new S.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,D.createWriteStream)(C);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>a(C))})}e.zip=u;function d(C,t,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=p(C,!0);return a.overwrite&&(r=r.then(o=>L.Promises.rm(t).then(()=>o))),r.then(o=>f(o,t,{sourcePathRegex:n},i))}e.extract=d;function y(C,t){return p(C).then(a=>new Promise((i,n)=>{a.on("entry",r=>{r.fileName===t&&h(a,r).then(o=>i(o),o=>n(o))}),a.once("close",()=>n(new Error(R.localize(2,null,t))))}))}function b(C,t){return y(C,t).then(a=>new Promise((i,n)=>{const r=[];a.once("error",n),a.on("data",o=>r.push(o)),a.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=b}),define(ne[289],se([0,1,126,164]),function(Z,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(A){return(0,D.buffer)(A,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=l}),define(ne[127],se([0,1,6,17,24,38,8,3,2,37,21,13,4,22,54,12,10,31,27,126,163,97,15,270,29,33,51,79,240,272,289,224,241,46,70,14,5,11,25,18,30,28]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t,a,i,n,r,o,s,c,w,E,k,N,M,$,T,B,q,G,Q,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,T.refineServiceDecorator)(i.IExtensionManagementService);let K=class extends a.AbstractExtensionManagementService{constructor(V,j,U,z,x,_,H,X,te,le,he,me){super(V,j,U,le,me),this.Z=x,this.ab=_,this.bb=H,this.cb=te,this.db=he,this.X=this.B(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new S.ResourceSet;const pe=this.B(X.createInstance(c.ExtensionsLifecycle));this.S=this.B(X.createInstance(W,Ee=>pe.postUninstall(Ee))),this.U=this.B(new E.ExtensionsManifestCache(z,this)),this.W=this.B(X.createInstance(s.ExtensionsDownloader));const Se=this.B(new k.ExtensionsWatcher(this,this.Z,me,_,he,te,U));this.B(Se.onDidChangeExtensionsByAnotherSource(Ee=>this.kb(Ee))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(V){this.v.trace("ExtensionManagementService#zip",V.identifier.id);const j=await this.jb(V),U=await(0,y.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,j);return h.URI.file(U)}async unzip(V){return this.v.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:j,cleanup:U}=await this.fb(V),z=v.resolve(j.fsPath);try{return await(0,w.getManifest)(z)}finally{await U()}}getInstalled(V,j=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(V??null,j)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.S.scanUserExtensionAtLocation(V)}async install(V,j={}){this.v.trace("ExtensionManagementService#install",V.toString());const{location:U,cleanup:z}=await this.fb(V);try{const x=await(0,w.getManifest)(v.resolve(U.fsPath));if(x.engines&&x.engines.vscode&&!(0,M.isEngineValid)(x.engines.vscode,this.w.version,this.w.date))throw new Error(b.localize(0,null,(0,n.getGalleryExtensionId)(x.publisher,x.name),this.w.version));return await this.z(x,U,j)}finally{await z()}}async installFromLocation(V,j){this.v.trace("ExtensionManagementService#installFromLocation",V.toString());const U=await this.S.scanUserExtensionAtLocation(V);if(!U)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.ob([U],j),this.v.info("Successfully installed extension",U.identifier.id,j.toString()),U}getMetadata(V,j=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(V,j)}async updateMetadata(V,j,U=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",V.identifier.id),j.isPreReleaseVersion&&(j.preRelease=!0),j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.pinned=j.pinned||void 0,V=await this.S.updateMetadata(V,j,U),this.U.invalidate(),this.X.fire(V),V}async reinstallFromGallery(V){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.t.isEnabled())throw new Error(b.localize(1,null));const j=await this.getTargetPlatform(),[U]=await this.t.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:j,compatible:!0},l.CancellationToken.None);if(!U)throw new Error(b.localize(2,null));await this.S.setUninstalled(V);try{await this.S.removeUninstalledExtension(V)}catch(z){throw new Error(b.localize(3,null,(0,A.toErrorMessage)(z)))}return this.installFromGallery(U)}markAsUninstalled(...V){return this.S.setUninstalled(...V)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(V){this.v.error(V)}}async download(V,j){const{location:U}=await this.W.download(V,j);return U}async fb(V){if(V.scheme===P.Schemas.file)return{location:V,async cleanup(){}};this.v.trace("Downloading extension from",V.toString());const j=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(V,j),this.v.info("Downloaded extension to",j.toString()),{location:j,cleanup:async()=>{try{await this.cb.del(j)}catch(z){this.v.error(z)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(V,j,U){if(h.URI.isUri(j))return new ee(V,j,U,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const z=n.ExtensionKey.create(j).toString();let x=this.Y.get(z);return x||(this.Y.set(z,x=new J(V,j,U,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),x.waitUntilTaskIsFinished().then(()=>this.Y.delete(z))),x}R(V,j){return new oe(V,j.profileLocation,this.ab)}async jb(V){const j=async z=>{let x=await d.Promises.readdir(z);x=x.map(X=>v.join(z,X));const _=await Promise.all(x.map(X=>d.Promises.stat(X)));let H=Promise.resolve([]);return _.forEach((X,te)=>{const le=x[te];X.isFile()&&(H=H.then(he=>[...he,le])),X.isDirectory()&&(H=H.then(he=>j(le).then(me=>[...he,...me])))}),H};return(await j(V.location.fsPath)).map(z=>({path:`extension/${v.relative(V.location.fsPath,z)}`,localPath:z}))}async kb({added:V,removed:j}){if(j)for(const U of j.extensions)this.v.info("Extensions removed from another source",U.id,j.profileLocation.toString()),this.p.fire({identifier:U,profileLocation:j.profileLocation});if(V){const z=(await this.S.scanExtensions(1,V.profileLocation)).filter(x=>V.extensions.some(_=>(0,n.areSameExtensions)(_,x.identifier)));this.m.fire(z.map(x=>(this.v.info("Extensions added from another source",x.identifier.id,V.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:V.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(j=>this.lb.add(j)));const V=await this.cb.resolve(this.Z.userExtensionsLocation);for(const j of V.children??[])j.isDirectory&&this.lb.add(j.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(j=>this.nb(j)))}async nb(V){if(!V.affects(this.Z.userExtensionsLocation,1))return;const j=[];for(const U of V.rawAdded){if(this.lb.has(U)||!this.db.extUri.isEqual(this.db.extUri.dirname(U),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(U,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(U).startsWith(".")||!(await this.cb.stat(U)).isDirectory)continue;const z=await this.S.scanUserExtensionAtLocation(U);z&&z.installedTimestamp===void 0&&(this.lb.add(U),j.push(z))}j.length&&(await this.ob(j,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",j.map(U=>U.identifier.id)))}async ob(V,j){await this.pb(V),await this.ab.addExtensionsToProfile(V.map(U=>[U,void 0]),j),this.m.fire(V.map(U=>({local:U,identifier:U.identifier,operation:1,profileLocation:j})))}async pb(V){const j=await this.S.getUninstalledExtensions();for(const U of V){const z=n.ExtensionKey.create(U);!j[z.toString()]||(this.v.trace("Removing the extension from uninstalled list:",z.id),await this.S.setInstalled(z),this.v.info("Removed the extension from uninstalled list:",z.id))}}};K=ye([Y(0,i.IExtensionGalleryService),Y(1,G.ITelemetryService),Y(2,B.ILogService),Y(3,t.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,C.IDownloadService),Y(7,T.IInstantiationService),Y(8,$.IFileService),Y(9,q.IProductService),Y(10,Q.IUriIdentityService),Y(11,re.IUserDataProfilesService)],K),e.ExtensionManagementService=K;let W=class extends I.Disposable{constructor(V,j,U,z,x,_){super(),this.k=V,this.l=j,this.m=U,this.n=z,this.p=x,this.s=_,this.h=this.B(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,g.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new D.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(V,j){const U={includeInvalid:!0,profileLocation:j};let z=[];return V===null||V===0?z.push(...await this.m.scanAllExtensions({includeInvalid:!0},U,!1)):V===1&&z.push(...await this.m.scanUserExtensions(U)),z=V!==null?z.filter(x=>x.type===V):z,Promise.all(z.map(x=>this.y(x)))}async scanAllUserExtensions(V){const j=await this.m.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(j.map(U=>this.y(U)))}async scanUserExtensionAtLocation(V){try{const j=await this.m.scanExistingExtension(V,1,{includeInvalid:!0});if(j)return await this.y(j)}catch(j){this.s.error(j)}return null}async extractUserExtension(V,j,U,z){await this.j.catch(()=>{});const x=V.toString(),_=v.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),H=v.join(this.m.userExtensionsLocation.fsPath,x);try{await d.Promises.rm(H)}catch{throw new i.ExtensionManagementError(b.localize(4,null,H,V.id),i.ExtensionManagementErrorCode.Delete)}await this.u(V,j,_,z),await this.m.updateMetadata(h.URI.file(_),U);try{this.h.fire(h.URI.file(H)),await this.v(V,_,H,Date.now()+2*60*1e3),this.s.info("Renamed to",H)}catch(X){try{await d.Promises.rm(_)}catch{}if(X.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.s.info(`Rename failed because of ${(0,L.getErrorMessage)(X)}. Deleted from extracted location`,_),X}return this.w(h.URI.file(H),1)}async scanMetadata(V,j){return j?(await this.n.scanProfileExtensions(j)).find(z=>(0,n.areSameExtensions)(z.identifier,V.identifier))?.metadata:this.m.scanMetadata(V.location)}async updateMetadata(V,j,U){return U?await this.n.updateMetadata([[V,j]],U):await this.m.updateMetadata(V.location,j),this.w(V.location,V.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...V){const j=V.map(U=>n.ExtensionKey.create(U));await this.t(U=>j.forEach(z=>{U[z.toString()]=!0,this.s.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(V){await this.t(j=>delete j[V.toString()])}async removeExtension(V,j){this.s.trace(`Deleting ${j} extension from disk`,V.identifier.id,V.location.fsPath);const U=this.p.extUri.joinPath(this.p.extUri.dirname(V.location),`.${(0,u.generateUuid)()}`);await this.v(V.identifier,V.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.l.del(U,{recursive:!0}),this.s.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.t(j=>delete j[n.ExtensionKey.create(V).toString()])}async t(V){return this.g.queue(async()=>{let j;try{j=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,$.toFileOperationResult)(z)!==1)throw z}let U={};if(j)try{U=JSON.parse(j)}catch{}return V&&(V(U),Object.keys(U).length?await this.l.writeFile(this.c,O.VSBuffer.fromString(JSON.stringify(U))):await this.l.del(this.c)),U})}async u(V,j,U,z){this.s.trace(`Started extracting the extension from ${j} to ${U}`);try{await d.Promises.rm(U)}catch(x){throw new i.ExtensionManagementError(this.D(x).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(j,U,{sourcePath:"extension",overwrite:!0},z),this.s.info(`Extracted extension to ${U}:`,V.id)}catch(x){try{await d.Promises.rm(U)}catch{}let _=i.ExtensionManagementErrorCode.Extract;throw x instanceof y.ExtractError&&(x.type==="CorruptZip"?_=i.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(_=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(x.message,_)}}async v(V,j,U,z){try{await d.Promises.rename(j,U)}catch(x){if(m.isWindows&&x&&x.code==="EPERM"&&Date.now()<z)return this.s.info(`Failed renaming ${j} to ${U} with 'EPERM' error. Trying again...`,V.id),this.v(V,j,U,z);throw new i.ExtensionManagementError(x.message||b.localize(5,null,j,U),x.code||i.ExtensionManagementErrorCode.Rename)}}async w(V,j){const U=await this.m.scanExistingExtension(V,j,{includeInvalid:!0});if(U)return this.y(U);throw new Error(b.localize(6,null,V.path))}async y(V){const j=await this.l.resolve(V.location);let U,z;return j.children&&(U=j.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,z=j.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:U,changelogUrl:z,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned}}async z(){const V=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(V));const j=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const x of j)V[n.ExtensionKey.create(x).toString()]||U.add(x.identifier.id.toLowerCase());try{const x=(0,n.groupByExtension)(j,_=>_.identifier);await D.Promises.settled(x.map(async _=>{const H=_.sort((X,te)=>f.rcompare(X.manifest.version,te.manifest.version))[0];U.has(H.identifier.id.toLowerCase())||await this.k(await this.y(H))}))}catch(x){this.s.error(x)}const z=j.filter(x=>x.metadata&&V[n.ExtensionKey.create(x).toString()]);await Promise.allSettled(z.map(x=>this.removeUninstalledExtension(x)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const V=[];let j;try{j=await this.l.resolve(this.m.userExtensionsLocation)}catch(U){(0,$.toFileOperationResult)(U)!==1&&this.s.error(U)}for(const U of j?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,u.isUUID)(U.name.substring(1))&&V.push((async()=>{this.s.trace("Deleting the generated extension folder",U.resource.toString());try{await this.l.del(U.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",U.resource.toString())}catch(z){this.s.error(z)}})());await Promise.allSettled(V)}D(V){const j=Array.isArray(V)?V:[V];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((U,z)=>new Error(`${U.message}${U.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}};W=ye([Y(1,$.IFileService),Y(2,o.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,Q.IUriIdentityService),Y(5,B.ILogService)],W),e.ExtensionsScanner=W;class F extends a.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,p.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(V,j,U,z,x,_,H,X,te){super(),this.identifier=V,this.source=j,this.l=U,this.m=z,this.n=x,this.o=_,this.p=H,this.q=X,this.s=te,this.j="Unverified",this.k=2}async h(V){const[j,U]=await this.x(V);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[j,U]],this.l.profileLocation),j}async u({zipPath:V,key:j,metadata:U},z){let x=await this.v(j);return x||(this.s.trace("Extracting extension...",j.id),x=await this.m.extractUserExtension(j,V,U,z),this.s.info("Extracting extension completed.",j.id)),x}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find(z=>n.ExtensionKey.create(z).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class J extends F{constructor(V,j,U,z,x,_,H,X,te,le){super(j.identifier,j,U,x,_,H,X,te,le),this.y=V,this.z=j,this.A=z}async x(V){const U=(await this.m.scanExtensions(null,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.z.identifier));U&&(this.k=3);const z={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,N.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||U?.isMachineScoped,isBuiltin:this.l.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,p.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.z.version)return[await this.m.updateMetadata(U,z),z];const{location:x,verificationStatus:_}=await this.A.download(this.z,this.k);try{return this.j=_,this.C(x.fsPath),[await this.u({zipPath:x.fsPath,key:n.ExtensionKey.create(this.z),metadata:z},V),z]}catch(H){try{await this.A.delete(x)}catch(X){this.s.warn("Error while deleting the downloaded file",x.toString(),(0,L.getErrorMessage)(X))}throw H}}async C(V){try{await(0,w.getManifest)(V)}catch(j){throw new i.ExtensionManagementError((0,a.joinErrors)(j).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=J;class ee extends F{constructor(V,j,U,z,x,_,H,X,te,le){super({id:(0,n.getGalleryExtensionId)(V.publisher,V.name)},j,U,x,_,H,X,te,le),this.y=V,this.z=j,this.A=z}async x(V){const j=new n.ExtensionKey(this.identifier,this.y.version),z=(await this.m.scanExtensions(1,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),x=await this.C(this.identifier.id,this.y.version,V);if(x.isApplicationScoped=(0,N.isApplicationScopedExtension)(this.y),x.isMachineScoped=this.l.isMachineScoped||z?.isMachineScoped,x.isBuiltin=this.l.isBuiltin||z?.isBuiltin,x.installedTimestamp=Date.now(),x.pinned=this.l.installGivenVersion?!0:void 0,z)if(this.k=3,j.equals(new n.ExtensionKey(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&f.gt(z.manifest.version,this.y.version)&&await this.m.setUninstalled(z);else{const H=await this.v(j);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:v.resolve(this.z.fsPath),key:j,metadata:x},V),x]}async C(V,j,U){try{let[z]=await this.A.getExtensions([{id:V,version:j}],U);if(z||([z]=await this.A.getExtensions([{id:V}],U)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class oe extends a.AbstractExtensionTask{constructor(V,j,U){super(),this.extension=V,this.j=j,this.k=U}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[290],se([0,1,2,29,80,239,127,11,19]),function(Z,e,D,O,l,A,L,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends D.Disposable{constructor(v,m,g,f,p,h){super(),v.cleanUp(),(0,A.migrateUnsupportedExtensions)(v,m,g,f,h),l.ExtensionStorageService.removeOutdatedExtensionVersions(v,p)}};S=ye([Y(0,L.INativeServerExtensionManagementService),Y(1,O.IExtensionGalleryService),Y(2,l.IExtensionStorageService),Y(3,O.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(ne[299],se([0,1,94,34,38,8,2,21,22,10,39,152,216,217,209,210,288,198,201,16,222,96,237,97,229,15,234,118,274,29,98,200,275,127,99,196,14,212,213,55,5,207,72,208,57,73,243,11,104,58,105,25,60,19,276,110,18,111,112,113,47,246,115,252,255,80,116,23,78,279,266,267,81,280,283,284,285,286,278,62,268,109,236,77,257,226,256,108,233,30,258,4,259,202,220,219,79,273,28,51,215,59,277,231,245,269,238,107,103,282,290,271,7,214]),function(Z,e,D,O,l,A,L,R,I,S,P,v,m,g,f,p,h,u,d,y,b,C,t,a,i,n,r,o,s,c,w,E,k,N,M,$,T,B,q,G,Q,re,K,W,F,J,ee,oe,ce,V,j,U,z,x,_,H,X,te,le,he,me,pe,Se,Ee,De,ke,We,$e,ae,fe,de,Ie,Pe,Fe,Ae,ze,Ne,Te,Be,ie,ue,ge,we,ve,Ce,Re,Le,Oe,Ue,je,qe,_e,nt,pt,kt,yt,At,Lt,vt,Ot,Tt,wt,Nt,Ut,Mt,Ft,jt,St,bt,$t,Bt,zt,Et,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends L.Disposable{constructor(be){super(),this.f=be,this.a=this.B(new v.Server),this.b=void 0,this.c=void 0,this.g()}g(){const be=async()=>{this.c?.fireOnWillShutdown(),this.dispose()};process.once("exit",be),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",be);const Me="vscode:electron-main->shared-process=disposeWorker",He=(Ke,et)=>{this.h(et)};D.ipcRenderer.on(Me,He),this.B((0,L.toDisposable)(()=>D.ipcRenderer.removeListener(Me,He)))}h(be){this.b?.disposeWorker(be)}async open(){const be=await this.i();(0,$e.registerConfiguration)(),be.invokeFunction(Me=>{const He=Me.get(oe.ILogService);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(He)}),this.B((0,L.combinedDisposable)(be.createInstance(m.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(g.LanguagePackCachedDataCleaner),be.createInstance(h.UnusedWorkspaceStorageDataCleaner),be.createInstance(p.LogsDataCleaner),be.createInstance(f.LocalizationsUpdater),be.createInstance(Bt.ExtensionsContributions),be.createInstance(Ft.UserDataProfilesCleaner)))}async i(){const be=new K.ServiceCollection,Me={_serviceBrand:void 0,...j.default};be.set(U.IProductService,Me);const He=new P.StaticRouter(Je=>Je==="main"),Ke=new W.MessagePortMainProcessService(this.a,He);be.set(F.IMainProcessService,Ke);const et=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Ke.getChannel("policy")):new wt.NullPolicyService;be.set(wt.IPolicyService,et);const Ge=new r.SharedProcessEnvironmentService(this.f.args,Me);be.set(n.INativeEnvironmentService,Ge);const Ze=new ce.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers.map(Je=>({...Je,resource:S.URI.revive(Je.resource)})),Ke.getChannel("logger"));be.set(oe.ILoggerService,Ze);const ot=this.B(Ze.createLogger((0,I.joinPath)(S.URI.file(Ge.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,Et.localize)(0,null)})),lt=this.B(new oe.ConsoleLogger(ot.getLevel())),Ve=this.B(new qt.LogService(ot,[lt]));be.set(oe.ILogService,Ve),this.c=this.B(new bt.SharedProcessLifecycleService(Ve)),be.set(bt.ISharedProcessLifecycleService,this.c),this.b=new Ue.SharedProcessWorkerService(Ve),be.set(Oe.ISharedProcessWorkerService,this.b);const Qe=this.B(new B.FileService(Ve));be.set(T.IFileService,Qe);const ut=this.B(new q.DiskFileSystemProvider(Ve));Qe.registerProvider(R.Schemas.file,ut);const ht=this.B(new nt.FileUserDataProvider(R.Schemas.file,this.B(new pt.DiskFileSystemProviderClient(Ke.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:_e.isLinux})),R.Schemas.vscodeUserData,Ve));Qe.registerProvider(R.Schemas.vscodeUserData,ht);const tt=this.B(new Nt.UserDataProfilesNativeService(this.f.profiles,Ke,Ge));be.set(vt.IUserDataProfilesService,tt);const Ye=this.B(new b.ConfigurationService(tt.defaultProfile.settingsResource,Qe,et,Ve));be.set(y.IConfigurationService,Ye);const st=new _.NativeStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ke,Ge);be.set(x.IStorageService,st),this.B((0,L.toDisposable)(()=>st.flush())),await Promise.all([Ye.initialize(),st.initialize()]);const ft=new qe.UriIdentityService(Qe);be.set(je.IUriIdentityService,ft),be.set(z.IRequestService,new Ut.SharedProcessRequestService(Ke,Ye,Me,Ve)),be.set(u.IChecksumService,new G.SyncDescriptor(d.ChecksumService,void 0,!1)),be.set(yt.IV8InspectProfilingService,new G.SyncDescriptor(kt.InspectProfilingService,void 0,!1));const at=P.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.f.windowId});be.set(V.INativeHostService,at),be.set(a.IDownloadService,new G.SyncDescriptor(i.DownloadService,void 0,!0));const dt=this.B(new ue.ActiveWindowManager(at)),xt=new P.StaticRouter(Je=>dt.getActiveClientId().then(gt=>Je===gt));be.set(M.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",xt)));let ct;const rt=[],It=(0,me.isInternalTelemetry)(Me,Ye);if((0,me.supportsTelemetry)(Me,Ge)){const Je=new le.TelemetryLogAppender(Ve,Ze,Ge,Me);rt.push(Je);const{installSourcePath:gt}=Ge;if(Me.aiConfig?.ariaKey){const Rt=new Mt.OneDataSystemAppender(It,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,L.toDisposable)(()=>Rt.flush())),rt.push(Rt)}ct=new he.TelemetryService({appenders:rt,commonProperties:(0,H.resolveCommonProperties)(Qe,(0,O.release)(),(0,O.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,It,gt),sendErrorTelemetry:!0,piiPaths:(0,me.getPiiPathsFromEnvironment)(Ge)},Ye,Me)}else{ct=me.NullTelemetryService;const Je=me.NullAppender;rt.push(Je)}this.a.registerChannel("telemetryAppender",new te.TelemetryAppenderChannel(rt)),be.set(X.ITelemetryService,ct);const Ht=new pe.CustomEndpointTelemetryService(Ye,ct,Ve,Ze,Ge,Me);be.set(X.ICustomEndpointTelemetryService,Ht),be.set(Ot.IExtensionsProfileScannerService,new G.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),be.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),be.set(w.IExtensionSignatureVerificationService,new G.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),be.set(N.INativeServerExtensionManagementService,new G.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),be.set(c.IExtensionGalleryService,new G.SyncDescriptor(s.ExtensionGalleryService,void 0,!0)),be.set(c.IExtensionTipsService,new G.SyncDescriptor(k.ExtensionTipsService,void 0,!1)),be.set(J.ILanguagePackService,new G.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),be.set(C.IDiagnosticsService,new G.SyncDescriptor(t.DiagnosticsService,void 0,!1)),be.set(ae.IUserDataSyncAccountService,new G.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),be.set($e.IUserDataSyncLogService,new G.SyncDescriptor(Ie.UserDataSyncLogService,void 0,!0)),be.set($e.IUserDataSyncUtilService,new de.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),be.set(c.IGlobalExtensionEnablementService,new G.SyncDescriptor(o.GlobalExtensionEnablementService,void 0,!1)),be.set(We.IIgnoredExtensionsManagementService,new G.SyncDescriptor(We.IgnoredExtensionsManagementService,void 0,!0)),be.set(ke.IExtensionStorageService,new G.SyncDescriptor(ke.ExtensionStorageService)),be.set($e.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Ne.UserDataSyncStoreManagementService,void 0,!0)),be.set($e.IUserDataSyncStoreService,new G.SyncDescriptor(Ne.UserDataSyncStoreService,void 0,!0)),be.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),be.set($e.IUserDataSyncBackupStoreService,new G.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),be.set($e.IUserDataSyncEnablementService,new G.SyncDescriptor(Fe.UserDataSyncEnablementService,void 0,!0)),be.set($e.IUserDataSyncService,new G.SyncDescriptor(Ae.UserDataSyncService,void 0,!1)),be.set(ie.IUserDataProfileStorageService,new G.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),be.set($e.IUserDataSyncResourceProviderService,new G.SyncDescriptor($t.UserDataSyncResourceProviderService,void 0,!0));const Pt=new De.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,Et.localize)(1,null),Ye,Ge,Ve,Ze);return Pt.initialize(),be.set(Ee.ILocalPtyService,this.B(Pt)),be.set(ge.ISignService,new G.SyncDescriptor(we.SignService,void 0,!1)),be.set(ve.ISharedTunnelsService,new G.SyncDescriptor(Ce.SharedTunnelsService)),be.set(Re.ISharedProcessTunnelService,new G.SyncDescriptor(Le.SharedProcessTunnelService)),be.set(St.IRemoteTunnelService,new G.SyncDescriptor(jt.RemoteTunnelService)),new re.InstantiationService(be)}j(be){const Me=new E.ExtensionManagementChannel(be.get(c.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Me);const He=P.ProxyChannel.fromService(be.get(J.ILanguagePackService));this.a.registerChannel("languagePacks",He);const Ke=P.ProxyChannel.fromService(be.get(C.IDiagnosticsService));this.a.registerChannel("diagnostics",Ke);const et=new E.ExtensionTipsChannel(be.get(c.IExtensionTipsService));this.a.registerChannel("extensionTipsService",et);const Ge=P.ProxyChannel.fromService(be.get(u.IChecksumService));this.a.registerChannel("checksum",Ge);const Ze=P.ProxyChannel.fromService(be.get(yt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",Ze);const ot=new de.UserDataSyncMachinesServiceChannel(be.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ot);const lt=P.ProxyChannel.fromService(be.get(X.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",lt);const Ve=new de.UserDataSyncAccountServiceChannel(be.get(ae.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ve);const Qe=new de.UserDataSyncStoreManagementServiceChannel(be.get($e.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ut=new ze.UserDataSyncChannel(be.get($e.IUserDataSyncService),be.get(vt.IUserDataProfilesService),be.get(oe.ILogService));this.a.registerChannel("userDataSync",ut);const ht=this.B(be.get(Q.IInstantiationService).createInstance(Te.UserDataAutoSyncService)),tt=new de.UserDataAutoSyncChannel(ht);this.a.registerChannel("userDataAutoSync",tt);const Ye=be.get(Ee.ILocalPtyService),st=P.ProxyChannel.fromService(Ye);this.a.registerChannel(Se.TerminalIpcChannels.LocalPty,st);const ft=P.ProxyChannel.fromService(be.get(Re.ISharedProcessTunnelService));this.a.registerChannel(Re.ipcSharedProcessTunnelChannelName,ft);const at=P.ProxyChannel.fromService(be.get(Oe.ISharedProcessWorkerService));this.a.registerChannel(Oe.ipcSharedProcessWorkerChannelName,at);const dt=P.ProxyChannel.fromService(be.get(St.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",dt)}k(be){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const He=(0,l.toErrorMessage)(Me,!0);!He||be.error(`[uncaught exception in sharedProcess]: ${He}`)})}}async function Vt(Ct){const be=new Wt(Ct);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await be.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Vt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/af4a70d991053dcbf64d9a86c76a02dced81d9c4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
