/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],O=0,R=x.length;O<R;O++)e[O]=Z[x[O]];return e};define(Z[48],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(k){return(S,g,c)=>{let I=null,p=null;if(typeof c.value=="function"?(I="value",p=c.value):typeof c.get=="function"&&(I="get",p=c.get),!p)throw new Error("not supported");c[I]=k(p,g)}}function R(k,S,g){let c=null,I=null;if(typeof g.value=="function"?(c="value",I=g.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",I=g.get),!I)throw new Error("not supported");const p=`$memoize$${S}`;g[c]=function(...d){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[p]}}e.memoize=R;function P(k,S,g){return O((c,I)=>{const p=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...w){this[d]||(this[d]=g?g():void 0),clearTimeout(this[p]),S&&(this[d]=S(this[d],...w),w=[this[d]]),this[p]=setTimeout(()=>{c.apply(this,w),this[d]=g?g():void 0},k)}})}e.debounce=P;function D(k,S,g){return O((c,I)=>{const p=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,w=`$throttle$lastRun$${I}`,E=`$throttle$pending$${I}`;return function(...A){if(this[d]||(this[d]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...A)),this[E])return;const u=this[w]+k;u<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0):(this[E]=!0,this[p]=setTimeout(()=>{this[E]=!1,this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0},u-Date.now()))}})}e.throttle=D}),define(Z[70],Q([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,c){if(!g)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function P(g,c="Unreachable"){throw new Error(c)}e.assertNever=P;function D(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=D;function k(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function S(g,c){let I=0;for(;I<g.length-1;){const p=g[I],d=g[I+1];if(!c(p,d))return!1;I++}return!0}e.checkAdjacentItems=S}),define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let i=0;const n=t.length;let r="",a=0,o=16,l=0;function h(ne){let ae=0,ue=0;for(;ae<ne;){const se=t.charCodeAt(i);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;i++,ae++}return ae<ne&&(ue=-1),ue}function N(ne){i=ne,r="",a=0,o=16,l=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(ae,i),i++;break}if(ue===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ve=h(4);ve>=0?ne+=String.fromCharCode(ve):l=4;break}default:l=5}ae=i;continue}if(ue>=0&&ue<=31)if(g(ue)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function ee(){if(r="",l=0,a=i,i>=n)return a=n,o=17;let ne=t.charCodeAt(i);if(S(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(S(ne));return o=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(ne){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=Y(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let se=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,se=!0;break}i++}return se||(i++,l=1),r=t.substring(ae,i),o=13}return r+=String.fromCharCode(ne),i++,o=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!c(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),o=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(a!==i){switch(r=t.substring(a,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(ne),i++,o=16}}function te(ne){if(S(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:N,getPosition:()=>i,scan:s?ie:ee,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>l}}e.createScanner=k;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function p(t,s){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(h,N,F,Y){a.value=h,a.offset=N,a.length=F,a.type=Y,a.colonOffset=void 0,r=a}try{b(t,{onObjectBegin:(h,N)=>{if(s<=h)throw n;r=void 0,o=s>h,i.push("")},onObjectProperty:(h,N,F)=>{if(s<N||(l(h,N,F,"property"),i[i.length-1]=h,s<=N+F))throw n},onObjectEnd:(h,N)=>{if(s<=h)throw n;r=void 0,i.pop()},onArrayBegin:(h,N)=>{if(s<=h)throw n;r=void 0,i.push(0)},onArrayEnd:(h,N)=>{if(s<=h)throw n;r=void 0,i.pop()},onLiteralValue:(h,N,F)=>{if(s<N||(l(h,N,F,m(h)),s<=N+F))throw n},onSeparator:(h,N,F)=>{if(s<=N)throw n;if(h===":"&&r&&r.type==="property")r.colonOffset=N,o=!1,r=void 0;else if(h===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:r,isAtPropertyKey:o,matches:h=>{let N=0;for(let F=0;N<h.length&&F<i.length;F++)if(h[N]===i[F]||h[N]==="*")N++;else if(h[N]!=="**")return!1;return N===h.length}}}e.getLocation=p;function d(t,s=[],i=D.DEFAULT){let n=null,r=[];const a=[];function o(h){Array.isArray(r)?r.push(h):n!==null&&(r[n]=h)}return b(t,{onObjectBegin:()=>{const h={};o(h),a.push(r),r=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const h=[];o(h),a.push(r),r=h,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(h,N,F)=>{s.push({error:h,offset:N,length:F})}},i),r[0]}e.parse=d;function w(t,s=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function a(h){return n.children.push(h),h}b(t,{onObjectBegin:h=>{n=a({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,N,F)=>{n=a({type:"property",offset:N,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:N,length:F,parent:n})},onObjectEnd:(h,N)=>{n.length=h+N-n.offset,n=n.parent,r(h+N)},onArrayBegin:(h,N)=>{n=a({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,N)=>{n.length=h+N-n.offset,n=n.parent,r(h+N)},onLiteralValue:(h,N,F)=>{a({type:m(h),offset:N,length:F,parent:n,value:h}),r(N+F)},onSeparator:(h,N,F)=>{n.type==="property"&&(h===":"?n.colonOffset=N:h===","&&r(N))},onError:(h,N,F)=>{s.push({error:h,offset:N,length:F})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=w;function E(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=E;function A(t){if(!t.parent||!t.parent.children)return[];const s=A(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=A;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=u(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function y(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=y(n[r],s,i);if(a)return a}return t}}e.findNodeAtOffset=y;function b(t,s,i=D.DEFAULT){const n=k(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(q){return q?J=>q(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),l=a(s.onObjectProperty),h=r(s.onObjectEnd),N=r(s.onArrayBegin),F=r(s.onArrayEnd),Y=a(s.onLiteralValue),ee=a(s.onSeparator),te=r(s.onComment),ie=a(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ue(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ne||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(q){case 12:case 13:ne?se(10):te();break;case 16:se(1);break;case 15:case 14:break;default:return q}}}function se(q,J=[],C=[]){if(ie(q),J.length+C.length>0){let L=n.getToken();for(;L!==17;){if(J.indexOf(L)!==-1){ue();break}else if(C.indexOf(L)!==-1)break;L=ue()}}}function ve(q){const J=n.getTokenValue();return q?Y(J):l(J),ue(),!0}function V(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(se(2),q=0)}catch{se(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ue(),!0}function j(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(ve(!1),n.getToken()===6?(ee(":"),ue(),W()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function M(){o(),ue();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),ee(","),ue(),n.getToken()===2&&ae)break}else q&&se(6,[],[]);j()||se(4,[],[2,5]),q=!0}return h(),n.getToken()!==2?se(7,[2],[]):ue(),!0}function $(){N(),ue();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),ee(","),ue(),n.getToken()===4&&ae)break}else q&&se(6,[],[]);W()||se(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?se(8,[4],[]):ue(),!0}function W(){switch(n.getToken()){case 3:return $();case 1:return M();case 10:return ve(!0);default:return V()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(se(4,[],[]),!1):W()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=b;function v(t,s){const i=k(t),n=[];let r,a=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=v;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(S,g,c){return Math.min(Math.max(S,g),c)}e.clamp=O;function R(S,g){return(g+S%g)%g}e.rot=R;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class D{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class k{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const c=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function x(P){const D=[];typeof P=="number"&&D.push("code/timeOrigin",P);function k(g){D.push(g,Date.now())}function S(){const g=[];for(let c=0;c<D.length;c+=2)g.push({name:D[c],startTime:D[c+1]});return g}return{mark:k,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(P+k.startTime)});return D}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function O(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=O(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var R in O)(typeof exports=="object"?exports:x)[R]=O[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function O(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,O),P.l=!0,P.exports}return O.m=x,O.c=e,O.d=function(R,P,D){O.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:D})},O.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},O.t=function(R,P){if(1&P&&(R=O(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var D=Object.create(null);if(O.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var k in R)O.d(D,k,function(S){return R[S]}.bind(null,k));return D},O.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return O.d(P,"a",P),P},O.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},O.p="",O(O.s=0)}([function(x,e,O){(function(R){var P;e=x.exports=C,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],g=e.src=[],c=0,I=c++;g[I]="0|[1-9]\\d*";var p=c++;g[p]="[0-9]+";var d=c++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;g[w]="("+g[I]+")\\.("+g[I]+")\\.("+g[I]+")";var E=c++;g[E]="("+g[p]+")\\.("+g[p]+")\\.("+g[p]+")";var A=c++;g[A]="(?:"+g[I]+"|"+g[d]+")";var u=c++;g[u]="(?:"+g[p]+"|"+g[d]+")";var f=c++;g[f]="(?:-("+g[A]+"(?:\\."+g[A]+")*))";var y=c++;g[y]="(?:-?("+g[u]+"(?:\\."+g[u]+")*))";var b=c++;g[b]="[0-9A-Za-z-]+";var v=c++;g[v]="(?:\\+("+g[b]+"(?:\\."+g[b]+")*))";var m=c++,t="v?"+g[w]+g[f]+"?"+g[v]+"?";g[m]="^"+t+"$";var s="[v=\\s]*"+g[E]+g[y]+"?"+g[v]+"?",i=c++;g[i]="^"+s+"$";var n=c++;g[n]="((?:<|>)?=?)";var r=c++;g[r]=g[p]+"|x|X|\\*";var a=c++;g[a]=g[I]+"|x|X|\\*";var o=c++;g[o]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var l=c++;g[l]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[y]+")?"+g[v]+"?)?)?";var h=c++;g[h]="^"+g[n]+"\\s*"+g[o]+"$";var N=c++;g[N]="^"+g[n]+"\\s*"+g[l]+"$";var F=c++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;g[Y]="(?:~>?)";var ee=c++;g[ee]="(\\s*)"+g[Y]+"\\s+",S[ee]=new RegExp(g[ee],"g");var te=c++;g[te]="^"+g[Y]+g[o]+"$";var ie=c++;g[ie]="^"+g[Y]+g[l]+"$";var ne=c++;g[ne]="(?:\\^)";var ae=c++;g[ae]="(\\s*)"+g[ne]+"\\s+",S[ae]=new RegExp(g[ae],"g");var ue=c++;g[ue]="^"+g[ne]+g[o]+"$";var se=c++;g[se]="^"+g[ne]+g[l]+"$";var ve=c++;g[ve]="^"+g[n]+"\\s*("+s+")$|^$";var V=c++;g[V]="^"+g[n]+"\\s*("+t+")$|^$";var j=c++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[o]+")",S[j]=new RegExp(g[j],"g");var M=c++;g[M]="^\\s*("+g[o]+")\\s+-\\s+("+g[o]+")\\s*$";var $=c++;g[$]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var W=c++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,g[q]),S[q]||(S[q]=new RegExp(g[q]));function J(B,G){if(B instanceof C)return B;if(typeof B!="string"||B.length>D||!(G?S[i]:S[m]).test(B))return null;try{return new C(B,G)}catch{return null}}function C(B,G){if(B instanceof C){if(B.loose===G)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof C))return new C(B,G);P("SemVer",B,G),this.loose=G;var X=B.trim().match(G?S[i]:S[m]);if(!X)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<k)return pe}return he}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=J,e.valid=function(B,G){var X=J(B,G);return X?X.version:null},e.clean=function(B,G){var X=J(B.trim().replace(/^[=v]+/,""),G);return X?X.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof C||(B=new C(B,this.loose)),this.compareMain(B)||this.comparePre(B)},C.prototype.compareMain=function(B){return B instanceof C||(B=new C(B,this.loose)),T(this.major,B.major)||T(this.minor,B.minor)||T(this.patch,B.patch)},C.prototype.comparePre=function(B){if(B instanceof C||(B=new C(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],he=B.prerelease[G];if(P("prerelease compare",G,X,he),X===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(X===void 0)return-1;if(X!==he)return T(X,he)}while(++G)},C.prototype.inc=function(B,G){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,G,X,he){typeof X=="string"&&(he=X,X=void 0);try{return new C(B,X).inc(G,he).version}catch{return null}},e.diff=function(B,G){if(H(B,G))return null;var X=J(B),he=J(G);if(X.prerelease.length||he.prerelease.length){for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in X)if((pe==="major"||pe==="minor"||pe==="patch")&&X[pe]!==he[pe])return pe},e.compareIdentifiers=T;var L=/^[0-9]+$/;function T(B,G){var X=L.test(B),he=L.test(G);return X&&he&&(B=+B,G=+G),X&&!he?-1:he&&!X?1:B<G?-1:B>G?1:0}function U(B,G,X){return new C(B,X).compare(new C(G,X))}function z(B,G,X){return U(B,G,X)>0}function K(B,G,X){return U(B,G,X)<0}function H(B,G,X){return U(B,G,X)===0}function re(B,G,X){return U(B,G,X)!==0}function le(B,G,X){return U(B,G,X)>=0}function Ee(B,G,X){return U(B,G,X)<=0}function me(B,G,X,he){var pe;switch(G){case"===":typeof B=="object"&&(B=B.version),typeof X=="object"&&(X=X.version),pe=B===X;break;case"!==":typeof B=="object"&&(B=B.version),typeof X=="object"&&(X=X.version),pe=B!==X;break;case"":case"=":case"==":pe=H(B,X,he);break;case"!=":pe=re(B,X,he);break;case">":pe=z(B,X,he);break;case">=":pe=le(B,X,he);break;case"<":pe=K(B,X,he);break;case"<=":pe=Ee(B,X,he);break;default:throw new TypeError("Invalid operator: "+G)}return pe}function ce(B,G){if(B instanceof ce){if(B.loose===G)return B;B=B.value}if(!(this instanceof ce))return new ce(B,G);P("comparator",B,G),this.loose=G,this.parse(B),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,G){return T(G,B)},e.major=function(B,G){return new C(B,G).major},e.minor=function(B,G){return new C(B,G).minor},e.patch=function(B,G){return new C(B,G).patch},e.compare=U,e.compareLoose=function(B,G){return U(B,G,!0)},e.rcompare=function(B,G,X){return U(G,B,X)},e.sort=function(B,G){return B.sort(function(X,he){return e.compare(X,he,G)})},e.rsort=function(B,G){return B.sort(function(X,he){return e.rcompare(X,he,G)})},e.gt=z,e.lt=K,e.eq=H,e.neq=re,e.gte=le,e.lte=Ee,e.cmp=me,e.Comparator=ce;var de={};function ge(B,G){if(B instanceof ge)return B.loose===G?B:new ge(B.raw,G);if(B instanceof ce)return new ge(B.value,G);if(!(this instanceof ge))return new ge(B,G);if(this.loose=G,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function oe(B){return!B||B.toLowerCase()==="x"||B==="*"}function ye(B,G,X,he,pe,Oe,Ie,Ae,ke,Te,Ue,Re,Le){return((G=oe(X)?"":oe(he)?">="+X+".0.0":oe(pe)?">="+X+"."+he+".0":">="+G)+" "+(Ae=oe(ke)?"":oe(Te)?"<"+(+ke+1)+".0.0":oe(Ue)?"<"+ke+"."+(+Te+1)+".0":Re?"<="+ke+"."+Te+"."+Ue+"-"+Re:"<="+Ae)).trim()}function Se(B,G){for(var X=0;X<B.length;X++)if(!B[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<B.length;X++)if(P(B[X].semver),B[X].semver!==de&&B[X].semver.prerelease.length>0){var he=B[X].semver;if(he.major===G.major&&he.minor===G.minor&&he.patch===G.patch)return!0}return!1}return!0}function Ne(B,G,X){try{G=new ge(G,X)}catch{return!1}return G.test(B)}function Fe(B,G,X,he){var pe,Oe,Ie,Ae,ke;switch(B=new C(B,he),G=new ge(G,he),X){case">":pe=z,Oe=Ee,Ie=K,Ae=">",ke=">=";break;case"<":pe=K,Oe=le,Ie=z,Ae="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(B,G,he))return!1;for(var Te=0;Te<G.set.length;++Te){var Ue=G.set[Te],Re=null,Le=null;if(Ue.forEach(function(Ce){Ce.semver===de&&(Ce=new ce(">=0.0.0")),Re=Re||Ce,Le=Le||Ce,pe(Ce.semver,Re.semver,he)?Re=Ce:Ie(Ce.semver,Le.semver,he)&&(Le=Ce)}),Re.operator===Ae||Re.operator===ke||(!Le.operator||Le.operator===Ae)&&Oe(B,Le.semver)||Le.operator===ke&&Ie(B,Le.semver))return!1}return!0}ce.prototype.parse=function(B){var G=this.loose?S[ve]:S[V],X=B.match(G);if(!X)throw new TypeError("Invalid comparator: "+B);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new C(X[2],this.loose):this.semver=de},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===de||(typeof B=="string"&&(B=new C(B,this.loose)),me(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,G){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ge(B.value,G),Ne(this.value,X,G);if(B.operator==="")return X=new ge(this.value,G),Ne(B.semver,X,G);var he=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Oe=this.semver.version===B.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ae=me(this.semver,"<",B.semver,G)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),ke=me(this.semver,">",B.semver,G)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return he||pe||Oe&&Ie||Ae||ke},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(B){var G=this.loose;B=B.trim(),P("range",B,G);var X=G?S[$]:S[M];B=B.replace(X,ye),P("hyphen replace",B),B=B.replace(S[j],"$1$2$3"),P("comparator trim",B,S[j]),B=(B=(B=B.replace(S[ee],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var he=G?S[ve]:S[V],pe=B.split(" ").map(function(Oe){return function(Ie,Ae){return P("comp",Ie),Ie=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){P("caret",Re,Le);var Ce=Le?S[se]:S[ue];return Re.replace(Ce,function(je,we,be,Pe,De){var Me;return P("caret",Re,je,we,be,Pe,De),oe(we)?Me="":oe(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":oe(Pe)?Me=we==="0"?">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":">="+we+"."+be+".0 <"+(+we+1)+".0.0":De?(P("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+De+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+De+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+De+" <"+(+we+1)+".0.0"):(P("no pr"),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+" <"+(+we+1)+".0.0"),P("caret return",Me),Me})}(Ue,Te)}).join(" ")}(Ie,Ae),P("caret",Ie),Ie=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){var Ce=Le?S[ie]:S[te];return Re.replace(Ce,function(je,we,be,Pe,De){var Me;return P("tilde",Re,je,we,be,Pe,De),oe(we)?Me="":oe(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":oe(Pe)?Me=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":De?(P("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=">="+we+"."+be+"."+Pe+De+" <"+we+"."+(+be+1)+".0"):Me=">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0",P("tilde return",Me),Me})}(Ue,Te)}).join(" ")}(Ie,Ae),P("tildes",Ie),Ie=function(ke,Te){return P("replaceXRanges",ke,Te),ke.split(/\s+/).map(function(Ue){return function(Re,Le){Re=Re.trim();var Ce=Le?S[N]:S[h];return Re.replace(Ce,function(je,we,be,Pe,De,Me){P("xRange",Re,je,we,be,Pe,De,Me);var We=oe(be),ze=We||oe(Pe),Be=ze||oe(De);return we==="="&&Be&&(we=""),We?je=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(Pe=0),Be&&(De=0),we===">"?(we=">=",ze?(be=+be+1,Pe=0,De=0):Be&&(Pe=+Pe+1,De=0)):we==="<="&&(we="<",ze?be=+be+1:Pe=+Pe+1),je=we+be+"."+Pe+"."+De):ze?je=">="+be+".0.0 <"+(+be+1)+".0.0":Be&&(je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),P("xRange return",je),je})}(Ue,Te)}).join(" ")}(Ie,Ae),P("xrange",Ie),Ie=function(ke,Te){return P("replaceStars",ke,Te),ke.trim().replace(S[W],"")}(Ie,Ae),P("stars",Ie),Ie}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new ce(Oe,G)})},ge.prototype.intersects=function(B,G){if(!(B instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(he){return B.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,G)})})})})},e.toComparators=function(B,G){return new ge(B,G).set.map(function(X){return X.map(function(he){return he.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new C(B,this.loose));for(var G=0;G<this.set.length;G++)if(Se(this.set[G],B))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(B,G,X){var he=null,pe=null;try{var Oe=new ge(G,X)}catch{return null}return B.forEach(function(Ie){Oe.test(Ie)&&(he&&pe.compare(Ie)!==-1||(pe=new C(he=Ie,X)))}),he},e.minSatisfying=function(B,G,X){var he=null,pe=null;try{var Oe=new ge(G,X)}catch{return null}return B.forEach(function(Ie){Oe.test(Ie)&&(he&&pe.compare(Ie)!==1||(pe=new C(he=Ie,X)))}),he},e.validRange=function(B,G){try{return new ge(B,G).range||"*"}catch{return null}},e.ltr=function(B,G,X){return Fe(B,G,"<",X)},e.gtr=function(B,G,X){return Fe(B,G,">",X)},e.outside=Fe,e.prerelease=function(B,G){var X=J(B,G);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(B,G,X){return B=new ge(B,X),G=new ge(G,X),B.intersects(G)},e.coerce=function(B){if(B instanceof C)return B;if(typeof B!="string")return null;var G=B.match(S[F]);return G==null?null:J((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,O(1))},function(x,e){var O,R,P=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function S(u){if(O===setTimeout)return setTimeout(u,0);if((O===D||!O)&&setTimeout)return O=setTimeout,setTimeout(u,0);try{return O(u,0)}catch{try{return O.call(null,u,0)}catch{return O.call(this,u,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:D}catch{O=D}try{R=typeof clearTimeout=="function"?clearTimeout:k}catch{R=k}})();var g,c=[],I=!1,p=-1;function d(){I&&g&&(I=!1,g.length?c=g.concat(c):p=-1,c.length&&w())}function w(){if(!I){var u=S(d);I=!0;for(var f=c.length;f;){for(g=c,c=[];++p<f;)g&&g[p].run();p=-1,f=c.length}g=null,I=!1,function(y){if(R===clearTimeout)return clearTimeout(y);if((R===k||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(y);try{R(y)}catch{try{return R.call(null,y)}catch{return R.call(this,y)}}}(u)}}function E(u,f){this.fun=u,this.array=f}function A(){}P.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)f[y-1]=arguments[y];c.push(new E(u,f)),c.length!==1||I||S(w)},E.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=A,P.addListener=A,P.once=A,P.off=A,P.removeListener=A,P.removeAllListeners=A,P.emit=A,P.prependListener=A,P.prependOnceListener=A,P.listeners=function(u){return[]},P.binding=function(u){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(u){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(S,g,c){this.level=S,this.key=g,this.value=c,this.forward=[]}}const P=void 0;class D{constructor(S,g=2**16){this.comparator=S,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P)}has(S){return Boolean(D.g(this,S,this.comparator))}get(S){return D.g(this,S,this.comparator)?.value}set(S,g){return D.h(this,S,g,this.comparator)&&(this.f+=1),this}delete(S){const g=D.k(this,S,this.comparator);return g&&(this.f-=1),g}forEach(S,g){let c=this.e.forward[0];for(;c;)S.call(g,c.value,c.key,this),c=c.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",g=this.e.forward[0];for(;g;)S+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return S}static g(S,g,c){let I=S.e;for(let p=S.d-1;p>=0;p--)for(;I.forward[p]&&c(I.forward[p].key,g)<0;)I=I.forward[p];if(I=I.forward[0],I&&c(I.key,g)===0)return I}static h(S,g,c,I){const p=[];let d=S.e;for(let w=S.d-1;w>=0;w--){for(;d.forward[w]&&I(d.forward[w].key,g)<0;)d=d.forward[w];p[w]=d}if(d=d.forward[0],d&&I(d.key,g)===0)return d.value=c,!1;{const w=D.j(S);if(w>S.d){for(let E=S.d;E<w;E++)p[E]=S.e;S.d=w}d=new R(w,g,c);for(let E=0;E<w;E++)d.forward[E]=p[E].forward[E],p[E].forward[E]=d;return!0}}static j(S,g=.5){let c=1;for(;Math.random()<g&&c<S.c;)c+=1;return c}static k(S,g,c){const I=[];let p=S.e;for(let d=S.d-1;d>=0;d--){for(;p.forward[d]&&c(p.forward[d].key,g)<0;)p=p.forward[d];I[d]=p}if(p=p.forward[0],!p||c(p.key,g)!==0)return!1;for(let d=0;d<S.d&&I[d].forward[d]===p;d++)I[d].forward[d]=p.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===P;)S.d-=1;return!0}}e.SkipList=D}),define(Z[43],Q([0,1,7,2]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(v){const m=v;return m?typeof m.read=="function":!1}e.isReadable=P;function D(v){const m=v;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function k(v){const m=v;return m?D(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=k;function S(v,m){return new g(v,m)}e.newWriteableStream=S;class g{constructor(m,t){this.e=m,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(t=>t(m))}h(m){this.c.error.length===0?(0,O.onUnexpectedError)(m):this.c.error.slice(0).forEach(t=>t(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,t){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(m,t){if(this.a.destroyed)return;let s;switch(m){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(v,m){const t=[];let s;for(;(s=v.read())!==null;)t.push(s);return m(t)}e.consumeReadable=c;function I(v,m,t){const s=[];let i;for(;(i=v.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?m(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return v.read()}}}e.peekReadable=I;function p(v,m){return new Promise((t,s)=>{const i=[];d(v,{onData:n=>{m&&i.push(n)},onError:n=>{m?s(n):t(void 0)},onEnd:()=>{t(m?m(i):void 0)}})})}e.consumeStream=p;function d(v,m){let t=!1;return v.on("error",s=>{t||m.onError(s)}),v.on("end",()=>{t||m.onEnd()}),v.on("data",s=>{t||m.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=d;function w(v,m){return new Promise((t,s)=>{const i=new R.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>m)return i.dispose(),v.pause(),t({stream:v,buffer:n,ended:!1})},a=l=>s(l),o=()=>t({stream:v,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>v.removeListener("error",a))),v.on("error",a),i.add((0,R.toDisposable)(()=>v.removeListener("end",o))),v.on("end",o),i.add((0,R.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=w;function E(v,m){const t=S(m);return t.end(v),t}e.toStream=E;function A(){const v=S(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=A;function u(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}e.toReadable=u;function f(v,m,t){const s=S(t);return d(v,{onData:i=>s.write(m.data(i)),onError:i=>s.error(m.error?m.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function y(v,m,t){let s=!1;return{read:()=>{const i=m.read();return s?i:(s=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=y;function b(v,m,t){let s=!1;const i=S(t);return d(m,{onData:n=>s?i.write(n):(s=!0,i.write(t([v,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(v)),i.end()}}),i}e.prefixedStream=b}),define(Z[14],Q([0,1,43]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let P,D;class k{static alloc(l){return R?new k(Buffer.allocUnsafe(l)):new k(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new k(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&R?new k(Buffer.from(l)):(P||(P=new TextEncoder),new k(P.encode(l)))}static fromByteArray(l){const h=k.alloc(l.length);for(let N=0,F=l.length;N<F;N++)h.buffer[N]=l[N];return h}static concat(l,h){if(typeof h>"u"){h=0;for(let Y=0,ee=l.length;Y<ee;Y++)h+=l[Y].byteLength}const N=k.alloc(h);let F=0;for(let Y=0,ee=l.length;Y<ee;Y++){const te=l[Y];N.set(te,F),F+=te.byteLength}return N}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=k.alloc(this.byteLength);return l.set(this),l}toString(){return R?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(l,h){return new k(this.buffer.subarray(l,h))}set(l,h){if(l instanceof k)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return c(this.buffer,l)}writeUInt32BE(l,h){I(this.buffer,l,h)}readUInt32LE(l){return p(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return w(this.buffer,l)}writeUInt8(l,h){E(this.buffer,l,h)}}e.VSBuffer=k;function S(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=S;function g(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255}e.writeUInt16LE=g;function c(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=c;function I(o,l,h){o[h+3]=l,l=l>>>8,o[h+2]=l,l=l>>>8,o[h+1]=l,l=l>>>8,o[h]=l}e.writeUInt32BE=I;function p(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=p;function d(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255,l=l>>>8,o[h+2]=l&255,l=l>>>8,o[h+3]=l&255}e.writeUInt32LE=d;function w(o,l){return o[l]}e.readUInt8=w;function E(o,l,h){o[h]=l}e.writeUInt8=E;function A(o){return O.consumeReadable(o,l=>k.concat(l))}e.readableToBuffer=A;function u(o){return O.toReadable(o)}e.bufferToReadable=u;function f(o){return O.consumeStream(o,l=>k.concat(l))}e.streamToBuffer=f;async function y(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await f(o.stream)])}e.bufferedStreamToBuffer=y;function b(o){return O.toStream(o,l=>k.concat(l))}e.bufferToStream=b;function v(o){return O.transform(o,{data:l=>typeof l=="string"?k.fromString(l):k.wrap(l)},l=>k.concat(l))}e.streamToBufferReadableStream=v;function m(o){return O.newWriteableStream(l=>k.concat(l),o)}e.newWriteableBufferStream=m;function t(o,l){return O.prefixedReadable(o,l,h=>k.concat(h))}e.prefixedBufferReadable=t;function s(o,l){return O.prefixedStream(o,l,h=>k.concat(h))}e.prefixedBufferStream=s;function i(o){let l=0,h=0,N=0;const F=new Uint8Array(Math.floor(o.length/4*3)),Y=te=>{switch(h){case 3:F[N++]=l|te,h=0;break;case 2:F[N++]=l|te>>>2,l=te<<6,h=3;break;case 1:F[N++]=l|te>>>4,l=te<<4,h=2;break;default:l=te<<2,h=1}};for(let te=0;te<o.length;te++){const ie=o.charCodeAt(te);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[te]}`)}}const ee=N;for(;h>0;)Y(0);return k.wrap(F).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},l=!0,h=!1){const N=h?r:n;let F="";const Y=o.byteLength%3;let ee=0;for(;ee<o.byteLength-Y;ee+=3){const te=o[ee+0],ie=o[ee+1],ne=o[ee+2];F+=N[te>>>2],F+=N[(te<<4|ie>>>4)&63],F+=N[(ie<<2|ne>>>6)&63],F+=N[ne&63]}if(Y===1){const te=o[ee+0];F+=N[te>>>2],F+=N[te<<4&63],l&&(F+="==")}else if(Y===2){const te=o[ee+0],ie=o[ee+1];F+=N[te>>>2],F+=N[(te<<4|ie>>>4)&63],F+=N[ie<<2&63],l&&(F+="=")}return F}e.encodeBase64=a}),define(Z[28],Q([0,1,3]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,v])=>{y[b]=v&&typeof v=="object"?R(v):v}),y}e.deepClone=R;function P(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const b=y.shift();Object.freeze(b);for(const v in b)if(D.call(b,v)){const m=b[v];typeof m=="object"&&!Object.isFrozen(m)&&!(0,O.isTypedArray)(m)&&y.push(m)}}return f}e.deepFreeze=P;const D=Object.prototype.hasOwnProperty;function k(f,y){return S(f,y,new Set)}e.cloneAndChange=k;function S(f,y,b){if((0,O.isUndefinedOrNull)(f))return f;const v=y(f);if(typeof v<"u")return v;if(Array.isArray(f)){const m=[];for(const t of f)m.push(S(t,y,b));return m}if((0,O.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const m={};for(const t in f)D.call(f,t)&&(m[t]=S(f[t],y,b));return b.delete(f),m}return f}function g(f,y,b=!0){return(0,O.isObject)(f)?((0,O.isObject)(y)&&Object.keys(y).forEach(v=>{v in f?b&&((0,O.isObject)(f[v])&&(0,O.isObject)(y[v])?g(f[v],y[v],b):f[v]=y[v]):f[v]=y[v]}),f):y}e.mixin=g;function c(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let b,v;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(b=0;b<f.length;b++)if(!c(f[b],y[b]))return!1}else{const m=[];for(v in f)m.push(v);m.sort();const t=[];for(v in y)t.push(v);if(t.sort(),!c(m,t))return!1;for(b=0;b<m.length;b++)if(!c(f[m[b]],y[m[b]]))return!1}return!0}e.equals=c;function I(f){const y=new Set;return JSON.stringify(f,(b,v)=>{if((0,O.isObject)(v)||Array.isArray(v)){if(y.has(v))return"[Circular]";y.add(v)}return v})}e.safeStringify=I;function p(f,y){const b=Object.create(null);return!f||!y||Object.keys(y).forEach(m=>{const t=f[m],s=y[m];c(t,s)||(b[m]=s)}),b}e.distinct=p;function d(f,y){const b=y.toLowerCase(),v=Object.keys(f).find(m=>m.toLowerCase()===b);return v?f[v]:f[y]}e.getCaseInsensitive=d;function w(f,y){const b=Object.create(null);for(const[v,m]of Object.entries(f))y(v,m)&&(b[v]=m);return b}e.filter=w;function E(f){let y=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)y=y.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return y}e.getAllPropertyNames=E;function A(f){const y=[];for(const b of E(f))typeof f[b]=="function"&&y.push(b);return y}e.getAllMethodNames=A;function u(f,y){const b=m=>function(){const t=Array.prototype.slice.call(arguments,0);return y(m,t)},v={};for(const m of f)v[m]=b(m);return v}e.createProxyObject=u}),define(Z[29],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return O.test(P)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(S){for(let g=0;g<S.length;g++)S[g]=Math.floor(Math.random()*256);return S};const D=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));return function(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let g=0,c="";return c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+="-",c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c+=k[D[g++]],c}}()}),define(Z[73],Q([0,1,33]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(k){const S=k.replace(/\-/g,":").toLowerCase();return!R.has(S)}function D(){const k=(0,O.networkInterfaces)();for(const S in k){const g=k[S];if(g){for(const{mac:c}of g)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[74],Q([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,P=R*60,D=P*24,k=D*7,S=D*30,g=D*365;function c(p,d,w,E){typeof p!="number"&&(p=p.getTime());const A=Math.round((new Date().getTime()-p)/1e3);if(A<-30)return(0,O.localize)(0,null,c(new Date().getTime()+A*1e3,!1));if(!E&&A<30)return(0,O.localize)(1,null);let u;return A<R?(u=A,d?u===1?w?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):w?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u):u===1?w?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):w?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):A<P?(u=Math.floor(A/R),d?u===1?w?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):w?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u):u===1?w?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):w?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):A<D?(u=Math.floor(A/P),d?u===1?w?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):w?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u):u===1?w?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):w?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):A<k?(u=Math.floor(A/D),d?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u)):A<S?(u=Math.floor(A/k),d?u===1?w?(0,O.localize)(30,null,u):(0,O.localize)(31,null,u):w?(0,O.localize)(32,null,u):(0,O.localize)(33,null,u):u===1?w?(0,O.localize)(34,null,u):(0,O.localize)(35,null,u):w?(0,O.localize)(36,null,u):(0,O.localize)(37,null,u)):A<g?(u=Math.floor(A/S),d?u===1?w?(0,O.localize)(38,null,u):(0,O.localize)(39,null,u):w?(0,O.localize)(40,null,u):(0,O.localize)(41,null,u):u===1?w?(0,O.localize)(42,null,u):(0,O.localize)(43,null,u):w?(0,O.localize)(44,null,u):(0,O.localize)(45,null,u)):(u=Math.floor(A/g),d?u===1?w?(0,O.localize)(46,null,u):(0,O.localize)(47,null,u):w?(0,O.localize)(48,null,u):(0,O.localize)(49,null,u):u===1?w?(0,O.localize)(50,null,u):(0,O.localize)(51,null,u):w?(0,O.localize)(52,null,u):(0,O.localize)(53,null,u))}e.fromNow=c;function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[76],Q([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,3,76]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(p,d){return d&&(p.stack||p.stacktrace)?P.localize(0,null,S(p),k(p.stack)||k(p.stacktrace)):S(p)}function k(p){return Array.isArray(p)?p.join(`
`):p}function S(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?P.localize(1,null,p.message):p.message||P.localize(2,null)}function g(p=null,d=!1){if(!p)return P.localize(3,null);if(Array.isArray(p)){const w=O.coalesce(p),E=g(w[0],d);return w.length>1?P.localize(4,null,E,w.length):E}if(R.isString(p))return p;if(p.detail){const w=p.detail;if(w.error)return D(w.error,d);if(w.exception)return D(w.exception,d)}return p.stack?D(p,d):p.message?p.message:P.localize(5,null)}e.toErrorMessage=g;function c(p){const d=p;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=c;function I(p,d){let w;return typeof p=="string"?w=new Error(p):w=p,w.actions=d,w}e.createErrorWithActions=I}),define(Z[77],Q([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(P){switch(P){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Z[50],Q([0,1,12]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var P;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...g){const c=g.reduce((d,w)=>(d[w]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!c[d]).forEach(d=>{for(let w=0;w<I.length;w++)if(d.search(I[w])!==-1){delete S[d];break}})}e.sanitizeProcessEnvironment=D;function k(S){!S||(delete S.DEBUG,O.isMacintosh&&delete S.DYLD_LIBRARY_PATH,O.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(Z[51],Q([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return P(f,0)}e.hash=R;function P(f,y){switch(typeof f){case"object":return f===null?D(349,y):Array.isArray(f)?g(f,y):c(f,y);case"string":return S(f,y);case"boolean":return k(f,y);case"number":return D(f,y);case"undefined":return D(937,y);default:return D(617,y)}}e.doHash=P;function D(f,y){return(y<<5)-y+f|0}e.numberHash=D;function k(f,y){return D(f?433:863,y)}function S(f,y){y=D(149417,y);for(let b=0,v=f.length;b<v;b++)y=D(f.charCodeAt(b),y);return y}e.stringHash=S;function g(f,y){return y=D(104579,y),f.reduce((b,v)=>P(v,b),y)}function c(f,y){return y=D(181387,y),Object.keys(f).sort().reduce((b,v)=>(b=S(v,b),P(f[v],b)),y)}class I{constructor(){this.g=0}get value(){return this.g}hash(y){return this.g=P(y,this.g),this.g}}e.Hasher=I;var p;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function d(f,y,b=32){const v=b-y,m=~((1<<v)-1);return(f<<y|(m&f)>>>v)>>>0}function w(f,y=0,b=f.byteLength,v=0){for(let m=0;m<b;m++)f[y+m]=v}function E(f,y,b="0"){for(;f.length<y;)f=b+f;return f}function A(f,y=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),y/4)}e.toHexString=A;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const b=y.length;if(b===0)return;const v=this.p;let m=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=y.charCodeAt(0),i=0);;){let n=s;if(O.isHighSurrogate(s))if(i+1<b){const r=y.charCodeAt(i+1);O.isLowSurrogate(r)?(i++,n=O.computeCodePoint(s,r)):n=65533}else{t=s;break}else O.isLowSurrogate(s)&&(n=65533);if(m=this.w(v,m,n),i++,i<b)s=y.charCodeAt(i);else break}this.r=m,this.u=t}w(y,b,v){return v<128?y[b++]=v:v<2048?(y[b++]=192|(v&1984)>>>6,y[b++]=128|(v&63)>>>0):v<65536?(y[b++]=224|(v&61440)>>>12,y[b++]=128|(v&4032)>>>6,y[b++]=128|(v&63)>>>0):(y[b++]=240|(v&1835008)>>>18,y[b++]=128|(v&258048)>>>12,y[b++]=128|(v&4032)>>>6,y[b++]=128|(v&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=u.g,b=this.q;for(let o=0;o<64;o+=4)y.setUint32(o,b.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)y.setUint32(o,d(y.getUint32(o-12,!1)^y.getUint32(o-32,!1)^y.getUint32(o-56,!1)^y.getUint32(o-64,!1),1),!1);let v=this.h,m=this.l,t=this.m,s=this.n,i=this.o,n,r,a;for(let o=0;o<80;o++)o<20?(n=m&t|~m&s,r=1518500249):o<40?(n=m^t^s,r=1859775393):o<60?(n=m&t|m&s|t&s,r=2400959708):(n=m^t^s,r=3395469782),a=d(v,5)+n+i+r+y.getUint32(o*4,!1)&4294967295,i=s,s=t,t=d(m,30),m=v,v=a;this.h=this.h+v&4294967295,this.l=this.l+m&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(Z[52],Q([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const D="error",k="warning",S="warn",g="info",c="ignore";function I(d){return d?O.equalsIgnoreCase(D,d)?P.Error:O.equalsIgnoreCase(k,d)||O.equalsIgnoreCase(S,d)?P.Warning:O.equalsIgnoreCase(g,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function p(d){switch(d){case P.Error:return D;case P.Warning:return k;case P.Info:return g;default:return c}}P.toString=p}(R||(R={})),e.default=R}),define(Z[79],Q([0,1,11]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=R;function P(c){const I=[];let p;try{const d=JSON.parse(c.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),p=w.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:p}}e.parse=P;function D(c){if(typeof c!="string")return D(P(c).stack);const I=c;if(I){const p=k(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=D;function k(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function S(c,I){const{args:p,stack:d}=P(c),w=typeof p[0]=="string"&&p.length===1;let E=k(d);E&&(E=`(${E.trim()})`);let A=[];if(typeof p[0]=="string"?E&&w?A=[`%c[${I}] %c${p[0]} %c${E}`,g("blue"),g(""),g("grey")]:A=[`%c[${I}] %c${p[0]}`,g("blue"),g(""),...p.slice(1)]:A=[`%c[${I}]%`,g("blue"),...p],E&&!w&&A.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,A)}e.log=S;function g(c){return`color: ${c}`}}),define(Z[53],Q([0,1,14,30,11]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(c){return JSON.stringify(c,S)}e.stringify=D;function k(c){let I=JSON.parse(c);return I=g(I),I}e.parse=k;function S(c,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function g(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return P.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof O.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let p=0;p<c.length;++p)c[p]=g(c[p],I+1);else for(const p in c)Object.hasOwnProperty.call(c,p)&&(c[p]=g(c[p],I+1))}return c}e.revive=g}),define(Z[80],Q([0,1,33,7,54,29,73]),function(x,e,O,R,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,p=0;const d=(0,O.networkInterfaces)();for(const w in d){const E=d[w];if(E)for(const{mac:A,internal:u}of E)u||(p+=1,this.c(A.toUpperCase())&&(I+=1))}this.b=p>0?I/p:0}return this.b}};let S;async function g(){return S||(S=(async()=>await c()||D.generateUuid())()),S}e.getMachineId=g;async function c(){try{const I=await new Promise((d,w)=>{x(["crypto"],d,w)}),p=(0,k.getMac)();return I.createHash("sha256").update(p,"utf8").digest("hex")}catch(I){R.onUnexpectedError(I);return}}}),define(Z[81],Q([0,1,33,15,20]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class p{constructor(m,t,s){this.exePath=m,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:v=!1}={}){return v?c===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:v=!1,findPreview:m=!1}={}){const t=d({useAlternateBitness:v});if(!t)return null;const s=R.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const o of await P.Promises.readdir(s)){let l=-1;if(m){const N=o.indexOf("-");if(N<0)continue;const F=o.substring(0,N);if(!D.test(F)||o.substring(N+1)!=="preview")continue;l=parseInt(F,10)}else{if(!D.test(o))continue;l=parseInt(o,10)}if(l<=i)continue;const h=R.join(s,o,"pwsh.exe");!await P.SymlinkSupport.existsFile(h)||(n=h,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",a=m?" Preview":"";return new p(n,`PowerShell${a}${r}`,!0)}async function E({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const m=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=v?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await P.Promises.readdir(m))if(t.test(i)){const n=R.join(m,i,"pwsh.exe");return new p(n,s)}return null}function A(){const v=R.join(O.homedir(),".dotnet","tools","pwsh.exe");return new p(v,".NET Core PowerShell Global Tool")}function u(){const v=R.join(process.env.windir,c===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(v,"Windows PowerShell",!0)}async function*f(){let v=await w();v&&(yield v),v=await w({useAlternateBitness:!0}),v&&(yield v),v=await E(),v&&(yield v),v=A(),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await E({findPreview:!0}),v&&(yield v),v=await w({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=u(),v&&(yield v)}async function*y(){for await(const v of f())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=y;async function b(){for await(const v of y())return v;return null}e.getFirstAvailablePowerShellInstallation=b}),define(Z[55],Q([0,1,15,12,35,50,3,20]),function(x,e,O,R,P,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function g(p=P.env){return p.comspec||"cmd.exe"}e.getWindowsShell=g;function c(p){let d=[],w=!1;const E=function(A){if(w){d.push(A);return}(!p.send(A,f=>{if(f&&console.error(f),w=!1,d.length>0){const y=d.slice(0);d=[],y.forEach(b=>E(b))}})||R.isWindows)&&(w=!0)};return{send:E}}e.createQueuedSender=c;var I;(function(p){async function d(w,E,A){if(O.isAbsolute(w))return w;if(E===void 0&&(E=P.cwd()),O.dirname(w)!=="."||(A===void 0&&k.isString(P.env.PATH)&&(A=P.env.PATH.split(O.delimiter)),A===void 0||A.length===0))return O.join(E,w);async function f(y){if(await S.Promises.exists(y)){let b;try{b=await S.Promises.stat(y)}catch(v){v.message.startsWith("EACCES")&&(b=await S.Promises.lstat(y))}return b?!b.isDirectory():!1}return!1}for(const y of A){let b;if(O.isAbsolute(y)?b=O.join(y,w):b=O.join(E,y,w),await f(b))return b;let v=b+".com";if(await f(v)||(v=b+".exe",await f(v)))return v}return O.join(E,w)}p.findExecutable=d})(I=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(p,d){return p===1?R.isWindows?I():D.getWindowsShell(d):g(p,d)}e.getSystemShell=k;let S=null;function g(p,d){if(R.isLinux&&p===2||R.isMacintosh&&p===3)return"/bin/bash";if(!S){let w;if(R.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,O.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let c=null;async function I(){return c||(c=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),c}});var fe=this&&this.__decorate||function(x,e,O,R){var P=arguments.length,D=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,O):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,O,R);else for(var S=x.length-1;S>=0;S--)(k=x[S])&&(D=(P<3?k(D):P>3?k(e,O,D):k(e,O))||D);return P>3&&D&&Object.defineProperty(e,O,D),D};define(Z[56],Q([0,1,19,5,14,23,48,7,4,2,53,30,3]),function(x,e,O,R,P,D,k,S,g,c,I,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var w;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(w||(w={}));function E(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var A;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(A||(A={}));function u(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));function y(j){let M=0;for(let $=0;;$+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<$,!(W.buffer[0]&128))return M}}const b=i(0);function v(j,M){if(M===0){j.write(b);return}let $=0;for(let q=M;q!==0;q=q>>>7)$++;const W=P.VSBuffer.alloc($);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class m{constructor(M){this.b=M,this.a=0}read(M){const $=this.b.slice(this.a,this.a+M);return this.a+=$.byteLength,$}}e.BufferReader=m;class t{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=P.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function a(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const $=P.VSBuffer.fromString(M);j.write(n.String),v(j,$.byteLength),j.write($)}else if(r&&Buffer.isBuffer(M)){const $=P.VSBuffer.wrap(M);j.write(n.Buffer),v(j,$.byteLength),j.write($)}else if(M instanceof P.VSBuffer)j.write(n.VSBuffer),v(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),v(j,M.length);for(const $ of M)a(j,$)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),v(j,M);else{const $=P.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),v(j,$.byteLength),j.write($)}}e.serialize=a;function o(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(y(j)).toString();case s.Buffer:return j.read(y(j)).buffer;case s.VSBuffer:return j.read(y(j));case s.Array:{const $=y(j),W=[];for(let q=0;q<$;q++)W.push(o(j));return W}case s.Object:return JSON.parse(j.read(y(j)).toString());case s.Int:return y(j)}}e.deserialize=o;class l{constructor(M,$,W=null,q=1e3){this.h=M,this.j=$,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(M,$){this.b.set(M,$),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const $=this.o([M.type]);this.k?.logOutgoing($,0,1,u(M.type));return}case 201:case 202:case 204:case 203:{const $=this.o([M.type,M.id],M.data);this.k?.logOutgoing($,M.id,1,u(M.type),M.data);return}}}o(M,$=void 0){const W=new t;return a(W,M),a(W,$),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const $=new m(M),W=o($),q=o($),J=W[0];switch(J){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(J)}: ${W[2]}.${W[3]}`,q),this.s({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(J)}: ${W[2]}.${W[3]}`,q),this.t({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(J)}`),this.u({type:J,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(J)}`),this.u({type:J,id:W[1]})}}s(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=new D.CancellationTokenSource;let q;try{q=$.call(this.j,M.name,M.arg,W.token)}catch(L){q=Promise.reject(L)}const J=M.id;q.then(L=>{this.m({id:J,data:L,type:201}),this.d.delete(M.id)},L=>{L instanceof Error?this.m({id:J,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:J,data:L,type:203}),this.d.delete(M.id)});const C=(0,c.toDisposable)(()=>W.cancel());this.d.set(M.id,C)}t(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=M.id,J=$.listen(this.j,M.name,M.arg)(C=>this.m({id:W,data:C,type:204}));this.d.set(M.id,J)}u(M){const $=this.d.get(M.id);$&&($.dispose(),this.d.delete(M.id))}v(M){let $=this.g.get(M.channelName);$||($=[],this.g.set(M.channelName,$));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:M,timeoutTimer:W})}w(M){const $=this.g.get(M);if($){for(const W of $)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var h;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class N{constructor(M,$=null){this.l=M,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=$}getChannel(M){const $=this;return{call(W,q,J){return $.a?Promise.reject(new S.CancellationError):$.m(M,W,q,J)},listen(W,q){return $.a?g.Event.None:$.o(M,W,q)}}}m(M,$,W,q=D.CancellationToken.None){const J=this.g++,L={id:J,type:100,channelName:M,name:$,arg:W};if(q.isCancellationRequested)return Promise.reject(new S.CancellationError);let T;return new Promise((z,K)=>{if(q.isCancellationRequested)return K(new S.CancellationError);const H=()=>{const me=ce=>{switch(ce.type){case 201:this.f.delete(J),z(ce.data);break;case 202:{this.f.delete(J);const de=new Error(ce.data.message);de.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,de.name=ce.data.name,K(de);break}case 203:this.f.delete(J),K(ce.data);break}};this.f.set(J,me),this.p(L)};let re=null;this.b===f.Idle?H():(re=(0,R.createCancelablePromise)(me=>this.u()),re.then(()=>{re=null,H()}));const le=()=>{re?(re.cancel(),re=null):this.p({id:J,type:101}),K(new S.CancellationError)},Ee=q.onCancellationRequested(le);T=(0,c.combinedDisposable)((0,c.toDisposable)(le),Ee),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(M,$,W){const q=this.g++,C={id:q,type:102,channelName:M,name:$,arg:W};let L=null;const T=new g.Emitter({onWillAddFirstListener:()=>{L=(0,R.createCancelablePromise)(z=>this.u()),L.then(()=>{L=null,this.d.add(T),this.p(C)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(T),this.p({id:q,type:103}))}}),U=z=>T.fire(z.data);return this.f.set(q,U),T.event}p(M){switch(M.type){case 100:case 102:{const $=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing($,M.id,0,`${E(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.q([M.type,M.id]);this.j?.logOutgoing($,M.id,0,E(M.type));return}}}q(M,$=void 0){const W=new t;return a(W,M),a(W,$),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const $=new m(M),W=o($),q=o($),J=W[0];switch(J){case 200:return this.j?.logIncoming(M.byteLength,0,0,u(J)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,u(J),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}fe([k.memoize],N.prototype,"onDidInitializePromise",null),e.ChannelClient=N;class F{get connections(){const M=[];return this.f.forEach($=>M.push($)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:$,onDidClientDisconnect:W})=>{g.Event.once($.onMessage)(J=>{const C=new m(J),L=o(C),T=new l($,L),U=new N($);this.a.forEach((K,H)=>T.registerChannel(H,K));const z={channelServer:T,channelClient:U,ctx:L};this.f.add(z),this.g.fire(z),W(()=>{T.dispose(),U.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(M,$){const W=this;return{call(q,J,C){let L;if((0,d.isFunction)($)){const U=(0,O.getRandomElement)(W.connections.filter($));L=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,$))}else L=$.routeCall(W,q,J);const T=L.then(U=>U.channelClient.getChannel(M));return ee(T).call(q,J,C)},listen(q,J){if((0,d.isFunction)($))return W.j(M,$,q,J);const C=$.routeEvent(W,q,J).then(L=>L.channelClient.getChannel(M));return ee(C).listen(q,J)}}}j(M,$,W,q){const J=this;let C=new c.DisposableStore;const L=new g.Emitter({onWillAddFirstListener:()=>{C=new c.DisposableStore;const T=new g.EventMultiplexer,U=new Map,z=H=>{const le=H.channelClient.getChannel(M).listen(W,q),Ee=T.add(le);U.set(H,Ee)},K=H=>{const re=U.get(H);!re||(re.dispose(),U.delete(H))};J.connections.filter($).forEach(z),g.Event.filter(J.onDidAddConnection,$)(z,void 0,C),J.onDidRemoveConnection(K,void 0,C),T.event(L.fire,L,C),C.add(T)},onDidRemoveLastListener:()=>{C.dispose()}});return L.event}registerChannel(M,$){this.a.set(M,$),this.f.forEach(W=>{W.channelServer.registerChannel(M,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Y{constructor(M,$,W=null){const q=new t;a(q,$),M.send(q.buffer),this.a=new N(M,W),this.d=new l(M,$,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,$){this.d.registerChannel(M,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function ee(j){return{call(M,$,W){return j.then(q=>q.call(M,$,W))},listen(M,$){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,$)),W.event}}}e.getDelayedChannel=ee;function te(j){let M=!1;return{call($,W,q){return M?j.call($,W,q):(0,R.timeout)(0).then(()=>M=!0).then(()=>j.call($,W,q))},listen($,W){if(M)return j.listen($,W);const q=new g.Relay;return(0,R.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen($,W)),q.event}}}e.getNextTickChannel=te;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const $ of M.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(J,C){const L=J,T=C&&C.disableMarshalling,U=new Map;for(const z in L)W(z)&&U.set(z,g.Event.buffer(L[z],!0));return new class{listen(z,K,H){const re=U.get(K);if(re)return re;if(q(K)){const le=L[K];if(typeof le=="function")return le.call(L,H)}throw new Error(`Event not found: ${K}`)}call(z,K,H){const re=L[K];if(typeof re=="function"){if(!T&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,I.revive)(H[le]);return re.apply(L,H)}throw new Error(`Method not found: ${K}`)}}}j.fromService=M;function $(J,C){const L=C&&C.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):q(U)?function(z){return J.listen(U,z)}:W(U)?J.listen(U):async function(...z){let K;C&&!(0,d.isUndefinedOrNull)(C.context)?K=[C.context,...z]:K=z;const H=await J.call(U,K);return L?H:(0,I.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=$;function W(J){return J[0]==="o"&&J[1]==="n"&&p.isUpperAsciiLetter(J.charCodeAt(2))}function q(J){return/^onDynamic/.test(J)&&p.isUpperAsciiLetter(J.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function se(j){return Array.isArray(j)?j.map(ue):ue(j)}function ve(j,M,$,W,q,J,C){C=se(C);const L=ae[q],T=L[W%L.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(J)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class V{constructor(M,$){this.d=M,this.f=$,this.a=0,this.b=0}logOutgoing(M,$,W,q,J){this.b+=M,ve(this.d,this.b,M,$,W,q,J)}logIncoming(M,$,W,q,J){this.a+=M,ve(this.f,this.a,M,$,W,q,J)}}e.IPCLogger=V}),define(Z[83],Q([0,1,57,5,14,23,79,7,4,2,28,55,50,56]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends w.ChannelServer{constructor(f){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",y=>P.VSBuffer.wrap(Buffer.from(y,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=E;class A{constructor(f,y){this.i=f,this.j=y,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const b=y&&y.timeout?y.timeout:6e4;this.b=new R.Delayer(b),this.d=null,this.f=null}getChannel(f){const y=this;return{call(b,v,m){return y.k(f,b,v,m)},listen(b,v){return y.l(f,b,v)}}}k(f,y,b,v=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(S.canceled());this.b.cancel();const m=this.n(f),t=(0,R.createCancelablePromise)(n=>m.call(y,b,n)),s=v.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,y,b){if(!this.b)return g.Event.None;this.b.cancel();let v;const m=new g.Emitter({onWillAddFirstListener:()=>{v=this.n(f).listen(y,b)(m.fire,m),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],y=Object.create(null);y.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(y.env={...y.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(y.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(y.env),this.d=(0,O.fork)(this.i,f,y);const b=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.j.serverName}`);return}b.fire(P.VSBuffer.wrap(Buffer.from(r,"base64")))});const m=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&m.send(r.buffer.toString("base64")),s=b.event,i={send:t,onMessage:s};this.f=new w.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,c.dispose)(o)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(f){let y=this.g.get(f);return y||(y=this.m.getChannel(f),this.g.set(f,y)),y}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=A}),define(Z[84],Q([0,1,5,4,2,3]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function S(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var g;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class c extends P.Disposable{constructor(d,w=Object.create(null)){super(),this.m=d,this.n=w,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new O.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((w,E)=>this.s(E,w)),d.deleted?.forEach(w=>this.s(w,void 0))}s(d,w){if(this.c===g.Closed)return;let E=!1;(0,D.isUndefinedOrNull)(w)?E=this.f.delete(d):this.f.get(d)!==w&&(this.f.set(d,w),E=!0),E&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,w){const E=this.f.get(d);return(0,D.isUndefinedOrNull)(E)?w:E}getBoolean(d,w){const E=this.get(d);return(0,D.isUndefinedOrNull)(E)?w:E==="true"}getNumber(d,w){const E=this.get(d);return(0,D.isUndefinedOrNull)(E)?w:parseInt(E,10)}async set(d,w){if(this.c===g.Closed)return;if((0,D.isUndefinedOrNull)(w))return this.delete(d);const E=String(w);if(this.f.get(d)!==E)return this.f.set(d,E),this.j.set(d,E),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===g.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(!!this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(!!this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===k.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class I{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((w,E)=>this.a.set(E,w)),d.delete?.forEach(w=>this.a.delete(w))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[85],Q([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,48,16,15,35,18,11]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,D.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(g.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=k.env.VSCODE_PORTABLE;return E?g.URI.file((0,D.join)(E,"argv.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,D.resolve)(E):(0,D.normalize)((0,D.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?g.URI.file((0,D.resolve)(E)):g.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,D.resolve)(E);const A=k.env.VSCODE_EXTENSIONS;if(A)return A;const u=k.env.VSCODE_PORTABLE;return u?(0,D.join)(u,"extensions"):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(A=>/^[^:/?#]+?:\/\//.test(A)?g.URI.parse(A):g.URI.file((0,D.normalize)(A)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?g.URI.parse(E):g.URI.file((0,D.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const A of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(A);u&&u[1]&&u[2]&&E.push([u[1],u[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,S.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=k.env.VSCODE_PORTABLE;return E?g.URI.file((0,D.join)(E,"policy.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this.a}constructor(E,A,u){this.a=E,this.b=A,this.c=u,this.editSessionId=this.args.editSessionId}}fe([R.memoize],c.prototype,"appRoot",null),fe([R.memoize],c.prototype,"userHome",null),fe([R.memoize],c.prototype,"userDataPath",null),fe([R.memoize],c.prototype,"appSettingsHome",null),fe([R.memoize],c.prototype,"tmpDir",null),fe([R.memoize],c.prototype,"cacheHome",null),fe([R.memoize],c.prototype,"stateResource",null),fe([R.memoize],c.prototype,"userRoamingDataHome",null),fe([R.memoize],c.prototype,"userDataSyncHome",null),fe([R.memoize],c.prototype,"userDataSyncLogResource",null),fe([R.memoize],c.prototype,"editSessionsLogResource",null),fe([R.memoize],c.prototype,"sync",null),fe([R.memoize],c.prototype,"machineSettingsResource",null),fe([R.memoize],c.prototype,"workspaceStorageHome",null),fe([R.memoize],c.prototype,"localHistoryHome",null),fe([R.memoize],c.prototype,"keyboardLayoutResource",null),fe([R.memoize],c.prototype,"argvResource",null),fe([R.memoize],c.prototype,"isExtensionDevelopment",null),fe([R.memoize],c.prototype,"untitledWorkspacesHome",null),fe([R.memoize],c.prototype,"installSourcePath",null),fe([R.memoize],c.prototype,"builtinExtensionsPath",null),fe([R.memoize],c.prototype,"extensionsPath",null),fe([R.memoize],c.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],c.prototype,"extensionDevelopmentKind",null),fe([R.memoize],c.prototype,"extensionTestsLocationURI",null),fe([R.memoize],c.prototype,"debugExtensionHost",null),fe([R.memoize],c.prototype,"logLevel",null),fe([R.memoize],c.prototype,"extensionLogLevel",null),fe([R.memoize],c.prototype,"serviceMachineIdResource",null),fe([R.memoize],c.prototype,"telemetryLogResource",null),fe([R.memoize],c.prototype,"disableWorkspaceTrust",null),fe([R.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function I(w,E){return d(w["inspect-extensions"],w["inspect-brk-extensions"],5870,E,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=I;function p(w,E){return d(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,E,w.extensionEnvironment)}e.parsePtyHostPort=p;function d(w,E,A,u,f,y){const v=Number(E||w)||(u?null:A),m=v?Boolean(!!E):!1;let t;if(y)try{t=JSON.parse(y)}catch{}return{port:v,break:m,debugId:f,env:t}}}),function(){"use strict";function x(e,O,R){function P(k,S){const g=D(k,S),c=[g];return e.isAbsolute(g)||c.unshift(R),e.resolve(...c)}function D(k,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,S);const I=k["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(O.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,S)}return{getUserDataPath:P}}if(typeof define=="function")define(Z[105],Q([157,33,35]),function(e,O,R){return x(e,O,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=x(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends R.AbstractNativeEnvironmentService{constructor(S,g){super(S,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,P.getUserDataPath)(S,g.nameShort)},g)}}e.NativeEnvironmentService=D}),define(Z[107],Q([0,1,3,90]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(k,S,g){try{D(k,S,g)}catch(c){console.error(c?.message??c)}return k}e.localizeManifest=P;function D(k,S,g){const c=(I,p,d)=>{const w=I[p];if((0,O.isString)(w)){const E=w,A=E.length;if(A>1&&E[0]==="%"&&E[A-1]==="%"){const u=E.substr(1,A-2);let f=S[u];f===void 0&&g&&(f=g[u]);const y=typeof f=="string"?f:f?.message,b=g?.[u],v=typeof b=="string"?b:b?.message;if(!y){v||console.warn(`[${k.name}]: ${(0,R.localize)(0,null,u)}`);return}if(d&&(p==="title"||p==="category")&&v&&v!==y){const m={value:y,original:v};I[p]=m}else I[p]=y}}else if((0,O.isObject)(w))for(const E in w)w.hasOwnProperty(E)&&(E==="commands"?c(w,E,!0):c(w,E,d));else if(Array.isArray(w))for(let E=0;E<w.length;E++)c(w,E,d)};for(const I in k)k.hasOwnProperty(I)&&c(k,I)}}),define(Z[108],Q([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(D,k){this.a.set(D,k)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const k in D.contributes){const S=this.a.get(k);if(!S)continue;const g=D.contributes[k],c=Array.isArray(g)?g:[g];try{S(c,D.activationEvents)}catch(I){(0,O.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Z[44],Q([0,1,18,52,94,41]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=g;function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=f.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=c;function I(f){if(!f)return null;const y=f.majorBase,b=f.majorMustEqual,v=f.minorBase;let m=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(y===0||(m=!1),s=!1);let i=0;if(f.preRelease){const n=S.exec(f.preRelease);if(n){const[,r,a,o]=n;i=Date.UTC(Number(r),Number(a)-1,Number(o))}}return{majorBase:y,majorMustEqual:b,minorBase:v,minorMustEqual:m,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function p(f,y,b){let v;typeof f=="string"?v=I(c(f)):v=f;let m;y instanceof Date?m=y.getTime():typeof y=="string"&&(m=new Date(y).getTime());let t;if(typeof b=="string"?t=I(c(b)):t=b,!v||!t)return!1;const s=v.majorBase,i=v.minorBase,n=v.patchBase;let r=t.majorBase,a=t.minorBase,o=t.patchBase;const l=t.notBefore;let h=t.majorMustEqual,N=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>a?!0:i<a||m&&m<l?!1:n>=o:(s===1&&r===0&&(!h||!N||!F)&&(r=1,a=0,o=0,h=!0,N=!1,F=!1),s<r?!1:s>r?!h:i<a?!1:i>a?!N:n<o?!1:n>o?!F:!(m&&m<l))}e.isValidVersion=p;function d(f,y,b,v,m){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof v.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!v.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!u(v.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!u(v.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const n=(0,O.joinPath)(b,v.main);(0,O.isEqualOrParent)(n,b)||t.push([R.default.Warning,P.localize(10,null,n.path,b.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,P.localize(11,null,"activationEvents","main")]),t}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([R.default.Error,P.localize(12,null,"browser")]),t;{const n=(0,O.joinPath)(b,v.browser);(0,O.isEqualOrParent)(n,b)||t.push([R.default.Warning,P.localize(13,null,n.path,b.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,P.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(v.version))return t.push([R.default.Error,P.localize(15,null)]),t;const s=[];if(!w(f,y,v,m,s))for(const n of s)t.push([R.default.Error,n]);return t}e.validateExtensionManifest=d;function w(f,y,b,v,m){return v||typeof b.main>"u"&&typeof b.browser>"u"?!0:A(f,y,b.engines.vscode,m)}e.isValidExtensionVersion=w;function E(f,y,b){return f==="*"||A(y,b,f)}e.isEngineValid=E;function A(f,y,b,v=[]){const m=I(c(b));if(!m)return v.push(P.localize(16,null,b)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return v.push(P.localize(17,null,b)),!1}else if(!m.majorMustEqual)return v.push(P.localize(18,null,b)),!1;return p(f,y,m)?!0:(v.push(P.localize(19,null,f,b)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let y=0,b=f.length;y<b;y++)if(typeof f[y]!="string")return!1;return!0}}),define(Z[109],Q([0,1,14,29]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(D,k,S){let g=S&&S.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const I=(await k.readFile(D.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(I)?I:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return S?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=P}),define(Z[45],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(P,D=[],k=!1){this.ctor=P,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=O}),define(Z[110],Q([0,1,45]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var P;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function D(S,g,c){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(c))),R.push([S,g])}e.registerSingleton=D;function k(){return R}e.getSingletonServiceDescriptors=k}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(D,k){this.key=D,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class R{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const k of this.a.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const S=this.lookupOrInsertNode(D),g=this.lookupOrInsertNode(k);S.outgoing.set(g.key,g),g.incoming.set(S.key,S)}removeNode(D){const k=this.b(D);this.a.delete(k);for(const S of this.a.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(D){const k=this.b(D);let S=this.a.get(k);return S||(S=new O(k,D),this.a.set(k,S)),S}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[k,S]of this.a)D.push(`${k}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,k]of this.a){const S=new Set([D]),g=this.c(k,S);if(g)return g}}c(D,k){for(const[S,g]of D.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const c=this.c(g,k);if(c)return c;k.delete(S)}}}e.Graph=R}),define(Z[24],Q([0,1,3,11,10]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationOverrides=D;function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=k;var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(u,f){const y=Object.create(null);for(const b in u)I(y,b,u[b],f);return y}e.toValuesTree=c;function I(u,f,y,b){const v=f.split("."),m=v.pop();let t=u;for(let s=0;s<v.length;s++){const i=v[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${f} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[m]=y}catch{b(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=I;function p(u,f){const y=f.split(".");d(u,y)}e.removeFromValueTree=p;function d(u,f){const y=f.shift();if(f.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const b=u[y];typeof b=="object"&&!Array.isArray(b)&&(d(b,f),Object.keys(b).length===0&&delete u[y])}}function w(u,f,y){function b(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const v=f.split("."),m=b(u,v);return typeof m>"u"?y:m}e.getConfigurationValue=w;function E(u,f,y){Object.keys(f).forEach(b=>{b!=="__proto__"&&(b in u?O.isObject(u[b])&&O.isObject(f[b])?E(u[b],f[b],y):y&&(u[b]=f[b]):u[b]=f[b])})}e.merge=E;function A(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=A}),define(Z[58],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Z[17],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[21],Q([0,1,88,10]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function P(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function D(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function k(f,y){switch(f){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function S(f,y){return y==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function g(f,y,b){return S(y,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:c(b).includes(f)}e.isTargetPlatformCompatible=g;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var w;(function(f){f.Install="install",f.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var A;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(y,b){super(y),this.code=b,this.name=b}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,O.localize)(1,null),original:"Preferences"}}),define(Z[59],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((D,k)=>x(["node-vsce-sign"],async S=>D(S),k))),this.a}async verify(D,k){let S;try{S=await this.b()}catch{return!1}return S.verify(D,k)}}e.ExtensionSignatureVerificationService=R}),define(Z[60],Q([0,1,14,7,96,13]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(I,p,d,w,E,A){let u;try{await S(I,p,d,w,E,A)}catch(f){u=f}finally{u&&E.errorTransformer&&(u=E.errorTransformer(u)),typeof u<"u"&&d.error(u),d.end()}}e.readFileIntoStream=k;async function S(I,p,d,w,E,A){g(A);const u=await I.open(p,{create:!1});try{g(A);let f=0,y=0,b=E&&typeof E.length=="number"?E.length:void 0,v=O.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),m=E&&typeof E.position=="number"?E.position:0,t=0;do y=await I.read(u,m,v.buffer,t,v.byteLength-t),m+=y,t+=y,f+=y,typeof b=="number"&&(b-=y),t===v.byteLength&&(await d.write(w(v)),v=O.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),t=0);while(y>0&&(typeof b!="number"||b>0)&&g(A)&&c(f,E));if(t>0){let s=t;typeof b=="number"&&(s=Math.min(t,b)),d.write(w(v.slice(0,s)))}}catch(f){throw(0,D.ensureFileSystemProviderError)(f)}finally{await I.close(u)}}function g(I){if(I.isCancellationRequested)throw(0,R.canceled)();return!0}function c(I,p){if(p?.limits){if(typeof p.limits.memory=="number"&&I>p.limits.memory)throw(0,D.createFileSystemProviderError)((0,P.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&I>p.limits.size)throw(0,D.createFileSystemProviderError)((0,P.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,4,158,2,12,159]),function(x,e,O,R,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(c){const I=this.i(c),p=I.filter(w=>{const E=this.c.get(w.path);return E?!(0,R.patternsEquals)(E.request.excludes,w.excludes)||!(0,R.patternsEquals)(E.request.includes,w.includes):!0}),d=Array.from(this.c.values()).filter(({request:w})=>!I.find(E=>E.path===w.path&&(0,R.patternsEquals)(E.excludes,w.excludes)&&(0,R.patternsEquals)(E.includes,w.includes))).map(({request:w})=>w.path);p.length&&this.j(`Request to start watching: ${p.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),d.length&&this.j(`Request to stop watching: ${d.join(",")}`);for(const w of d)this.h(w);for(const w of p)this.g(w)}g(c){const I=new k.NodeJSFileWatcherLibrary(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),p={request:c,instance:I};this.c.set(c.path,p)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const I=this.c.get(c);I&&(this.c.delete(c),I.instance.dispose())}i(c){const I=new Map;for(const p of c){const d=D.isLinux?p.path:p.path.toLowerCase();I.set(d,p)}return Array.from(I.values())}async setVerboseLogging(c){this.f=c;for(const[,I]of this.c)I.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,I){return I?`[File Watcher (node.js)] ${c} (path: ${I.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=S}),define(Z[113],Q([0,1,61,112]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends O.AbstractNonRecursiveWatcherClient{constructor(k,S,g){super(k,S,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(g,c,I){super(g,c,I),this.m()}l(g){const c=g.add(new P.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:I,signal:p})=>this.n(`terminated by itself with code ${I}, signal: ${p}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...P){this.a=new Map;for(const[D,k]of P)this.set(D,k)}set(P,D){const k=this.a.get(P);return this.a.set(P,D),k}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=O}),define(Z[115],Q([0,1,5,7,2,45,111,10,62,160]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class p extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class d{constructor(u=new g.ServiceCollection,f=!1,y,b=I){this.f=u,this.g=f,this.h=y,this.i=b,this.o=new Set,this.f.set(S.IInstantiationService,this),this._globalGraph=b?y?._globalGraph??new k.Graph(v=>v):void 0}createChild(u){return new d(u,this.g,this,this.i)}invokeFunction(u,...f){const y=E.traceInvocation(this.i,u);let b=!1;try{return u({get:m=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(m,y);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...f)}finally{b=!0,y.stop()}}createInstance(u,...f){let y,b;return u instanceof D.SyncDescriptor?(y=E.traceCreation(this.i,u.ctor),b=this.j(u.ctor,u.staticArguments.concat(f),y)):(y=E.traceCreation(this.i,u),b=this.j(u,f,y)),y.stop(),b}j(u,f=[],y){const b=S._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),v=[];for(const t of b){const s=this.m(t.id,y);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(s)}const m=b.length>0?b[0].index:f.length;if(f.length!==m){console.trace(`[createInstance] First service dependency of ${u.name} at position ${m+1} conflicts with ${f.length} static arguments`);const t=m-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,m)}return Reflect.construct(u,f.concat(v))}k(u,f){if(this.f.get(u)instanceof D.SyncDescriptor)this.f.set(u,f);else if(this.h)this.h.k(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const f=this.f.get(u);return!f&&this.h?this.h.l(u):f}m(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const y=this.l(u);return y instanceof D.SyncDescriptor?this.q(u,y,f.branch(u,!0)):(f.branch(u,!1),y)}q(u,f,y){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,f,y)}finally{this.o.delete(u)}}r(u,f,y){const b=new k.Graph(t=>t.id.toString());let v=0;const m=[{id:u,desc:f,_trace:y}];for(;m.length;){const t=m.pop();if(b.lookupOrInsertNode(t),v++>1e3)throw new p(b);for(const s of S._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof D.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};b.insertEdge(t,n),m.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:s}of t){if(this.l(s.id)instanceof D.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}b.removeNode(s)}}return this.l(u)}s(u,f,y=[],b,v){if(this.f.get(u)instanceof D.SyncDescriptor)return this.t(u,f,y,b,v);if(this.h)return this.h.s(u,f,y,b,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(u,f,y=[],b,v){if(b){const m=new d(void 0,this.g,this,this.i);m.c=String(u);const t=new Map,s=new O.IdleValue(()=>{const i=m.j(f,y,v);for(const[n,r]of t){const a=i[n];if(typeof a=="function")for(const o of r)a.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new c.LinkedList,t.set(n,o)),(h,N,F)=>{const Y=o.push([h,N,F]);return(0,P.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),i[n]=a),a},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,y,v)}u(u,f){if(f&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=d;var w;(function(A){A[A.None=0]="None",A[A.Creation=1]="Creation",A[A.Invocation=2]="Invocation",A[A.Branch=3]="Branch"})(w||(w={}));class E{static traceInvocation(u,f){return u?new E(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(u,f){return u?new E(1,f.name):E.c}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const y=new E(3,u.toString());return this.h.push([u,f,y]),y}stop(){const u=Date.now()-this.g;E.f+=u;let f=!1;function y(v,m){const t=[],s=new Array(v+1).join("	");for(const[i,n,r]of m.h)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const a=y(v+1,r);a&&t.push(a)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(u>2||f)&&E.all.add(b.join(`
`))}}E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0,e.Trace=E});var _=this&&this.__param||function(x,e){return function(O,R){e(O,R,x)}};define(Z[63],Q([0,1,23,2,12,98,21,10]),function(x,e,O,R,P,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(I){return I.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let c=class extends R.Disposable{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new O.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const E=d.firstPage.filter(A=>A.properties.localizedLanguages?.length&&A.tags.some(u=>u.startsWith("lp-"))).map(A=>{const u=A.properties.localizedLanguages?.[0],f=g(A);return{...this.f(f,u,A),extensionId:A.identifier.id,galleryExtension:A}});return E.push(this.f("en","English")),E}f(p,d,w){const E=d??p;let A;if(E!==p&&(A=`(${p})`),p.toLowerCase()===P.language.toLowerCase()&&(A??="",A+=(0,D.localize)(0,null)),w?.installCount){A??="";const u=w.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),A+=` $(cloud-download) ${f}`}return{id:p,label:E,description:A}}};c=fe([_(0,k.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Z[6],Q([0,1,34,4,2,36,12,3,11,10]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function I(){return new Date().toISOString()}function p(o){return(0,S.isNumber)(o)}e.isLogLevel=p;var d;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function w(o,l,h){switch(l){case d.Trace:o.trace(h);break;case d.Debug:o.debug(h);break;case d.Info:o.info(h);break;case d.Warning:o.warn(h);break;case d.Error:o.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=w;function E(o){let l="";for(let h=0;h<o.length;h++){let N=o[h];if(typeof N=="object")try{N=JSON.stringify(N)}catch{}l+=(h>0?" ":"")+N}return l}e.format=E;class A extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==d.Off&&this.b<=l}}e.AbstractLogger=A;class u extends A{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...h){this.f(d.Trace)&&this.g(d.Trace,E([l,...h]))}debug(l,...h){this.f(d.Debug)&&this.g(d.Debug,E([l,...h]))}info(l,...h){this.f(d.Info)&&this.g(d.Info,E([l,...h]))}warn(l,...h){this.f(d.Warning)&&this.g(d.Warning,E([l,...h]))}error(l,...h){if(this.f(d.Error))if(l instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=l.stack,this.g(d.Error,E(N))}else this.g(d.Error,E([l,...h]))}flush(){}}e.AbstractMessageLogger=u;class f extends A{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!k.isWindows}trace(l,...h){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}debug(l,...h){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}info(l,...h){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}warn(l,...h){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,l,...h):console.warn(`[main ${I()}]`,l,...h))}error(l,...h){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,l,...h):console.error(`[main ${I()}]`,l,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends A{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...h){this.f(d.Trace)&&console.log("%cTRACE","color: #888",l,...h)}debug(l,...h){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...h)}info(l,...h){this.f(d.Info)&&console.log("%c INFO","color: #33f",l,...h)}warn(l,...h){this.f(d.Warning)&&console.log("%c WARN","color: #993",l,...h)}error(l,...h){this.f(d.Error)&&console.log("%c  ERR","color: #f33",l,...h)}dispose(){}flush(){}}e.ConsoleLogger=y;class b extends A{constructor(l,h=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(h)}trace(l,...h){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(l),...h])}debug(l,...h){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(l),...h])}info(l,...h){this.f(d.Info)&&this.g.log(d.Info,[this.h(l),...h])}warn(l,...h){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(l),...h])}error(l,...h){this.f(d.Error)&&this.g.log(d.Error,[this.h(l),...h])}h(l){return typeof l=="string"?l:(0,O.toErrorMessage)(l,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class v extends A{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const h of this.g)h.setLevel(l);super.setLevel(l)}trace(l,...h){for(const N of this.g)N.trace(l,...h)}debug(l,...h){for(const N of this.g)N.debug(l,...h)}info(l,...h){for(const N of this.g)N.info(l,...h)}warn(l,...h){for(const N of this.g)N.warn(l,...h)}error(l,...h){for(const N of this.g)N.error(l,...h)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=v;class m extends P.Disposable{constructor(l,h){if(super(),this.j=l,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,h)for(const N of h)this.c.set(N.resource,N)}getLogger(l){return this.b.get(l)}createLogger(l,h){let N=this.b.get(l);const F=h?.logLevel==="always"?d.Trace:h?.logLevel;return N||(N=this.k(l,F??this.getLogLevel(l)??this.j,h),this.b.set(l,N)),this.registerLogger({resource:l,id:h?.id??l.toString(),logLevel:F,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),N}setLogLevel(l,h){if(g.URI.isUri(l)){const N=l,F=h,Y=this.c.get(N);Y&&F!==Y.logLevel&&(Y.logLevel=F===this.j?void 0:F,this.b.get(N)?.setLevel(F),this.c.set(Y.resource,Y),this.g.fire([N,F]))}else{this.j=l;for(const[N,F]of this.b.entries())this.c.get(N)?.logLevel===void 0&&F.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,h){const N=this.c.get(l);N&&h!==!N.hidden&&(N.hidden=!h,this.c.set(N.resource,N),this.h.fire([l,h]))}getLogLevel(l){let h;return l&&(h=this.c.get(l)?.logLevel),h??this.j}registerLogger(l){const h=this.c.get(l.resource);h?h.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const h=this.c.get(l);if(h){this.c.delete(l);const N=this.b.get(l);N&&(this.b.delete(l),N.dispose()),this.f.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=m;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(l){}getLevel(){return d.Info}trace(l,...h){}debug(l,...h){}info(l,...h){}warn(l,...h){}error(l,...h){}critical(l,...h){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends m{constructor(){super(d.Info)}k(l,h,N){return new t}}e.NullLoggerService=i;function n(o){if(o.verbose)return d.Trace;if(typeof o.logLevel=="string"){const l=a(o.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(o){switch(o){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function a(o){switch(o){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=a}),define(Z[116],Q([0,1,19,5,7,4,2,15,61,6]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends k.Disposable{constructor(d,w){super(),this.a=d,this.b=w,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(d,w){return w.recursive||this.b?.watcher?.forceUniversal?this.l(d,w):this.u(d,w)}l(d,w){const E={path:this.C(d),excludes:w.excludes,includes:w.includes,recursive:w.recursive},A=(0,O.insert)(this.j,E);return this.m(),(0,k.toDisposable)(()=>{A(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(d=>(0,P.onUnexpectedError)(d))}n(){this.h||(this.h=this.B(this.p(w=>this.c.fire((0,g.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const w of this.j)(0,g.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const w of this.j)(0,g.isRecursiveWatchRequest)(w)&&d.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(d,w){const E={path:this.C(d),excludes:w.excludes,includes:w.includes,recursive:!1},A=(0,O.insert)(this.s,E);return this.v(),(0,k.toDisposable)(()=>{A(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(d=>(0,P.onUnexpectedError)(d))}w(){return this.r||(this.r=this.B(this.y(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}C(d){return(0,S.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[117],Q([0,1,19,5,14,23,4,51,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new u.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,w.isAbsolutePath)(t))throw new u.FileOperationError((0,A.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new b.ErrorNoTelemetry;throw i.message=(0,A.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,u.toFileSystemProviderErrorCode)(i)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,A.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,l=await i.stat(t);let h;return this.p(i,t,l,void 0,!!o,(N,F)=>(h||(h=I.TernarySearchTree.forUris(()=>!n),h.set(t,!0),r&&h.fill(!0,r)),h.get(N.resource)||h.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&a?F===1:!1))}async p(t,s,i,n,r,a){const{providerExtUri:o}=this.N(t),l={resource:s,name:o.basename(s),isFile:(i.type&u.FileType.File)!==0,isDirectory:(i.type&u.FileType.Directory)!==0,isSymbolicLink:(i.type&u.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&a(l,n)){try{const h=await t.readdir(s),N=await R.Promises.settled(h.map(async([F,Y])=>{try{const ee=o.joinPath(s,F),te=r?await t.stat(ee):{type:Y};return await this.p(t,ee,te,h.length,r,a)}catch(ee){return this.b.trace(ee),null}}));l.children=(0,O.coalesce)(N)}catch(h){this.b.trace(h),l.children=[]}return l}return l}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,A.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=P.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let o;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof P.VSBuffer))if((0,E.isReadableStream)(s)){const l=await(0,E.peekStream)(s,3);l.ended?o=P.VSBuffer.concat(l.buffer):o=l}else o=(0,E.peekReadable)(s,l=>P.VSBuffer.concat(l),3);else o=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&o instanceof P.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof P.VSBuffer?(0,P.bufferToReadable)(o):o),this.m.fire(new u.FileOperationEvent(t,4))}catch(a){throw new u.FileOperationError((0,A.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(a).toString()),(0,u.toFileOperationResult)(a),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,A.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,A.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,u.etag)({mtime:i.mtime,size:r.size}))throw new u.FileOperationError((0,A.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,a)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,s,i,n);r(o)}catch(o){a(o)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new D.CancellationTokenSource(n),a=this.F(s,i).then(l=>l,l=>{throw r.cancel(),l});let o;try{return typeof i?.etag=="string"&&i.etag!==u.ETAG_DISABLED&&await a,i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,s,i):(0,u.hasFileReadStreamCapability)(t)?o=this.z(t,s,r.token,i):o=this.C(t,s,r.token,i),{...await a,value:o}}catch(l){throw o&&await(0,E.consumeStream)(o),this.w(l,s,i)}}w(t,s,i){const n=(0,A.localize)(8,null,this.nb(s),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,E.transform)(r,{data:a=>a instanceof P.VSBuffer?a:P.VSBuffer.wrap(a),error:a=>this.w(a,s,n)},a=>P.VSBuffer.concat(a))}C(t,s,i,n=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,s,n)},i),r}D(t,s,i){const n=(0,E.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(P.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new u.FileOperationError((0,A.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===i.etag)throw new u.NotModifiedSinceFileOperationError((0,A.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,A.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(s),s);await this.M(r,t,a,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"move",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,a==="move"?2:3,o)),o}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"copy",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,a==="copy"?3:2,o)),o}async I(t,s,i,n,r,a){if(s.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.M(t,s,i,n,r,a);if(o&&!l&&a&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:a});else{const h=await this.resolve(s);h.isDirectory?await this.L(t,h,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:a}),r):(await this.I(t,s,i,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async r=>{const a=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,a):this.J(t,r.resource,i,a)}))}async M(t,s,i,n,r,a){let o=!1;if(t===i){const{providerExtUri:h,isPathCaseSensitive:N}=this.N(t);if(N||(o=h.isEqual(s,n)),o&&r==="copy")throw new Error((0,A.localize)(12,null,this.nb(s),this.nb(n)));if(!o&&h.isEqualOrParent(n,s))throw new Error((0,A.localize)(13,null,this.nb(s),this.nb(n)))}const l=await this.exists(n);if(l&&!o){if(!a)throw new u.FileOperationError((0,A.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:h}=this.N(t);if(h.isEqualOrParent(s,n))throw new Error((0,A.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}N(t){const s=this.O(t);return{providerExtUri:s?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&u.FileType.Directory)===0)throw new Error((0,A.localize)(16,null,this.nb(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(a){if((0,u.toFileSystemProviderErrorCode)(a)!==u.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,A.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,A.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,A.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,u.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,u.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const a=await this.W(t,s);n?(0,c.dispose)(a):r=()=>(0,c.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(t,s){const i=await this.j(t),n=(0,S.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=P.VSBuffer.concat(i.buffer);await this.bb(t,s,a,a.byteLength,n,0),n+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,o)=>{(0,E.listenStream)(r,{onData:async l=>{r.pause();try{await this.bb(t,s,l,l.byteLength,n,0)}catch(h){return o(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>o(l),onEnd:()=>a()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,a){let o=0;for(;o<n;)o+=await t.write(s,r+o,i.buffer,a+o,n-o)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof P.VSBuffer?r=n:(0,E.isReadableStream)(n)?r=await(0,P.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?r=await(0,P.bufferedStreamToBuffer)(n):r=(0,P.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,a;try{r=await t.open(s,{create:!1}),a=await i.open(n,{create:!0,unlock:!1});const o=P.VSBuffer.alloc(this.a);let l=0,h=0,N=0;do N=await t.read(r,l,o.buffer,h,o.byteLength-h),await this.bb(i,a,o,N,l,h),l+=N,h+=N,h===o.byteLength&&(h=0);while(N>0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await R.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(s);await this.bb(i,r,P.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,P.streamToBuffer)(this.C(t,s,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new u.FileOperationError((0,A.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,A.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};v=fe([_(0,y.ILogService)],v),e.FileService=v}),define(Z[119],Q([0,1,120,161,5,36,14,4,162,2,15,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(s)}`)}})();class t extends y.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=S.Event.None,this.H=new D.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,d.joinPath)(i,a.name))).type:o=this.G(a),r.push([a.name,o])}catch(o){this.a.trace(o)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=u.FileType.Unknown:i.isFile()?r=u.FileType.File:i.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new P.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const a=this.C(i);return await E.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const a=(0,w.newWriteableStream)(o=>k.VSBuffer.concat(o.map(l=>k.VSBuffer.wrap(l))).buffer);return(0,f.readFileIntoStream)(this,i,a,o=>o.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const o=this.C(i);if(!r.create||!r.overwrite){if(await E.Promises.exists(o)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,A.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,A.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let a;(0,u.isFileOpenForWriteOptions)(n)&&(a=await this.I(i));let o;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:h}=await E.SymlinkSupport.stat(r);h.mode&128||await E.Promises.chmod(r,h.mode|128)}catch(h){this.a.trace(h)}let l;if((0,u.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await E.Promises.truncate(r,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}l||(l="w")}else l="r";o=await E.Promises.open(r,l)}catch(l){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.Z(i,l):this.Y(l)}if(this.L.set(o,0),(0,u.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),a){const l=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,a),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),l.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await E.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,o){const l=this.P(i,n);let h=null;try{h=(await E.Promises.read(i,r,a,o,l)).bytesRead}catch(N){throw this.Y(N)}finally{this.Q(i,l,h)}return h}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const a=this.L.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,a+r):this.L.delete(i)))}async write(i,n,r,a,o){return(0,P.retry)(()=>this.R(i,n,r,a,o),100,3)}async R(i,n,r,a,o){const l=this.P(i,n);let h=null;try{h=(await E.Promises.write(i,r,a,o,l)).bytesWritten}catch(N){throw await this.Z(this.N.get(i),N)}finally{this.Q(i,l,h)}return h}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"move",r.overwrite),await E.Promises.move(a,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,A.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(o)),l.toString()))),this.Y(l)}}async copy(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"copy",r.overwrite),await E.Promises.copy(a,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,A.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(o)),l.toString()))),this.Y(l)}}async S(i,n,r,a){const o=this.C(i),l=this.C(n);let h=!1;if(!!(this.capabilities&1024)||(h=(0,g.isEqual)(o,l,!0)),h&&r==="copy")throw(0,u.createFileSystemProviderError)((0,A.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!h&&await E.Promises.exists(l)){if(!a)throw(0,u.createFileSystemProviderError)((0,A.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const a=this.C(i),o=this.C(n),l=!!(this.capabilities&1024);if((0,g.isEqual)(a,o,!l))return;const h=new c.DisposableStore;try{const[N,F]=await Promise.all([this.I(i),this.I(n)]);h.add(N),h.add(F),r&&await E.Promises.mkdir((0,I.dirname)(o),{recursive:!0}),await E.Promises.copyFile(a,o)}catch(N){if(N.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(N)}finally{h.dispose()}}p(i,n,r){return new v.UniversalWatcherClient(a=>i(a),a=>n(a),r)}y(i,n,r){return new m.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}Y(i){if(i instanceof u.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await E.SymlinkSupport.stat(this.C(i));a.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Z[121],Q([0,1,2,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends O.Disposable{constructor(k,S=[]){super(),this.a=new R.MultiplexLogger([k,...S]),this.B(k.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...S){this.a.trace(k,...S)}debug(k,...S){this.a.debug(k,...S)}info(k,...S){this.a.info(k,...S)}warn(k,...S){this.a.warn(k,...S)}error(k,...S){this.a.error(k,...S)}flush(){this.a.flush()}}e.LogService=P}),define(Z[122],Q([0,1,13,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function D(c,I,p,d,w){try{const E=await new Promise((u,f)=>{x(["spdlog"],u,f)});E.setFlushOn(P.Trace);const A=await E.createAsyncRotatingLogger(c,I,p,d);return w?A.clearFormatters():A.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),A}catch(E){console.error(E)}return null}function k(c,I,p){switch(I){case R.LogLevel.Trace:c.trace(p);break;case R.LogLevel.Debug:c.debug(p);break;case R.LogLevel.Info:c.info(p);break;case R.LogLevel.Warning:c.warn(p);break;case R.LogLevel.Error:c.error(p);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function S(c,I){switch(I){case R.LogLevel.Trace:c.setLevel(P.Trace);break;case R.LogLevel.Debug:c.setLevel(P.Debug);break;case R.LogLevel.Info:c.setLevel(P.Info);break;case R.LogLevel.Warning:c.setLevel(P.Warning);break;case R.LogLevel.Error:c.setLevel(P.Error);break;case R.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class g extends R.AbstractMessageLogger{constructor(I,p,d,w,E){super(),this.k=[],this.setLevel(E),this.l=this.n(I,p,d,w),this.B(this.onDidChangeLogLevel(A=>{this.m&&S(this.m,A)}))}async n(I,p,d,w){const E=d?6:1,A=30/E*O.ByteSize.MB,u=await D(I,p,A,E,w);if(u){this.m=u,S(this.m,this.getLevel());for(const{level:f,message:y}of this.k)k(this.m,f,y);this.k=[]}}g(I,p){this.m?k(this.m,I,p):this.getLevel()<=I&&this.k.push({level:I,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[38],Q([0,1,4,64,2,10]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class k extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const I=Object.keys(this.f).length;return this.f={...c,...this.f},I!==Object.keys(this.f).length&&await this.i(c),R.Iterable.reduce(this.g.entries(),(p,[d,w])=>({...p,[d]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[I,p])=>({...c,[I]:{definition:p,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=k;class S{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Z[123],Q([0,1,5,4,64,3,13,6,38]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(p,d){const w=[];for(const E of new Set(P.Iterable.concat(p.keys(),d.keys())))p.get(E)!==d.get(E)&&w.push(E);return w}let I=class extends g.AbstractPolicyService{constructor(d,w,E){super(),this.j=d,this.k=w,this.l=E,this.c=this.B(new O.ThrottledDelayer(500));const A=R.Event.filter(w.onDidFilesChange,u=>u.affects(d));this.B(w.watch(d)),this.B(A(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const d=new Map;try{const w=await this.k.readFile(this.j),E=JSON.parse(w.value.toString());if(!(0,D.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const A of Object.keys(E))this.f[A]&&d.set(A,E[A])}catch(w){w.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",w)}return d}async p(){const d=await this.n(),w=c(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};I=fe([_(1,k.IFileService),_(2,S.ILogService)],I),e.FilePolicyService=I}),define(Z[31],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(k,S){O.ok(R.isString(k)),O.ok(R.isObject(S)),O.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,S)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new P}),define(Z[124],Q([0,1,4,37]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[P(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const k=new D;R.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[42],Q([0,1,19,4,3,86,24,124,37]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=g.Registry.as(S.Extensions.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const a in n)if(s.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),l=o?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[a]))l.set(Y,r);const h={...o?.value||{},...n[a]};this.a.set(a,{source:r,value:h,valuesSources:l});const N=(0,k.getLanguageTagSettingPlainKey)(a),F={type:"object",default:h,description:D.localize(1,null,N),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:P.isString(r)?void 0:r,defaultValueSource:r};i.push(...A(a)),this.d[a]=F,this.b.properties[a]=F}else{this.a.set(a,{value:n[a],source:r});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const a=this.a.get(r),o=P.isString(n)?n:n?.id,l=P.isString(a?.source)?a?.source:a?.source?.id;if(o===l)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const a=this.d[r];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,a){r=P.isUndefinedOrNull(t.scope)?r:t.scope;const o=t.properties;if(o)for(const h in o){const N=o[h];if(s&&b(h,N)){delete o[h];continue}if(N.source=i,N.defaultDefaultValue=o[h].default,this.w(h,N),e.OVERRIDE_PROPERTY_REGEX.test(h)?N.scope=void 0:(N.scope=P.isUndefinedOrNull(N.scope)?r:N.scope,N.restricted=P.isUndefinedOrNull(N.restricted)?!!n?.includes(h):N.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.f[h]=o[h],delete o[h];continue}else this.d[h]=o[h],o[h].policy?.name&&this.e.set(o[h].policy.name,h);!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),a.add(h)}const l=t.allOf;if(l)for(const h of l)this.p(h,s,i,n,r,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const a in n)this.r(a,n[a]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;P.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),P.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const w="\\[([^\\]]+)\\]",E=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function A(m){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let s=E.exec(m);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=E.exec(m)}}return(0,O.distinct)(t)}e.overrideIdentifiersFromKey=A;function u(m){return m.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const y=new d;g.Registry.add(e.Extensions.Configuration,y);function b(m,t){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?D.localize(7,null,m):y.getConfigurationProperties()[m]!==void 0?D.localize(8,null,m):t.policy?.name&&y.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,m,t.policy?.name,y.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=b;function v(){const m=[],t=y.getConfigurationProperties();for(const s of Object.keys(t))m.push([s,t[s].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=v}),define(Z[65],Q([0,1,19,4,49,2,36,28,3,11,24,42,37]),function(x,e,O,R,P,D,k,S,g,c,I,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function w(s){return Object.isFrozen(s)?s:S.deepFreeze(s)}class E{constructor(i={},n=[],r=[],a){this.b=i,this.c=n,this.d=r,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const r=new A("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),a=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:a,merged:o}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,I.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return O.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=S.deepClone(this.contents),r=S.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const l of i)if(o.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const h of l.overrides){const[N]=r.filter(F=>O.equals(F.identifiers,h.identifiers));N?(this.h(N.contents,h.contents),N.keys.push(...h.keys),N.keys=O.distinct(N.keys)):r.push(S.deepClone(h))}for(const h of l.keys)a.indexOf(h)===-1&&a.push(h)}return new E(n,a,r,o.every(l=>l instanceof E)?void 0:o)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const l=n[a];l&&(typeof o=="object"&&typeof l=="object"?(o=S.deepClone(o),this.h(o,l)):o=l),r[a]=o}return new E(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=S.deepClone(n[r])}}i(i){let n=null,r=null;const a=o=>{o&&(r?this.h(r,o):r=S.deepClone(o))};for(const o of this.overrides)O.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&a(o.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,I.addToValueTree)(this.contents,i,n,a=>console.error(a)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,I.toValuesTree)(this.contents[i],a=>console.error(a))})}}e.ConfigurationModel=E;class A{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:a,overrides:o,restricted:l,hasExcludedProperties:h}=this.h(i,n);this.b=new E(r,a,o,h?[i]:void 0),this.c=l||[]}g(i){let n={},r=null,a=[];const o=[],l=[];function h(F){Array.isArray(a)?a.push(F):r!==null&&(a[r]=F)}const N={onObjectBegin:()=>{const F={};h(F),o.push(a),a=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const F=[];h(F),o.push(a),a=F,r=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:h,onError:(F,Y,ee)=>{l.push({error:F,offset:Y,length:ee})}};if(i)try{P.visit(i,N),n=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=d.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.i(i,r,!0,n);i=a.raw;const o=(0,I.toValuesTree)(i,N=>console.error(`Conflict in settings file ${this.f}: ${N}`)),l=Object.keys(i),h=this.j(i,N=>console.error(`Conflict in settings file ${this.f}: ${N}`));return{contents:o,keys:l,overrides:h,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(i,n,r,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const l={},h=[];for(const N in i)if(p.OVERRIDE_PROPERTY_REGEX.test(N)&&r){const F=this.i(i[N],n,!1,a);l[N]=F.raw,o=o||F.hasExcludedProperties,h.push(...F.restricted)}else{const F=n[N],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&h.push(N),(Y===void 0||a.scopes===void 0||a.scopes.includes(Y))&&!(a.skipRestricted&&F?.restricted)?l[N]=i[N]:o=!0}return{raw:l,restricted:h,hasExcludedProperties:o}}j(i,n){const r=[];for(const a of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const l in i[a])o[l]=i[a][l];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=A;class u extends D.Disposable{constructor(i,n,r,a){super(),this.f=i,this.g=n,this.h=a,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new A(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class f{constructor(i,n,r,a,o,l,h,N,F,Y,ee,te,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=o,this.f=l,this.g=h,this.h=N,this.i=F,this.j=Y,this.k=ee,this.l=te,this.m=ie}get value(){return w(this.c)}n(i,n,r){const a=i.inspect(n,r);return{get value(){return w(a.value)},get override(){return w(a.override)},get merged(){return w(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class y{constructor(i,n,r,a,o=new E,l=new E,h=new k.ResourceMap,N=new E,F=new k.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=a,this.h=o,this.i=l,this.j=h,this.l=N,this.m=F,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this.m.get(r.resource),a||(a=new E,this.m.set(r.resource,a))):a=this.l,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const a=this.q(i,n,r),o=this.u(n.resource,r),l=n.resource?this.m.get(n.resource)||this.l:this.l,h=new Set;for(const N of a.overrides)for(const F of N.identifiers)a.getOverrideValue(i,F)!==void 0&&h.add(F);return new f(i,n,a.getValue(i),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,o||void 0,l)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:o,removed:l}=m(this.c,i);n=[...a,...o,...l]}for(const a of n)for(const o of(0,p.overrideIdentifiersFromKey)(a)){const l=this.c.getKeysForOverrideIdentifier(o),h=i.getKeysForOverrideIdentifier(o),N=[...h.filter(F=>l.indexOf(F)===-1),...l.filter(F=>h.indexOf(F)===-1),...l.filter(F=>!S.equals(this.c.override(o).getValue(F),i.override(o).getValue(F)))];r.push([o,N])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:a}=m(this.d,i),o=[...n,...r,...a];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=m(this.applicationConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=m(this.localUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=m(this.remoteUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=m(this.workspaceConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:a,updated:o,removed:l,overrides:h}=m(r,n),N=[...a,...o,...l];return(N.length||!r)&&this.updateFolderConfiguration(i,n),{keys:N,overrides:h}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:o,overrides:l}=m(n,void 0);return{keys:[...r,...a,...o],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let a=this.r(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(a=a.merge(this.d)),a}r({resource:i},n){let r=this.s();if(n&&i){const a=n.getFolder(i);a&&(r=this.t(a.uri)||r);const o=this.m.get(i);o&&(r=r.merge(o))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),a=this.j.get(i);a?(n=r.merge(a),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:o}=this.j.get(n);return i.push([n,{contents:r,overrides:a,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),a=this.x(i.application),o=this.x(i.user),l=this.x(i.workspace),h=i.folders.reduce((N,F)=>(N.set(c.URI.revive(F[0]),this.x(F[1])),N),new k.ResourceMap);return new y(n,r,a,o,new E,l,h,new E,new k.ResourceMap)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=y;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const a of s)a.keys.forEach(o=>i.add(o)),a.overrides.forEach(([o,l])=>{const h=(0,k.getOrSet)(n,o,new Set);l.forEach(N=>h.add(N))});const r=[];return n.forEach((a,o)=>r.push([o,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=b;class v{constructor(i,n,r,a){this.change=i,this.f=n,this.g=r,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const l of o)this.affectedKeys.add(l);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=y.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,a=this.d.indexOf(r);if(a<0)return!1;const o=a+r.length;if(o>=this.d.length)return!1;const l=this.d.charCodeAt(o);if(l!==this.b&&l!==this.c)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,N=this.g.getValue(i,n,this.h);return!S.equals(h,N)}return!0}}e.ConfigurationChangeEvent=v;function m(s,i){const{added:n,removed:r,updated:a}=t(i?.rawConfiguration,s?.rawConfiguration),o=[],l=s?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const N=h.filter(F=>!l.includes(F));for(const F of N)o.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const N=l.filter(F=>!h.includes(F));for(const F of N)o.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const N of l)if(h.includes(N)){const F=t({contents:s.getOverrideValue(void 0,N)||{},keys:s.getKeysForOverrideIdentifier(N)},{contents:i.getOverrideValue(void 0,N)||{},keys:i.getKeysForOverrideIdentifier(N)});o.push([N,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:a,overrides:o}}function t(s,i){const n=s?i?s.keys.filter(o=>i.keys.indexOf(o)===-1):[...s.keys]:[],r=i?s?i.keys.filter(o=>s.keys.indexOf(o)===-1):[...i.keys]:[],a=[];if(s&&i){for(const o of i.keys)if(s.keys.indexOf(o)!==-1){const l=(0,I.getConfigurationValue)(i.contents,o),h=(0,I.getConfigurationValue)(s.contents,o);S.equals(l,h)||a.push(o)}}return{added:n,removed:r,updated:a}}}),define(Z[125],Q([0,1,19,4,2,28,3,65,42,6,38,37]),function(x,e,O,R,P,D,k,S,g,c,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.c(Array.from(u),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,f){this.h(u,p.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new S.ConfigurationModel;const u=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,f){const y=this.f();for(const b of u){const v=y[b],m=f[b];v!==void 0?this.b.addValue(b,v):m?this.b.addValue(b,m.default):this.b.removeValue(b)}}}e.DefaultConfiguration=d;class w{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let E=class extends P.Disposable{get configurationModel(){return this.b}constructor(u,f,y){super(),this.c=u,this.f=f,this.g=y,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},y=[],b=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const v of u){const m=b[v];if(!m){y.push(v);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}y.push(v),f[m.policy.name]={type:m.type}}}return(0,k.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),y}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const f=p.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),y=(0,O.coalesce)(u.map(b=>f.get(b)));this.j(y,!0)}j(u,f){this.g.trace("PolicyConfiguration#update",u);const y=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),b=[],v=this.b.isEmpty();for(const m of u){const t=y[m]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(v?s!==void 0:!(0,D.equals)(this.b.getValue(m),s))&&b.push([m,s])}else this.b.getValue(m)!==void 0&&b.push([m,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const m=this.b;this.b=new S.ConfigurationModel;for(const t of m.keys)this.b.setValue(t,m.getValue(t));for(const[t,s]of b)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};E=fe([_(1,I.IPolicyService),_(2,c.ILogService)],E),e.PolicyConfiguration=E}),define(Z[126],Q([0,1,5,4,2,18,24,65,125,38]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends P.Disposable{constructor(d,w,E,A){super(),this.i=d,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=E instanceof c.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,E,A)),this.f=this.B(new S.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,w)),this.a=new S.Configuration(this.b.configurationModel,this.c.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.g=this.B(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:f})=>this.k(u,f))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,w,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.Configuration(d,w,new S.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(d,w){const E=typeof d=="string"?d:void 0,A=(0,k.isConfigurationOverrides)(d)?d:(0,k.isConfigurationOverrides)(w)?w:{};return this.a.getValue(E,A,void 0)}updateValue(d,w,E,A){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.j(d)}j(d){const w=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(d);this.m(E,w,2)}k(d,w){const E=this.a.toData(),A=this.a.compareAndUpdateDefaultConfiguration(d,w);this.m(A,E,7)}l(d){const w=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(d);this.m(E,w,7)}m(d,w,E){const A=new S.ConfigurationChangeEvent(d,{data:w},this.a);A.source=E,A.sourceConfig=this.n(E),this.h.fire(A)}n(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[66],Q([0,1,16]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(c){return c.scheme===O.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=R;function P(c){if(!c)return;const I=c.indexOf("+");return I<0?c:c.substr(0,I)}e.getRemoteName=P;function D(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=D;function k(c){const{host:I,port:p}=g(c);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:p}}e.parseAuthorityWithPort=k;function S(c,I){let{host:p,port:d}=g(c);return typeof d>"u"&&(d=I),{host:p,port:d}}e.parseAuthorityWithOptionalPort=S;function g(c){const I=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const p=c.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(Z[32],Q([0,1,30,10,66]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(E){this.value=E,this.c=E.toLowerCase()}static equals(E,A){if(typeof E>"u"||E===null)return typeof A>"u"||A===null;if(typeof A>"u"||A===null)return!1;if(typeof E=="string"||typeof A=="string"){const u=typeof E=="string"?E:E.value,f=typeof A=="string"?A:A.value;return O.equalsIgnoreCase(u,f)}return E.c===A.c}static toKey(E){return typeof E=="string"?E.toLowerCase():E.c}}e.ExtensionIdentifier=g;function c(w){return I(w)}e.isApplicationScopedExtension=c;function I(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function p(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function d(w,E){if(E){const A=`onResolveRemoteAuthority:${(0,P.getRemoteName)(E)}`;return w.activationEvents?.indexOf(A)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[127],Q([0,1,2,15,20,32]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends O.Disposable{constructor(g,c){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(I=>this.c(I))),this.B(c.onDidUninstallExtension(I=>this.f(I)))}c(g){g.some(c=>!!c.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){P.Promises.rm(this.a,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[46],Q([0,1,14,99,42,10,37]),function(x,e,O,R,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function S(A){return A.res.statusCode&&A.res.statusCode>=200&&A.res.statusCode<300||A.res.statusCode===1223}e.isSuccess=S;function g(A){return A.res.statusCode===204}async function c(A){return g(A)?null:(await(0,O.streamToBuffer)(A.stream)).toString()}e.asText=c;async function I(A){if(!S(A))throw new Error("Server returned "+A.res.statusCode);return c(A)}e.asTextOrError=I;async function p(A){if(!S(A))throw new Error("Server returned "+A.res.statusCode);if(g(A))return null;const f=(await(0,O.streamToBuffer)(A.stream)).toString();try{return JSON.parse(f)}catch(y){throw y.message+=`:
`+f,y}}e.asJson=p;function d(A){E(A)}e.updateProxyConfigurationsScope=d;let w;function E(A){const u=k.Registry.as(P.Extensions.Configuration),f=w;w={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:A,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[w],remove:f?[f]:[]})}E(2)}),define(Z[128],Q([0,1,23,16,13,46]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,I=O.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,c);return}const p={type:"GET",url:g.toString(!0)},d=await this.a.request(p,I);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const w=await(0,D.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${w}`)}}};k=fe([_(0,D.IRequestService),_(1,P.IFileService)],k),e.DownloadService=k}),define(Z[129],Q([0,1,130,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(k,S){return k.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:k.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(k,S,g={}){const c=(0,O.parse)(k),I=g.proxyUrl||P(c,S);if(!I)return null;const p=(0,O.parse)(I);if(!/^https?:$/.test(p.protocol||""))return null;const d={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((w,E)=>{x(["http-proxy-agent"],w,E)}))(d):new(await new Promise((w,E)=>{x(["https-proxy-agent"],w,E)}))(d)}e.getProxyAgent=D}),define(Z[131],Q([0,1,57,15,100,23,34,7,12,29,82,163,5,71]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function A(f,y,b,v){return b["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(v)&&!b["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(v)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=d.Promises.withAsyncBody(async(m,t)=>{const s=new D.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,w.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,P.localize)(0,null)))},i);try{m(await u(y,s.token))}catch(a){!(0,S.isCancellationError)(a)&&!s.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,k.toErrorMessage)(a)))):m({})}finally{clearTimeout(r),s.dispose()}})),E)}e.getResolvedShellEnv=A;async function u(f,y){const b=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",b);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const m=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(m+"({.*})"+m),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(y.isCancellationRequested)return r(new S.CancellationError);const a=(0,R.basename)(i);let o,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${h} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${h} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const N=(0,O.spawn)(i,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(N.kill(),r(new S.CancellationError))),N.on("error",ee=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(ee)),r(ee)});const F=[];N.stdout.on("data",ee=>F.push(ee));const Y=[];N.stderr.on("data",ee=>Y.push(ee)),N.on("close",(ee,te)=>{const ie=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),ee||te)return r(new Error((0,P.localize)(2,null,ee,te)));const ae=t.exec(ie),ue=ae?ae[1]:"{}";try{const se=JSON.parse(ue);b?se.ELECTRON_RUN_AS_NODE=b:delete se.ELECTRON_RUN_AS_NODE,v?se.ELECTRON_NO_ATTACH_CONSOLE=v:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(se)),r(se)}})})}}),define(Z[67],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,O.createDecorator)("stateService")}),define(Z[132],Q([0,1,5,14,3,17,13,6]),function(x,e,O,R,P,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(p,d,w){this.f=p,this.g=d,this.h=w,this.a=Object.create(null),this.b="",this.c=new O.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,d){const w=this.a[p];return(0,P.isUndefinedOrNull)(w)?d:w}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:w,data:E}of p)this.a[w]!==E&&((0,P.isUndefinedOrNull)(E)?(0,P.isUndefined)(this.a[w])||(this.a[w]=void 0,d=!0):(this.a[w]=E,d=!0));d&&this.j()}removeItem(p){(0,P.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(p)),this.b=p}catch(d){this.g.error(d)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let c=class{constructor(p,d,w){this.a=new g(p.stateResource,d,w)}async init(){await this.a.init()}getItem(p,d){return this.a.getItem(p,d)}};c=fe([_(0,D.IEnvironmentService),_(1,S.ILogService),_(2,k.IFileService)],c),e.StateService=c}),define(Z[68],Q([0,1,12,35,11,29]),function(x,e,O,R,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(c){if(O.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function S(c,I,p,d,w,E,A,u,f,y){const b=Object.create(null);b["common.machineId"]=A,b.sessionID=(0,D.generateUuid)()+Date.now(),b.commitHash=w,b.version=E,b["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,O.PlatformToString)(O.platform),b["common.nodePlatform"]=R.platform,b["common.nodeArch"]=d,b["common.product"]=y||"desktop",u&&(b["common.msftInternal"]=u);let v=0;const m=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),O.isLinuxSnap&&(b["common.snap"]="true");const t=k(p);t&&(b["common.platformDetail"]=t);try{const s=await c.readFile(P.URI.file(f));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=S;function g(c){const I=R.env.USERDNSDOMAIN;if(!I)return!1;const p=I.toLowerCase();return c.some(d=>p===d)}e.verifyMicrosoftInternalDomain=g}),define(Z[25],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,28,3,4,24,66,68,25]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o}}e.TelemetryTrustedValue=c;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,l){return Promise.resolve(void 0)}publicLog2(o,l){return this.publicLog(o,l)}publicLogError(o,l){return Promise.resolve(void 0)}publicLogError2(o,l){return this.publicLogError(o,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class p{async publicLog(o,l,h){}async publicLogError(o,l,h){}}e.NullEndpointTelemetryService=p,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(a,o){return P.Event.debounce(o.onDidChangeConfiguration,(h,N)=>{const F=h?new Set([...h.affectedKeys,...N.affectedKeys]):N.affectedKeys;return{...N,affectedKeys:F}},1e3,!0)(h=>{h.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(h.source),configurationKeys:v(h.affectedKeys)})})}e.configurationTelemetry=d;function w(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=w;function E(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=E;function A(a){const o=a.getValue(g.TELEMETRY_SETTING_ID),l=a.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function u(a){const o={},l={},h={};b(a,h);for(let N in h){N=N.length>150?N.substr(N.length-149):N;const F=h[N];typeof F=="number"?l[N]=F:typeof F=="boolean"?l[N]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${N} has been trimmed to 8192, the original length is ${F.length}`),o[N]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(o[N]=F)}return{properties:o,measurements:l}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function y(a){if(!a)return"none";const o=(0,k.getRemoteName)(a);return f.has(o)?o:"other"}e.cleanRemoteAuthority=y;function b(a,o,l=0,h){if(!!a)for(const N of Object.getOwnPropertyNames(a)){const F=a[N],Y=h?h+N:N;Array.isArray(F)?o[Y]=(0,O.safeStringify)(F):F instanceof Date?o[Y]=F.toISOString():(0,R.isObject)(F)?l<2?b(F,o,l+1,Y+"."):o[Y]=(0,O.safeStringify)(F):o[Y]=F}}function v(a){if(!a)return[];const o=[];return m(o,"",a),o}function m(a,o,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(h=>m(a,o?`${o}.${h}`:h,l[h])):a.push(o)}function t(a,o){const l=a.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,S.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=t;function s(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let l=a;const h=[];for(const ee of o)for(;;){const te=ee.exec(a);if(!te)break;h.push([te.index,ee.lastIndex])}const N=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(l="";;){const ee=F.exec(a);if(!ee)break;const te=h.some(([ie,ne])=>ee.index<ne&&ie<F.lastIndex);!N.test(ee[0])&&!te&&(l+=a.substring(Y,ee.index)+"<REDACTED: user-file-path>",Y=F.lastIndex)}return Y<a.length&&(l+=a.substr(Y)),l}function n(a){if(!a)return a;const o=a.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return a}function r(a,o){return(0,O.cloneAndChange)(a,l=>{if(l instanceof c)return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=i(h,o);for(const N of o)h=h.replace(N,"");return h=n(h),h}})}e.cleanData=r}),define(Z[26],Q([0,1,30,21,32,12,11,7,35,39]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,O.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=I;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,a)}static parse(n){const r=p.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=w.exec(i);return n&&n[1]?[u(n[1]),n[2]]:[u(i),void 0]}e.getIdAndVersion=E;function A(i,n){return`${i}.${n}`}e.getExtensionId=A;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(i,n){return u(A(i,n))}e.getGalleryExtensionId=f;function y(i,n){const r=[],a=o=>{for(const l of r)if(l.some(h=>I(n(h),n(o))))return l;return null};for(const o of i){const l=a(o);l?l.push(o):r.push([o])}return r}e.groupByExtension=y;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function v(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function m(i,n){const r=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&r.every(l=>!I(l.identifier,{id:o}))){const l=i.filter(h=>I(h.identifier,{id:o}));l.length===1&&(r.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=m;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,n){const r=await t(i,n),a=(0,R.getTargetPlatform)(r?"alpine":D.platform,g.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(Z[133],Q([0,1,23,7,16,18,41,11,89,21,26,32]),function(x,e,O,R,P,D,k,S,g,c,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=u=>(0,g.localize)(0,null,u),w=(0,g.localize)(1,null,"ms-dotnettools.csharp");function E(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let A=class{constructor(f,y){this.a=f,this.b=y}get d(){}async listExtensions(f,y,b,v=console){let m=await this.a.getInstalled(1,b);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(y&&y!==""){if(t.indexOf(y.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){v.log("Possible Categories: "),t.forEach(i=>{v.log(i)});return}this.d&&v.log((0,g.localize)(2,null,this.d)),m=m.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of m)s!==i.identifier.id&&(s=i.identifier.id,v.log(E(i.manifest,f)))}async installExtensions(f,y,b,v,m=console){const t=[],s=[];f.length&&m.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,b.profileLocation),n=(l,h)=>{const N=i.find(F=>(0,I.areSameExtensions)(F.identifier,{id:l}));if(N){if(!v&&(!h||h==="prerelease"&&N.preRelease))return m.log((0,g.localize)(5,null,l,N.manifest.version,l)),!1;if(h&&N.manifest.version===h)return m.log((0,g.localize)(6,null,`${l}@${h}`)),!1}return!0},r=(l,h,N)=>{o.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...b,isBuiltin:N,installPreReleaseVersion:h==="prerelease"||b.installPreReleaseVersion}})},a=[],o=[];for(const l of f)if(l instanceof S.URI)a.push(l);else{const[h,N]=(0,I.getIdAndVersion)(l);n(h,N)&&r(h,N,!1)}for(const l of y){const[h,N]=(0,I.getIdAndVersion)(l);n(h,N)&&r(h,N,!0)}if(a.length&&await Promise.all(a.map(async l=>{try{const h=await this.f(l,{...b,isBuiltin:!1},v,m);h&&s.push(h)}catch(h){m.error(h.message||h.stack||h),t.push(l.toString())}})),o.length){const l=await this.g(o);await Promise.all(o.map(async h=>{const N=l.get(h.id.toLowerCase());if(N)try{const F=await this.h(h,N,i,v,m);F&&s.push(F)}catch(F){m.error(F.message||F.stack||F),t.push(h.id)}else m.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${w}`),t.push(h.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(f,y,b,v){const m=await this.a.getManifest(f);if(!m)throw new Error("Invalid vsix");if(await this.k(m,b,y.profileLocation,v))try{return await this.a.install(f,y),v.log((0,g.localize)(8,null,(0,D.basename)(f))),m}catch(s){if((0,R.isCancellationError)(s))return v.log((0,g.localize)(9,null,(0,D.basename)(f))),null;throw s}return null}async g(f){const y=new Map,b=f.some(m=>m.installOptions.installPreReleaseVersion),v=await this.b.getExtensions(f.map(m=>({...m,preRelease:b})),O.CancellationToken.None);for(const m of v)y.set(m.identifier.id.toLowerCase(),m);return y}async h({id:f,version:y,installOptions:b},v,m,t,s){const i=await this.b.getManifest(v,O.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=m.find(r=>(0,I.areSameExtensions)(r.identifier,v.identifier));if(n){if(v.version===n.manifest.version)return s.log((0,g.localize)(10,null,y?`${f}@${y}`:f)),null;s.log((0,g.localize)(11,null,f,v.version))}try{b.isBuiltin?s.log(y?(0,g.localize)(12,null,f,y):(0,g.localize)(13,null,f)):s.log(y?(0,g.localize)(14,null,f,y):(0,g.localize)(15,null,f));const r=await this.a.installFromGallery(v,{...b,installGivenVersion:!!y});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}j(f,y){return!0}async k(f,y,b,v){const m={id:(0,I.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.a.getInstalled(1,b)).find(i=>(0,I.areSameExtensions)(m,i.identifier)&&(0,k.gt)(i.manifest.version,f.version));return s&&!y?(v.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.j(f,v)}async uninstallExtensions(f,y,b,v=console){const m=async s=>{if(s instanceof S.URI){const i=await this.a.getManifest(s);return E(i)}return s},t=[];for(const s of f){const i=await m(s),r=(await this.a.getInstalled(void 0,b)).filter(a=>(0,I.areSameExtensions)(a.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${w}`);if(r.some(a=>a.type===0)){v.log((0,g.localize)(19,null,i));return}if(!y&&r.some(a=>a.isBuiltin)){v.log((0,g.localize)(20,null,i));return}v.log((0,g.localize)(21,null,i));for(const a of r)await this.a.uninstall(a,{profileLocation:b}),t.push(a);this.d?v.log((0,g.localize)(22,null,i,this.d)):v.log((0,g.localize)(23,null,i))}}async locateExtension(f,y=console){const b=await this.a.getInstalled();f.forEach(v=>{b.forEach(m=>{if(m.identifier.id===v&&m.location.scheme===P.Schemas.file){y.log(m.location.fsPath);return}})})}l(f){return this.d?(0,g.localize)(24,null,f,this.d):(0,g.localize)(25,null,f)}};A=fe([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],A),e.ExtensionManagementCLI=A}),define(Z[134],Q([0,1,5,7,2,16,12,18,41,3,29,20,24,17,21,26,59,13,6]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let b=class $e extends P.Disposable{constructor(m,t,s,i,n,r){super(),this.h=t,this.i=s,this.j=i,this.k=n,this.l=r,this.extensionsDownloadDir=m.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(m,t){await this.g;const s=(0,S.joinPath)(this.extensionsDownloadDir,this.v(m));try{await this.r(m,s,n=>this.i.download(m,n,t))}catch(n){throw new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.m(m)){const n=await this.n(m);try{await this.k.verify(s.fsPath,n.fsPath)&&(i="Verified"),this.l.info(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`)}catch(r){const a=r,o=a.code;if(o==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`);else if(!a.didExecute)this.l.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i} (${o})`);else throw await this.delete(n),await this.delete(s),new E.ExtensionManagementError(o,E.ExtensionManagementErrorCode.Signature)}}return{location:s,verificationStatus:i}}async m(m){if(!m.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(t)?t:!0}async n(m){await this.g;const t=(0,S.joinPath)(this.extensionsDownloadDir,`${this.v(m)}${$e.c}`);return await this.r(m,t,s=>this.i.downloadSignatureArchive(m,s)),t}async r(m,t,s){if(await this.h.exists(t))return;if(t.scheme!==D.Schemas.file){await s(t);return}const i=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.h.exists(i)||await s(i);try{await this.t(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",m.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(m){await this.g,await this.h.del(m)}async t(m,t,s){try{await p.Promises.rename(m.fsPath,t.fsPath)}catch(i){if(k.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.l.info(`Failed renaming ${m} to ${t} with 'EPERM' error. Trying again...`),this.t(m,t,s);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const m=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const t=[],s=[],i=[];for(const a of m.children)if(a.name.endsWith($e.c))i.push(a.resource);else{const o=A.ExtensionKey.parse(a.name);o&&s.push([o,a])}const n=(0,A.groupByExtension)(s,([a])=>a),r=[];for(const a of n)a.sort((o,l)=>g.rcompare(o[0].version,l[0].version)),t.push(...a.slice(1).map(o=>o[1].resource)),r.push(a[0][1]);r.sort((a,o)=>a.mtime-o.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),t.push(...i),await O.Promises.settled(t.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(m){this.l.error(m)}}v(m){return this.f?A.ExtensionKey.create(m).toString().toLowerCase():(0,I.generateUuid)()}};b.c=".sigzip",b=fe([_(0,w.INativeEnvironmentService),_(1,f.IFileService),_(2,E.IExtensionGalleryService),_(3,d.IConfigurationService),_(4,u.IExtensionSignatureVerificationService),_(5,y.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[135],Q([0,1,4,2,36,26,32]),function(x,e,O,R,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class S extends R.Disposable{constructor(c,I,p,d,w,E,A){super(),this.f=c,this.g=I,this.h=p,this.i=d,this.j=w,this.k=E,this.l=A,this.a=this.B(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,u=>A.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,I){try{await Promise.all(I.map(p=>(this.c.deleteAndDispose(p.id),this.z(p.extensionsResource)))),c.length&&await Promise.all(c.map(p=>(this.c.set(p.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(p.extensionsResource)),this.k.watch(p.extensionsResource))),this.y(p.extensionsResource))))}catch(p){throw this.l.error(p),p}}async r(c){for(const I of c.extensions)this.D(this.G(I.identifier,I.version),c.profileLocation)}async s(c){for(const I of c.extensions){const p=this.G(I.identifier,I.version);c.error?this.F(p,c.profileLocation):this.D(p,c.profileLocation)}}async t(c){for(const I of c.extensions)this.F(this.G(I.identifier,I.version),c.profileLocation)}async u(c){const I=[],p=[];for(const d of c.extensions){const w=this.G(d.identifier,d.version);c.error?this.D(w,c.profileLocation):(this.F(w,c.profileLocation),this.b.has(w)||(this.l.debug("Extension is removed from all profiles",d.identifier.id,d.version),p.push(this.f.scanInstalledExtensionAtLocation(d.location).then(E=>{E?I.push(E):this.l.info("Extension not found at the location",d.location.toString())},E=>this.l.error(E)))))}try{await Promise.all(p),I.length&&await this.C(I)}catch(d){this.l.error(d)}}v(c){for(const I of this.h.profiles)c.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(c){const I=[],p=[],d=await this.i.scanProfileExtensions(c),w=new Set,E=new Set;for(const[A,u]of this.b)u.has(c)&&E.add(A);for(const A of d){const u=this.G(A.identifier,A.version);w.add(u),E.has(u)||(I.push(A.identifier),this.D(u,c))}for(const A of E)if(!w.has(A)){const u=this.H(A);u&&(p.push(u.identifier),this.F(A,c))}(I.length||p.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:c}:void 0,removed:p.length?{extensions:p,profileLocation:c}:void 0})}async y(c){const I=await this.i.scanProfileExtensions(c);for(const p of I)this.D(this.G(p.identifier,p.version),c)}async z(c){for(const I of[...this.b.keys()])this.F(I,c);await this.C()}async C(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.G(p.identifier,p.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}D(c,I){let p=this.b.get(c);p||this.b.set(c,p=new P.ResourceSet(d=>this.j.extUri.getComparisonKey(d))),p.add(I)}F(c,I){const p=this.b.get(c);p&&p.delete(I),p?.size||this.b.delete(c)}G(c,I){return`${k.ExtensionIdentifier.toKey(c.id)}@${I}`}H(c){const[I,p]=(0,D.getIdAndVersion)(c);return p?{identifier:{id:I},version:p}:void 0}}e.ExtensionsWatcher=S}),define(Z[136],Q([0,1,109,39]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(D,k,S,g,c,I,p){const d={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`};if((0,R.supportsTelemetry)(k,S)&&(0,R.getTelemetryLevel)(g)===3){const w=await(0,O.getServiceMachineId)(S,c,I),{machineId:E}=await p.getTelemetryInfo();d["X-Market-User-Id"]=w,d["VSCode-SessionId"]=E||w}return d}e.resolveMarketplaceHeaders=P}),define(Z[137],Q([0,1,164,19,5,2,16,15,20,17,21,26,6,63,12,11]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends w.LanguagePackBaseService{constructor(v,m,t,s){super(t),this.h=v,this.i=s,this.g=this.B(new f(m,s)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(v){const t=(await this.g.getLanguagePacks())[E.Language.value()];if(!t){this.i.warn(`No language pack found for ${E.Language.value()}`);return}const s=t.translations[v];return s?A.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),m=Object.keys(v).map(t=>{const s=v[t];return{...this.f(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((t,s)=>t.label.localeCompare(s.label)),m}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const m=await this.g.getLanguagePacks();Object.keys(m).some(t=>m[t]&&m[t].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(m);return!(0,R.equals)(Object.keys(v),Object.keys(t))}};u=fe([_(0,I.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,I.IExtensionGalleryService),_(3,d.ILogService)],u),e.NativeLanguagePackService=u;let f=class extends D.Disposable{constructor(v,m){super(),this.i=m,this.c={},this.f=(0,S.join)(v.userDataPath,"languagepacks.json"),this.g=new P.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(m=>{Object.keys(m).forEach(t=>delete m[t]),this.j(m,...v)}).then(()=>this.c)}j(v,...m){for(const t of m)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(v,t);Object.keys(v).forEach(t=>this.l(v[t]))}k(v,m){const t=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const i of s)if(m.location.scheme===k.Schemas.file&&y(i)){let n=v[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},v[i.languageId]=n);const r=n.extensions.filter(a=>(0,p.areSameExtensions)(a.extensionIdentifier,t))[0];r?r.version=m.manifest.version:n.extensions.push({extensionIdentifier:t,version:m.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,S.join)(m.location.fsPath,a.path)}}l(v){if(v){const m=(0,O.createHash)("md5");for(const t of v.extensions)m.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);v.hash=m.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let m=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(m=v(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),g.Promises.writeFile(this.f,s)}).then(()=>m,t=>this.i.error(t))})}};f=fe([_(0,c.INativeEnvironmentService),_(1,d.ILogService)],f);function y(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const v of b.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(Z[138],Q([0,1,7,28,39]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function S(c,I,p){const d=await new Promise((f,y)=>{x(["@microsoft/1ds-core-js"],f,y)}),w=await new Promise((f,y)=>{x(["@microsoft/1ds-post-js"],f,y)}),E=new d.AppInsightsCore,A=new w.PostChannel,u={instrumentationKey:c,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[A]]};if(p){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:p};u.extensionConfig[A.identifier]=f}return E.initialize(u,[]),E.addTelemetryInitializer(f=>{I&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),E}class g{constructor(I,p,d,w,E){this.e=I,this.f=p,this.g=d,this.h=E,this.c=D,this.d=k,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(p=>{I(p)},p=>{(0,O.onUnexpectedError)(p),console.error(p)})}}log(I,p){if(!this.a)return;p=(0,R.mixin)(p,this.g),p=(0,P.validateTelemetryData)(p);const d=this.f+"/"+I;try{this.i(w=>{w.pluginVersionString=p?.properties.version??"Unknown",w.track({name:d,baseData:{name:d,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[139],Q([0,1,2,28,12,30,101,24,42,140,31,37,25,39]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,y,b){this.k=y,this.l=b,this.d={},this.i=new O.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(d.TELEMETRY_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,y){this.d[f]=y}m(){let f=(0,w.getTelemetryLevel)(this.k);const y=this.l.enabledTelemetryLevels;if(y){this.h=this.sendErrorTelemetry?y.error:!1;const b=y.usage?3:y.error?2:0;f=Math.min(f,b)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,y=f.sessionID,b=f["common.machineId"],v=f["common.firstSessionDate"],m=f["common.msftInternal"];return{sessionId:y,machineId:b,firstSessionDate:v,msftInternal:m}}dispose(){this.i.dispose()}n(f,y,b){return this.g<y?Promise.resolve(void 0):this.c.then(v=>{b=(0,R.mixin)(b,this.d),b=(0,w.cleanData)(b,this.j),b=(0,R.mixin)(b,v),this.b.forEach(m=>m.log(f,b))},v=>{console.error(v)})}publicLog(f,y){return this.n(f,3,y)}publicLog2(f,y){return this.publicLog(f,y)}publicLogError(f,y){return this.h?this.n(f,2,y):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=fe([_(1,S.IConfigurationService),_(2,I.IProductService)],E),e.TelemetryService=E;function A(){const u=(0,k.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=P.isWeb?"":(0,k.localize)(3,null),b=(0,k.localize)(4,null),v=(0,k.localize)(5,null),m=(0,k.localize)(6,null),t=(0,k.localize)(7,null),s=`
|       | ${b} | ${v} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,k.localize)(8,null);return`
${u} ${f} ${y}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:A(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,k.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,k.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[141],Q([0,1,165,138]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends R.AbstractOneDataSystemAppender{constructor(k,S,g,c){const I={sendPOST:(p,d)=>{const w={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const E=O.request(p.urlString,w,A=>{A.on("data",function(u){d(A.statusCode??200,A.headers,u.toString())}),A.on("error",function(u){d(0,{})})});E.write(p.data),E.end()}catch{d(0,{})}}};super(k,S,g,c,I)}}e.OneDataSystemAppender=P}),define(Z[142],Q([0,1,15,20]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function P(D,k){const S=Object.create(null),g=(I,p)=>{const d=JSON.parse(I);S[p]=d};if(k){const I=[],p=await R.Promises.readdir(k);for(const w of p)try{(await R.Promises.stat((0,O.join)(k,w))).isDirectory()&&I.push(w)}catch{}const d=[];for(const w of I)(await R.Promises.readdir((0,O.join)(k,w))).filter(A=>A==="telemetry.json").length===1&&d.push(w);for(const w of d){const E=(await R.Promises.readFile((0,O.join)(k,w,"telemetry.json"))).toString();g(E,w)}}let c=(await R.Promises.readFile((0,O.join)(D,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await R.Promises.readFile((0,O.join)(D,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(S,null,4)}e.buildTelemetryMessage=P}),define(Z[143],Q([0,1,12,80,25]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(k){let S=k.getItem(P.machineIdKey);return(typeof S!="string"||O.isMacintosh&&S==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(S=await(0,R.getMachineId)()),S}e.resolveMachineId=D}),define(Z[27],Q([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Z[144],Q([0,1,27,110,13,18,72,4,2]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let I=class{constructor(d){this.g=d,this.c=new g.DisposableStore,this.f=2**16;const w=new Map,E=A=>{let u=w.get(A.scheme);return u===void 0&&(u=d.hasProvider(A)&&!this.g.hasCapability(A,1024),w.set(A.scheme,u)),u};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(A=>{w.delete(A.scheme)})),this.extUri=new D.ExtUri(E),this.d=new k.SkipList((A,u)=>this.extUri.compare(A,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,D.normalizePath)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((E,A)=>E[1].touch<A[1].touch?1:E[1].touch>A[1].touch?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let E=0;E<w;E++)this.d.set(d[E][0],d[E][1].touch())}};I=fe([_(0,P.IFileService)],I),e.UriIdentityService=I,(0,R.registerSingleton)(O.IUriIdentityService,I,1)}),define(Z[145],Q([0,1,103,15,54,18,11,10,16]),function(x,e,O,R,P,D,k,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function I(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=p;function d(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function w(i){const n=i;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=w;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function A(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=A;function u(i){const n=i;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(n,r,a,o,l){this.h=n,this.j=a,this.k=o,this.l=l,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function b(i){return new y({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function m(i){let n;return k.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=m;function t(i,n){return!v(i,n)&&!m(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,R.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Z[22],Q([0,1,51,4,2,18,11,102,17,13,10,6,145,36,27,5,29,30,3]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function v(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:k.URI.revive(i.location).with({scheme:n}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=v;function m(i,n,r,a){return{id:i,name:n,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=m;let t=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,a,o){super(),this.m=n,this.n=r,this.r=a,this.s=o,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new w.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const l of this.I()){if(!l.name||!(0,y.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(m((0,D.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.s.error(l)}const r=new w.ResourceMap,a=new Map,o=this.v();if(n.unshift({...o,extensionsResource:this.N()??o.extensionsResource,isDefault:!0}),n.length)try{const l=this.L();if(l.workspaces)for(const[h,N]of Object.entries(l.workspaces)){const F=k.URI.parse(h),Y=n.find(ee=>ee.id===N);Y&&r.set(F,Y)}if(l.emptyWindows)for(const[h,N]of Object.entries(l.emptyWindows)){const F=n.find(Y=>Y.id===N);F&&a.set(h,F)}}catch(l){this.s.error(l)}this.t={profiles:n,workspaces:r,emptyWindows:a}}return this.t}v(){return m("__default__profile__",(0,S.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const h of this.profiles){const N=a.exec(h.name),F=N?parseInt(N[1]):0;o=F>o?F:o}const l=`${r} ${o+1}`;return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),n,r,a)}async createProfile(n,r,a,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(n,r,a);return o&&await this.setProfileForWorkspace(o,l),l}async w(n,r,a){if(!(0,y.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const l=this.profiles.find(F=>F.name===r||F.id===n);if(l)return l;const h=m(n,r,(0,D.joinPath)(this.profilesHome,n),a);await this.n.createFolder(h.location);const N=[];return this.h.fire({profile:h,join(F){N.push(F)}}),await A.Promises.settled(N),this.C([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=m(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.C([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:r,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return k.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,a){const o=[...this.profiles,...n],l=[];this.l.profiles=[];for(let h of o)h.isDefault||r.some(N=>h.id===N.id)||(h=a.find(N=>h.id===N.id)??h,h.isTransient?this.l.profiles.push(h):l.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.J(l),this.t=void 0,this.D(n,r,a)}D(n,r,a){this.g.fire({added:n,removed:r,updated:a,all:this.profiles})}F(n,r,a){a=r?.isTransient?!0:a,a||this.F(n,void 0,!0);const o=this.y(n),l=a?this.l:this.u;k.URI.isUri(o)?(l.workspaces.delete(o),r&&l.workspaces.set(o,r)):(l.emptyWindows.delete(o),r&&l.emptyWindows.set(o,r)),a||this.G()}G(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.id;const r={};for(const[a,o]of this.u.emptyWindows.entries())r[a.toString()]=o.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},a=this.v();if(n.workspaces)for(const[l,h]of Object.entries(n.workspaces)){const N=k.URI.parse(h);r[l]=this.r.extUri.isEqual(N,a.location)?a.id:this.r.extUri.basename(N)}const o={};if(n.emptyWindows)for(const[l,h]of Object.entries(n.emptyWindows)){const N=k.URI.parse(h);o[l]=this.r.extUri.isEqual(N,a.location)?a.id:this.r.extUri.basename(N)}return{workspaces:r,emptyWindows:o}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=fe([_(0,g.IEnvironmentService),_(1,c.IFileService),_(2,E.IUriIdentityService),_(3,p.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=s}),define(Z[146],Q([0,1,19,5,23,7,4,2,12,11,87,21,26,32,6,31,25,22]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var y;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(y=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let b=class extends S.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,a,o,l){super(),this.t=n,this.u=r,this.v=a,this.w=o,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,S.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,p.isTargetPlatformCompatible)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new p.ExtensionManagementError(I.localize(0,null),p.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(a.manifest,a.extension,r)}catch(a){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),m(a)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,w.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},l=te=>`${d.ExtensionKey.create(te).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const te=this.j.get(l(r));if(te)return this.v.info("Extensions is already requested to install",r.identifier.id),te.task.waitUntilTaskIsFinished()}const h=[],N=[],F=[],Y=this.Q(n,r,o);c.URI.isUri(r)||this.j.set(l(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:o.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),h.push({task:Y,manifest:n});let ee=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ae,manifest:ue}of(0,O.distinct)(ie,({gallery:se})=>se.identifier.id)){ee=ee||!!ue.extensionDependencies?.some(V=>(0,d.areSameExtensions)({id:V},Y.identifier));const se=l(ae),ve=this.j.get(se);if(ve){if(this.C(Y,ve.task)){const V=ve.task.identifier;this.v.info("Waiting for already requested installing extension",V.id,Y.identifier.id),ve.waitingTasks.push(Y),N.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,d.areSameExtensions)(M.identifier,V)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",V.id,Y.identifier.id),!j.find($=>(0,d.areSameExtensions)($.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!ne.some(({identifier:V})=>(0,d.areSameExtensions)(V,ae.identifier))){const V=this.Q(ue,ae,{...o,donotIncludePackAndDependencies:!0});this.j.set(se,{task:V,waitingTasks:[Y]}),this.l.fire({identifier:V.identifier,source:ae,profileLocation:o.profileLocation}),this.v.info("Installing extension:",V.identifier.id,Y.identifier.id),h.push({task:V,manifest:ue})}}}catch(ie){if(c.URI.isUri(Y.source))(0,O.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,O.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const te=h.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(ue=>te.has(ue.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!ee)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.D(ie.map(async({task:ae})=>{const ue=new Date().getTime();try{const se=await ae.run();if(await this.D(this.s.map(ve=>ve.postInstall(se,ae.source,o,P.CancellationToken.None))),!c.URI.isUri(ae.source)){const ve=ae.operation===3,V=ve?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ve?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,durationSinceUpdate:V}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}F.push({local:se,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw c.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,error:se}),this.v.error("Error while installing the extension:",ae.identifier.id),se}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return N.length&&await this.D(N),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,Y.identifier))[0].local}catch(te){if(h.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:ue}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ue.id):this.v.warn("Rollback: Error while uninstalling extension",ue.id,(0,D.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:o.context,profileLocation:o.profileLocation}))),te}finally{for(const{task:te}of h)te.source&&!c.URI.isUri(te.source)&&this.j.delete(l(te.source))}}C(n,r){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(r)||o.some(l=>this.C(l,r)))||a===r&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const r=[],a=[],o=await Promise.allSettled(n);for(const l of o)l.status==="fulfilled"?r.push(l.value):a.push(l.reason);if(a.length)throw v(a);return r}async F(n,r,a,o,l){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,l),N=[],F=[],Y=async(ee,te)=>{N.push(ee);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=a?h.find(ue=>(0,d.areSameExtensions)(ue.identifier,ee)):void 0;for(const ue of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(se=>(0,d.areSameExtensions)({id:se},{id:ue}))||ne.every(se=>!(0,d.areSameExtensions)({id:se},{id:ue}))&&ne.push(ue)}if(ne.length){const ae=ne.filter(ue=>N.every(se=>!(0,d.areSameExtensions)(se,{id:ue})));if(ae.length){const ue=await this.t.getExtensions(ae.map(se=>({id:se,preRelease:o})),P.CancellationToken.None);for(const se of ue){if(N.find(j=>(0,d.areSameExtensions)(j,se.identifier)))continue;const ve=ie.some(j=>(0,d.areSameExtensions)({id:j},se.identifier));let V;try{V=await this.G(se,!1,o)}catch(j){if(j instanceof p.ExtensionManagementError&&j.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ve){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw j}F.push({gallery:V.extension,manifest:V.manifest}),await Y(V.extension.identifier,V.manifest)}}}};return await Y(n,r),F}async G(n,r,a){if((await this.getExtensionsControlManifest()).malicious.some(N=>(0,d.areSameExtensions)(n.identifier,N)))throw new p.ExtensionManagementError(I.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const N=await this.getTargetPlatform();throw new p.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.w.nameLong,(0,p.TargetPlatformToString)(N)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,r,a);if(l){if(a&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],P.CancellationToken.None))[0]?new p.ExtensionManagementError(I.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const h=await this.t.getManifest(l,P.CancellationToken.None);if(h===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(h.version!==l.version)throw new p.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:h}}async H(n,r,a){const o=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,a,o)&&(l=n),l||(r?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},P.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,a,o)),l}async I(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},o=ee=>`${ee.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.k.get(o(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const h=ee=>{const te=this.R(ee,a);return this.k.set(o(te.extension.identifier),te),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.n.fire({identifier:ee.identifier,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped}),te},N=(ee,te)=>{te?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,te.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(ee),error:te}),this.p.fire({identifier:ee.identifier,error:te?.code,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped})},F=[],Y=[];try{F.push(h(n));const ee=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.M(n,ee);for(const ie of te)this.k.has(o(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(h(ie))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(te=>te.extension),ee,n),await this.D(F.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ie=>ie.postUninstall(te.extension,a,P.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}N(te.extension)}catch(ie){const ne=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,D.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw N(te.extension,ne),ne}finally{Y.push(te)}}))}catch(ee){const te=ee instanceof p.ExtensionManagementError?ee:new p.ExtensionManagementError((0,D.getErrorMessage)(ee),p.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Y.includes(ie)||N(ie.extension,te)}throw te}finally{for(const ee of F)this.k.delete(o(ee.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}J(n,r,a){for(const o of n){const l=this.N(o,r);if(l.length){const h=l.filter(N=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,N.identifier)));if(h.length)throw new Error(this.L(o,h,a))}}}L(n,r,a){return a===n?r.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const l=r.filter(N=>!N.isBuiltin&&o.some(F=>(0,d.areSameExtensions)({id:F},N.identifier))),h=[];for(const N of l)h.push(...this.M(N,r,a));return[...l,...h]}return[]}N(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,d.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};b=fe([_(0,p.IExtensionGalleryService),_(1,u.ITelemetryService),_(2,E.ILogService),_(3,A.IProductService),_(4,f.IUserDataProfilesService)],b),e.AbstractExtensionManagementService=b;function v(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=v;function m(i){if(i instanceof p.ExtensionManagementError)return i;const n=new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:a,duration:o,error:l,durationSinceUpdate:h}){let N,F;l&&(l instanceof p.ExtensionManagementError?(N=l.code,l.code===p.ExtensionManagementErrorCode.Signature&&(F=l.message)):N=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:a,success:!l,duration:o,errorcode:N,errorcodeDetail:F,durationSinceUpdate:h})}class s{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(n=>new Promise((r,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Z[40],Q([0,1,5,14,2,4,36,11,21,26,13,10,6,22,27,3,7,25]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var y;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(y=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let v=class extends P.Disposable{constructor(i,n,r,a,o,l){super(),this.i=i,this.j=n,this.k=r,this.l=a,this.m=o,this.n=l,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new k.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],a=[];try{return await this.p(n,o=>{const l=[];for(const h of o)i.some(([N])=>(0,c.areSameExtensions)(N.identifier,h.identifier)&&N.manifest.version!==h.version)?r.push(h):l.push(h);for(const[h,N]of i)if(!l.some(F=>(0,c.areSameExtensions)(F.identifier,h.identifier)&&F.version===h.manifest.version)){const F={identifier:h.identifier,version:h.manifest.version,location:h.location,metadata:N};a.push(F),l.push(F)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),l}),a.length&&this.c.fire({extensions:a,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),a}catch(o){throw a.length&&this.c.fire({extensions:a,error:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const r=[];return await this.p(n,a=>{const o=[];for(const l of a){const h=i.find(([N])=>(0,c.areSameExtensions)(N.identifier,l.identifier)&&N.manifest.version===l.version);h&&(l.metadata={...l.metadata,...h[1]},r.push(l)),o.push(l)}return o}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,a=>{const o=[];for(const l of a)(0,c.areSameExtensions)(l.identifier,i.identifier)?r.push(l):o.push(l);return r.length&&this.f.fire({extensions:r,profileLocation:n}),o}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(a){throw r.length&&this.g.fire({extensions:r,error:a,profileLocation:n}),a}}async p(i,n,r){return this.w(i).queue(async()=>{let a=[],o;try{const l=await this.j.readFile(i);o=JSON.parse(l.value.toString().trim()||"[]")}catch(l){if((0,I.toFileOperationResult)(l)!==1)throw l;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(o=await this.v()),!o&&r?.bailOutWhenFileNotFound)throw new b((0,u.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.r(i);let l=!1;for(const h of o){m(h)||this.r(i);let N;if((0,A.isString)(h.relativeLocation))N=this.t(h.relativeLocation);else if((0,A.isString)(h.location))N=this.t(h.location),l=!0,h.relativeLocation=h.location,h.location=N.toJSON();else{N=S.URI.revive(h.location);const F=this.s(N);F&&(l=!0,h.relativeLocation=F)}a.push({identifier:h.identifier,location:N,version:h.version,metadata:h.metadata})}l&&await this.j.writeFile(i,R.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const l=a.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),relativeLocation:this.s(h.location),metadata:h.metadata}));await this.j.writeFile(i,R.VSBuffer.fromString(JSON.stringify(l)))}return a})}r(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqualOrParent(i,this.i)?this.l.extUri.relativePath(this.i,i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(o){if((0,I.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",i.toString());let a;try{const o=JSON.parse(r);Array.isArray(o)&&o.every(l=>m(l))?a=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(i)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(n)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.n.error(o)}return a})()),this.u}w(i){let n=this.h.get(i);return n||(n=new O.Queue,this.h.set(i,n)),n}};v=fe([_(1,I.IFileService),_(2,w.IUserDataProfilesService),_(3,E.IUriIdentityService),_(4,f.ITelemetryService),_(5,d.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function m(s){return(0,A.isObject)(s)&&(0,g.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,A.isString)(s.location))&&((0,A.isUndefined)(s.relativeLocation)||(0,A.isString)(s.relativeLocation))&&s.version&&(0,A.isString)(s.version)}function t(s){return s?(0,A.isString)(s.path)&&(0,A.isString)(s.scheme):!1}}),define(Z[47],Q([0,1,19,5,28,14,7,49,78,2,16,15,12,18,41,52,3,11,91,17,26,32,44,13,10,6,31,4,53,40,22,27,107,108]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b,v,m,t,s,i,n,r,a,o,l,h,N,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ee;(function(ve){function V(j,M){if(j===M)return!0;const $=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if($.length!==W.size)return!1;for(const q of $){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ve.equals=V})(ee=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends c.Disposable{constructor(V,j,M,$,W,q,J,C,L,T,U,z){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=j,this.l=M,this.m=$,this.n=W,this.p=q,this.r=J,this.s=C,this.t=L,this.u=T,this.v=U,this.w=z,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,w.joinPath)(this.m,m.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,w.joinPath)(this.m,m.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,j,M){const[$,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(V,[...$,...W]):[];return this.F($,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const j=[];j.push(this.G(!!V.useCache,V.language)),j.push(this.H(V.language,!!V.checkControlFile));const[M,$]=await Promise.all(j);return this.D([...M,...$],0,V,!1)}async scanUserExtensions(V){const j=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(j,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,M),W=V.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions($)}catch(J){if(J instanceof l.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions($);else throw J}return q=await this.D(q,1,V,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(V,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter($=>$.scheme===I.Schemas.file).map(async $=>{const W=await this.J($,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(J=>(J.type=j.find(C=>(0,v.areSameExtensions)(C.identifier,J.identifier))?.type??J.type,this.k.validate(J,W)))}))).flat();return this.D(M,"development",V,!0)}return[]}async scanExistingExtension(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension($);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions($);return this.D(W,j,M,!0)}async scanMetadata(V){const j=(0,w.joinPath)(V,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(V,j){const M=(0,w.joinPath)(V,"package.json"),$=(await this.r.readFile(M)).value.toString(),W=JSON.parse($);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,w.joinPath)(V,"package.json"),D.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof l.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,j,M,$){return M.includeAllVersions||(V=this.F(j===0?V:void 0,j===1?V:void 0,j==="development"?V:void 0,await this.getTargetPlatform(),$)),M.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,q)=>{const J=p.basename(W.location.fsPath),C=p.basename(q.location.fsPath);return J<C?-1:J>C?1:0})}F(V,j,M,$,W){const q=(C,L,T)=>{if(C.isValid&&!L.isValid)return!1;if(C.isValid===L.isValid){if(W&&E.gt(C.manifest.version,L.manifest.version))return this.s.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${C.location.path} with version ${C.manifest.version}`),!1;if(E.eq(C.manifest.version,L.manifest.version)){if(C.type===0)return this.s.debug(`Skipping extension ${L.location.path} in favour of system extension ${C.location.path} with same version`),!1;if(C.targetPlatform===$)return this.s.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${C.location.path} with ${L.location.path}.`):this.s.debug(`Overwriting user extension ${C.location.path} with ${L.location.path}.`),!0},J=new Map;return V?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!1))&&J.set(L,C)}),j?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);if(!T&&V&&C.type===0){this.s.debug(`Skipping obsolete system extension ${C.location.path}.`);return}(!T||q(T,C,!1))&&J.set(L,C)}),M?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!0))&&J.set(L,C),J.set(L,C)}),[...J.values()]}async G(V,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(V&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(V,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const $=j?await this.I():{},W=[],q=f.URI.file(p.normalize(p.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const C of M){const L=$[C.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":W.push((0,w.joinPath)(q,C.name));break;default:W.push(f.URI.file(L));break}}const J=await Promise.all(W.map(async C=>this.k.scanExtension(await this.J(C,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",J.length),(0,O.coalesce)(J)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,j,M,$,W,q,J){const C=await this.f(W??d.language),L=await this.L(V),T=j&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=T?await this.L(T):void 0;return new ie(V,L,T,U,j,J,M,$,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,C)}async L(V){try{const j=await this.r.stat(V);if(typeof j.mtime=="number")return j.mtime}catch{}}};te=fe([_(4,h.IUserDataProfilesService),_(5,l.IExtensionsProfileScannerService),_(6,s.IFileService),_(7,n.ILogService),_(8,b.IEnvironmentService),_(9,r.IProductService),_(10,N.IUriIdentityService),_(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(V,j,M,$,W,q,J,C,L,T,U,z,K,H,re){this.location=V,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=$,this.profile=W,this.profileScanOptions=q,this.type=J,this.excludeObsolete=C,this.validate=L,this.productVersion=T,this.productDate=U,this.productCommit=z,this.devMode=K,this.language=H,this.translations=re}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,j){return(0,w.isEqual)(V.location,j.location)&&V.mtime===j.mtime&&(0,w.isEqual)(V.applicationExtensionslocation,j.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&V.profile===j.profile&&P.equals(V.profileScanOptions,j.profileScanOptions)&&V.type===j.type&&V.excludeObsolete===j.excludeObsolete&&V.validate===j.validate&&V.productVersion===j.productVersion&&V.productDate===j.productDate&&V.productCommit===j.productCommit&&V.devMode===j.devMode&&V.language===j.language&&ee.equals(V.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends c.Disposable{constructor(V,j,M,$,W){super(),this.f=V,this.g=j,this.h=M,this.i=$,this.j=W}async scanExtensions(V){const j=V.profile?await this.l(V):await this.k(V);let M={};if(V.excludeObsolete&&V.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();M=JSON.parse($)}catch{}return(0,u.isEmptyObject)(M)?j:j.filter($=>!M[v.ExtensionKey.create($).toString()])}async k(V){const j=await this.i.resolve(V.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async $=>{if(!$.isDirectory||V.type===1&&(0,w.basename)($.resource).indexOf(".")===0)return null;const W=new ie($.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,O.coalesce)(M).sort(($,W)=>$.location.path<W.location.path?-1:1)}async l(V){let j=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){j=j.filter($=>!$.metadata?.isApplicationScoped);const M=await this.m(V.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,V);j.push(...M)}return j}async m(V,j,M){const $=await this.g.scanProfileExtensions(V,M.profileScanOptions);if(!$.length)return[];const W=await Promise.all($.map(async q=>{if(j(q)){const J=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(J,q.metadata)}return null}));return(0,O.coalesce)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,w.joinPath)(V.location,"package.json"))){const j=await this.scanExtension(V);return j?[j]:[]}else return await this.scanExtensions(V)}catch(j){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,k.getErrorMessage)(j)),[]}}async scanExtension(V,j){try{let M=await this.scanExtensionManifest(V.location);if(M){M.publisher||(M.publisher=m.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const $=(0,v.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:$,uuid:j.id}:{id:$},q=j?.isSystem?0:V.type,J=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(V.location,M,ie.createNlsConfiguration(V));const C={type:q,identifier:W,manifest:M,location:V.location,isBuiltin:J,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return V.validate?this.validate(C,V):C}}catch(M){V.type!==0&&this.j.error(M)}return null}validate(V,j){let M=!0;const $=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,V.manifest,V.isBuiltin);for(const[W,q]of $)W===A.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return V.isValid=M,V.validations=$,V}async scanExtensionManifest(V){const j=(0,w.joinPath)(V,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(V,(0,y.localize)(0,null,j.path,W.message))),null}let $;try{$=JSON.parse(M)}catch{const q=[];(0,S.parse)(M,q);for(const J of q)this.j.error(this.t(V,(0,y.localize)(1,null,j.path,J.offset,J.length,(0,g.getParseErrorMessage)(J.error))));return null}return(0,S.getNodeType)($)!=="object"?(this.j.error(this.t(V,(0,y.localize)(2,null,j.path))),null):$}async n(V,j,M){const $=await this.p(V,j,M);if($)try{const W=[],q=await this.r($.default,W);if(W.length>0)return W.forEach(C=>{this.j.error(this.t(V,(0,y.localize)(3,null,$.default?.path,(0,g.getParseErrorMessage)(C.error))))}),j;if((0,S.getNodeType)($)!=="object")return this.j.error(this.t(V,(0,y.localize)(4,null,$.default?.path))),j;const J=$.values||Object.create(null);return(0,F.localizeManifest)(j,J,q)}catch{}return j}async p(V,j,M){const $=(0,w.joinPath)(V,"package.nls.json"),W=(L,T)=>{T.forEach(U=>{this.j.error(this.t(V,(0,y.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},q=L=>{this.j.error(this.t(V,(0,y.localize)(6,null,L?.path)))},J=`${j.publisher}.${j.name}`,C=M.translations[J];if(C)try{const L=f.URI.file(C),T=(await this.i.readFile(L)).value.toString(),U=[],z=(0,S.parse)(T,U);return U.length>0?(W(L,U),{values:void 0,default:$}):(0,S.getNodeType)(z)!=="object"?(q(L),{values:void 0,default:$}):{values:z.contents?z.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let T;try{T=await this.s(V,M)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.i.readFile(T.localized)).value.toString(),z=[],K=(0,S.parse)(U,z);return z.length>0?(W(T.localized,z),{values:void 0,default:T.original}):(0,S.getNodeType)(K)!=="object"?(q(T.localized),{values:void 0,default:T.original}):{values:K,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(V,j){if(V)try{const M=(await this.i.readFile(V)).value.toString();return(0,S.parse)(M,j)}catch{}}s(V,j){return new Promise((M,$)=>{const W=q=>{const J=(0,w.joinPath)(V,`package.nls.${q}.json`);this.i.exists(J).then(C=>{C&&M({localized:J,original:(0,w.joinPath)(V,"package.nls.json")});const L=q.lastIndexOf("-");L===-1?M({localized:(0,w.joinPath)(V,"package.nls.json"),original:null}):(q=q.substring(0,L),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,w.joinPath)(V,"package.nls.json"),original:null});W(j.language)})}t(V,j){return`[${V.path}]: ${j}`}};ne=fe([_(1,l.IExtensionsProfileScannerService),_(2,N.IUriIdentityService),_(3,s.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(V,j,M,$,W,q){super(j,M,$,W,q),this.y=V,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const j=await this.z();if(this.u=V,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),j.result.map($=>($.location=f.URI.revive($.location),$));const M=await super.scanExtensions(V);return await this.C({input:V,result:M}),M}async z(){try{const V=await this.i.readFile(this.y),j=JSON.parse(V.value.toString());return{result:j.result,input:(0,o.revive)(j.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,k.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(V)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,k.getErrorMessage)(j))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const j=V.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch($){this.j.error($)}}};ae=fe([_(2,l.IExtensionsProfileScannerService),_(3,N.IUriIdentityService),_(4,s.IFileService),_(5,n.ILogService)],ae);function ue(ve,V){const j=(0,v.getExtensionId)(ve.manifest.publisher,ve.manifest.name);return{id:j,identifier:new m.ExtensionIdentifier(j),isBuiltin:ve.type===0,isUserBuiltin:ve.type===1&&ve.isBuiltin,isUnderDevelopment:V,extensionLocation:ve.location,uuid:ve.identifier.uuid,targetPlatform:ve.targetPlatform,...ve.manifest}}e.toExtensionDescription=ue;class se extends te{constructor(V,j,M,$,W,q,J,C,L,T,U,z){super(V,j,(0,w.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)($,m.MANIFEST_CACHE_FOLDER),W,q,J,C,L,T,U,z),this.M=(async()=>{if(d.translationsConfigFile)try{const K=await this.r.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=se}),define(Z[147],Q([0,1,57,5,34,4,2,16,15,20,6,22]),function(x,e,O,R,P,D,k,S,g,c,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(E,A){super(),this.b=E,this.f=A,this.a=new R.Limiter(5)}async postUninstall(E){const A=this.g(E,"uninstall");A&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(A.script,"uninstall",A.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(u)}}));try{await c.Promises.rm(this.j(E))}catch(u){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(u)}}g(E,A){const u=`vscode:${A}`;if(E.location.scheme===S.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[u]=="string"){const f=E.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${u} should be a node script`),null):{script:(0,g.join)(E.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(E,A,u,f,y){return new Promise((b,v)=>{const m=this.i(E,A,u,y);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?v(i):b(void 0)};m.on("error",i=>{s((0,P.toErrorMessage)(i)||"Unknown")}),m.on("exit",(i,n)=>{s(i?`post-${A} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,m.kill(),v("timed out")},5e3))})}i(E,A,u,f){const y={silent:!0,execArgv:void 0},b=(0,O.fork)(E,[`--type=extension-post-${A}`,...u],y);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const v=D.Event.fromNodeEventEmitter(b.stdout,"data"),m=D.Event.fromNodeEventEmitter(b.stderr,"data");v(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${A}`,i)),m(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${A}`,i));const t=D.Event.any(D.Event.map(v,i=>({data:`%c${i}`,format:[""]})),D.Event.map(m,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),b}j(E){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};d=fe([_(0,p.IUserDataProfilesService),_(1,I.ILogService)],d),e.ExtensionsLifecycle=d}),define(Z[148],Q([0,1,6,22,27,25,40,13,17,11]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends k.AbstractExtensionsProfileScannerService{constructor(d,w,E,A,u,f){super(c.URI.file(d.extensionsPath),w,E,A,u,f)}};I=fe([_(0,g.INativeEnvironmentService),_(1,S.IFileService),_(2,R.IUserDataProfilesService),_(3,P.IUriIdentityService),_(4,D.ITelemetryService),_(5,O.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(Z[149],Q([0,1,11,17,40,47,13,10,6,31,27,22]),function(x,e,O,R,P,D,k,S,g,c,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends D.NativeExtensionsScannerService{constructor(E,A,u,f,y,b,v,m){super(O.URI.file(y.builtinExtensionsPath),O.URI.file(y.extensionsPath),y.userHome,O.URI.file(y.userDataPath),E,A,u,f,y,b,v,m)}};d=fe([_(0,p.IUserDataProfilesService),_(1,P.IExtensionsProfileScannerService),_(2,k.IFileService),_(3,g.ILogService),_(4,R.INativeEnvironmentService),_(5,c.IProductService),_(6,I.IUriIdentityService),_(7,S.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(Z[150],Q([0,1,5,4,2,118,3,84,10,22]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var I;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function w(y){const b=y.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=w;class E extends P.Disposable{constructor(b={flushInterval:E.a}){super(),this.j=b,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,v){if(v===e.TARGET_KEY){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:v,target:this.F(b)[v]})}r(b){this.f.fire({reason:b})}get(b,v,m){return this.L(v)?.get(b,m)}getBoolean(b,v,m){return this.L(v)?.getBoolean(b,m)}getNumber(b,v,m){return this.L(v)?.getNumber(b,m)}store(b,v,m,t){if((0,k.isUndefinedOrNull)(v)){this.remove(b,m);return}this.t(()=>{this.u(b,m,t),this.L(m)?.set(b,v)})}remove(b,v){this.t(()=>{this.u(b,v,void 0),this.L(v)?.delete(b)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,v){const m=[],t=this.F(b);for(const s of Object.keys(t))t[s]===v&&m.push(s);return m}u(b,v,m){const t=this.F(v);typeof m=="number"?t[b]!==m&&(t[b]=m,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const v=this.L(b);return v?w(v):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=I.NONE){this.f.fire({reason:b});const v=this.L(-1),m=this.L(0),t=this.L(1);switch(b){case I.NONE:await O.Promises.settled([v?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await O.Promises.settled([v?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,m=this.L(1)?.items??new Map;return f(b,v,m,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,v){return this.r(I.NONE),(0,c.isUserDataProfile)(b)?this.N(b,v):this.O(b,v)}H(b,v){return!(b.id===v.id||A(v)&&A(b))}I(b,v,m,t){this.t(()=>{if(t)for(const[s,i]of b)v.set(s,i);else{const s=new Set;for(const[i,n]of b)s.add(i),v.get(i)!==n&&this.n(m,i);for(const[i]of v.items)s.has(i)||this.n(m,i)}})}}E.a=60*1e3,e.AbstractStorageService=E;function A(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=A;class u extends E{constructor(){super(),this.p=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.InMemoryStorageService=u;async function f(y,b,v,m,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;y.forEach((Y,ee)=>{n.set(ee,Y),r.set(ee,i(Y))});const a=new Map,o=new Map;b.forEach((Y,ee)=>{a.set(ee,Y),o.set(ee,i(Y))});const l=new Map,h=new Map;v.forEach((Y,ee)=>{l.set(ee,Y),h.set(ee,i(Y))}),console.group(m!==t?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const N=[];if(n.forEach((Y,ee)=>{N.push({key:ee,value:Y})}),console.table(N),console.groupEnd(),console.log(r),m!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];a.forEach((ee,te)=>{Y.push({key:te,value:ee})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const F=[];l.forEach((Y,ee)=>{F.push({key:ee,value:Y})}),console.table(F),console.groupEnd(),console.log(h)}e.logStorage=f}),define(Z[151],Q([0,1,19,23,7,12,35,3,11,24,17,21,26,44,13,6,31,46,136,150,25]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const m=D.isWeb?"web":(0,p.getTargetPlatform)(D.platform,k.arch),t="X-Market-Search-Activity-Id";var s;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...L){return String(L.reduce((T,U)=>T|U,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(T=l){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,U=this.d.pageSize){return new h({...this.d,pageNumber:T,pageSize:U})}withFilter(T,...U){const z=[...this.d.criteria,...U.length?U.map(K=>({filterType:T,value:K})):[{filterType:T}]];return new h({...this.d,criteria:z})}withSortBy(T){return new h({...this.d,sortBy:T})}withSortOrder(T){return new h({...this.d,sortOrder:T})}withFlags(...T){return new h({...this.d,flags:T.reduce((U,z)=>U|z,0)})}withAssetTypes(...T){return new h({...this.d,assetTypes:T})}withSource(T){return new h({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:z,sortBy:K,sortOrder:H,flags:re,assetTypes:le}=this.d;return{filters:[{criteria:T,pageNumber:U,pageSize:z,sortBy:K,sortOrder:H}],assetTypes:le,flags:re}}get searchText(){const T=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(L,T){const U=(L||[]).filter(z=>z.statisticName===T)[0];return U?U.value:0}function F(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(z=>z.assetType.indexOf(T)===0).reduce((z,K)=>{const H=te(L,K.assetType);return H&&z.push([K.assetType.substring(T.length),H]),z},[])}function Y(L){if(L.properties){const T=L.properties.filter(K=>K.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=T.filter(K=>U.test(K.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(L,r.Repository)}function ee(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function te(L,T){return L.files.filter(z=>z.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ie(L,T){const U=L.properties?L.properties.filter(K=>K.key===T):[],z=U.length>0&&U[0].value;return z?z.split(",").map(K=>(0,d.adoptToGalleryExtensionId)(K)):[]}function ne(L){const T=L.properties?L.properties.filter(U=>U.key===a.Engine):[];return T.length>0&&T[0].value||""}function ae(L){const T=L.properties?L.properties.filter(U=>U.key===a.PreRelease):[];return T.length>0&&T[0].value==="true"}function ue(L){const T=L.properties?L.properties.filter(z=>z.key===a.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function se(L){return L.properties?.find(T=>T.key===a.SponsorLink)?.value}function ve(L){return L.indexOf("preview")!==-1}function V(L){return L.targetPlatform?(0,p.toTargetPlatform)(L.targetPlatform):"undefined"}function j(L){const T=(0,O.distinct)(L.versions.map(V)),U=!!L.tags?.includes(p.WEB_EXTENSION_TAG),z=T.indexOf("web");return U?z===-1&&T.push("web"):z!==-1&&T.splice(z,1),T}function M(L,T){const U=(0,p.getFallbackTargetPlarforms)(T);for(let z=0;z<L.length;z++){const K=L[z];if(K.version===L[z-1]?.version){let H=z;const re=V(K);if(re===T)for(;H>0&&L[H-1].version===K.version;)H--;else if(U.includes(re))for(;H>0&&L[H-1].version===K.version&&V(L[H-1])!==T;)H--;H!==z&&(L.splice(z,1),L.splice(H,0,K))}}return L}e.sortExtensionVersions=M;function $(L,T,U){L.telemetryData={index:T,querySource:U,queryActivityId:L.queryContext?.[t]}}function W(L,T,U,z){const K=L.versions[0],H={manifest:te(T,r.Manifest),readme:te(T,r.Details),changelog:te(T,r.Changelog),license:te(T,r.License),repository:Y(T),download:ee(T),icon:te(T,r.Icon),signature:te(T,r.Signature),coreTranslations:F(T)};return{identifier:{id:(0,d.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(K),description:L.shortDescription||"",installCount:N(L.statistics,"install"),rating:N(L.statistics,"averagerating"),ratingCount:N(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ie(T,a.Dependency),extensionPack:ie(T,a.ExtensionPack),engine:ne(T),localizedLanguages:ue(T),targetPlatform:V(T),isPreReleaseVersion:ae(T)},hasPreReleaseVersion:ae(K),hasReleaseVersion:!0,preview:ve(L.flags),isSigned:!!H.signature,queryContext:z}}let q=class{constructor(T,U,z,K,H,re,le,Ee){this.k=U,this.l=z,this.n=K,this.o=H,this.q=re,this.u=le,this.w=Ee;const me=le.extensionsGallery,ce=me?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=ce?me.servicePPEUrl:me?.serviceUrl,this.g=ce?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,y.resolveMarketplaceHeaders)(le.version,le,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,U,z){const K=R.CancellationToken.isCancellationToken(U)?{}:U,H=R.CancellationToken.isCancellationToken(U)?U:z,re=[],le=[],Ee=[],me=[];let ce=!0;for(const oe of T){oe.uuid?le.push(oe.uuid):re.push(oe.id);const ye=!!(oe.version||oe.preRelease);Ee.push({id:oe.id,uuid:oe.uuid,includePreRelease:ye}),oe.version&&me.push({id:oe.id,uuid:oe.uuid,version:oe.version}),ce=ce&&!!oe.hasPreRelease&&!ye}if(!le.length&&!re.length)return[];let de=new h().withPage(1,T.length);le.length&&(de=de.withFilter(n.ExtensionId,...le)),re.length&&(de=de.withFilter(n.ExtensionName,...re)),(K.queryAllVersions||ce)&&(de=de.withFlags(de.flags,s.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:ge}=await this.z(de,{targetPlatform:K.targetPlatform??m,includePreRelease:Ee,versions:me,compatible:!!K.compatible},H);return K.source&&ge.forEach((oe,ye)=>$(oe,ye,K.source)),ge}async getCompatibleExtension(T,U,z){if((0,p.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(T,U,z))return T;const K=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,T.identifier.uuid),{extensions:H}=await this.z(K,{targetPlatform:z,compatible:!0,includePreRelease:U},R.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,U,z){if(!(0,p.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,z)||!U&&T.properties.isPreReleaseVersion)return!1;let K=T.properties.engine;if(!K){const H=await this.getManifest(T,R.CancellationToken.None);if(!H)throw new Error("Manifest was not found");K=H.engines.vscode}return(0,w.isEngineValid)(K,this.u.version,this.u.date)}async y(T,U,z,K,H){if(!(0,p.isTargetPlatformCompatible)(V(T),K,H)||U!=="any"&&ae(T)!==(U==="prerelease"))return!1;if(z)try{const re=await this.E(T);if(!(0,w.isEngineValid)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,P.getErrorMessage)(re)),!1}return!0}async query(T,U){let z=T.text||"";const K=T.pageSize??50;let H=new h().withPage(1,K);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,de,ge)=>(H=H.withFilter(n.Category,ge||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,de,ge)=>(H=H.withFilter(n.Tag,ge||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),H=H.withFilter(n.SearchText,z)),H=H.withSortBy(0)):T.ids?H=H.withFilter(n.ExtensionId,...T.ids):T.names?H=H.withFilter(n.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const re=async(ce,de)=>{const{extensions:ge,total:oe}=await this.z(ce,{targetPlatform:m,compatible:!1,includePreRelease:!!T.includePreRelease},de);return ge.forEach((ye,Se)=>$(ye,(ce.pageNumber-1)*ce.pageSize+Se,T.source)),{extensions:ge,total:oe}},{extensions:le,total:Ee}=await re(H,U),me=async(ce,de)=>{if(de.isCancellationRequested)throw new P.CancellationError;const{extensions:ge}=await re(H.withPage(ce+1),de);return ge};return{firstPage:le,total:Ee,pageSize:H.pageSize,getPage:me}}async z(T,U,z){const K=T.flags;!!(T.flags&s.IncludeLatestVersionOnly)&&!!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(T.flags&s.IncludeLatestVersionOnly)&&!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),T=T.withFlags(T.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:re,context:le}=await this.B(T,z);if(!(T.flags&s.IncludeLatestVersionOnly)){const de=[];for(const ge of H){const oe=await this.A(ge,U,le);oe&&de.push(oe)}return{extensions:de,total:re}}const me=[],ce=new Map;for(let de=0;de<H.length;de++){const ge=H[de],oe={id:(0,d.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},ye=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ne=>(0,d.areSameExtensions)(Ne,oe))?.includePreRelease;if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(j(ge),U.targetPlatform))continue;const Se=await this.A(ge,U,le);!Se||Se.properties.isPreReleaseVersion&&(!ye||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?ce.set(ge.extensionId,de):me.push([de,Se])}if(ce.size){const de=new Date().getTime(),ge=new h().withFlags(K&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ce.size).withFilter(n.ExtensionId,...ce.keys()),{extensions:oe}=await this.z(ge,U,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ce.size});for(const ye of oe){const Se=ce.get(ye.identifier.uuid);me.push([Se,ye])}}return{extensions:me.sort((de,ge)=>de[0]-ge[0]).map(([,de])=>de),total:re}}async A(T,U,z){const K={id:(0,d.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},H=U.versions?.find(me=>(0,d.areSameExtensions)(me,K))?.version,re=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,K))?.includePreRelease,le=j(T),Ee=M(T.versions,U.targetPlatform);if(U.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(le,U.targetPlatform))return null;for(let me=0;me<Ee.length;me++){const ce=Ee[me];if(!(H&&ce.version!==H)){if(await this.y(ce,re?"any":"release",U.compatible,le,U.targetPlatform))return W(T,ce,le,z);if(H&&ce.version===H)return null}}return H||U.compatible?null:W(T,T.versions[0],le)}async B(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const z=await this.j,K=JSON.stringify(T.raw),H={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},re=new Date().getTime();let le,Ee,me=0;try{if(le=await this.k.request({type:"POST",url:this.g&&T.criteria.some(de=>de.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:H},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const ce=await(0,f.asJson)(le);if(ce){const de=ce.results[0],ge=de.extensions,oe=de.resultMetadata&&de.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return me=oe&&oe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:me,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ce){throw Ee=ce,ce}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(K.length),duration:new Date().getTime()-re,success:!!le&&(0,f.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:Ee?(0,P.isCancellationError)(Ee)?"canceled":(0,P.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(T,U,z,K){if(!this.isEnabled())return;const H=D.isWeb?this.x(`/itemName/${T}.${U}/version/${z}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${U}/${z}/stats?statType=${K}`),re=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:H,headers:Ee},R.CancellationToken.None)}catch{}}async download(T,U,z){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const K=(0,d.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:de}),le=z===2?"install":z===3?"update":"",Ee=le?{uri:`${T.assets.download.uri}${g.URI.parse(T.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${T.assets.download.fallbackUri}${g.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:T.assets.download,me=T.queryContext?.[t]?{[t]:T.queryContext[t]}:void 0,ce=await this.D(Ee,me?{headers:me}:void 0);await this.q.writeFile(U,ce.stream),re(new Date().getTime()-H)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const z=await this.D(T.assets.signature);await this.q.writeFile(U,z.stream)}async getReadme(T,U){if(T.assets.readme){const z=await this.D(T.assets.readme,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getManifest(T,U){if(T.assets.manifest){const z=await this.D(T.assets.manifest,{},U),K=await(0,f.asTextOrError)(z);return K?JSON.parse(K):null}return null}async C(T,U){const z=te(T,r.Manifest);if(!z)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},H=await this.D(z,{headers:K});return await(0,f.asJson)(H)}async getCoreTranslation(T,U){const z=T.assets.coreTranslations.filter(K=>K[0]===U.toUpperCase())[0];if(z){const K=await this.D(z[1]),H=await(0,f.asTextOrError)(K);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const z=await this.D(T.assets.changelog,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(T,U,z){let K=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?K=K.withFilter(n.ExtensionId,T.identifier.uuid):K=K.withFilter(n.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.B(K,R.CancellationToken.None);if(!H.length)return[];const re=j(H[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(re,z))return[];const le=[];await Promise.all(H[0].versions.map(async ce=>{try{await this.y(ce,U?"any":"release",!0,re,z)&&le.push(ce)}catch{}}));const Ee=[],me=new Set;for(const ce of M(le,z))me.has(ce.version)||(me.add(ce.version),Ee.push({version:ce.version,date:ce.lastUpdated,isPreReleaseVersion:ae(ce)}));return Ee}async D(T,U={},z=R.CancellationToken.None){const K=await this.j,H={type:"GET"},re={...K,...U.headers||{}};U={...U,...H,headers:re};const le=T.uri,Ee=T.fallbackUri,me={...U,url:le};try{const ce=await this.k.request(me,z);if(ce.res.statusCode===200)return ce;const de=await(0,f.asTextOrError)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${de}`)}catch(ce){if((0,P.isCancellationError)(ce))throw ce;const de=(0,P.getErrorMessage)(ce);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:de});const ge={...U,url:Ee};return this.k.request(ge,z)}}async E(T){let U=ne(T);if(!U){const z=await this.C(T,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");U=z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const T=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(T),z=[],K={};if(U){for(const H of U.malicious)z.push({id:H});if(U.migrateToPreRelease)for(const[H,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,w.isEngineValid)(re.engine,this.u.version,this.u.date))&&(K[H.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,re]of Object.entries(U.deprecated))re&&(K[H.toLowerCase()]=(0,S.isBoolean)(re)?{}:re)}return{malicious:z,deprecated:K}}};q=fe([_(1,f.IRequestService),_(2,A.ILogService),_(3,I.IEnvironmentService),_(4,v.ITelemetryService),_(5,E.IFileService),_(6,u.IProductService),_(7,c.IConfigurationService)],q);let J=class extends q{constructor(T,U,z,K,H,re,le,Ee){super(T,U,z,K,H,re,le,Ee)}};J=fe([_(0,b.IStorageService),_(1,f.IRequestService),_(2,A.ILogService),_(3,I.IEnvironmentService),_(4,v.ITelemetryService),_(5,E.IFileService),_(6,u.IProductService),_(7,c.IConfigurationService)],J),e.ExtensionGalleryService=J;let C=class extends q{constructor(T,U,z,K,H,re,le){super(void 0,T,U,z,K,H,re,le)}};C=fe([_(0,f.IRequestService),_(1,A.ILogService),_(2,I.IEnvironmentService),_(3,v.ITelemetryService),_(4,E.IFileService),_(5,u.IProductService),_(6,c.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(Z[152],Q([0,1,3,11,17,13,6,67,27,22]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let I=class extends c.UserDataProfilesService{constructor(w,E,A,u){super(E,A,w,u),this.a=E}N(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I=fe([_(0,g.IUriIdentityService),_(1,P.INativeEnvironmentService),_(2,D.IFileService),_(3,k.ILogService)],I),e.ServerUserDataProfilesService=I;let p=class Ve extends I{constructor(w,E,A,u,f){super(E,A,u,f),this.Q=w}I(){return this.Q.getItem(Ve.b,[]).map(E=>({...E,location:(0,O.isString)(E.location)?this.r.extUri.joinPath(this.profilesHome,E.location):R.URI.revive(E.location)}))}L(){const w=this.Q.getItem(Ve.c,{});return this.Q.getItem(Ve.P,!1)?w:this.H(w)}N(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p.P="profileAssociationsMigration",p=fe([_(0,S.IStateService),_(1,g.IUriIdentityService),_(2,P.INativeEnvironmentService),_(3,D.IFileService),_(4,k.ILogService)],p),e.UserDataProfilesService=p}),define(Z[153],Q([0,1,38,5,166,2,6]),function(x,e,O,R,P,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let S=class extends O.AbstractPolicyService{constructor(c,I){super(),this.j=c,this.k=I,this.a=new R.Throttler,this.b=this.B(new D.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((I,p)=>{try{this.b.value=(0,P.createWatcher)(this.k,c,d=>{this.m(d),I()})}catch(d){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),p(d)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const I in c){const p=c[I];p===void 0?this.g.delete(I):this.g.set(I,p)}this.h.fire(Object.keys(c))}};S=fe([_(0,k.ILogService)],S),e.NativePolicyService=S}),define(Z[69],Q([0,1,120,5,15,3,20,85,167,168]),function(x,e,O,R,P,D,k,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=I;function p(m){const t=m.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(m){if(m instanceof I)return m;let t;return/end of central directory record signature not found/.test(m.message)&&(t="CorruptZip"),new I(t,m)}function w(m,t,s,i,n,r){const a=P.dirname(t),o=P.join(i,a);if(!o.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const l=P.join(i,t);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,F)=>{if(!r.isCancellationRequested)try{h=(0,O.createWriteStream)(l,{mode:s}),h.once("close",()=>N()),h.once("error",F),m.once("error",F),m.pipe(h)}catch(Y){F(Y)}}))}function E(m,t,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),m.close()}),new Promise((a,o)=>{const l=new R.Sequencer,h=N=>{N.isCancellationRequested||(r++,m.readEntry())};m.once("error",o),m.once("close",()=>n.then(()=>{i.isCancellationRequested||m.entryCount===r?a():o(new I("Incomplete",new Error(S.localize(1,null,r,m.entryCount))))},o)),m.readEntry(),m.on("entry",N=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(N.fileName)){h(i);return}const F=N.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const te=P.join(t,F);n=(0,R.createCancelablePromise)(ie=>k.Promises.mkdir(te,{recursive:!0}).then(()=>h(ie)).then(void 0,o));return}const Y=u(m,N),ee=p(N);n=(0,R.createCancelablePromise)(te=>l.queue(()=>Y.then(ie=>w(ie,F,ee,t,s,te).then(()=>h(te)))).then(null,o))})})}function A(m,t=!1){return new Promise((s,i)=>{(0,g.open)(m,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,D.assertIsDefined)(r))})})}function u(m,t){return new Promise((s,i)=>{m.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,D.assertIsDefined)(r))})})}function f(m,t){return new Promise((s,i)=>{const n=new c.ZipFile;t.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,O.createWriteStream)(m);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(m))})}e.zip=f;function y(m,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=A(m,!0);return s.overwrite&&(r=r.then(a=>k.Promises.rm(t).then(()=>a))),r.then(a=>E(a,t,{sourcePathRegex:n},i))}e.extract=y;function b(m,t){return A(m).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&u(s,r).then(a=>i(a),a=>n(a))}),s.once("close",()=>n(new Error(S.localize(2,null,t))))}))}function v(m,t){return b(m,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",a=>r.push(a)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=v}),define(Z[154],Q([0,1,69,93]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(D){return(0,O.buffer)(D,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=P}),define(Z[155],Q([0,1,5,14,23,34,7,4,2,36,16,15,12,18,41,3,11,29,20,69,92,58,17,146,21,26,40,47,134,147,154,127,135,32,44,13,10,6,31,25,27,22]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b,v,m,t,s,i,n,r,a,o,l,h,N,F,Y,ee,te,ie,ne,ae,ue,se,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(i.IExtensionManagementService);let V=class extends s.AbstractExtensionManagementService{constructor(C,L,T,U,z,K,H,re,le,Ee,me,ce){super(C,L,T,Ee,ce),this.Z=z,this.ab=K,this.bb=H,this.cb=le,this.db=me,this.X=this.B(new S.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const de=this.B(re.createInstance(l.ExtensionsLifecycle));this.S=this.B(re.createInstance(j,oe=>de.postUninstall(oe))),this.U=this.B(new N.ExtensionsManifestCache(U,this)),this.W=this.B(re.createInstance(o.ExtensionsDownloader));const ge=this.B(new F.ExtensionsWatcher(this,this.Z,ce,K,me,le,T));this.B(ge.onDidChangeExtensionsByAnotherSource(oe=>this.kb(oe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(C){this.v.trace("ExtensionManagementService#zip",C.identifier.id);const L=await this.jb(C),T=await(0,b.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,L);return u.URI.file(T)}async unzip(C){return this.v.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:L,cleanup:T}=await this.fb(C),U=p.resolve(L.fsPath);try{return await(0,h.getManifest)(U)}finally{await T()}}getInstalled(C,L=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(C??null,L)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.S.scanUserExtensionAtLocation(C)}async install(C,L={}){this.v.trace("ExtensionManagementService#install",C.toString());const{location:T,cleanup:U}=await this.fb(C);try{const z=await(0,h.getManifest)(p.resolve(T.fsPath));if(z.engines&&z.engines.vscode&&!(0,ee.isEngineValid)(z.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,n.getGalleryExtensionId)(z.publisher,z.name),this.w.version));return await this.z(z,T,L)}finally{await U()}}async installFromLocation(C,L){this.v.trace("ExtensionManagementService#installFromLocation",C.toString());const T=await this.S.scanUserExtensionAtLocation(C);if(!T)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([T],L),this.v.info("Successfully installed extension",T.identifier.id,L.toString()),T}getMetadata(C,L=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(C,L)}async updateMetadata(C,L,T=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",C.identifier.id),L.isPreReleaseVersion&&(L.preRelease=!0),L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.pinned=L.pinned||void 0,C=await this.S.updateMetadata(C,L,T),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const L=await this.getTargetPlatform(),[T]=await this.t.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:L,compatible:!0},P.CancellationToken.None);if(!T)throw new Error(v.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(U){throw new Error(v.localize(3,null,(0,D.toErrorMessage)(U)))}return this.installFromGallery(T)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(C){this.v.error(C)}}async download(C,L){const{location:T}=await this.W.download(C,L);return T}async fb(C){if(C.scheme===I.Schemas.file)return{location:C,async cleanup(){}};this.v.trace("Downloading extension from",C.toString());const L=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(C,L),this.v.info("Downloaded extension to",L.toString()),{location:L,cleanup:async()=>{try{await this.cb.del(L)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(C,L,T){if(u.URI.isUri(L))return new W(C,L,T,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const U=n.ExtensionKey.create(L).toString();let z=this.Y.get(U);return z||(this.Y.set(U,z=new $(C,L,T,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(U))),z}R(C,L){return new q(C,L.profileLocation,this.ab)}async jb(C){const L=async U=>{let z=await y.Promises.readdir(U);z=z.map(re=>p.join(U,re));const K=await Promise.all(z.map(re=>y.Promises.stat(re)));let H=Promise.resolve([]);return K.forEach((re,le)=>{const Ee=z[le];re.isFile()&&(H=H.then(me=>[...me,Ee])),re.isDirectory()&&(H=H.then(me=>L(Ee).then(ce=>[...me,...ce])))}),H};return(await L(C.location.fsPath)).map(U=>({path:`extension/${p.relative(C.location.fsPath,U)}`,localPath:U}))}async kb({added:C,removed:L}){if(L)for(const T of L.extensions)this.v.info("Extensions removed from another source",T.id,L.profileLocation.toString()),this.p.fire({identifier:T,profileLocation:L.profileLocation});if(C){const U=(await this.S.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(K=>(0,n.areSameExtensions)(K,z.identifier)));this.m.fire(U.map(z=>(this.v.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(L=>this.lb.add(L)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const L of C.children??[])L.isDirectory&&this.lb.add(L.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(L=>this.nb(L)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const L=[];for(const T of C.rawAdded){if(this.lb.has(T)||!this.db.extUri.isEqual(this.db.extUri.dirname(T),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(T,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(T).startsWith(".")||!(await this.cb.stat(T)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(T);U&&U.installedTimestamp===void 0&&(this.lb.add(T),L.push(U))}L.length&&(await this.ob(L,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",L.map(T=>T.identifier.id)))}async ob(C,L){await this.pb(C),await this.ab.addExtensionsToProfile(C.map(T=>[T,void 0]),L),this.m.fire(C.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:L})))}async pb(C){const L=await this.S.getUninstalledExtensions();for(const T of C){const U=n.ExtensionKey.create(T);!L[U.toString()]||(this.v.trace("Removing the extension from uninstalled list:",U.id),await this.S.setInstalled(U),this.v.info("Removed the extension from uninstalled list:",U.id))}}};V=fe([_(0,i.IExtensionGalleryService),_(1,ue.ITelemetryService),_(2,ne.ILogService),_(3,t.INativeEnvironmentService),_(4,a.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,m.IDownloadService),_(7,ie.IInstantiationService),_(8,te.IFileService),_(9,ae.IProductService),_(10,se.IUriIdentityService),_(11,ve.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let j=class extends g.Disposable{constructor(C,L,T,U,z,K){super(),this.k=C,this.l=L,this.m=T,this.n=U,this.p=z,this.s=K,this.h=this.B(new S.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,w.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new O.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(C,L){const T={includeInvalid:!0,profileLocation:L};let U=[];return C===null||C===0?U.push(...await this.m.scanAllExtensions({includeInvalid:!0},T,!1)):C===1&&U.push(...await this.m.scanUserExtensions(T)),U=C!==null?U.filter(z=>z.type===C):U,Promise.all(U.map(z=>this.y(z)))}async scanAllUserExtensions(C){const L=await this.m.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(L.map(T=>this.y(T)))}async scanUserExtensionAtLocation(C){try{const L=await this.m.scanExistingExtension(C,1,{includeInvalid:!0});if(L)return await this.y(L)}catch(L){this.s.error(L)}return null}async extractUserExtension(C,L,T,U){await this.j.catch(()=>{});const z=C.toString(),K=p.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),H=p.join(this.m.userExtensionsLocation.fsPath,z);try{await y.Promises.rm(H)}catch{throw new i.ExtensionManagementError(v.localize(4,null,H,C.id),i.ExtensionManagementErrorCode.Delete)}await this.u(C,L,K,U),await this.m.updateMetadata(u.URI.file(K),T);try{this.h.fire(u.URI.file(H)),await this.v(C,K,H,Date.now()+2*60*1e3),this.s.info("Renamed to",H)}catch(re){try{await y.Promises.rm(K)}catch{}if(re.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.s.info(`Rename failed because of ${(0,k.getErrorMessage)(re)}. Deleted from extracted location`,K),re}return this.w(u.URI.file(H),1)}async scanMetadata(C,L){return L?(await this.n.scanProfileExtensions(L)).find(U=>(0,n.areSameExtensions)(U.identifier,C.identifier))?.metadata:this.m.scanMetadata(C.location)}async updateMetadata(C,L,T){return T?await this.n.updateMetadata([[C,L]],T):await this.m.updateMetadata(C.location,L),this.w(C.location,C.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...C){const L=C.map(T=>n.ExtensionKey.create(T));await this.t(T=>L.forEach(U=>{T[U.toString()]=!0,this.s.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(C){await this.t(L=>delete L[C.toString()])}async removeExtension(C,L){this.s.trace(`Deleting ${L} extension from disk`,C.identifier.id,C.location.fsPath);const T=this.p.extUri.joinPath(this.p.extUri.dirname(C.location),`.${(0,f.generateUuid)()}`);await this.v(C.identifier,C.location.fsPath,T.fsPath,Date.now()+2*60*1e3),await this.l.del(T,{recursive:!0}),this.s.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.t(L=>delete L[n.ExtensionKey.create(C).toString()])}async t(C){return this.g.queue(async()=>{let L;try{L=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,te.toFileOperationResult)(U)!==1)throw U}let T={};if(L)try{T=JSON.parse(L)}catch{}return C&&(C(T),Object.keys(T).length?await this.l.writeFile(this.c,R.VSBuffer.fromString(JSON.stringify(T))):await this.l.del(this.c)),T})}async u(C,L,T,U){this.s.trace(`Started extracting the extension from ${L} to ${T}`);try{await y.Promises.rm(T)}catch(z){throw new i.ExtensionManagementError(this.D(z).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,b.extract)(L,T,{sourcePath:"extension",overwrite:!0},U),this.s.info(`Extracted extension to ${T}:`,C.id)}catch(z){try{await y.Promises.rm(T)}catch{}let K=i.ExtensionManagementErrorCode.Extract;throw z instanceof b.ExtractError&&(z.type==="CorruptZip"?K=i.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(K=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(z.message,K)}}async v(C,L,T,U){try{await y.Promises.rename(L,T)}catch(z){if(d.isWindows&&z&&z.code==="EPERM"&&Date.now()<U)return this.s.info(`Failed renaming ${L} to ${T} with 'EPERM' error. Trying again...`,C.id),this.v(C,L,T,U);throw new i.ExtensionManagementError(z.message||v.localize(5,null,L,T),z.code||i.ExtensionManagementErrorCode.Rename)}}async w(C,L){const T=await this.m.scanExistingExtension(C,L,{includeInvalid:!0});if(T)return this.y(T);throw new Error(v.localize(6,null,C.path))}async y(C){const L=await this.l.resolve(C.location);let T,U;return L.children&&(T=L.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,U=L.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:T,changelogUrl:U,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async z(){const C=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(C));const L=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const z of L)C[n.ExtensionKey.create(z).toString()]||T.add(z.identifier.id.toLowerCase());try{const z=(0,n.groupByExtension)(L,K=>K.identifier);await O.Promises.settled(z.map(async K=>{const H=K.sort((re,le)=>E.rcompare(re.manifest.version,le.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.k(await this.y(H))}))}catch(z){this.s.error(z)}const U=L.filter(z=>z.metadata&&C[n.ExtensionKey.create(z).toString()]);await Promise.allSettled(U.map(z=>this.removeUninstalledExtension(z)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const C=[];let L;try{L=await this.l.resolve(this.m.userExtensionsLocation)}catch(T){(0,te.toFileOperationResult)(T)!==1&&this.s.error(T)}for(const T of L?.children??[])T.isDirectory&&T.name.startsWith(".")&&(0,f.isUUID)(T.name.substring(1))&&C.push((async()=>{this.s.trace("Deleting the generated extension folder",T.resource.toString());try{await this.l.del(T.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",T.resource.toString())}catch(U){this.s.error(U)}})());await Promise.allSettled(C)}D(C){const L=Array.isArray(C)?C:[C];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((T,U)=>new Error(`${T.message}${T.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};j=fe([_(1,te.IFileService),_(2,a.IExtensionsScannerService),_(3,r.IExtensionsProfileScannerService),_(4,se.IUriIdentityService),_(5,ne.ILogService)],j),e.ExtensionsScanner=j;class M extends s.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,A.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,L,T,U,z,K,H,re,le){super(),this.identifier=C,this.source=L,this.l=T,this.m=U,this.n=z,this.o=K,this.p=H,this.q=re,this.s=le,this.j="Unverified",this.k=2}async h(C){const[L,T]=await this.x(C);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[L,T]],this.l.profileLocation),L}async u({zipPath:C,key:L,metadata:T},U){let z=await this.v(L);return z||(this.s.trace("Extracting extension...",L.id),z=await this.m.extractUserExtension(L,C,T,U),this.s.info("Extracting extension completed.",L.id)),z}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(U=>n.ExtensionKey.create(U).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class $ extends M{constructor(C,L,T,U,z,K,H,re,le,Ee){super(L.identifier,L,T,z,K,H,re,le,Ee),this.y=C,this.z=L,this.A=U}async x(C){const T=(await this.m.scanExtensions(null,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.z.identifier));T&&(this.k=3);const U={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,Y.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||T?.isMachineScoped,isBuiltin:this.l.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,A.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.z.version)return[await this.m.updateMetadata(T,U),U];const{location:z,verificationStatus:K}=await this.A.download(this.z,this.k);try{return this.j=K,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.ExtensionKey.create(this.z),metadata:U},C),U]}catch(H){try{await this.A.delete(z)}catch(re){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,k.getErrorMessage)(re))}throw H}}async C(C){try{await(0,h.getManifest)(C)}catch(L){throw new i.ExtensionManagementError((0,s.joinErrors)(L).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class W extends M{constructor(C,L,T,U,z,K,H,re,le,Ee){super({id:(0,n.getGalleryExtensionId)(C.publisher,C.name)},L,T,z,K,H,re,le,Ee),this.y=C,this.z=L,this.A=U}async x(C){const L=new n.ExtensionKey(this.identifier,this.y.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),z=await this.C(this.identifier.id,this.y.version,C);if(z.isApplicationScoped=(0,Y.isApplicationScopedExtension)(this.y),z.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,z.isBuiltin=this.l.isBuiltin||U?.isBuiltin,z.installedTimestamp=Date.now(),z.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,L.equals(new n.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(v.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&E.gt(U.manifest.version,this.y.version)&&await this.m.setUninstalled(U);else{const H=await this.v(L);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(v.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:p.resolve(this.z.fsPath),key:L,metadata:z},C),z]}async C(C,L,T){try{let[U]=await this.A.getExtensions([{id:C,version:L}],T);if(U||([U]=await this.A.getExtensions([{id:C}],T)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class q extends s.AbstractExtensionTask{constructor(C,L,T){super(),this.extension=C,this.j=L,this.k=T}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[156],Q([0,1,130,5,14,7,2,3,24,17,131,6,129,169]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let E=class extends k.Disposable{constructor(u,f,y){super(),this.h=u,this.i=f,this.j=y,this.k(),this.B(u.onDidChangeConfiguration(b=>{b.affectsConfiguration("http")&&this.k()}))}k(){const u=this.h.getValue("http");this.a=u?.proxy,this.b=!!u?.proxyStrictSSL,this.f=u?.proxyAuthorization}async request(u,f){this.j.trace("RequestService#request (node) - begin",u.url);const{a:y,b}=this;let v;try{v=await(0,I.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const m={...process.env,...v},t=u.agent?u.agent:await(0,d.getProxyAgent)(u.url||"",m,{proxyUrl:y,strictSSL:b});u.agent=t,u.strictSSL=b,this.f&&(u.headers={...u.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(u,f);return this.j.trace("RequestService#request (node) - success",u.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",u.url,s),s}}async l(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((b,v)=>{x(["https"],b,v)}):await new Promise((b,v)=>{x(["http"],b,v)})).request}m(u,f){return R.Promises.withAsyncBody(async(y,b)=>{const v=(0,O.parse)(u.url),m=u.getRawRequest?u.getRawRequest(u):await this.l(u),t={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,S.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const s=m(t,i=>{const n=(0,S.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...u,url:i.headers.location,followRedirects:n-1},f).then(y,b);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,w.createGunzip)())),y({res:i,stream:(0,P.streamToBufferReadableStream)(r)})}});s.on("error",b),u.timeout&&s.setTimeout(u.timeout),u.isChromiumNetwork&&s.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&s.write(u.data),s.end(),f.onCancellationRequested(()=>{s.abort(),b(new D.CancellationError)})})}async resolveProxy(u){}};E=fe([_(0,g.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,p.ILogService)],E),e.RequestService=E}),define(Z[170],Q([0,1,33,5,14,34,7,2,16,15,12,35,11,20,24,126,58,128,17,106,151,21,59,133,40,47,155,149,13,117,119,45,115,62,63,137,6,122,123,38,153,140,31,46,156,67,132,68,25,139,39,141,142,27,144,22,152,143,148,121]),function(x,e,O,R,P,D,k,S,g,c,I,p,d,w,E,A,u,f,y,b,v,m,t,s,i,n,r,a,o,l,h,N,F,Y,ee,te,ie,ne,ae,ue,se,ve,V,j,M,$,W,q,J,C,L,T,U,z,K,H,re,le,Ee,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ce extends S.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,ye]=await this.f();return oe.invokeFunction(async Se=>{const Ne=Se.get(ie.ILogService),Fe=Se.get(o.IFileService),B=Se.get(y.INativeEnvironmentService),G=Se.get(H.IUserDataProfilesService);Ne.info("CLI main",this.b),this.g(Ne),await this.h(B,Fe,G,oe),await Promise.all(ye.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,ye={_serviceBrand:void 0,...ve.default};oe.set(V.IProductService,ye);const Se=new b.NativeEnvironmentService(this.b,ye);oe.set(y.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(Re=>Re?w.Promises.mkdir(Re,{recursive:!0}):void 0));const Ne=(0,ie.getLogLevel)(Se),Fe=new ne.SpdLogLogger("cli",(0,c.join)(Se.logsPath,"cli.log"),!0,!1,Ne),B=[];Ne===ie.LogLevel.Trace&&B.push(new ie.ConsoleLogger(Ne));const G=this.B(new me.LogService(Fe,B));oe.set(ie.ILogService,G);const X=this.B(new l.FileService(G));oe.set(o.IFileService,X);const he=this.B(new h.DiskFileSystemProvider(G));X.registerProvider(g.Schemas.file,he);const pe=new W.StateService(Se,G,X);oe.set($.IStateService,pe);const Oe=new K.UriIdentityService(X);oe.set(z.IUriIdentityService,Oe);const Ie=new re.UserDataProfilesService(pe,Oe,Se,X,G);oe.set(H.IUserDataProfilesService,Ie);const Ae=I.isWindows&&ye.win32RegValueName?this.B(new se.NativePolicyService(G,ye.win32RegValueName)):Se.policyFile?this.B(new ae.FilePolicyService(Se.policyFile,X,G)):new ue.NullPolicyService;oe.set(ue.IPolicyService,Ae);const ke=this.B(new A.ConfigurationService(Ie.defaultProfile.settingsResource,X,Ae,G));oe.set(E.IConfigurationService,ke),await Promise.all([pe.init(),ke.initialize()]),Ie.init(),oe.set(z.IUriIdentityService,new K.UriIdentityService(X)),oe.set(j.IRequestService,new N.SyncDescriptor(M.RequestService,void 0,!0)),oe.set(u.IDownloadService,new N.SyncDescriptor(f.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new N.SyncDescriptor(Ee.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new N.SyncDescriptor(a.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new N.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(r.INativeServerExtensionManagementService,new N.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),oe.set(m.IExtensionGalleryService,new N.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(ee.ILanguagePackService,new N.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Te=[],Ue=(0,L.isInternalTelemetry)(ye,ke);if((0,L.supportsTelemetry)(ye,Se)){ye.aiConfig&&ye.aiConfig.ariaKey&&Te.push(new T.OneDataSystemAppender(Ue,"monacoworkbench",null,ye.aiConfig.ariaKey));const{installSourcePath:Re}=Se,Le={appenders:Te,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,le.resolveMachineId)(pe)}catch(je){je.code!=="ENOENT"&&G.error(je)}return(0,q.resolveCommonProperties)(X,(0,O.release)(),(0,O.hostname)(),process.arch,ye.commit,ye.version,Ce,Ue,Re)})(),piiPaths:(0,L.getPiiPathsFromEnvironment)(Se)};oe.set(J.ITelemetryService,new N.SyncDescriptor(C.TelemetryService,[Le],!1))}else oe.set(J.ITelemetryService,L.NullTelemetryService);return[new F.InstantiationService(oe),Te]}g(oe){(0,k.setUnexpectedErrorHandler)(ye=>{const Se=(0,D.toErrorMessage)(ye,!0);!Se||oe.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ye=>{(0,k.isSigPipeError)(ye)||(0,k.onUnexpectedError)(ye)}),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye))}async h(oe,ye,Se,Ne){let Fe;if(oe.args.profile&&(Fe=Se.profiles.find(G=>G.name===oe.args.profile),!Fe))throw new Error(`Profile '${oe.args.profile}' not found.`);const B=(Fe??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,ye,this.b["install-source"]);if(this.b["list-extensions"])return Ne.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const G={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return Ne.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],G,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ne.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["locate-extension"])return Ne.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(ye=>/\.vsix$/i.test(ye)?d.URI.file((0,c.isAbsolute)(ye)?ye:(0,c.join)((0,p.cwd)(),ye)):ye)}async j(oe,ye,Se){await ye.writeFile(d.URI.file(oe.installSourcePath),P.VSBuffer.fromString(Se.slice(0,30)))}}async function de(ge){const oe=new ce(ge);try{await oe.run()}finally{oe.dispose()}}e.main=de})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/af4a70d991053dcbf64d9a86c76a02dced81d9c4/core/vs/code/node/cliProcessMain.js.map
